
#include <rf_core.hh>

using namespace rfrt;

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace NativeJava {

RF_DECL (ArgsReader);

RF_DECL (DeclarationReader);

RF_DECL (Main);

RF_DECL (HeadReader);

RF_DECL (PrintDeclReader);

RF_DECL (NoWhitespaces);

RF_DECL (GetWhileNotWhitespace);

RF_DECL (Whitespaces);

}

}

}

}

}

namespace refal {

namespace StdIO {

RF_DECL (Print);

}

}

namespace refal {

namespace Convert {

RF_DECL (ToWord);

}

}

namespace refal {

namespace StdIO {

RF_DECL (WriteLn);

RF_DECL (Write);

}

}

namespace refal {

namespace Convert {

RF_DECL (ToChars);

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace NativeJava {

RF_DECL (Whitespace);

}

}

}

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace NativeJava {

static Expr String;

static Expr _c_10;

static Expr _c_0;

static Expr _c_1;

static Expr _c_2;

static Expr _c_3;

static Expr _c_4;

static Expr _c_5;

static Expr _c_6;

static Expr _c_7;

static Expr _c_8;

static Expr _c_9;

static Expr _c_11;

static Expr _c_12;

static Expr _c_13;

static Expr _c_14;

static Expr _c_15;

RF_FUNC (Whitespace, (RF_ARG _gt_arg1;;), RF_VOID)
  {
    {
      if (!_gt_arg1.term_eq (_c_0, 0))
      {
        goto _block1__branch1;
      }
      goto _block1;
    }
  _block1__branch1: {}
    if (!_gt_arg1.term_eq (_c_1, 0))
    {
      RF_RETFAIL;
    }
  }
_block1: {}
RF_END

RF_FUNC (GetWhileNotWhitespace, (RF_ARG _ve_arg;;), (RF_RES _v_res1, _v_res2;;))
  Expr _ge_arg__1;
  {
    {
      if (_ve_arg.get_len () < 1)
      {
        goto _block1__branch1;
      }
      RF_lsplit (_ve_arg, 0, _ve_head, _v_lsplit__arg);
      for ( ; ; RF_iter(_ve_arg)++)
      {
        {
          if (!RF_iter(_ve_arg))
          {
            goto _block1__branch1;
          }
          int _v_len1 = _v_lsplit__arg.get_len ();
          int _v_len2 = 1;
          if (_v_len1 < _v_len2)
          {
            goto _block1__branch1;
          }
          int _v_len__tail = (_v_len1 - _v_len2);
          Expr _vt_term;
          _vt_term = Expr (_v_lsplit__arg, 0, 1);
          Expr _ve_tail;
          _ve_tail = Expr (_v_lsplit__arg, (0 + 1), _v_len__tail);
          {
            if (!RF_CALL (Whitespace, _vt_term, /*void*/))
            {
              goto _block2__branch1;
            }
            goto _continue1;
          }
        _block2__branch1: {}
          _ge_arg__1 = (_vt_term + _ve_tail);
          goto _exit1;
        }
    _continue1: {}
      }
    _exit1: {}
      goto _block1;
    }
  _block1__branch1: {}
    _ge_arg__1 = empty;
  }
_block1: {}
  {
    {
      if (_ge_arg__1.get_len () < 1)
      {
        goto _block3__branch1;
      }
      RF_lsplit (_ge_arg__1, 0, _ve_head, _v_lsplit__arg__1);
      for ( ; ; RF_iter(_ge_arg__1)++)
      {
        {
          if (!RF_iter(_ge_arg__1))
          {
            goto _block3__branch1;
          }
          int _v_len3 = _v_lsplit__arg__1.get_len ();
          int _v_len4 = 1;
          if (_v_len3 < _v_len4)
          {
            goto _block3__branch1;
          }
          int _v_len__tail2 = (_v_len3 - _v_len4);
          Expr _vt_term;
          _vt_term = Expr (_v_lsplit__arg__1, 0, 1);
          Expr _ve_tail;
          _ve_tail = Expr (_v_lsplit__arg__1, (0 + 1), _v_len__tail2);
          {
            {
              if (!RF_CALL (Whitespace, _vt_term, /*void*/))
              {
                goto _block4__branch1;
              }
              _v_res1 = _ve_head;
              _v_res2 = _ve_tail;
              goto _block4;
            }
          _block4__branch1: {}
            goto _continue2;
          }
        _block4: {}
          goto _exit2;
        }
    _continue2: {}
      }
    _exit2: {}
      goto _block3;
    }
  _block3__branch1: {}
    _v_res1 = _ge_arg__1;
    _v_res2 = empty;
  }
_block3: {}
RF_END

RF_FUNC (Whitespaces, (RF_ARG _ve_arg;;), RF_VOID)
  {
    if (_ve_arg.get_len () < 1)
    {
      goto _block1__branch1;
    }
    RF_lsplit (_ve_arg, 0, _ve__dollar_tmp_m_23_m_14, _v_lsplit__arg);
    for ( ; ; RF_iter(_ve_arg)++)
    {
      {
        if (!RF_iter(_ve_arg))
        {
          goto _block1__branch1;
        }
        int _v_len1 = _v_lsplit__arg.get_len ();
        int _v_len2 = 1;
        if (_v_len1 < _v_len2)
        {
          goto _block1__branch1;
        }
        int _v_len___dollar_tmp_m_23_m_23 = (_v_len1 - _v_len2);
        Expr _vt_term;
        _vt_term = Expr (_v_lsplit__arg, 0, 1);
        Expr _ve__dollar_tmp_m_23_m_23;
        _ve__dollar_tmp_m_23_m_23 = Expr (_v_lsplit__arg, (0 + 1), _v_len___dollar_tmp_m_23_m_23);
        {
          if (!RF_CALL (Whitespace, _vt_term, /*void*/))
          {
            goto _negation1;
          }
          goto _continue1;
        }
      _negation1: {}
        RF_RETFAIL;
      }
  _continue1: {}
    }
  _exit1: {}
  }
_block1__branch1: {}
RF_END

RF_FUNC (NoWhitespaces, (RF_ARG _ve_arg;;), RF_VOID)
  {
    if (_ve_arg.get_len () < 1)
    {
      goto _block1__branch1;
    }
    RF_lsplit (_ve_arg, 0, _ve__dollar_tmp_m_28_m_14, _v_lsplit__arg);
    for ( ; ; RF_iter(_ve_arg)++)
    {
      {
        if (!RF_iter(_ve_arg))
        {
          goto _block1__branch1;
        }
        int _v_len1 = _v_lsplit__arg.get_len ();
        int _v_len2 = 1;
        if (_v_len1 < _v_len2)
        {
          goto _block1__branch1;
        }
        int _v_len___dollar_tmp_m_28_m_23 = (_v_len1 - _v_len2);
        Expr _vt_term;
        _vt_term = Expr (_v_lsplit__arg, 0, 1);
        Expr _ve__dollar_tmp_m_28_m_23;
        _ve__dollar_tmp_m_28_m_23 = Expr (_v_lsplit__arg, (0 + 1), _v_len___dollar_tmp_m_28_m_23);
        if (!RF_CALL (Whitespace, _vt_term, /*void*/))
        {
          goto _continue1;
        }
        RF_RETFAIL;
      }
  _continue1: {}
    }
  _exit1: {}
  }
_block1__branch1: {}
RF_END

RF_FUNC (DeclarationReader, (RF_ARG _vs_decl;;), (RF_RES _v_res1, _v_res2, _v_res3, _v_res4, _v_res5;;))
  Expr _ve_string;
  RF_CALL (::refal::Convert::ToChars, _vs_decl, _ve_string);
  {
    {
      if (_ve_string.get_len () < 2)
      {
        goto _block1__branch1;
      }
      RF_lsplit (_ve_string, 0, _ve_head, _v_lsplit__string);
      for ( ; ; RF_iter(_ve_string)++)
      {
        {
          if (!RF_iter(_ve_string))
          {
            goto _block1__branch1;
          }
          if (_v_lsplit__string.get_len () < 2)
          {
            goto _block1__branch1;
          }
          if (!_c_3.term_eq (_v_lsplit__string, 0))
          {
            goto _continue1;
          }
          Expr _v_subexpr__lsplit__string (Expr (_v_lsplit__string, (0 + 1), (_v_lsplit__string.get_len () - (0 + 1 + 0))));
          RF_lsplit (_v_subexpr__lsplit__string, 0, _ve_args, _v_lsplit__lsplit__string);
          for ( ; ; RF_iter(_v_subexpr__lsplit__string)++)
          {
            {
              if (!RF_iter(_v_subexpr__lsplit__string))
              {
                goto _continue1;
              }
              int _v_len1 = _v_lsplit__lsplit__string.get_len ();
              int _v_len2 = 1;
              if (_v_len1 < _v_len2)
              {
                goto _continue1;
              }
              int _v_len___dollar_tmp_m_35_m_37 = (_v_len1 - _v_len2);
              if (!_c_2.term_eq (_v_lsplit__lsplit__string, 0))
              {
                goto _continue2;
              }
              Expr _ve__dollar_tmp_m_35_m_37;
              _ve__dollar_tmp_m_35_m_37 = Expr (_v_lsplit__lsplit__string, (0 + 1), _v_len___dollar_tmp_m_35_m_37);
              Expr _gs_auxcall1;
              Expr _gs_auxcall2;
              Expr _gs_auxcall3;
              Expr _gs_auxcall4;
              RF_CALL (HeadReader, _ve_head, (_gs_auxcall1, _gs_auxcall2, _gs_auxcall3, _gs_auxcall4));
              Expr _ge_auxcall5;
              RF_CALL (ArgsReader, _ve_args, _ge_auxcall5);
              _v_res1 = _gs_auxcall1;
              _v_res2 = _gs_auxcall2;
              _v_res3 = _gs_auxcall3;
              _v_res4 = _gs_auxcall4;
              _v_res5 = _ge_auxcall5 ();
              goto _exit2;
            }
        _continue2: {}
          }
        _exit2: {}
          goto _exit1;
        }
    _continue1: {}
      }
    _exit1: {}
      goto _block1;
    }
  _block1__branch1: {}
    RF_CALL (HeadReader, _ve_string, (_v_res1, _v_res2, _v_res3, _v_res4));
    _v_res5 = empty;
  }
_block1: {}
RF_END

RF_FUNC (HeadReader, (RF_ARG _ve_head;;), (RF_RES _v_res1, _v_res2, _v_res3, _v_res4;;))
  Expr _ve_nws1;
  Expr _ge_head__0;
  RF_CALL (GetWhileNotWhitespace, _ve_head, (_ve_nws1, _ge_head__0));
  Expr _ve_nws2;
  RF_CALL (GetWhileNotWhitespace, _ge_head__0, (_ve_nws2, _ge_head__0));
  Expr _ve_nws3;
  RF_CALL (GetWhileNotWhitespace, _ge_head__0, (_ve_nws3, _ge_head__0));
  if (!RF_CALL (Whitespaces, _ge_head__0, /*void*/))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _ve_static;
  Expr _ve_resType;
  Expr _ve_methodname;
  {
    {
      Expr _v_compose1 ((_ve_nws1 () + _ve_nws2 () + _ve_nws3 ()));
      if (_v_compose1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__compose1 (Expr (_v_compose1, 0));
      int _v_len1 = _v_deref__compose1.get_len ();
      int _v_len2 = 0;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      int _v_len__methodname__2 = (_v_len1 - _v_len2);
      if (!_c_4.eq (_v_compose1, (0 + 1)))
      {
        goto _block1__branch1;
      }
      Expr _ge_methodname__2;
      _ge_methodname__2 = Expr (_v_deref__compose1, 0, _v_len__methodname__2);
      _ve_static = empty;
      _ve_resType = empty;
      _ve_methodname = _ge_methodname__2;
      goto _block1;
    }
  _block1__branch1: {}
    {
      Expr _v_compose2 ((_ve_nws1 () + _ve_nws2 () + _ve_nws3 ()));
      if (_v_compose2.symbol_at (0))
      {
        goto _block1__branch2;
      }
      if (_v_compose2.symbol_at ((0 + 1)))
      {
        goto _block1__branch2;
      }
      Expr _v_deref__compose2 (Expr (_v_compose2, 0));
      Expr _v_deref__compose22 (Expr (_v_compose2, (0 + 1)));
      int _v_len3 = _v_deref__compose22.get_len ();
      int _v_len4 = 0;
      if (_v_len3 < _v_len4)
      {
        goto _block1__branch2;
      }
      int _v_len__methodname__22 = (_v_len3 - _v_len4);
      int _v_len5 = _v_deref__compose2.get_len ();
      int _v_len6 = 0;
      if (_v_len5 < _v_len6)
      {
        goto _block1__branch2;
      }
      int _v_len__resType__2 = (_v_len5 - _v_len6);
      if (!_c_5.term_eq (_v_compose2, (0 + 1 + 1)))
      {
        goto _block1__branch2;
      }
      Expr _ge_resType__2;
      _ge_resType__2 = Expr (_v_deref__compose2, 0, _v_len__resType__2);
      Expr _ge_methodname__2;
      _ge_methodname__2 = Expr (_v_deref__compose22, 0, _v_len__methodname__22);
      _ve_static = empty;
      _ve_resType = _ge_resType__2;
      _ve_methodname = _ge_methodname__2;
      goto _block1;
    }
  _block1__branch2: {}
    Expr _v_compose3 ((_ve_nws1 () + _ve_nws2 () + _ve_nws3 ()));
    if (_v_compose3.symbol_at (0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    if (_v_compose3.symbol_at ((0 + 1)))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    if (_v_compose3.symbol_at ((0 + 1 + 1)))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _v_deref__compose3 (Expr (_v_compose3, 0));
    Expr _v_deref__compose32 (Expr (_v_compose3, (0 + 1)));
    Expr _v_deref__compose33 (Expr (_v_compose3, (0 + 1 + 1)));
    int _v_len7 = _v_deref__compose3.get_len ();
    int _v_len8 = 0;
    if (_v_len7 < _v_len8)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    int _v_len__static__2 = (_v_len7 - _v_len8);
    int _v_len9 = _v_deref__compose33.get_len ();
    int _v_len10 = 0;
    if (_v_len9 < _v_len10)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    int _v_len__methodname__23 = (_v_len9 - _v_len10);
    int _v_len11 = _v_deref__compose32.get_len ();
    int _v_len12 = 0;
    if (_v_len11 < _v_len12)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    int _v_len__resType__22 = (_v_len11 - _v_len12);
    Expr _ge_static__2;
    _ge_static__2 = Expr (_v_deref__compose3, 0, _v_len__static__2);
    Expr _ge_resType__2;
    _ge_resType__2 = Expr (_v_deref__compose32, 0, _v_len__resType__22);
    Expr _ge_methodname__2;
    _ge_methodname__2 = Expr (_v_deref__compose33, 0, _v_len__methodname__23);
    _ve_static = _ge_static__2;
    _ve_resType = _ge_resType__2;
    _ve_methodname = _ge_methodname__2;
  }
_block1: {}
  {
    {
      if (_ve_static.get_len () != 0)
      {
        goto _block2__branch1;
      }
      goto _block2;
    }
  _block2__branch1: {}
    if (_ve_static.get_len () != 6)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    if (!_c_6.eq (_ve_static, 0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
  }
_block2: {}
  Expr _vs_static;
  RF_CALL (::refal::Convert::ToWord, _ve_static, _vs_static);
  Expr _vs_resType;
  RF_CALL (::refal::Convert::ToWord, _ve_resType, _vs_resType);
  Expr _vs_className;
  Expr _vs_methodName;
  {
    {
      if (!_vs_resType.term_eq (_c_7, 0))
      {
        goto _block3__branch1;
      }
      Expr _gs_auxcall1;
      RF_CALL (::refal::Convert::ToWord, _ve_methodname, _gs_auxcall1);
      _vs_className = _gs_auxcall1;
      _vs_methodName = _c_7;
      goto _block3;
    }
  _block3__branch1: {}
    {
      if (_ve_methodname.get_len () < 1)
      {
        goto _block3__branch2;
      }
      RF_rsplit (_ve_methodname, 0, _v_rsplit__methodname, _ve_methodname1);
      for ( ; ; RF_iter(_ve_methodname)--)
      {
        {
          if (!RF_iter(_ve_methodname))
          {
            goto _block3__branch2;
          }
          int _v_len13 = _v_rsplit__methodname.get_len ();
          int _v_len14 = 1;
          if (_v_len13 < _v_len14)
          {
            goto _block3__branch2;
          }
          int _v_len__classname = (_v_len13 - _v_len14);
          if (!_c_8.term_eq (_v_rsplit__methodname, (0 + _v_len__classname)))
          {
            goto _continue1;
          }
          Expr _ve_classname;
          _ve_classname = Expr (_v_rsplit__methodname, 0, _v_len__classname);
          Expr _gs_auxcall2;
          RF_CALL (::refal::Convert::ToWord, _ve_classname, _gs_auxcall2);
          RF_CALL (::refal::Convert::ToWord, _ve_methodname1, _vs_methodName);
          _vs_className = _gs_auxcall2;
          goto _exit1;
        }
    _continue1: {}
      }
    _exit1: {}
      goto _block3;
    }
  _block3__branch2: {}
    RF_CALL (::refal::Convert::ToWord, _ve_methodname, _vs_methodName);
    _vs_className = _c_7;
  }
_block3: {}
  _v_res1 = _vs_static;
  _v_res2 = _vs_resType;
  _v_res3 = _vs_className;
  _v_res4 = _vs_methodName;
RF_END

RF_FUNC (ArgsReader, (RF_ARG _ve_args;;), (RF_RES _v_res1;;))
  Expr _ve_argTypes;
  Expr _ge_args__0 (_ve_args);
  for ( ; ; )
  {
    {
      if (!RF_CALL (Whitespaces, _ge_args__0, /*void*/))
      {
        goto _iter1;
      }
      _v_res1 = _ve_argTypes;
      goto _exit__iter1;
    }
  _iter1: {}
    Expr _ve_arg;
    Expr _ve_tail;
    {
      {
        if (_ge_args__0.get_len () < 1)
        {
          goto _block2__branch1;
        }
        RF_lsplit (_ge_args__0, 0, _ge_arg__4, _v_lsplit__args__0);
        for ( ; ; RF_iter(_ge_args__0)++)
        {
          {
            if (!RF_iter(_ge_args__0))
            {
              goto _block2__branch1;
            }
            int _v_len1 = _v_lsplit__args__0.get_len ();
            int _v_len2 = 1;
            if (_v_len1 < _v_len2)
            {
              goto _block2__branch1;
            }
            int _v_len__tail__4 = (_v_len1 - _v_len2);
            if (!_c_9.term_eq (_v_lsplit__args__0, 0))
            {
              goto _continue1;
            }
            Expr _ge_tail__4;
            _ge_tail__4 = Expr (_v_lsplit__args__0, (0 + 1), _v_len__tail__4);
            _ve_arg = _ge_arg__4;
            _ve_tail = _ge_tail__4;
            goto _exit1;
          }
      _continue1: {}
        }
      _exit1: {}
        goto _block2;
      }
    _block2__branch1: {}
      int _v_len3 = _ge_args__0.get_len ();
      int _v_len4 = 0;
      if (_v_len3 < _v_len4)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      int _v_len___dollar_tmp_m_63_m_8 = (_v_len3 - _v_len4);
      Expr _ve__dollar_tmp_m_63_m_8;
      _ve__dollar_tmp_m_63_m_8 = Expr (_ge_args__0, 0, _v_len___dollar_tmp_m_63_m_8);
      _ve_arg = _ge_args__0;
      _ve_tail = empty;
    }
  _block2: {}
    if (_ve_arg.get_len () < 0)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    RF_rsplit (_ve_arg, 0, _v_rsplit__arg, _ve_ws13);
    for ( ; ; RF_iter(_ve_arg)--)
    {
      {
        if (!RF_iter(_ve_arg))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        if (_v_rsplit__arg.get_len () < 0)
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        RF_rsplit (_v_rsplit__arg, 0, _v_rsplit__rsplit__arg, _ve_argName);
        for ( ; ; RF_iter(_v_rsplit__arg)--)
        {
          {
            if (!RF_iter(_v_rsplit__arg))
            {
              goto _continue2;
            }
            if (_v_rsplit__rsplit__arg.get_len () < 0)
            {
              goto _continue2;
            }
            RF_rsplit (_v_rsplit__rsplit__arg, 0, _v_rsplit__rsplit__rsplit__arg, _ve_ws12);
            for ( ; ; RF_iter(_v_rsplit__rsplit__arg)--)
            {
              {
                if (!RF_iter(_v_rsplit__rsplit__arg))
                {
                  goto _continue3;
                }
                if (_v_rsplit__rsplit__rsplit__arg.get_len () < 0)
                {
                  goto _continue3;
                }
                RF_rsplit (_v_rsplit__rsplit__rsplit__arg, 0, _ve_ws11, _ve_argType);
                for ( ; ; RF_iter(_v_rsplit__rsplit__rsplit__arg)--)
                {
                  {
                    if (!RF_iter(_v_rsplit__rsplit__rsplit__arg))
                    {
                      goto _continue4;
                    }
                    if (_ve_ws11.get_len () < 0)
                    {
                      goto _continue4;
                    }
                    if (!RF_CALL (NoWhitespaces, _ve_argType, /*void*/))
                    {
                      goto _continue5;
                    }
                    if (!RF_CALL (NoWhitespaces, _ve_argName, /*void*/))
                    {
                      goto _continue5;
                    }
                    if (!RF_CALL (Whitespaces, _ve_ws11, /*void*/))
                    {
                      goto _continue5;
                    }
                    if (!RF_CALL (Whitespaces, _ve_ws12, /*void*/))
                    {
                      goto _continue5;
                    }
                    if (!RF_CALL (Whitespaces, _ve_ws13, /*void*/))
                    {
                      goto _continue5;
                    }
                    Expr _gs_auxcall1;
                    RF_CALL (::refal::Convert::ToWord, _ve_argType, _gs_auxcall1);
                    _ve_argTypes = (_ve_argTypes + _gs_auxcall1);
                    _ge_args__0 = _ve_tail;
                    goto _exit5;
                  }
              _continue5: {}
                }
              _exit5: {}
                goto _exit4;
              }
          _continue4: {}
            }
          _exit4: {}
            goto _exit3;
          }
      _continue3: {}
        }
      _exit3: {}
        goto _exit2;
      }
  _continue2: {}
    }
  _exit2: {}
  }
_exit__iter1: {}
RF_END

RF_FUNC (PrintDeclReader, (RF_ARG _vs_string;;), RF_VOID)
  RF_CALL (::refal::StdIO::Write, _vs_string, /*void*/);
  RF_CALL (::refal::StdIO::Print, _c_10, /*void*/);
  Expr _gs_auxcall1;
  Expr _gs_auxcall2;
  Expr _gs_auxcall3;
  Expr _gs_auxcall4;
  Expr _ge_auxcall5;
  RF_CALL (DeclarationReader, _vs_string, (_gs_auxcall1, _gs_auxcall2, _gs_auxcall3, _gs_auxcall4, _ge_auxcall5));
  RF_TAILCALL (::refal::StdIO::WriteLn, (_gs_auxcall1 + _gs_auxcall2 + _gs_auxcall3 + _gs_auxcall4 + _ge_auxcall5), /*void*/);
RF_END

RF_FUNC (Main, RF_VOID, (RF_RES _v_res1;;))
  RF_CALL (PrintDeclReader, _c_11, /*void*/);
  RF_CALL (PrintDeclReader, _c_12, /*void*/);
  RF_CALL (PrintDeclReader, _c_13, /*void*/);
  RF_CALL (PrintDeclReader, _c_14, /*void*/);
  RF_CALL (PrintDeclReader, _c_15, /*void*/);
  _v_res1 = empty;
RF_END

}

}

}

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace NativeJava {

static void init_ () {
  String = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"String");
  _c_10 = rftype::Char::create_expr (L" - ");
  _c_0 = Expr (_c_10, 0, 1);
  _c_1 = rftype::Char::create_expr (L"\t");
  _c_2 = rftype::Char::create_expr (L")");
  _c_3 = rftype::Char::create_expr (L"(");
  _c_4 = (empty) () + (empty) ();
  _c_5 = (empty) ();
  _c_6 = rftype::Char::create_expr (L"static");
  _c_7 = Expr::create<rftype::Word>("");
  _c_8 = rftype::Char::create_expr (L".");
  _c_9 = rftype::Char::create_expr (L",");
  _c_11 = Expr::create<rftype::Word>("Integer (int x, double)");
  _c_12 = Expr::create<rftype::Word>("Integer Integer.toInteger (int x, double)");
  _c_13 = Expr::create<rftype::Word>("static Integer java.lang.Integer.toInteger (int x, double)");
  _c_14 = Expr::create<rftype::Word>("Integer Integer.toInteger");
  _c_15 = Expr::create<rftype::Word>("static Integer java.lang.Integer.toInteger");
}

static AtStart init_registrator_ (&init_);

}

}

}

}

}
