
#include <rf_core.hh>

using namespace rfrt;

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_as2as {

RF_DECL (Build_Subst);

RF_DECL (Generate_In_Vars);

RF_DECL (Flatten_Result);

RF_DECL (Rename);

RF_DECL (RFP_As2As_Transform);

RF_DECL (IsOld_Var);

RF_DECL (Rename_Vars);

RF_DECL (Rename_Vars_0);

RF_DECL (Rename_0);

RF_DECL (Transform2);

RF_DECL (Var_Subst);

}

}

}

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_debug {

RF_DECL (Add_Debug);

}

}

}

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_as2as {

RF_DECL (Unstick_Blocks);

}

}

}

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_format {

RF_DECL (MSG);

RF_DECL (Format_Exp);

}

}

}

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_as2as {

RF_DECL (Transform);

}

}

}

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_helper {

RF_DECL (Subst);

}

}

}

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_vars {

RF_DECL (Gener_Var_Indices);

}

}

}

}

}

namespace refal {

namespace Arithm {

RF_DECL (Add);

}

}

namespace refal {

namespace Box {

RF_DECL (Get);

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_vars {

RF_DECL (Vars);

}

}

}

}

}

namespace refal {

namespace List {

RF_DECL (Or);

RF_DECL (Map);

}

}

namespace refal {

namespace Table {

RF_DECL (IsInTable);

}

}

namespace refal {

namespace List {

RF_DECL (Split);

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_helper {

extern Expr RFP_Options;

}

}

}

}

}

namespace refal {

namespace Table {

RF_DECL (Lookup);

}

}

namespace refal {

namespace Box {

RF_DECL (Store);

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_helper {

RF_DECL (Del_Pragmas);

}

}

}

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_as2as {

static Expr Free_Idx;

static Expr _c_0;

static Expr _c_1;

static Expr _c_2;

static Expr _c_3;

static Expr _c_28;

static Expr _c_4;

static Expr _c_5;

static Expr _c_6;

static Expr _c_7;

static Expr _c_8;

static Expr _c_9;

static Expr _c_10;

static Expr _c_11;

static Expr _c_12;

static Expr _c_13;

static Expr _c_14;

static Expr _c_15;

static Expr _c_16;

static Expr _c_17;

static Expr _c_18;

static Expr _c_19;

static Expr _c_20;

static Expr _c_21;

static Expr _c_22;

static Expr _c_23;

static Expr _c_24;

static Expr _c_25;

static Expr _c_26;

static Expr _c_27;

static Expr _c_29;

static Expr _c_30;

static Expr _c_31;

static Expr _c_32;

static Expr _c_33;

static Expr _c_34;

static Expr _c_35;

RF_FUNC (RFP_As2As_Transform, (RF_ARG _ve_Items;;), (RF_RES _v_res1;;))
  Expr _ve_targets;
  {
    {
      if (!RF_CALL (::refal::Table::Lookup, (org::refal::plus::compiler::rfp_helper::RFP_Options, _c_0), _ve_targets))
      {
        goto _block1__branch1;
      }
      goto _block1;
    }
  _block1__branch1: {}
    _ve_targets = empty;
  }
_block1: {}
  RF_TAILCALL (Transform, (_ve_targets, _ve_Items), _v_res1);
RF_END

RF_FUNC (Transform, (RF_ARG _ve_targets, _ve_Items;;), (RF_RES _v_res1;;))
  Expr _ge_Items__0;
  Expr _ve_rest (_ve_Items);
  for ( ; ; )
  {
    {
      if (_ve_rest.get_len () != 0)
      {
        goto _iter1;
      }
      _v_res1 = _ge_Items__0;
      goto _exit__iter1;
    }
  _iter1: {}
    Expr _v_Transform21;
    RF_CALL (Transform2, (_ve_targets, _ve_rest), (_v_Transform21, _ve_rest));
    _ge_Items__0 = (_ge_Items__0 + _v_Transform21);
  }
_exit__iter1: {}
RF_END

RF_FUNC (Transform2, (RF_ARG _ve_targets, _ve_Items;;), (RF_RES _v_res1, _v_res2;;))
  {
    {
      int _v_len1 = _ve_Items.get_len ();
      int _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      int _v_len__rest = (_v_len1 - _v_len2);
      Expr _vt_item;
      _vt_item = Expr (_ve_Items, 0, 1);
      Expr _ve_rest;
      _ve_rest = Expr (_ve_Items, (0 + 1), _v_len__rest);
      Expr _ge_item__3;
      {
        {
          {
            {
              int _v_len3 = _ve_targets.get_len ();
              int _v_len4 = 0;
              if (_v_len3 < (_v_len4 + 1))
              {
                goto _block3__branch1;
              }
              int _v_len___dollar_tmp_m_54_m_20 = (_v_len3 - _v_len4);
              Expr _vv__dollar_tmp_m_54_m_20;
              _vv__dollar_tmp_m_54_m_20 = Expr (_ve_targets, 0, _v_len___dollar_tmp_m_54_m_20);
              if (_ve_targets.get_len () < 1)
              {
                goto _block2__branch1;
              }
              RF_lsplit (_ve_targets, 0, _ve__dollar_tmp_m_55_m_22, _v_lsplit__targets);
              for ( ; ; RF_iter(_ve_targets)++)
              {
                {
                  if (!RF_iter(_ve_targets))
                  {
                    goto _block2__branch1;
                  }
                  int _v_len5 = _v_lsplit__targets.get_len ();
                  int _v_len6 = 1;
                  if (_v_len5 < _v_len6)
                  {
                    goto _block2__branch1;
                  }
                  int _v_len___dollar_tmp_m_55_m_31 = (_v_len5 - _v_len6);
                  Expr _vt_name;
                  _vt_name = Expr (_v_lsplit__targets, 0, 1);
                  Expr _ve__dollar_tmp_m_55_m_31;
                  _ve__dollar_tmp_m_55_m_31 = Expr (_v_lsplit__targets, (0 + 1), _v_len___dollar_tmp_m_55_m_31);
                  {
                    {
                      if (_vt_item.symbol_at (0))
                      {
                        goto _block4__branch1;
                      }
                      Expr _v_deref__item (Expr (_vt_item, 0));
                      int _v_len7 = _v_deref__item.get_len ();
                      int _v_len8 = 4;
                      if (_v_len7 < _v_len8)
                      {
                        goto _block4__branch1;
                      }
                      int _v_len___dollar_tmp_m_57_m_51 = (_v_len7 - _v_len8);
                      if (_v_deref__item.symbol_at ((0 + 1 + 1)))
                      {
                        goto _block4__branch1;
                      }
                      Expr _v_deref__deref__item (Expr (_v_deref__item, (0 + 1 + 1)));
                      if (_v_deref__deref__item.get_len () != 3)
                      {
                        goto _block4__branch1;
                      }
                      if (_v_deref__deref__item.symbol_at ((0 + 1)))
                      {
                        goto _block4__branch1;
                      }
                      if (_v_deref__deref__item.symbol_at ((0 + 1 + 1)))
                      {
                        goto _block4__branch1;
                      }
                      Expr _v_deref__deref__deref__item (Expr (_v_deref__deref__item, (0 + 1)));
                      Expr _v_deref__deref__deref__item2 (Expr (_v_deref__deref__item, (0 + 1 + 1)));
                      int _v_len9 = _v_deref__deref__deref__item2.get_len ();
                      int _v_len10 = 0;
                      if (_v_len9 < _v_len10)
                      {
                        goto _block4__branch1;
                      }
                      int _v_len__line = (_v_len9 - _v_len10);
                      int _v_len11 = _v_deref__deref__deref__item.get_len ();
                      int _v_len12 = 0;
                      if (_v_len11 < _v_len12)
                      {
                        goto _block4__branch1;
                      }
                      int _v_len__file = (_v_len11 - _v_len12);
                      if (!_vt_name.term_eq (_v_deref__item, (0 + 1 + 1 + 1)))
                      {
                        goto _block4__branch1;
                      }
                      if (!_c_1.term_eq (_v_deref__deref__item, 0))
                      {
                        goto _block4__branch1;
                      }
                      Expr _vt__dollar_tmp_m_57_m_13;
                      _vt__dollar_tmp_m_57_m_13 = Expr (_v_deref__item, 0, 1);
                      Expr _vt__dollar_tmp_m_57_m_15;
                      _vt__dollar_tmp_m_57_m_15 = Expr (_v_deref__item, (0 + 1), 1);
                      Expr _ve__dollar_tmp_m_57_m_51;
                      _ve__dollar_tmp_m_57_m_51 = Expr (_v_deref__item, (0 + 1 + 1 + 1 + 1), _v_len___dollar_tmp_m_57_m_51);
                      Expr _ve_file;
                      _ve_file = Expr (_v_deref__deref__deref__item, 0, _v_len__file);
                      Expr _ve_line;
                      _ve_line = Expr (_v_deref__deref__deref__item2, 0, _v_len__line);
                      goto _block4;
                    }
                  _block4__branch1: {}
                    if (_vt_item.symbol_at (0))
                    {
                      goto _continue1;
                    }
                    Expr _v_deref__item2 (Expr (_vt_item, 0));
                    int _v_len13 = _v_deref__item2.get_len ();
                    int _v_len14 = 3;
                    if (_v_len13 < _v_len14)
                    {
                      goto _continue1;
                    }
                    int _v_len___dollar_tmp_m_58_m_24 = (_v_len13 - _v_len14);
                    if (!_vt_name.term_eq (_v_deref__item2, (0 + 1 + 1)))
                    {
                      goto _continue1;
                    }
                    Expr _vt__dollar_tmp_m_58_m_13;
                    _vt__dollar_tmp_m_58_m_13 = Expr (_v_deref__item2, 0, 1);
                    Expr _vt__dollar_tmp_m_58_m_15;
                    _vt__dollar_tmp_m_58_m_15 = Expr (_v_deref__item2, (0 + 1), 1);
                    Expr _ve__dollar_tmp_m_58_m_24;
                    _ve__dollar_tmp_m_58_m_24 = Expr (_v_deref__item2, (0 + 1 + 1 + 1), _v_len___dollar_tmp_m_58_m_24);
                  }
                _block4: {}
                  goto _exit1;
                }
            _continue1: {}
              }
            _exit1: {}
              goto _block3;
            }
          _block3__branch1: {}
          }
        _block3: {}
          if (_vt_item.symbol_at (0))
          {
            goto _block2__branch1;
          }
          Expr _v_deref__item3 (Expr (_vt_item, 0));
          int _v_len15 = _v_deref__item3.get_len ();
          int _v_len16 = 6;
          if (_v_len15 < _v_len16)
          {
            goto _block2__branch1;
          }
          int _v_len__pragma = (_v_len15 - _v_len16);
          if (_v_deref__item3.symbol_at ((0 + 1 + 1 + _v_len__pragma + 1)))
          {
            goto _block2__branch1;
          }
          if (_v_deref__item3.symbol_at ((0 + 1 + 1 + _v_len__pragma + 1 + 1)))
          {
            goto _block2__branch1;
          }
          if (_v_deref__item3.symbol_at ((0 + 1 + 1 + _v_len__pragma + 1 + 1 + 1)))
          {
            goto _block2__branch1;
          }
          Expr _v_deref__deref__item3 (Expr (_v_deref__item3, (0 + 1 + 1 + _v_len__pragma + 1)));
          Expr _v_deref__deref__item32 (Expr (_v_deref__item3, (0 + 1 + 1 + _v_len__pragma + 1 + 1)));
          Expr _v_deref__deref__item33 (Expr (_v_deref__item3, (0 + 1 + 1 + _v_len__pragma + 1 + 1 + 1)));
          int _v_len17 = _v_deref__deref__item3.get_len ();
          int _v_len18 = 0;
          if (_v_len17 < _v_len18)
          {
            goto _block2__branch1;
          }
          int _v_len__in = (_v_len17 - _v_len18);
          int _v_len19 = _v_deref__deref__item33.get_len ();
          int _v_len20 = 1;
          if (_v_len19 < _v_len20)
          {
            goto _block2__branch1;
          }
          int _v_len__branch = (_v_len19 - _v_len20);
          int _v_len21 = _v_deref__deref__item32.get_len ();
          int _v_len22 = 0;
          if (_v_len21 < _v_len22)
          {
            goto _block2__branch1;
          }
          int _v_len__out = (_v_len21 - _v_len22);
          if (!_v_deref__item3.symbol_at (0))
          {
            goto _block2__branch1;
          }
          if (!_v_deref__item3.symbol_at ((0 + 1)))
          {
            goto _block2__branch1;
          }
          if (!_c_2.term_eq (_v_deref__deref__item33, 0))
          {
            goto _block2__branch1;
          }
          Expr _vs_link;
          _vs_link = Expr (_v_deref__item3, 0, 1);
          Expr _vs_tag;
          _vs_tag = Expr (_v_deref__item3, (0 + 1), 1);
          Expr _ve_pragma;
          _ve_pragma = Expr (_v_deref__item3, (0 + 1 + 1), _v_len__pragma);
          Expr _vt_name;
          _vt_name = Expr (_v_deref__item3, (0 + 1 + 1 + _v_len__pragma), 1);
          Expr _ve_in;
          _ve_in = Expr (_v_deref__deref__item3, 0, _v_len__in);
          Expr _ve_out;
          _ve_out = Expr (_v_deref__deref__item32, 0, _v_len__out);
          Expr _ve_branch;
          _ve_branch = Expr (_v_deref__deref__item33, (0 + 1), _v_len__branch);
          Expr _ve_p;
          Expr _ge_branch__5;
          {
            {
              if (_v_len__pragma != 1)
              {
                goto _block5__branch1;
              }
              if (_ve_pragma.symbol_at (0))
              {
                goto _block5__branch1;
              }
              Expr _v_deref__pragma (Expr (_ve_pragma, 0));
              int _v_len23 = _v_deref__pragma.get_len ();
              int _v_len24 = 1;
              if (_v_len23 < _v_len24)
              {
                goto _block5__branch1;
              }
              int _v_len___dollar_tmp_m_63_m_29 = (_v_len23 - _v_len24);
              if (!_c_1.term_eq (_v_deref__pragma, 0))
              {
                goto _block5__branch1;
              }
              Expr _ve__dollar_tmp_m_63_m_29;
              _ve__dollar_tmp_m_63_m_29 = Expr (_v_deref__pragma, (0 + 1), _v_len___dollar_tmp_m_63_m_29);
              int _v_len25 = _v_len__branch;
              int _v_len26 = 1;
              if (_v_len25 < _v_len26)
              {
                goto _block1__branch1;
              }
              int _v_len__br = (_v_len25 - _v_len26);
              Expr _gt_p__6;
              _gt_p__6 = Expr (_ve_branch, 0, 1);
              Expr _ve_br;
              _ve_br = Expr (_ve_branch, (0 + 1), _v_len__br);
              _ve_p = _gt_p__6;
              _ge_branch__5 = _ve_br;
              goto _block5;
            }
          _block5__branch1: {}
            _ve_p = empty;
            _ge_branch__5 = _ve_branch;
          }
        _block5: {}
          Expr _ge_in__6;
          Expr _ge_branch__5__6;
          Expr _ge_auxcall1;
          RF_CALL (org::refal::plus::compiler::rfp_format::Format_Exp, _ve_in, _ge_auxcall1);
          RF_CALL (Generate_In_Vars, (_ge_auxcall1, _ge_branch__5), (_ge_in__6, _ge_branch__5__6));
          Expr _ge_in__6__7;
          Expr _ge_branch__5__6__7;
          {
            {
              if (!RF_CALL (::refal::Table::IsInTable, (org::refal::plus::compiler::rfp_helper::RFP_Options, _c_3), /*void*/))
              {
                goto _block7__branch1;
              }
              int _v_len27 = _ve_p.get_len ();
              int _v_len28 = 0;
              if (_v_len27 < (_v_len28 + 1))
              {
                goto _block7__branch1;
              }
              int _v_len___dollar_tmp_m_76_m_46 = (_v_len27 - _v_len28);
              Expr _vv__dollar_tmp_m_76_m_46;
              _vv__dollar_tmp_m_76_m_46 = Expr (_ve_p, 0, _v_len___dollar_tmp_m_76_m_46);
              Expr _ge_auxcall2;
              RF_CALL (org::refal::plus::compiler::rfp_helper::Del_Pragmas, _ge_in__6, _ge_auxcall2);
              Expr _ge_auxcall3;
              RF_CALL (org::refal::plus::compiler::rfp_debug::Add_Debug, ((_c_4 + _ve_p + _ge_in__6) () + _ge_branch__5__6), _ge_auxcall3);
              RF_CALL (org::refal::plus::compiler::rfp_helper::Del_Pragmas, _ge_auxcall3, _ge_branch__5__6__7);
              _ge_in__6__7 = _ge_auxcall2;
              goto _block7;
            }
          _block7__branch1: {}
            {
              int _v_len29 = _ve_p.get_len ();
              int _v_len30 = 0;
              if (_v_len29 < (_v_len30 + 1))
              {
                goto _block7__branch2;
              }
              int _v_len___dollar_tmp_m_78_m_16 = (_v_len29 - _v_len30);
              Expr _vv__dollar_tmp_m_78_m_16;
              _vv__dollar_tmp_m_78_m_16 = Expr (_ve_p, 0, _v_len___dollar_tmp_m_78_m_16);
              Expr _ge_auxcall4;
              RF_CALL (org::refal::plus::compiler::rfp_helper::Del_Pragmas, _ge_in__6, _ge_auxcall4);
              RF_CALL (org::refal::plus::compiler::rfp_helper::Del_Pragmas, _ge_branch__5__6, _ge_branch__5__6__7);
              _ge_in__6__7 = _ge_auxcall4;
              goto _block7;
            }
          _block7__branch2: {}
            _ge_in__6__7 = _ge_in__6;
            _ge_branch__5__6__7 = _ge_branch__5__6;
          }
        _block7: {}
          RF_CALL (::refal::Box::Store, (Free_Idx, _c_5), /*void*/);
          Expr _v_Unstick__Blocks1;
          RF_CALL (Unstick_Blocks, _ge_branch__5__6__7, (_ge_branch__5__6__7, _v_Unstick__Blocks1));
          Expr _vt__dollar_tmp_m_83_m_46 (_v_Unstick__Blocks1 ());
          Expr _ge_auxcall5;
          RF_CALL (org::refal::plus::compiler::rfp_vars::Vars, _ge_in__6__7, _ge_auxcall5);
          RF_CALL (Rename_Vars, (_c_6, _ge_auxcall5, empty, _ge_branch__5__6__7), _ge_branch__5__6__7);
          _ge_item__3 = (_vs_link + _vs_tag + _vt_name + _ge_in__6__7 () + _ve_out () + (_c_2 + _ge_branch__5__6__7) ()) ();
          goto _block2;
        }
      _block2__branch1: {}
        RF_CALL (org::refal::plus::compiler::rfp_helper::Del_Pragmas, _vt_item, _ge_item__3);
      }
    _block2: {}
      _v_res1 = _ge_item__3;
      _v_res2 = _ve_rest;
      goto _block1;
    }
  _block1__branch1: {}
    _v_res1 = empty;
    _v_res2 = empty;
  }
_block1: {}
RF_END

RF_FUNC (Unstick_Blocks, (RF_ARG _ve_Sentence;;), (RF_RES _v_res1, _v_res2;;))
  if (_ve_Sentence.get_len () < 0)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  RF_lsplit (_ve_Sentence, 0, _ve_L, _ve_Snt);
  for ( ; ; RF_iter(_ve_Sentence)++)
  {
    {
      if (!RF_iter(_ve_Sentence))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      if (_ve_Snt.get_len () < 0)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      {
        {
          int _v_len1 = _ve_Snt.get_len ();
          int _v_len2 = 1;
          if (_v_len1 < _v_len2)
          {
            goto _block1__branch1;
          }
          int _v_len__R = (_v_len1 - _v_len2);
          if (_ve_Snt.symbol_at (0))
          {
            goto _block1__branch1;
          }
          Expr _v_deref__Snt (Expr (_ve_Snt, 0));
          int _v_len3 = _v_deref__Snt.get_len ();
          int _v_len4 = 1;
          if (_v_len3 < _v_len4)
          {
            goto _block1__branch1;
          }
          int _v_len__branches = (_v_len3 - _v_len4);
          if (!_v_deref__Snt.symbol_at (0))
          {
            goto _block1__branch1;
          }
          Expr _ve_R;
          _ve_R = Expr (_ve_Snt, (0 + 1), _v_len__R);
          Expr _vs_block;
          _vs_block = Expr (_v_deref__Snt, 0, 1);
          Expr _ve_branches;
          _ve_branches = Expr (_v_deref__Snt, (0 + 1), _v_len__branches);
          {
            {
              if (!_vs_block.term_eq (_c_7, 0))
              {
                goto _block2__branch1;
              }
              goto _block2;
            }
          _block2__branch1: {}
            if (!_vs_block.term_eq (_c_8, 0))
            {
              goto _block1__branch1;
            }
          }
        _block2: {}
          Expr _ve_br;
          Expr _ve_Fes;
          for ( ; ; )
          {
            {
              if (_ve_branches.get_len () != 0)
              {
                goto _iter1;
              }
              {
                {
                  {
                    {
                      int _v_len5 = _v_len__R;
                      int _v_len6 = 1;
                      if (_v_len5 < _v_len6)
                      {
                        goto _block4__branch1;
                      }
                      int _v_len___dollar_tmp_m_112_m_41 = (_v_len5 - _v_len6);
                      if (_ve_R.symbol_at (0))
                      {
                        goto _block4__branch1;
                      }
                      Expr _v_deref__R (Expr (_ve_R, 0));
                      int _v_len7 = _v_deref__R.get_len ();
                      int _v_len8 = 2;
                      if (_v_len7 < _v_len8)
                      {
                        goto _block4__branch1;
                      }
                      int _v_len___dollar_tmp_m_112_m_38 = (_v_len7 - _v_len8);
                      if (_v_deref__R.symbol_at ((0 + 1)))
                      {
                        goto _block4__branch1;
                      }
                      Expr _v_deref__deref__R (Expr (_v_deref__R, (0 + 1)));
                      int _v_len9 = _v_deref__deref__R.get_len ();
                      int _v_len10 = 2;
                      if (_v_len9 < _v_len10)
                      {
                        goto _block4__branch1;
                      }
                      int _v_len___dollar_tmp_m_112_m_35 = (_v_len9 - _v_len10);
                      if (_v_deref__deref__R.symbol_at ((0 + 1)))
                      {
                        goto _block4__branch1;
                      }
                      Expr _v_deref__deref__deref__R (Expr (_v_deref__deref__R, (0 + 1)));
                      int _v_len11 = _v_deref__deref__deref__R.get_len ();
                      int _v_len12 = 1;
                      if (_v_len11 < _v_len12)
                      {
                        goto _block4__branch1;
                      }
                      int _v_len___dollar_tmp_m_112_m_32 = (_v_len11 - _v_len12);
                      if (!_c_7.term_eq (_v_deref__R, 0))
                      {
                        goto _block4__branch1;
                      }
                      if (!_c_2.term_eq (_v_deref__deref__R, 0))
                      {
                        goto _block4__branch1;
                      }
                      if (!_c_9.term_eq (_v_deref__deref__deref__R, 0))
                      {
                        goto _block4__branch1;
                      }
                      Expr _ve__dollar_tmp_m_112_m_41;
                      _ve__dollar_tmp_m_112_m_41 = Expr (_ve_R, (0 + 1), _v_len___dollar_tmp_m_112_m_41);
                      Expr _ve__dollar_tmp_m_112_m_38;
                      _ve__dollar_tmp_m_112_m_38 = Expr (_v_deref__R, (0 + 1 + 1), _v_len___dollar_tmp_m_112_m_38);
                      Expr _ve__dollar_tmp_m_112_m_35;
                      _ve__dollar_tmp_m_112_m_35 = Expr (_v_deref__deref__R, (0 + 1 + 1), _v_len___dollar_tmp_m_112_m_35);
                      Expr _ve__dollar_tmp_m_112_m_32;
                      _ve__dollar_tmp_m_112_m_32 = Expr (_v_deref__deref__deref__R, (0 + 1), _v_len___dollar_tmp_m_112_m_32);
                      goto _block4;
                    }
                  _block4__branch1: {}
                    {
                      int _v_len13 = _v_len__R;
                      int _v_len14 = 1;
                      if (_v_len13 < _v_len14)
                      {
                        goto _block4__branch2;
                      }
                      int _v_len___dollar_tmp_m_113_m_42 = (_v_len13 - _v_len14);
                      if (_ve_R.symbol_at (0))
                      {
                        goto _block4__branch2;
                      }
                      Expr _v_deref__R2 (Expr (_ve_R, 0));
                      int _v_len15 = _v_deref__R2.get_len ();
                      int _v_len16 = 2;
                      if (_v_len15 < _v_len16)
                      {
                        goto _block4__branch2;
                      }
                      int _v_len___dollar_tmp_m_113_m_39 = (_v_len15 - _v_len16);
                      if (_v_deref__R2.symbol_at ((0 + 1)))
                      {
                        goto _block4__branch2;
                      }
                      Expr _v_deref__deref__R2 (Expr (_v_deref__R2, (0 + 1)));
                      int _v_len17 = _v_deref__deref__R2.get_len ();
                      int _v_len18 = 2;
                      if (_v_len17 < _v_len18)
                      {
                        goto _block4__branch2;
                      }
                      int _v_len___dollar_tmp_m_113_m_36 = (_v_len17 - _v_len18);
                      if (_v_deref__deref__R2.symbol_at ((0 + 1)))
                      {
                        goto _block4__branch2;
                      }
                      Expr _v_deref__deref__deref__R2 (Expr (_v_deref__deref__R2, (0 + 1)));
                      int _v_len19 = _v_deref__deref__deref__R2.get_len ();
                      int _v_len20 = 1;
                      if (_v_len19 < _v_len20)
                      {
                        goto _block4__branch2;
                      }
                      int _v_len___dollar_tmp_m_113_m_33 = (_v_len19 - _v_len20);
                      if (!_c_7.term_eq (_v_deref__R2, 0))
                      {
                        goto _block4__branch2;
                      }
                      if (!_c_2.term_eq (_v_deref__deref__R2, 0))
                      {
                        goto _block4__branch2;
                      }
                      if (!_c_10.term_eq (_v_deref__deref__deref__R2, 0))
                      {
                        goto _block4__branch2;
                      }
                      Expr _ve__dollar_tmp_m_113_m_42;
                      _ve__dollar_tmp_m_113_m_42 = Expr (_ve_R, (0 + 1), _v_len___dollar_tmp_m_113_m_42);
                      Expr _ve__dollar_tmp_m_113_m_39;
                      _ve__dollar_tmp_m_113_m_39 = Expr (_v_deref__R2, (0 + 1 + 1), _v_len___dollar_tmp_m_113_m_39);
                      Expr _ve__dollar_tmp_m_113_m_36;
                      _ve__dollar_tmp_m_113_m_36 = Expr (_v_deref__deref__R2, (0 + 1 + 1), _v_len___dollar_tmp_m_113_m_36);
                      Expr _ve__dollar_tmp_m_113_m_33;
                      _ve__dollar_tmp_m_113_m_33 = Expr (_v_deref__deref__deref__R2, (0 + 1), _v_len___dollar_tmp_m_113_m_33);
                      goto _block4;
                    }
                  _block4__branch2: {}
                    {
                      int _v_len21 = _v_len__R;
                      int _v_len22 = 1;
                      if (_v_len21 < _v_len22)
                      {
                        goto _block4__branch3;
                      }
                      int _v_len___dollar_tmp_m_114_m_41 = (_v_len21 - _v_len22);
                      if (_ve_R.symbol_at (0))
                      {
                        goto _block4__branch3;
                      }
                      Expr _v_deref__R3 (Expr (_ve_R, 0));
                      int _v_len23 = _v_deref__R3.get_len ();
                      int _v_len24 = 2;
                      if (_v_len23 < _v_len24)
                      {
                        goto _block4__branch3;
                      }
                      int _v_len___dollar_tmp_m_114_m_38 = (_v_len23 - _v_len24);
                      if (_v_deref__R3.symbol_at ((0 + 1)))
                      {
                        goto _block4__branch3;
                      }
                      Expr _v_deref__deref__R3 (Expr (_v_deref__R3, (0 + 1)));
                      int _v_len25 = _v_deref__deref__R3.get_len ();
                      int _v_len26 = 2;
                      if (_v_len25 < _v_len26)
                      {
                        goto _block4__branch3;
                      }
                      int _v_len___dollar_tmp_m_114_m_35 = (_v_len25 - _v_len26);
                      if (_v_deref__deref__R3.symbol_at ((0 + 1)))
                      {
                        goto _block4__branch3;
                      }
                      Expr _v_deref__deref__deref__R3 (Expr (_v_deref__deref__R3, (0 + 1)));
                      int _v_len27 = _v_deref__deref__deref__R3.get_len ();
                      int _v_len28 = 1;
                      if (_v_len27 < _v_len28)
                      {
                        goto _block4__branch3;
                      }
                      int _v_len___dollar_tmp_m_114_m_32 = (_v_len27 - _v_len28);
                      if (!_c_8.term_eq (_v_deref__R3, 0))
                      {
                        goto _block4__branch3;
                      }
                      if (!_c_2.term_eq (_v_deref__deref__R3, 0))
                      {
                        goto _block4__branch3;
                      }
                      if (!_c_9.term_eq (_v_deref__deref__deref__R3, 0))
                      {
                        goto _block4__branch3;
                      }
                      Expr _ve__dollar_tmp_m_114_m_41;
                      _ve__dollar_tmp_m_114_m_41 = Expr (_ve_R, (0 + 1), _v_len___dollar_tmp_m_114_m_41);
                      Expr _ve__dollar_tmp_m_114_m_38;
                      _ve__dollar_tmp_m_114_m_38 = Expr (_v_deref__R3, (0 + 1 + 1), _v_len___dollar_tmp_m_114_m_38);
                      Expr _ve__dollar_tmp_m_114_m_35;
                      _ve__dollar_tmp_m_114_m_35 = Expr (_v_deref__deref__R3, (0 + 1 + 1), _v_len___dollar_tmp_m_114_m_35);
                      Expr _ve__dollar_tmp_m_114_m_32;
                      _ve__dollar_tmp_m_114_m_32 = Expr (_v_deref__deref__deref__R3, (0 + 1), _v_len___dollar_tmp_m_114_m_32);
                      goto _block4;
                    }
                  _block4__branch3: {}
                    {
                      int _v_len29 = _v_len__R;
                      int _v_len30 = 1;
                      if (_v_len29 < _v_len30)
                      {
                        goto _block4__branch4;
                      }
                      int _v_len___dollar_tmp_m_115_m_42 = (_v_len29 - _v_len30);
                      if (_ve_R.symbol_at (0))
                      {
                        goto _block4__branch4;
                      }
                      Expr _v_deref__R4 (Expr (_ve_R, 0));
                      int _v_len31 = _v_deref__R4.get_len ();
                      int _v_len32 = 2;
                      if (_v_len31 < _v_len32)
                      {
                        goto _block4__branch4;
                      }
                      int _v_len___dollar_tmp_m_115_m_39 = (_v_len31 - _v_len32);
                      if (_v_deref__R4.symbol_at ((0 + 1)))
                      {
                        goto _block4__branch4;
                      }
                      Expr _v_deref__deref__R4 (Expr (_v_deref__R4, (0 + 1)));
                      int _v_len33 = _v_deref__deref__R4.get_len ();
                      int _v_len34 = 2;
                      if (_v_len33 < _v_len34)
                      {
                        goto _block4__branch4;
                      }
                      int _v_len___dollar_tmp_m_115_m_36 = (_v_len33 - _v_len34);
                      if (_v_deref__deref__R4.symbol_at ((0 + 1)))
                      {
                        goto _block4__branch4;
                      }
                      Expr _v_deref__deref__deref__R4 (Expr (_v_deref__deref__R4, (0 + 1)));
                      int _v_len35 = _v_deref__deref__deref__R4.get_len ();
                      int _v_len36 = 1;
                      if (_v_len35 < _v_len36)
                      {
                        goto _block4__branch4;
                      }
                      int _v_len___dollar_tmp_m_115_m_33 = (_v_len35 - _v_len36);
                      if (!_c_8.term_eq (_v_deref__R4, 0))
                      {
                        goto _block4__branch4;
                      }
                      if (!_c_2.term_eq (_v_deref__deref__R4, 0))
                      {
                        goto _block4__branch4;
                      }
                      if (!_c_10.term_eq (_v_deref__deref__deref__R4, 0))
                      {
                        goto _block4__branch4;
                      }
                      Expr _ve__dollar_tmp_m_115_m_42;
                      _ve__dollar_tmp_m_115_m_42 = Expr (_ve_R, (0 + 1), _v_len___dollar_tmp_m_115_m_42);
                      Expr _ve__dollar_tmp_m_115_m_39;
                      _ve__dollar_tmp_m_115_m_39 = Expr (_v_deref__R4, (0 + 1 + 1), _v_len___dollar_tmp_m_115_m_39);
                      Expr _ve__dollar_tmp_m_115_m_36;
                      _ve__dollar_tmp_m_115_m_36 = Expr (_v_deref__deref__R4, (0 + 1 + 1), _v_len___dollar_tmp_m_115_m_36);
                      Expr _ve__dollar_tmp_m_115_m_33;
                      _ve__dollar_tmp_m_115_m_33 = Expr (_v_deref__deref__deref__R4, (0 + 1), _v_len___dollar_tmp_m_115_m_33);
                      goto _block4;
                    }
                  _block4__branch4: {}
                    {
                      int _v_len37 = _v_len__R;
                      int _v_len38 = 1;
                      if (_v_len37 < _v_len38)
                      {
                        goto _block4__branch5;
                      }
                      int _v_len___dollar_tmp_m_116_m_20 = (_v_len37 - _v_len38);
                      if (_ve_R.symbol_at (0))
                      {
                        goto _block4__branch5;
                      }
                      Expr _v_deref__R5 (Expr (_ve_R, 0));
                      int _v_len39 = _v_deref__R5.get_len ();
                      int _v_len40 = 1;
                      if (_v_len39 < _v_len40)
                      {
                        goto _block4__branch5;
                      }
                      int _v_len___dollar_tmp_m_116_m_17 = (_v_len39 - _v_len40);
                      if (!_c_9.term_eq (_v_deref__R5, 0))
                      {
                        goto _block4__branch5;
                      }
                      Expr _ve__dollar_tmp_m_116_m_20;
                      _ve__dollar_tmp_m_116_m_20 = Expr (_ve_R, (0 + 1), _v_len___dollar_tmp_m_116_m_20);
                      Expr _ve__dollar_tmp_m_116_m_17;
                      _ve__dollar_tmp_m_116_m_17 = Expr (_v_deref__R5, (0 + 1), _v_len___dollar_tmp_m_116_m_17);
                      goto _block4;
                    }
                  _block4__branch5: {}
                    int _v_len41 = _v_len__R;
                    int _v_len42 = 1;
                    if (_v_len41 < _v_len42)
                    {
                      goto _block3__branch1;
                    }
                    int _v_len___dollar_tmp_m_117_m_20 = (_v_len41 - _v_len42);
                    if (_ve_R.symbol_at (0))
                    {
                      goto _block3__branch1;
                    }
                    Expr _v_deref__R6 (Expr (_ve_R, 0));
                    int _v_len43 = _v_deref__R6.get_len ();
                    int _v_len44 = 1;
                    if (_v_len43 < _v_len44)
                    {
                      goto _block3__branch1;
                    }
                    int _v_len___dollar_tmp_m_117_m_17 = (_v_len43 - _v_len44);
                    if (!_c_10.term_eq (_v_deref__R6, 0))
                    {
                      goto _block3__branch1;
                    }
                    Expr _ve__dollar_tmp_m_117_m_20;
                    _ve__dollar_tmp_m_117_m_20 = Expr (_ve_R, (0 + 1), _v_len___dollar_tmp_m_117_m_20);
                    Expr _ve__dollar_tmp_m_117_m_17;
                    _ve__dollar_tmp_m_117_m_17 = Expr (_v_deref__R6, (0 + 1), _v_len___dollar_tmp_m_117_m_17);
                  }
                _block4: {}
                  Expr _v_Get1;
                  RF_CALL (::refal::Box::Get, Free_Idx, _v_Get1);
                  if (_v_Get1.get_len () != 1)
                  {
                    RF_FUNC_ERROR (unexpected_fail);
                  }
                  if (!_v_Get1.symbol_at (0))
                  {
                    RF_FUNC_ERROR (unexpected_fail);
                  }
                  Expr _vs_N;
                  _vs_N = Expr (_v_Get1, 0, 1);
                  Expr _ge_auxcall1;
                  RF_CALL (org::refal::plus::compiler::rfp_format::MSG, _ve_Fes, _ge_auxcall1);
                  Expr _ve_aux;
                  RF_CALL (org::refal::plus::compiler::rfp_vars::Gener_Var_Indices, (_vs_N, _ge_auxcall1, _c_11), (_ve_aux, _vs_N));
                  RF_CALL (::refal::Box::Store, (Free_Idx, _vs_N), /*void*/);
                  RF_CALL (org::refal::plus::compiler::rfp_helper::Del_Pragmas, _ve_aux, _ve_aux);
                  Expr _v_Unstick__Blocks1;
                  RF_CALL (Unstick_Blocks, _ve_R, (_v_Unstick__Blocks1, _v_res2));
                  _v_res1 = (_ve_L + (_vs_block + _ve_br) () + (_c_12 + _ve_aux) () + (_c_4 + _ve_aux) () + _v_Unstick__Blocks1);
                  goto _block3;
                }
              _block3__branch1: {}
                {
                  if (_v_len__R != 0)
                  {
                    goto _block3__branch2;
                  }
                  Expr _ge_auxcall2;
                  RF_CALL (org::refal::plus::compiler::rfp_format::MSG, _ve_Fes, _ge_auxcall2);
                  _v_res1 = (_ve_L + (_vs_block + _ve_br) ());
                  _v_res2 = _ge_auxcall2;
                  goto _block3;
                }
              _block3__branch2: {}
                Expr _v_Unstick__Blocks2;
                RF_CALL (Unstick_Blocks, _ve_R, (_v_Unstick__Blocks2, _v_res2));
                _v_res1 = (_ve_L + (_vs_block + _ve_br) () + _v_Unstick__Blocks2);
              }
            _block3: {}
              goto _exit__iter1;
            }
          _iter1: {}
            int _v_len45 = _ve_branches.get_len ();
            int _v_len46 = 1;
            if (_v_len45 < _v_len46)
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            int _v_len__rest = (_v_len45 - _v_len46);
            if (_ve_branches.symbol_at (0))
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            Expr _v_deref__branches (Expr (_ve_branches, 0));
            int _v_len47 = _v_deref__branches.get_len ();
            int _v_len48 = 1;
            if (_v_len47 < _v_len48)
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            int _v_len__branch = (_v_len47 - _v_len48);
            if (!_c_2.term_eq (_v_deref__branches, 0))
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            Expr _ve_rest;
            _ve_rest = Expr (_ve_branches, (0 + 1), _v_len__rest);
            Expr _ve_branch;
            _ve_branch = Expr (_v_deref__branches, (0 + 1), _v_len__branch);
            Expr _ve_new__branch;
            Expr _ve_Fe;
            RF_CALL (Unstick_Blocks, _ve_branch, (_ve_new__branch, _ve_Fe));
            _ve_branches = _ve_rest;
            _ve_br = (_ve_br + (_c_2 + _ve_new__branch) ());
            _ve_Fes = (_ve_Fes + _ve_Fe ());
          }
        _exit__iter1: {}
          goto _block1;
        }
      _block1__branch1: {}
        {
          int _v_len49 = _ve_Snt.get_len ();
          int _v_len50 = 1;
          if (_v_len49 < _v_len50)
          {
            goto _block1__branch2;
          }
          int _v_len__R2 = (_v_len49 - _v_len50);
          if (_ve_Snt.symbol_at (0))
          {
            goto _block1__branch2;
          }
          Expr _v_deref__Snt2 (Expr (_ve_Snt, 0));
          if (_v_deref__Snt2.get_len () != 2)
          {
            goto _block1__branch2;
          }
          if (_v_deref__Snt2.symbol_at ((0 + 1)))
          {
            goto _block1__branch2;
          }
          Expr _v_deref__deref__Snt2 (Expr (_v_deref__Snt2, (0 + 1)));
          int _v_len51 = _v_deref__deref__Snt2.get_len ();
          int _v_len52 = 1;
          if (_v_len51 < _v_len52)
          {
            goto _block1__branch2;
          }
          int _v_len__branches2 = (_v_len51 - _v_len52);
          if (!_c_4.term_eq (_v_deref__Snt2, 0))
          {
            goto _block1__branch2;
          }
          if (!_v_deref__deref__Snt2.symbol_at (0))
          {
            goto _block1__branch2;
          }
          Expr _ve_R;
          _ve_R = Expr (_ve_Snt, (0 + 1), _v_len__R2);
          Expr _vs_block;
          _vs_block = Expr (_v_deref__deref__Snt2, 0, 1);
          Expr _ve_branches;
          _ve_branches = Expr (_v_deref__deref__Snt2, (0 + 1), _v_len__branches2);
          {
            {
              if (!_vs_block.term_eq (_c_7, 0))
              {
                goto _block6__branch1;
              }
              goto _block6;
            }
          _block6__branch1: {}
            if (!_vs_block.term_eq (_c_8, 0))
            {
              goto _block1__branch2;
            }
          }
        _block6: {}
          Expr _v_Unstick__Blocks3;
          RF_CALL (Unstick_Blocks, ((_vs_block + _ve_branches) () + _ve_R), (_v_Unstick__Blocks3, _v_res2));
          _v_res1 = (_ve_L + _v_Unstick__Blocks3);
          goto _block1;
        }
      _block1__branch2: {}
        {
          int _v_len53 = _ve_Snt.get_len ();
          int _v_len54 = 1;
          if (_v_len53 < _v_len54)
          {
            goto _block1__branch3;
          }
          int _v_len__R3 = (_v_len53 - _v_len54);
          if (_ve_Snt.symbol_at (0))
          {
            goto _block1__branch3;
          }
          Expr _v_deref__Snt3 (Expr (_ve_Snt, 0));
          int _v_len55 = _v_deref__Snt3.get_len ();
          int _v_len56 = 1;
          if (_v_len55 < _v_len56)
          {
            goto _block1__branch3;
          }
          int _v_len__Re = (_v_len55 - _v_len56);
          if (!_c_4.term_eq (_v_deref__Snt3, 0))
          {
            goto _block1__branch3;
          }
          Expr _ve_R;
          _ve_R = Expr (_ve_Snt, (0 + 1), _v_len__R3);
          Expr _ve_Re;
          _ve_Re = Expr (_v_deref__Snt3, (0 + 1), _v_len__Re);
          Expr _ve_assigns;
          RF_CALL (Flatten_Result, (_c_13, empty, _ve_Re), (_ve_assigns, _ve_Re));
          Expr _ve_Result;
          {
            {
              int _v_len57 = _ve_Re.get_len ();
              int _v_len58 = 1;
              if (_v_len57 < _v_len58)
              {
                goto _block7__branch1;
              }
              int _v_len__1 = (_v_len57 - _v_len58);
              if (_ve_Re.symbol_at ((0 + _v_len__1)))
              {
                goto _block7__branch1;
              }
              Expr _v_deref__Re (Expr (_ve_Re, (0 + _v_len__1)));
              int _v_len59 = _v_deref__Re.get_len ();
              int _v_len60 = 1;
              if (_v_len59 < _v_len60)
              {
                goto _block7__branch1;
              }
              int _v_len__2 = (_v_len59 - _v_len60);
              if (!_c_14.term_eq (_v_deref__Re, 0))
              {
                goto _block7__branch1;
              }
              Expr _ve_1;
              _ve_1 = Expr (_ve_Re, 0, _v_len__1);
              Expr _ve_2;
              _ve_2 = Expr (_v_deref__Re, (0 + 1), _v_len__2);
              _ve_Result = ((_c_4 + _ve_1) () + _ve_2);
              goto _block7;
            }
          _block7__branch1: {}
            _ve_Result = (_c_4 + _ve_Re) ();
          }
        _block7: {}
          {
            {
              int _v_len61 = _v_len__R3;
              int _v_len62 = 0;
              if (_v_len61 < (_v_len62 + 1))
              {
                goto _block8__branch1;
              }
              int _v_len___dollar_tmp_m_138_m_13 = (_v_len61 - _v_len62);
              Expr _vv__dollar_tmp_m_138_m_13;
              _vv__dollar_tmp_m_138_m_13 = Expr (_ve_R, 0, _v_len___dollar_tmp_m_138_m_13);
              Expr _v_Unstick__Blocks4;
              RF_CALL (Unstick_Blocks, _ve_R, (_v_Unstick__Blocks4, _v_res2));
              _v_res1 = (_ve_L + _ve_assigns + _ve_Result + _v_Unstick__Blocks4);
              goto _block8;
            }
          _block8__branch1: {}
            Expr _ve_Fe;
            RF_CALL (org::refal::plus::compiler::rfp_format::Format_Exp, _ve_Re, _ve_Fe);
            RF_CALL (org::refal::plus::compiler::rfp_format::MSG, (_ve_Fe () + _ve_Fe ()), _ve_Fe);
            _v_res1 = (_ve_L + _ve_assigns + _ve_Result);
            _v_res2 = _ve_Fe;
          }
        _block8: {}
          goto _block1;
        }
      _block1__branch3: {}
        {
          int _v_len63 = _ve_Snt.get_len ();
          int _v_len64 = 1;
          if (_v_len63 < _v_len64)
          {
            goto _block1__branch4;
          }
          int _v_len__R4 = (_v_len63 - _v_len64);
          if (_ve_Snt.symbol_at (0))
          {
            goto _block1__branch4;
          }
          Expr _v_deref__Snt4 (Expr (_ve_Snt, 0));
          if (_v_deref__Snt4.get_len () != 2)
          {
            goto _block1__branch4;
          }
          if (_v_deref__Snt4.symbol_at ((0 + 1)))
          {
            goto _block1__branch4;
          }
          Expr _v_deref__deref__Snt4 (Expr (_v_deref__Snt4, (0 + 1)));
          int _v_len65 = _v_deref__deref__Snt4.get_len ();
          int _v_len66 = 1;
          if (_v_len65 < _v_len66)
          {
            goto _block1__branch4;
          }
          int _v_len__body = (_v_len65 - _v_len66);
          if (!_c_15.term_eq (_v_deref__Snt4, 0))
          {
            goto _block1__branch4;
          }
          if (!_c_2.term_eq (_v_deref__deref__Snt4, 0))
          {
            goto _block1__branch4;
          }
          Expr _ve_R;
          _ve_R = Expr (_ve_Snt, (0 + 1), _v_len__R4);
          Expr _ve_body;
          _ve_body = Expr (_v_deref__deref__Snt4, (0 + 1), _v_len__body);
          Expr _v_Unstick__Blocks5;
          RF_CALL (Unstick_Blocks, _ve_body, (_ve_body, _v_Unstick__Blocks5));
          Expr _vt_empty (_v_Unstick__Blocks5 ());
          Expr _v_Unstick__Blocks6;
          RF_CALL (Unstick_Blocks, _ve_R, (_v_Unstick__Blocks6, _v_res2));
          _v_res1 = (_ve_L + (_c_15 + (_c_2 + _ve_body) ()) () + _v_Unstick__Blocks6);
          goto _block1;
        }
      _block1__branch4: {}
        {
          int _v_len67 = _ve_Snt.get_len ();
          int _v_len68 = 1;
          if (_v_len67 < _v_len68)
          {
            goto _block1__branch5;
          }
          int _v_len__R5 = (_v_len67 - _v_len68);
          if (_ve_Snt.symbol_at (0))
          {
            goto _block1__branch5;
          }
          Expr _v_deref__Snt5 (Expr (_ve_Snt, 0));
          if (_v_deref__Snt5.get_len () != 3)
          {
            goto _block1__branch5;
          }
          if (_v_deref__Snt5.symbol_at ((0 + 1)))
          {
            goto _block1__branch5;
          }
          Expr _v_deref__deref__Snt5 (Expr (_v_deref__Snt5, (0 + 1)));
          int _v_len69 = _v_deref__deref__Snt5.get_len ();
          int _v_len70 = 1;
          if (_v_len69 < _v_len70)
          {
            goto _block1__branch5;
          }
          int _v_len__body2 = (_v_len69 - _v_len70);
          if (!_c_16.term_eq (_v_deref__Snt5, 0))
          {
            goto _block1__branch5;
          }
          if (!_c_2.term_eq (_v_deref__deref__Snt5, 0))
          {
            goto _block1__branch5;
          }
          Expr _ve_R;
          _ve_R = Expr (_ve_Snt, (0 + 1), _v_len__R5);
          Expr _vt_IterVars;
          _vt_IterVars = Expr (_v_deref__Snt5, (0 + 1 + 1), 1);
          Expr _ve_body;
          _ve_body = Expr (_v_deref__deref__Snt5, (0 + 1), _v_len__body2);
          Expr _v_Unstick__Blocks7;
          RF_CALL (Unstick_Blocks, _ve_body, (_ve_body, _v_Unstick__Blocks7));
          Expr _vt__dollar_tmp_m_148_m_40 (_v_Unstick__Blocks7 ());
          Expr _v_Unstick__Blocks8;
          RF_CALL (Unstick_Blocks, _ve_R, (_v_Unstick__Blocks8, _v_res2));
          _v_res1 = (_ve_L + (_c_16 + (_c_2 + _ve_body) () + _vt_IterVars) () + _v_Unstick__Blocks8);
          goto _block1;
        }
      _block1__branch5: {}
        {
          if (_ve_Snt.get_len () != 1)
          {
            goto _block1__branch6;
          }
          if (_ve_Snt.symbol_at (0))
          {
            goto _block1__branch6;
          }
          Expr _v_deref__Snt6 (Expr (_ve_Snt, 0));
          if (_v_deref__Snt6.get_len () != 3)
          {
            goto _block1__branch6;
          }
          if (_v_deref__Snt6.symbol_at ((0 + 1)))
          {
            goto _block1__branch6;
          }
          if (_v_deref__Snt6.symbol_at ((0 + 1 + 1)))
          {
            goto _block1__branch6;
          }
          Expr _v_deref__deref__Snt6 (Expr (_v_deref__Snt6, (0 + 1)));
          Expr _v_deref__deref__Snt62 (Expr (_v_deref__Snt6, (0 + 1 + 1)));
          int _v_len71 = _v_deref__deref__Snt62.get_len ();
          int _v_len72 = 1;
          if (_v_len71 < _v_len72)
          {
            goto _block1__branch6;
          }
          int _v_len__CatchSnt = (_v_len71 - _v_len72);
          int _v_len73 = _v_deref__deref__Snt6.get_len ();
          int _v_len74 = 1;
          if (_v_len73 < _v_len74)
          {
            goto _block1__branch6;
          }
          int _v_len__TrySnt = (_v_len73 - _v_len74);
          if (!_c_17.term_eq (_v_deref__Snt6, 0))
          {
            goto _block1__branch6;
          }
          if (!_c_2.term_eq (_v_deref__deref__Snt6, 0))
          {
            goto _block1__branch6;
          }
          if (!_c_2.term_eq (_v_deref__deref__Snt62, 0))
          {
            goto _block1__branch6;
          }
          Expr _ve_TrySnt;
          _ve_TrySnt = Expr (_v_deref__deref__Snt6, (0 + 1), _v_len__TrySnt);
          Expr _ve_CatchSnt;
          _ve_CatchSnt = Expr (_v_deref__deref__Snt62, (0 + 1), _v_len__CatchSnt);
          Expr _v_Unstick__Blocks9;
          RF_CALL (Unstick_Blocks, _ve_TrySnt, (_ve_TrySnt, _v_Unstick__Blocks9));
          Expr _vt_Try__Fe (_v_Unstick__Blocks9 ());
          Expr _v_Unstick__Blocks10;
          RF_CALL (Unstick_Blocks, _ve_CatchSnt, (_ve_CatchSnt, _v_Unstick__Blocks10));
          Expr _vt_Catch__Fe (_v_Unstick__Blocks10 ());
          Expr _ge_auxcall3;
          RF_CALL (org::refal::plus::compiler::rfp_format::MSG, (_vt_Try__Fe + _vt_Catch__Fe), _ge_auxcall3);
          _v_res1 = (_ve_L + (_c_17 + (_c_2 + _ve_TrySnt) () + (_c_2 + _ve_CatchSnt) ()) ());
          _v_res2 = _ge_auxcall3;
          goto _block1;
        }
      _block1__branch6: {}
        {
          if (_ve_Snt.get_len () != 1)
          {
            goto _block1__branch7;
          }
          if (_ve_Snt.symbol_at (0))
          {
            goto _block1__branch7;
          }
          Expr _v_deref__Snt7 (Expr (_ve_Snt, 0));
          if (_v_deref__Snt7.get_len () != 2)
          {
            goto _block1__branch7;
          }
          if (_v_deref__Snt7.symbol_at ((0 + 1)))
          {
            goto _block1__branch7;
          }
          Expr _v_deref__deref__Snt7 (Expr (_v_deref__Snt7, (0 + 1)));
          int _v_len75 = _v_deref__deref__Snt7.get_len ();
          int _v_len76 = 1;
          if (_v_len75 < _v_len76)
          {
            goto _block1__branch7;
          }
          int _v_len__Err = (_v_len75 - _v_len76);
          if (!_c_18.term_eq (_v_deref__Snt7, 0))
          {
            goto _block1__branch7;
          }
          if (!_c_2.term_eq (_v_deref__deref__Snt7, 0))
          {
            goto _block1__branch7;
          }
          Expr _ve_Err;
          _ve_Err = Expr (_v_deref__deref__Snt7, (0 + 1), _v_len__Err);
          Expr _v_Unstick__Blocks11;
          RF_CALL (Unstick_Blocks, _ve_Err, (_ve_Err, _v_Unstick__Blocks11));
          Expr _vt__dollar_tmp_m_155_m_36 (_v_Unstick__Blocks11 ());
          _v_res1 = (_ve_L + (_c_18 + (_c_2 + _ve_Err) ()) ());
          _v_res2 = _c_19;
          goto _block1;
        }
      _block1__branch7: {}
        {
          if (_ve_Snt.get_len () != 1)
          {
            goto _block1__branch8;
          }
          if (!_c_19.term_eq (_ve_Snt, 0))
          {
            goto _block1__branch8;
          }
          _v_res1 = _ve_Sentence;
          _v_res2 = _c_19;
          goto _block1;
        }
      _block1__branch8: {}
        if (_ve_Snt.get_len () != 0)
        {
          goto _continue1;
        }
        _v_res1 = empty;
        _v_res2 = empty;
      }
    _block1: {}
      goto _exit1;
    }
_continue1: {}
  }
_exit1: {}
RF_END

RF_FUNC (Flatten_Result, (RF_ARG _vs_Istail, _ve_Re, _ve_items;;), (RF_RES _v_res1, _v_res2;;))
  {
    {
      int _v_len1 = _ve_items.get_len ();
      int _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      int _v_len__rest = (_v_len1 - _v_len2);
      Expr _vt_1;
      _vt_1 = Expr (_ve_items, 0, 1);
      Expr _ve_rest;
      _ve_rest = Expr (_ve_items, (0 + 1), _v_len__rest);
      {
        {
          if (_vt_1.symbol_at (0))
          {
            goto _block2__branch1;
          }
          Expr _v_deref__1 (Expr (_vt_1, 0));
          int _v_len3 = _v_deref__1.get_len ();
          int _v_len4 = 1;
          if (_v_len3 < _v_len4)
          {
            goto _block2__branch1;
          }
          int _v_len___dollar_tmp_m_162_m_28 = (_v_len3 - _v_len4);
          if (!_c_7.term_eq (_v_deref__1, 0))
          {
            goto _block2__branch1;
          }
          Expr _ve__dollar_tmp_m_162_m_28;
          _ve__dollar_tmp_m_162_m_28 = Expr (_v_deref__1, (0 + 1), _v_len___dollar_tmp_m_162_m_28);
          goto _block2;
        }
      _block2__branch1: {}
        if (_vt_1.symbol_at (0))
        {
          goto _block1__branch1;
        }
        Expr _v_deref__12 (Expr (_vt_1, 0));
        int _v_len5 = _v_deref__12.get_len ();
        int _v_len6 = 1;
        if (_v_len5 < _v_len6)
        {
          goto _block1__branch1;
        }
        int _v_len___dollar_tmp_m_162_m_40 = (_v_len5 - _v_len6);
        if (!_c_8.term_eq (_v_deref__12, 0))
        {
          goto _block1__branch1;
        }
        Expr _ve__dollar_tmp_m_162_m_40;
        _ve__dollar_tmp_m_162_m_40 = Expr (_v_deref__12, (0 + 1), _v_len___dollar_tmp_m_162_m_40);
      }
    _block2: {}
      Expr _ve_1;
      Expr _ve_Format;
      RF_CALL (Unstick_Blocks, _vt_1, (_ve_1, _ve_Format));
      {
        {
          if (_ve_Format.get_len () != 1)
          {
            goto _block3__branch1;
          }
          if (!_c_19.term_eq (_ve_Format, 0))
          {
            goto _block3__branch1;
          }
          _v_res1 = empty;
          _v_res2 = (_ve_Re + (_c_14 + _ve_1) ());
          goto _block3;
        }
      _block3__branch1: {}
        Expr _v_Get1;
        RF_CALL (::refal::Box::Get, Free_Idx, _v_Get1);
        if (_v_Get1.get_len () != 1)
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        if (!_v_Get1.symbol_at (0))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        Expr _vs_N;
        _vs_N = Expr (_v_Get1, 0, 1);
        Expr _ve_aux;
        RF_CALL (org::refal::plus::compiler::rfp_vars::Gener_Var_Indices, (_vs_N, _ve_Format, _c_20), (_ve_aux, _vs_N));
        RF_CALL (::refal::Box::Store, (Free_Idx, _vs_N), /*void*/);
        RF_CALL (org::refal::plus::compiler::rfp_helper::Del_Pragmas, _ve_aux, _ve_aux);
        Expr _v_Flatten__Result1;
        RF_CALL (Flatten_Result, (_vs_Istail, (_ve_Re + _ve_aux), _ve_rest), (_v_Flatten__Result1, _v_res2));
        _v_res1 = (_ve_1 + (_c_12 + _ve_aux) () + _v_Flatten__Result1);
      }
    _block3: {}
      goto _block1;
    }
  _block1__branch1: {}
    {
      int _v_len7 = _ve_items.get_len ();
      int _v_len8 = 1;
      if (_v_len7 < _v_len8)
      {
        goto _block1__branch2;
      }
      int _v_len__rest2 = (_v_len7 - _v_len8);
      if (_ve_items.symbol_at (0))
      {
        goto _block1__branch2;
      }
      Expr _v_deref__items (Expr (_ve_items, 0));
      int _v_len9 = _v_deref__items.get_len ();
      int _v_len10 = 2;
      if (_v_len9 < _v_len10)
      {
        goto _block1__branch2;
      }
      int _v_len__r = (_v_len9 - _v_len10);
      if (!_c_21.term_eq (_v_deref__items, 0))
      {
        goto _block1__branch2;
      }
      Expr _ve_rest;
      _ve_rest = Expr (_ve_items, (0 + 1), _v_len__rest2);
      Expr _vt_name;
      _vt_name = Expr (_v_deref__items, (0 + 1), 1);
      Expr _ve_r;
      _ve_r = Expr (_v_deref__items, (0 + 1 + 1), _v_len__r);
      Expr _ve_assigns;
      RF_CALL (Flatten_Result, (_c_22, empty, _ve_r), (_ve_assigns, _ve_r));
      Expr _vt_1 ((_c_21 + _vt_name + _ve_r) ());
      {
        {
          if (_v_len__rest2 != 0)
          {
            goto _block4__branch1;
          }
          if (!_vs_Istail.term_eq (_c_13, 0))
          {
            goto _block4__branch1;
          }
          _v_res1 = _ve_assigns;
          _v_res2 = (_ve_Re + _vt_1);
          goto _block4;
        }
      _block4__branch1: {}
        Expr _v_Get2;
        RF_CALL (::refal::Box::Get, Free_Idx, _v_Get2);
        if (_v_Get2.get_len () != 1)
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        if (!_v_Get2.symbol_at (0))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        Expr _vs_N;
        _vs_N = Expr (_v_Get2, 0, 1);
        Expr _ge_auxcall1;
        RF_CALL (org::refal::plus::compiler::rfp_format::Format_Exp, _vt_1, _ge_auxcall1);
        Expr _ve_aux1;
        RF_CALL (org::refal::plus::compiler::rfp_vars::Gener_Var_Indices, (_vs_N, _ge_auxcall1, _c_23), (_ve_aux1, _vs_N));
        RF_CALL (::refal::Box::Store, (Free_Idx, _vs_N), /*void*/);
        RF_CALL (org::refal::plus::compiler::rfp_helper::Del_Pragmas, _ve_aux1, _ve_aux1);
        Expr _v_Flatten__Result2;
        RF_CALL (Flatten_Result, (_vs_Istail, (_ve_Re + _ve_aux1), _ve_rest), (_v_Flatten__Result2, _v_res2));
        _v_res1 = (_ve_assigns + (_c_4 + _vt_1) () + (_c_12 + _ve_aux1) () + _v_Flatten__Result2);
      }
    _block4: {}
      goto _block1;
    }
  _block1__branch2: {}
    {
      int _v_len11 = _ve_items.get_len ();
      int _v_len12 = 1;
      if (_v_len11 < _v_len12)
      {
        goto _block1__branch3;
      }
      int _v_len__rest3 = (_v_len11 - _v_len12);
      if (_ve_items.symbol_at (0))
      {
        goto _block1__branch3;
      }
      Expr _v_deref__items2 (Expr (_ve_items, 0));
      int _v_len13 = _v_deref__items2.get_len ();
      int _v_len14 = 1;
      if (_v_len13 < _v_len14)
      {
        goto _block1__branch3;
      }
      int _v_len__r2 = (_v_len13 - _v_len14);
      if (!_c_24.term_eq (_v_deref__items2, 0))
      {
        goto _block1__branch3;
      }
      Expr _ve_rest;
      _ve_rest = Expr (_ve_items, (0 + 1), _v_len__rest3);
      Expr _ve_r;
      _ve_r = Expr (_v_deref__items2, (0 + 1), _v_len__r2);
      Expr _ve_assigns;
      RF_CALL (Flatten_Result, (_c_22, empty, _ve_r), (_ve_assigns, _ve_r));
      Expr _v_Flatten__Result3;
      RF_CALL (Flatten_Result, (_vs_Istail, (_ve_Re + (_c_24 + _ve_r) ()), _ve_rest), (_v_Flatten__Result3, _v_res2));
      _v_res1 = (_ve_assigns + _v_Flatten__Result3);
      goto _block1;
    }
  _block1__branch3: {}
    {
      int _v_len15 = _ve_items.get_len ();
      int _v_len16 = 1;
      if (_v_len15 < _v_len16)
      {
        goto _block1__branch4;
      }
      int _v_len__rest4 = (_v_len15 - _v_len16);
      Expr _vt_1;
      _vt_1 = Expr (_ve_items, 0, 1);
      Expr _ve_rest;
      _ve_rest = Expr (_ve_items, (0 + 1), _v_len__rest4);
      RF_TAILCALL (Flatten_Result, (_vs_Istail, (_ve_Re + _vt_1), _ve_rest), (_v_res1, _v_res2));
      goto _block1;
    }
  _block1__branch4: {}
    if (_ve_items.get_len () != 0)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    _v_res1 = empty;
    _v_res2 = _ve_Re;
  }
_block1: {}
RF_END

RF_FUNC (Generate_In_Vars, (RF_ARG _ve_in, _ve_Sentence;;), (RF_RES _v_res1, _v_res2;;))
  Expr _ge_in__1;
  Expr _ge_Sentence__1;
  {
    {
      Expr _ve_Pe;
      Expr _ve_Snt;
      Expr _vs_pragmas;
      {
        {
          int _v_len1 = _ve_Sentence.get_len ();
          int _v_len2 = 1;
          if (_v_len1 < _v_len2)
          {
            goto _block2__branch1;
          }
          int _v_len__Snt__4 = (_v_len1 - _v_len2);
          if (_ve_Sentence.symbol_at (0))
          {
            goto _block2__branch1;
          }
          Expr _v_deref__Sentence (Expr (_ve_Sentence, 0));
          int _v_len3 = _v_deref__Sentence.get_len ();
          int _v_len4 = 2;
          if (_v_len3 < _v_len4)
          {
            goto _block2__branch1;
          }
          int _v_len__Pe__4 = (_v_len3 - _v_len4);
          if (_v_deref__Sentence.symbol_at ((0 + 1)))
          {
            goto _block2__branch1;
          }
          Expr _v_deref__deref__Sentence (Expr (_v_deref__Sentence, (0 + 1)));
          int _v_len5 = _v_deref__deref__Sentence.get_len ();
          int _v_len6 = 1;
          if (_v_len5 < _v_len6)
          {
            goto _block2__branch1;
          }
          int _v_len___dollar_tmp_m_209_m_20 = (_v_len5 - _v_len6);
          if (!_c_9.term_eq (_v_deref__Sentence, 0))
          {
            goto _block2__branch1;
          }
          if (!_c_1.term_eq (_v_deref__deref__Sentence, 0))
          {
            goto _block2__branch1;
          }
          Expr _ge_Snt__4;
          _ge_Snt__4 = Expr (_ve_Sentence, (0 + 1), _v_len__Snt__4);
          Expr _ge_Pe__4;
          _ge_Pe__4 = Expr (_v_deref__Sentence, (0 + 1 + 1), _v_len__Pe__4);
          Expr _ve__dollar_tmp_m_209_m_20;
          _ve__dollar_tmp_m_209_m_20 = Expr (_v_deref__deref__Sentence, (0 + 1), _v_len___dollar_tmp_m_209_m_20);
          _ve_Pe = _ge_Pe__4;
          _ve_Snt = _ge_Snt__4;
          _vs_pragmas = _c_25;
          goto _block2;
        }
      _block2__branch1: {}
        {
          int _v_len7 = _ve_Sentence.get_len ();
          int _v_len8 = 1;
          if (_v_len7 < _v_len8)
          {
            goto _block2__branch2;
          }
          int _v_len__Snt__42 = (_v_len7 - _v_len8);
          if (_ve_Sentence.symbol_at (0))
          {
            goto _block2__branch2;
          }
          Expr _v_deref__Sentence2 (Expr (_ve_Sentence, 0));
          int _v_len9 = _v_deref__Sentence2.get_len ();
          int _v_len10 = 2;
          if (_v_len9 < _v_len10)
          {
            goto _block2__branch2;
          }
          int _v_len__Pe__42 = (_v_len9 - _v_len10);
          if (_v_deref__Sentence2.symbol_at ((0 + 1)))
          {
            goto _block2__branch2;
          }
          Expr _v_deref__deref__Sentence2 (Expr (_v_deref__Sentence2, (0 + 1)));
          int _v_len11 = _v_deref__deref__Sentence2.get_len ();
          int _v_len12 = 1;
          if (_v_len11 < _v_len12)
          {
            goto _block2__branch2;
          }
          int _v_len___dollar_tmp_m_210_m_21 = (_v_len11 - _v_len12);
          if (!_c_10.term_eq (_v_deref__Sentence2, 0))
          {
            goto _block2__branch2;
          }
          if (!_c_1.term_eq (_v_deref__deref__Sentence2, 0))
          {
            goto _block2__branch2;
          }
          Expr _ge_Snt__4;
          _ge_Snt__4 = Expr (_ve_Sentence, (0 + 1), _v_len__Snt__42);
          Expr _ge_Pe__4;
          _ge_Pe__4 = Expr (_v_deref__Sentence2, (0 + 1 + 1), _v_len__Pe__42);
          Expr _ve__dollar_tmp_m_210_m_21;
          _ve__dollar_tmp_m_210_m_21 = Expr (_v_deref__deref__Sentence2, (0 + 1), _v_len___dollar_tmp_m_210_m_21);
          _ve_Pe = _ge_Pe__4;
          _ve_Snt = _ge_Snt__4;
          _vs_pragmas = _c_25;
          goto _block2;
        }
      _block2__branch2: {}
        {
          int _v_len13 = _ve_Sentence.get_len ();
          int _v_len14 = 1;
          if (_v_len13 < _v_len14)
          {
            goto _block2__branch3;
          }
          int _v_len__Snt__43 = (_v_len13 - _v_len14);
          if (_ve_Sentence.symbol_at (0))
          {
            goto _block2__branch3;
          }
          Expr _v_deref__Sentence3 (Expr (_ve_Sentence, 0));
          int _v_len15 = _v_deref__Sentence3.get_len ();
          int _v_len16 = 1;
          if (_v_len15 < _v_len16)
          {
            goto _block2__branch3;
          }
          int _v_len__Pe__43 = (_v_len15 - _v_len16);
          if (!_c_9.term_eq (_v_deref__Sentence3, 0))
          {
            goto _block2__branch3;
          }
          Expr _ge_Snt__4;
          _ge_Snt__4 = Expr (_ve_Sentence, (0 + 1), _v_len__Snt__43);
          Expr _ge_Pe__4;
          _ge_Pe__4 = Expr (_v_deref__Sentence3, (0 + 1), _v_len__Pe__43);
          _ve_Pe = _ge_Pe__4;
          _ve_Snt = _ge_Snt__4;
          _vs_pragmas = _c_26;
          goto _block2;
        }
      _block2__branch3: {}
        int _v_len17 = _ve_Sentence.get_len ();
        int _v_len18 = 1;
        if (_v_len17 < _v_len18)
        {
          goto _block1__branch1;
        }
        int _v_len__Snt__44 = (_v_len17 - _v_len18);
        if (_ve_Sentence.symbol_at (0))
        {
          goto _block1__branch1;
        }
        Expr _v_deref__Sentence4 (Expr (_ve_Sentence, 0));
        int _v_len19 = _v_deref__Sentence4.get_len ();
        int _v_len20 = 1;
        if (_v_len19 < _v_len20)
        {
          goto _block1__branch1;
        }
        int _v_len__Pe__44 = (_v_len19 - _v_len20);
        if (!_c_10.term_eq (_v_deref__Sentence4, 0))
        {
          goto _block1__branch1;
        }
        Expr _ge_Snt__4;
        _ge_Snt__4 = Expr (_ve_Sentence, (0 + 1), _v_len__Snt__44);
        Expr _ge_Pe__4;
        _ge_Pe__4 = Expr (_v_deref__Sentence4, (0 + 1), _v_len__Pe__44);
        _ve_Pe = _ge_Pe__4;
        _ve_Snt = _ge_Snt__4;
        _vs_pragmas = _c_26;
      }
    _block2: {}
      {
        {
          Expr _v_Format__Exp1;
          RF_CALL (org::refal::plus::compiler::rfp_format::Format_Exp, _ve_Pe, _v_Format__Exp1);
          if (_v_Format__Exp1.get_len () != _ve_in.get_len ())
          {
            goto _block3__branch1;
          }
          if (!_ve_in.eq (_v_Format__Exp1, 0))
          {
            goto _block3__branch1;
          }
          Expr _ve_args;
          RF_CALL (org::refal::plus::compiler::rfp_vars::Vars, _ve_Pe, _ve_args);
          {
            if (_ve_args.get_len () < 2)
            {
              goto _negation1;
            }
            RF_lsplit (_ve_args, 0, _ve__dollar_tmp_m_217_m_24, _v_lsplit__args);
            for ( ; ; RF_iter(_ve_args)++)
            {
              {
                if (!RF_iter(_ve_args))
                {
                  goto _negation1;
                }
                if (_v_lsplit__args.get_len () < 2)
                {
                  goto _negation1;
                }
                if (_v_lsplit__args.symbol_at (0))
                {
                  goto _continue1;
                }
                Expr _v_deref__lsplit__args (Expr (_v_lsplit__args, 0));
                int _v_len21 = _v_deref__lsplit__args.get_len ();
                int _v_len22 = 1;
                if (_v_len21 < _v_len22)
                {
                  goto _continue1;
                }
                int _v_len___dollar_tmp_m_217_m_27 = (_v_len21 - _v_len22);
                Expr _ve__dollar_tmp_m_217_m_27;
                _ve__dollar_tmp_m_217_m_27 = Expr (_v_deref__lsplit__args, 0, _v_len___dollar_tmp_m_217_m_27);
                Expr _vt_1;
                _vt_1 = Expr (_v_deref__lsplit__args, (0 + _v_len___dollar_tmp_m_217_m_27), 1);
                Expr _v_subexpr__lsplit__args (Expr (_v_lsplit__args, (0 + 1), (_v_lsplit__args.get_len () - (0 + 1 + 0))));
                RF_lsplit (_v_subexpr__lsplit__args, 0, _ve__dollar_tmp_m_217_m_33, _v_lsplit__lsplit__args);
                for ( ; ; RF_iter(_v_subexpr__lsplit__args)++)
                {
                  {
                    if (!RF_iter(_v_subexpr__lsplit__args))
                    {
                      goto _continue1;
                    }
                    int _v_len23 = _v_lsplit__lsplit__args.get_len ();
                    int _v_len24 = 1;
                    if (_v_len23 < _v_len24)
                    {
                      goto _continue1;
                    }
                    int _v_len___dollar_tmp_m_217_m_42 = (_v_len23 - _v_len24);
                    if (_v_lsplit__lsplit__args.symbol_at (0))
                    {
                      goto _continue2;
                    }
                    Expr _v_deref__lsplit__lsplit__args (Expr (_v_lsplit__lsplit__args, 0));
                    int _v_len25 = _v_deref__lsplit__lsplit__args.get_len ();
                    int _v_len26 = 1;
                    if (_v_len25 < _v_len26)
                    {
                      goto _continue2;
                    }
                    int _v_len___dollar_tmp_m_217_m_36 = (_v_len25 - _v_len26);
                    if (!_vt_1.term_eq (_v_deref__lsplit__lsplit__args, (0 + _v_len___dollar_tmp_m_217_m_36)))
                    {
                      goto _continue2;
                    }
                    Expr _ve__dollar_tmp_m_217_m_42;
                    _ve__dollar_tmp_m_217_m_42 = Expr (_v_lsplit__lsplit__args, (0 + 1), _v_len___dollar_tmp_m_217_m_42);
                    Expr _ve__dollar_tmp_m_217_m_36;
                    _ve__dollar_tmp_m_217_m_36 = Expr (_v_deref__lsplit__lsplit__args, 0, _v_len___dollar_tmp_m_217_m_36);
                    goto _exit2;
                  }
              _continue2: {}
                }
              _exit2: {}
                goto _exit1;
              }
          _continue1: {}
            }
          _exit1: {}
            goto _block3__branch1;
          }
        _negation1: {}
          _ge_in__1 = _ve_Pe;
          _ge_Sentence__1 = _ve_Snt;
          goto _block3;
        }
      _block3__branch1: {}
        Expr _ve_in__expr;
        Expr _vs__dollar_tmp_m_219_m_56;
        RF_CALL (org::refal::plus::compiler::rfp_vars::Gener_Var_Indices, (_c_5, _ve_in, _c_27), (_ve_in__expr, _vs__dollar_tmp_m_219_m_56));
        {
          {
            if (!_vs_pragmas.term_eq (_c_26, 0))
            {
              goto _block5__branch1;
            }
            Expr _ge_in__expr__7;
            RF_CALL (org::refal::plus::compiler::rfp_helper::Del_Pragmas, _ve_in__expr, _ge_in__expr__7);
            _ge_in__1 = _ge_in__expr__7;
            _ge_Sentence__1 = ((_c_4 + _ge_in__expr__7) () + _ve_Sentence);
            goto _block5;
          }
        _block5__branch1: {}
          _ge_in__1 = _ve_in__expr;
          _ge_Sentence__1 = ((_c_28 + _ve_in__expr) () + _ve_Sentence);
        }
      _block5: {}
      }
    _block3: {}
      goto _block1;
    }
  _block1__branch1: {}
    {
      int _v_len27 = _ve_Sentence.get_len ();
      int _v_len28 = 1;
      if (_v_len27 < _v_len28)
      {
        goto _block1__branch2;
      }
      int _v_len__Snt = (_v_len27 - _v_len28);
      if (_ve_Sentence.symbol_at (0))
      {
        goto _block1__branch2;
      }
      Expr _v_deref__Sentence5 (Expr (_ve_Sentence, 0));
      int _v_len29 = _v_deref__Sentence5.get_len ();
      int _v_len30 = 2;
      if (_v_len29 < _v_len30)
      {
        goto _block1__branch2;
      }
      int _v_len__branches = (_v_len29 - _v_len30);
      if (_v_deref__Sentence5.symbol_at ((0 + 1)))
      {
        goto _block1__branch2;
      }
      Expr _v_deref__deref__Sentence5 (Expr (_v_deref__Sentence5, (0 + 1)));
      int _v_len31 = _v_deref__deref__Sentence5.get_len ();
      int _v_len32 = 1;
      if (_v_len31 < _v_len32)
      {
        goto _block1__branch2;
      }
      int _v_len__Pragma = (_v_len31 - _v_len32);
      if (!_v_deref__Sentence5.symbol_at (0))
      {
        goto _block1__branch2;
      }
      if (!_c_1.term_eq (_v_deref__deref__Sentence5, 0))
      {
        goto _block1__branch2;
      }
      Expr _ve_Snt;
      _ve_Snt = Expr (_ve_Sentence, (0 + 1), _v_len__Snt);
      Expr _vs_block;
      _vs_block = Expr (_v_deref__Sentence5, 0, 1);
      Expr _ve_branches;
      _ve_branches = Expr (_v_deref__Sentence5, (0 + 1 + 1), _v_len__branches);
      Expr _ve_Pragma;
      _ve_Pragma = Expr (_v_deref__deref__Sentence5, (0 + 1), _v_len__Pragma);
      {
        {
          if (!_vs_block.term_eq (_c_7, 0))
          {
            goto _block6__branch1;
          }
          goto _block6;
        }
      _block6__branch1: {}
        if (!_vs_block.term_eq (_c_8, 0))
        {
          goto _block1__branch2;
        }
      }
    _block6: {}
      Expr _ve_in__expr;
      Expr _vs__dollar_tmp_m_235_m_54;
      RF_CALL (org::refal::plus::compiler::rfp_vars::Gener_Var_Indices, (_c_5, _ve_in, _c_27), (_ve_in__expr, _vs__dollar_tmp_m_235_m_54));
      Expr _ve_in__vars;
      RF_CALL (org::refal::plus::compiler::rfp_vars::Vars, _ve_in__expr, _ve_in__vars);
      Expr _ve_br;
      for ( ; ; )
      {
        {
          if (_ve_branches.get_len () != 0)
          {
            goto _iter1;
          }
          _ge_in__1 = _ve_in__expr;
          _ge_Sentence__1 = ((_vs_block + (_c_1 + _ve_Pragma) () + _ve_br) () + _ve_Snt);
          goto _exit__iter1;
        }
      _iter1: {}
        int _v_len33 = _ve_branches.get_len ();
        int _v_len34 = 1;
        if (_v_len33 < _v_len34)
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        int _v_len__rest = (_v_len33 - _v_len34);
        if (_ve_branches.symbol_at (0))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        Expr _v_deref__branches (Expr (_ve_branches, 0));
        int _v_len35 = _v_deref__branches.get_len ();
        int _v_len36 = 3;
        if (_v_len35 < _v_len36)
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        int _v_len__br__snt = (_v_len35 - _v_len36);
        if (_v_deref__branches.symbol_at ((0 + 1 + 1)))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        Expr _v_deref__deref__branches (Expr (_v_deref__branches, (0 + 1 + 1)));
        int _v_len37 = _v_deref__deref__branches.get_len ();
        int _v_len38 = 2;
        if (_v_len37 < _v_len38)
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        int _v_len__Pe = (_v_len37 - _v_len38);
        if (!_c_2.term_eq (_v_deref__branches, 0))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        if (!_v_deref__deref__branches.symbol_at (0))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        Expr _ve_rest;
        _ve_rest = Expr (_ve_branches, (0 + 1), _v_len__rest);
        Expr _vt_p;
        _vt_p = Expr (_v_deref__branches, (0 + 1), 1);
        Expr _ve_br__snt;
        _ve_br__snt = Expr (_v_deref__branches, (0 + 1 + 1 + 1), _v_len__br__snt);
        Expr _vs_dir;
        _vs_dir = Expr (_v_deref__deref__branches, 0, 1);
        Expr _vt_pp;
        _vt_pp = Expr (_v_deref__deref__branches, (0 + 1), 1);
        Expr _ve_Pe;
        _ve_Pe = Expr (_v_deref__deref__branches, (0 + 1 + 1), _v_len__Pe);
        {
          {
            Expr _v_Format__Exp2;
            RF_CALL (org::refal::plus::compiler::rfp_format::Format_Exp, _ve_Pe, _v_Format__Exp2);
            if (_v_Format__Exp2.get_len () != _ve_in.get_len ())
            {
              goto _block8__branch1;
            }
            if (!_ve_in.eq (_v_Format__Exp2, 0))
            {
              goto _block8__branch1;
            }
            Expr _ve_vars;
            RF_CALL (org::refal::plus::compiler::rfp_vars::Vars, _ve_Pe, _ve_vars);
            {
              if (_ve_vars.get_len () < 2)
              {
                goto _negation2;
              }
              RF_lsplit (_ve_vars, 0, _ve__dollar_tmp_m_241_m_26, _v_lsplit__vars);
              for ( ; ; RF_iter(_ve_vars)++)
              {
                {
                  if (!RF_iter(_ve_vars))
                  {
                    goto _negation2;
                  }
                  if (_v_lsplit__vars.get_len () < 2)
                  {
                    goto _negation2;
                  }
                  if (_v_lsplit__vars.symbol_at (0))
                  {
                    goto _continue3;
                  }
                  Expr _v_deref__lsplit__vars (Expr (_v_lsplit__vars, 0));
                  int _v_len39 = _v_deref__lsplit__vars.get_len ();
                  int _v_len40 = 1;
                  if (_v_len39 < _v_len40)
                  {
                    goto _continue3;
                  }
                  int _v_len___dollar_tmp_m_241_m_29 = (_v_len39 - _v_len40);
                  Expr _ve__dollar_tmp_m_241_m_29;
                  _ve__dollar_tmp_m_241_m_29 = Expr (_v_deref__lsplit__vars, 0, _v_len___dollar_tmp_m_241_m_29);
                  Expr _vt_1;
                  _vt_1 = Expr (_v_deref__lsplit__vars, (0 + _v_len___dollar_tmp_m_241_m_29), 1);
                  Expr _v_subexpr__lsplit__vars (Expr (_v_lsplit__vars, (0 + 1), (_v_lsplit__vars.get_len () - (0 + 1 + 0))));
                  RF_lsplit (_v_subexpr__lsplit__vars, 0, _ve__dollar_tmp_m_241_m_35, _v_lsplit__lsplit__vars);
                  for ( ; ; RF_iter(_v_subexpr__lsplit__vars)++)
                  {
                    {
                      if (!RF_iter(_v_subexpr__lsplit__vars))
                      {
                        goto _continue3;
                      }
                      int _v_len41 = _v_lsplit__lsplit__vars.get_len ();
                      int _v_len42 = 1;
                      if (_v_len41 < _v_len42)
                      {
                        goto _continue3;
                      }
                      int _v_len___dollar_tmp_m_241_m_44 = (_v_len41 - _v_len42);
                      if (_v_lsplit__lsplit__vars.symbol_at (0))
                      {
                        goto _continue4;
                      }
                      Expr _v_deref__lsplit__lsplit__vars (Expr (_v_lsplit__lsplit__vars, 0));
                      int _v_len43 = _v_deref__lsplit__lsplit__vars.get_len ();
                      int _v_len44 = 1;
                      if (_v_len43 < _v_len44)
                      {
                        goto _continue4;
                      }
                      int _v_len___dollar_tmp_m_241_m_38 = (_v_len43 - _v_len44);
                      if (!_vt_1.term_eq (_v_deref__lsplit__lsplit__vars, (0 + _v_len___dollar_tmp_m_241_m_38)))
                      {
                        goto _continue4;
                      }
                      Expr _ve__dollar_tmp_m_241_m_44;
                      _ve__dollar_tmp_m_241_m_44 = Expr (_v_lsplit__lsplit__vars, (0 + 1), _v_len___dollar_tmp_m_241_m_44);
                      Expr _ve__dollar_tmp_m_241_m_38;
                      _ve__dollar_tmp_m_241_m_38 = Expr (_v_deref__lsplit__lsplit__vars, 0, _v_len___dollar_tmp_m_241_m_38);
                      goto _exit4;
                    }
                _continue4: {}
                  }
                _exit4: {}
                  goto _exit3;
                }
            _continue3: {}
              }
            _exit3: {}
              goto _block8__branch1;
            }
          _negation2: {}
            Expr _ve_pats;
            Expr _ve_repls;
            RF_CALL (Build_Subst, (_ve_vars, _ve_in__vars, _ve_br__snt), (_ve_pats, _ve_repls));
            Expr _ge_auxcall1;
            RF_CALL (org::refal::plus::compiler::rfp_helper::Subst, (_ve_pats, _ve_repls, _ve_br__snt), _ge_auxcall1);
            _ve_br = (_ve_br + (_c_2 + _vt_p + _ge_auxcall1) ());
            _ve_branches = _ve_rest;
            goto _block8;
          }
        _block8__branch1: {}
          _ve_br = (_ve_br + (_c_2 + _vt_p + (_vs_dir + _vt_pp + _ve_Pe) () + _ve_br__snt) ());
          _ve_branches = _ve_rest;
        }
      _block8: {}
      }
    _exit__iter1: {}
      goto _block1;
    }
  _block1__branch2: {}
    {
      int _v_len45 = _ve_Sentence.get_len ();
      int _v_len46 = 1;
      if (_v_len45 < _v_len46)
      {
        goto _block1__branch3;
      }
      int _v_len__Snt2 = (_v_len45 - _v_len46);
      if (_ve_Sentence.symbol_at (0))
      {
        goto _block1__branch3;
      }
      Expr _v_deref__Sentence6 (Expr (_ve_Sentence, 0));
      int _v_len47 = _v_deref__Sentence6.get_len ();
      int _v_len48 = 1;
      if (_v_len47 < _v_len48)
      {
        goto _block1__branch3;
      }
      int _v_len__branches2 = (_v_len47 - _v_len48);
      if (!_v_deref__Sentence6.symbol_at (0))
      {
        goto _block1__branch3;
      }
      Expr _ve_Snt;
      _ve_Snt = Expr (_ve_Sentence, (0 + 1), _v_len__Snt2);
      Expr _vs_block;
      _vs_block = Expr (_v_deref__Sentence6, 0, 1);
      Expr _ve_branches;
      _ve_branches = Expr (_v_deref__Sentence6, (0 + 1), _v_len__branches2);
      {
        {
          if (!_vs_block.term_eq (_c_7, 0))
          {
            goto _block10__branch1;
          }
          goto _block10;
        }
      _block10__branch1: {}
        if (!_vs_block.term_eq (_c_8, 0))
        {
          goto _block1__branch3;
        }
      }
    _block10: {}
      Expr _ve_in__expr;
      Expr _vs__dollar_tmp_m_253_m_54;
      RF_CALL (org::refal::plus::compiler::rfp_vars::Gener_Var_Indices, (_c_5, _ve_in, _c_27), (_ve_in__expr, _vs__dollar_tmp_m_253_m_54));
      RF_CALL (org::refal::plus::compiler::rfp_helper::Del_Pragmas, _ve_in__expr, _ve_in__expr);
      Expr _ve_in__vars;
      RF_CALL (org::refal::plus::compiler::rfp_vars::Vars, _ve_in__expr, _ve_in__vars);
      Expr _ve_br;
      for ( ; ; )
      {
        {
          if (_ve_branches.get_len () != 0)
          {
            goto _iter2;
          }
          _ge_in__1 = _ve_in__expr;
          _ge_Sentence__1 = ((_vs_block + _ve_br) () + _ve_Snt);
          goto _exit__iter2;
        }
      _iter2: {}
        int _v_len49 = _ve_branches.get_len ();
        int _v_len50 = 1;
        if (_v_len49 < _v_len50)
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        int _v_len__rest2 = (_v_len49 - _v_len50);
        if (_ve_branches.symbol_at (0))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        Expr _v_deref__branches2 (Expr (_ve_branches, 0));
        int _v_len51 = _v_deref__branches2.get_len ();
        int _v_len52 = 2;
        if (_v_len51 < _v_len52)
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        int _v_len__br__snt2 = (_v_len51 - _v_len52);
        if (_v_deref__branches2.symbol_at ((0 + 1)))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        Expr _v_deref__deref__branches2 (Expr (_v_deref__branches2, (0 + 1)));
        int _v_len53 = _v_deref__deref__branches2.get_len ();
        int _v_len54 = 1;
        if (_v_len53 < _v_len54)
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        int _v_len__Pe2 = (_v_len53 - _v_len54);
        if (!_c_2.term_eq (_v_deref__branches2, 0))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        if (!_v_deref__deref__branches2.symbol_at (0))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        Expr _ve_rest;
        _ve_rest = Expr (_ve_branches, (0 + 1), _v_len__rest2);
        Expr _ve_br__snt;
        _ve_br__snt = Expr (_v_deref__branches2, (0 + 1 + 1), _v_len__br__snt2);
        Expr _vs_dir;
        _vs_dir = Expr (_v_deref__deref__branches2, 0, 1);
        Expr _ve_Pe;
        _ve_Pe = Expr (_v_deref__deref__branches2, (0 + 1), _v_len__Pe2);
        {
          {
            Expr _v_Format__Exp3;
            RF_CALL (org::refal::plus::compiler::rfp_format::Format_Exp, _ve_Pe, _v_Format__Exp3);
            if (_v_Format__Exp3.get_len () != _ve_in.get_len ())
            {
              goto _block12__branch1;
            }
            if (!_ve_in.eq (_v_Format__Exp3, 0))
            {
              goto _block12__branch1;
            }
            Expr _ve_vars;
            RF_CALL (org::refal::plus::compiler::rfp_vars::Vars, _ve_Pe, _ve_vars);
            {
              if (_ve_vars.get_len () < 2)
              {
                goto _negation3;
              }
              RF_lsplit (_ve_vars, 0, _ve__dollar_tmp_m_260_m_26, _v_lsplit__vars2);
              for ( ; ; RF_iter(_ve_vars)++)
              {
                {
                  if (!RF_iter(_ve_vars))
                  {
                    goto _negation3;
                  }
                  if (_v_lsplit__vars2.get_len () < 2)
                  {
                    goto _negation3;
                  }
                  if (_v_lsplit__vars2.symbol_at (0))
                  {
                    goto _continue5;
                  }
                  Expr _v_deref__lsplit__vars2 (Expr (_v_lsplit__vars2, 0));
                  int _v_len55 = _v_deref__lsplit__vars2.get_len ();
                  int _v_len56 = 1;
                  if (_v_len55 < _v_len56)
                  {
                    goto _continue5;
                  }
                  int _v_len___dollar_tmp_m_260_m_29 = (_v_len55 - _v_len56);
                  Expr _ve__dollar_tmp_m_260_m_29;
                  _ve__dollar_tmp_m_260_m_29 = Expr (_v_deref__lsplit__vars2, 0, _v_len___dollar_tmp_m_260_m_29);
                  Expr _vt_1;
                  _vt_1 = Expr (_v_deref__lsplit__vars2, (0 + _v_len___dollar_tmp_m_260_m_29), 1);
                  Expr _v_subexpr__lsplit__vars2 (Expr (_v_lsplit__vars2, (0 + 1), (_v_lsplit__vars2.get_len () - (0 + 1 + 0))));
                  RF_lsplit (_v_subexpr__lsplit__vars2, 0, _ve__dollar_tmp_m_260_m_35, _v_lsplit__lsplit__vars2);
                  for ( ; ; RF_iter(_v_subexpr__lsplit__vars2)++)
                  {
                    {
                      if (!RF_iter(_v_subexpr__lsplit__vars2))
                      {
                        goto _continue5;
                      }
                      int _v_len57 = _v_lsplit__lsplit__vars2.get_len ();
                      int _v_len58 = 1;
                      if (_v_len57 < _v_len58)
                      {
                        goto _continue5;
                      }
                      int _v_len___dollar_tmp_m_260_m_44 = (_v_len57 - _v_len58);
                      if (_v_lsplit__lsplit__vars2.symbol_at (0))
                      {
                        goto _continue6;
                      }
                      Expr _v_deref__lsplit__lsplit__vars2 (Expr (_v_lsplit__lsplit__vars2, 0));
                      int _v_len59 = _v_deref__lsplit__lsplit__vars2.get_len ();
                      int _v_len60 = 1;
                      if (_v_len59 < _v_len60)
                      {
                        goto _continue6;
                      }
                      int _v_len___dollar_tmp_m_260_m_38 = (_v_len59 - _v_len60);
                      if (!_vt_1.term_eq (_v_deref__lsplit__lsplit__vars2, (0 + _v_len___dollar_tmp_m_260_m_38)))
                      {
                        goto _continue6;
                      }
                      Expr _ve__dollar_tmp_m_260_m_44;
                      _ve__dollar_tmp_m_260_m_44 = Expr (_v_lsplit__lsplit__vars2, (0 + 1), _v_len___dollar_tmp_m_260_m_44);
                      Expr _ve__dollar_tmp_m_260_m_38;
                      _ve__dollar_tmp_m_260_m_38 = Expr (_v_deref__lsplit__lsplit__vars2, 0, _v_len___dollar_tmp_m_260_m_38);
                      goto _exit6;
                    }
                _continue6: {}
                  }
                _exit6: {}
                  goto _exit5;
                }
            _continue5: {}
              }
            _exit5: {}
              goto _block12__branch1;
            }
          _negation3: {}
            Expr _ve_pats;
            Expr _ve_repls;
            RF_CALL (Build_Subst, (_ve_vars, _ve_in__vars, _ve_br__snt), (_ve_pats, _ve_repls));
            Expr _ge_auxcall2;
            RF_CALL (org::refal::plus::compiler::rfp_helper::Subst, (_ve_pats, _ve_repls, _ve_br__snt), _ge_auxcall2);
            _ve_br = (_ve_br + (_c_2 + _ge_auxcall2) ());
            _ve_branches = _ve_rest;
            goto _block12;
          }
        _block12__branch1: {}
          _ve_br = (_ve_br + (_c_2 + (_vs_dir + _ve_Pe) () + _ve_br__snt) ());
          _ve_branches = _ve_rest;
        }
      _block12: {}
      }
    _exit__iter2: {}
      goto _block1;
    }
  _block1__branch3: {}
    _ge_in__1 = _ve_in;
    _ge_Sentence__1 = _ve_Sentence;
  }
_block1: {}
  _v_res1 = _ge_in__1;
  _v_res2 = _ge_Sentence__1;
RF_END

RF_FUNC (Rename_Vars, (RF_ARG _vs_num, _ve_upper__vars, _ve_res__vars, _ve_Snt;;), (RF_RES _v_res1;;))
  Expr _ve_vars (_ve_upper__vars);
  Expr _ve_new__Snt;
  Expr _ge_Snt__0 (_ve_Snt);
  for ( ; ; )
  {
    {
      if (_ge_Snt__0.get_len () != 0)
      {
        goto _iter1;
      }
      _v_res1 = _ve_new__Snt;
      goto _exit__iter1;
    }
  _iter1: {}
    int _v_len1 = _ge_Snt__0.get_len ();
    int _v_len2 = 1;
    if (_v_len1 < _v_len2)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    int _v_len__rest = (_v_len1 - _v_len2);
    Expr _vt_Statement;
    _vt_Statement = Expr (_ge_Snt__0, 0, 1);
    Expr _ve_rest;
    _ve_rest = Expr (_ge_Snt__0, (0 + 1), _v_len__rest);
    {
      {
        Expr _ve_Pe;
        {
          {
            if (_vt_Statement.symbol_at (0))
            {
              goto _block3__branch1;
            }
            Expr _v_deref__Statement (Expr (_vt_Statement, 0));
            int _v_len3 = _v_deref__Statement.get_len ();
            int _v_len4 = 1;
            if (_v_len3 < _v_len4)
            {
              goto _block3__branch1;
            }
            int _v_len__Pe__6 = (_v_len3 - _v_len4);
            if (!_c_9.term_eq (_v_deref__Statement, 0))
            {
              goto _block3__branch1;
            }
            Expr _ge_Pe__6;
            _ge_Pe__6 = Expr (_v_deref__Statement, (0 + 1), _v_len__Pe__6);
            _ve_Pe = _ge_Pe__6;
            goto _block3;
          }
        _block3__branch1: {}
          if (_vt_Statement.symbol_at (0))
          {
            goto _block2__branch1;
          }
          Expr _v_deref__Statement2 (Expr (_vt_Statement, 0));
          int _v_len5 = _v_deref__Statement2.get_len ();
          int _v_len6 = 1;
          if (_v_len5 < _v_len6)
          {
            goto _block2__branch1;
          }
          int _v_len__Pe__62 = (_v_len5 - _v_len6);
          if (!_c_10.term_eq (_v_deref__Statement2, 0))
          {
            goto _block2__branch1;
          }
          Expr _ge_Pe__6;
          _ge_Pe__6 = Expr (_v_deref__Statement2, (0 + 1), _v_len__Pe__62);
          _ve_Pe = _ge_Pe__6;
        }
      _block3: {}
        Expr _ge_auxcall1;
        RF_CALL (org::refal::plus::compiler::rfp_vars::Vars, _ve_Pe, _ge_auxcall1);
        Expr _ve_old__vars;
        Expr _ve_new__vars;
        RF_CALL (::refal::List::Split, (_c_29, _ve_res__vars, _ge_auxcall1), (_ve_old__vars, _ve_new__vars));
        Expr _ve_renames;
        if (!RF_CALL (::refal::List::Map, (_c_30, _vs_num, _ve_old__vars), _ve_renames))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        Expr _ve_pats;
        Expr _ve_repls;
        RF_CALL (Build_Subst, (_ve_old__vars, _ve_renames, _ge_Snt__0), (_ve_pats, _ve_repls));
        Expr _v_Subst1;
        RF_CALL (org::refal::plus::compiler::rfp_helper::Subst, (_ve_pats, _ve_repls, _ge_Snt__0), _v_Subst1);
        int _v_len7 = _v_Subst1.get_len ();
        int _v_len8 = 1;
        if (_v_len7 < _v_len8)
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        int _v_len__rest__Snt = (_v_len7 - _v_len8);
        if (_v_Subst1.symbol_at (0))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        Expr _v_deref__Subst1 (Expr (_v_Subst1, 0));
        int _v_len9 = _v_deref__Subst1.get_len ();
        int _v_len10 = 1;
        if (_v_len9 < _v_len10)
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        int _v_len__Pe1 = (_v_len9 - _v_len10);
        if (!_v_deref__Subst1.symbol_at (0))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        Expr _ve_rest__Snt;
        _ve_rest__Snt = Expr (_v_Subst1, (0 + 1), _v_len__rest__Snt);
        Expr _vs_tag;
        _vs_tag = Expr (_v_deref__Subst1, 0, 1);
        Expr _ve_Pe1;
        _ve_Pe1 = Expr (_v_deref__Subst1, (0 + 1), _v_len__Pe1);
        Expr _ge_auxcall2;
        RF_CALL (org::refal::plus::compiler::rfp_vars::Vars, _ve_Pe1, _ge_auxcall2);
        Expr _ge_auxcall3;
        RF_CALL (::refal::List::Or, (_ve_vars, _ge_auxcall2), _ge_auxcall3);
        _ve_vars = _ge_auxcall3;
        _ve_new__Snt = (_ve_new__Snt + (_vs_tag + _ve_Pe1) ());
        _ge_Snt__0 = _ve_rest__Snt;
        goto _block2;
      }
    _block2__branch1: {}
      {
        if (_vt_Statement.symbol_at (0))
        {
          goto _block2__branch2;
        }
        Expr _v_deref__Statement3 (Expr (_vt_Statement, 0));
        int _v_len11 = _v_deref__Statement3.get_len ();
        int _v_len12 = 1;
        if (_v_len11 < _v_len12)
        {
          goto _block2__branch2;
        }
        int _v_len__He = (_v_len11 - _v_len12);
        if (!_c_12.term_eq (_v_deref__Statement3, 0))
        {
          goto _block2__branch2;
        }
        Expr _ve_He;
        _ve_He = Expr (_v_deref__Statement3, (0 + 1), _v_len__He);
        Expr _ge_auxcall4;
        RF_CALL (org::refal::plus::compiler::rfp_vars::Vars, _ve_He, _ge_auxcall4);
        Expr _ve_old__vars;
        Expr _ve_new__vars;
        RF_CALL (::refal::List::Split, (_c_29, (_ve_upper__vars + _ve_res__vars), _ge_auxcall4), (_ve_old__vars, _ve_new__vars));
        Expr _ve_renames;
        if (!RF_CALL (::refal::List::Map, (_c_30, _vs_num, _ve_old__vars), _ve_renames))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        Expr _ve_pats;
        Expr _ve_repls;
        RF_CALL (Build_Subst, (_ve_old__vars, _ve_renames, _ge_Snt__0), (_ve_pats, _ve_repls));
        Expr _v_Subst2;
        RF_CALL (org::refal::plus::compiler::rfp_helper::Subst, (_ve_pats, _ve_repls, _ge_Snt__0), _v_Subst2);
        int _v_len13 = _v_Subst2.get_len ();
        int _v_len14 = 1;
        if (_v_len13 < _v_len14)
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        int _v_len__rest__Snt2 = (_v_len13 - _v_len14);
        if (_v_Subst2.symbol_at (0))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        Expr _v_deref__Subst2 (Expr (_v_Subst2, 0));
        int _v_len15 = _v_deref__Subst2.get_len ();
        int _v_len16 = 1;
        if (_v_len15 < _v_len16)
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        int _v_len__He1 = (_v_len15 - _v_len16);
        if (!_c_12.term_eq (_v_deref__Subst2, 0))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        Expr _ve_rest__Snt;
        _ve_rest__Snt = Expr (_v_Subst2, (0 + 1), _v_len__rest__Snt2);
        Expr _ve_He1;
        _ve_He1 = Expr (_v_deref__Subst2, (0 + 1), _v_len__He1);
        Expr _ge_auxcall5;
        RF_CALL (org::refal::plus::compiler::rfp_vars::Vars, _ve_He1, _ge_auxcall5);
        Expr _ge_auxcall6;
        RF_CALL (::refal::List::Or, (_ve_vars, _ge_auxcall5), _ge_auxcall6);
        _ve_vars = _ge_auxcall6;
        _ve_new__Snt = (_ve_new__Snt + (_c_12 + _ve_He1) ());
        _ge_Snt__0 = _ve_rest__Snt;
        goto _block2;
      }
    _block2__branch2: {}
      {
        if (_vt_Statement.symbol_at (0))
        {
          goto _block2__branch3;
        }
        Expr _v_deref__Statement4 (Expr (_vt_Statement, 0));
        int _v_len17 = _v_deref__Statement4.get_len ();
        int _v_len18 = 1;
        if (_v_len17 < _v_len18)
        {
          goto _block2__branch3;
        }
        int _v_len__branches = (_v_len17 - _v_len18);
        if (!_v_deref__Statement4.symbol_at (0))
        {
          goto _block2__branch3;
        }
        Expr _vs_block;
        _vs_block = Expr (_v_deref__Statement4, 0, 1);
        Expr _ve_branches;
        _ve_branches = Expr (_v_deref__Statement4, (0 + 1), _v_len__branches);
        {
          {
            if (!_vs_block.term_eq (_c_7, 0))
            {
              goto _block4__branch1;
            }
            goto _block4;
          }
        _block4__branch1: {}
          if (!_vs_block.term_eq (_c_8, 0))
          {
            goto _block2__branch3;
          }
        }
      _block4: {}
        Expr _ve_bl__res__vars;
        {
          {
            int _v_len19 = _v_len__rest;
            int _v_len20 = 1;
            if (_v_len19 < _v_len20)
            {
              goto _block5__branch1;
            }
            int _v_len___dollar_tmp_m_324_m_24 = (_v_len19 - _v_len20);
            if (_ve_rest.symbol_at (0))
            {
              goto _block5__branch1;
            }
            Expr _v_deref__rest (Expr (_ve_rest, 0));
            int _v_len21 = _v_deref__rest.get_len ();
            int _v_len22 = 1;
            if (_v_len21 < _v_len22)
            {
              goto _block5__branch1;
            }
            int _v_len__Pe = (_v_len21 - _v_len22);
            if (!_c_9.term_eq (_v_deref__rest, 0))
            {
              goto _block5__branch1;
            }
            Expr _ve__dollar_tmp_m_324_m_24;
            _ve__dollar_tmp_m_324_m_24 = Expr (_ve_rest, (0 + 1), _v_len___dollar_tmp_m_324_m_24);
            Expr _ve_Pe;
            _ve_Pe = Expr (_v_deref__rest, (0 + 1), _v_len__Pe);
            RF_CALL (org::refal::plus::compiler::rfp_vars::Vars, _ve_Pe, _ve_bl__res__vars);
            goto _block5;
          }
        _block5__branch1: {}
          {
            int _v_len23 = _v_len__rest;
            int _v_len24 = 1;
            if (_v_len23 < _v_len24)
            {
              goto _block5__branch2;
            }
            int _v_len___dollar_tmp_m_325_m_25 = (_v_len23 - _v_len24);
            if (_ve_rest.symbol_at (0))
            {
              goto _block5__branch2;
            }
            Expr _v_deref__rest2 (Expr (_ve_rest, 0));
            int _v_len25 = _v_deref__rest2.get_len ();
            int _v_len26 = 1;
            if (_v_len25 < _v_len26)
            {
              goto _block5__branch2;
            }
            int _v_len__Pe2 = (_v_len25 - _v_len26);
            if (!_c_10.term_eq (_v_deref__rest2, 0))
            {
              goto _block5__branch2;
            }
            Expr _ve__dollar_tmp_m_325_m_25;
            _ve__dollar_tmp_m_325_m_25 = Expr (_ve_rest, (0 + 1), _v_len___dollar_tmp_m_325_m_25);
            Expr _ve_Pe;
            _ve_Pe = Expr (_v_deref__rest2, (0 + 1), _v_len__Pe2);
            RF_CALL (org::refal::plus::compiler::rfp_vars::Vars, _ve_Pe, _ve_bl__res__vars);
            goto _block5;
          }
        _block5__branch2: {}
          {
            int _v_len27 = _v_len__rest;
            int _v_len28 = 1;
            if (_v_len27 < _v_len28)
            {
              goto _block5__branch3;
            }
            int _v_len___dollar_tmp_m_326_m_26 = (_v_len27 - _v_len28);
            if (_ve_rest.symbol_at (0))
            {
              goto _block5__branch3;
            }
            Expr _v_deref__rest3 (Expr (_ve_rest, 0));
            int _v_len29 = _v_deref__rest3.get_len ();
            int _v_len30 = 1;
            if (_v_len29 < _v_len30)
            {
              goto _block5__branch3;
            }
            int _v_len__He2 = (_v_len29 - _v_len30);
            if (!_c_12.term_eq (_v_deref__rest3, 0))
            {
              goto _block5__branch3;
            }
            Expr _ve__dollar_tmp_m_326_m_26;
            _ve__dollar_tmp_m_326_m_26 = Expr (_ve_rest, (0 + 1), _v_len___dollar_tmp_m_326_m_26);
            Expr _ve_He;
            _ve_He = Expr (_v_deref__rest3, (0 + 1), _v_len__He2);
            RF_CALL (org::refal::plus::compiler::rfp_vars::Vars, _ve_He, _ve_bl__res__vars);
            goto _block5;
          }
        _block5__branch3: {}
          {
            if (_v_len__rest != 0)
            {
              goto _block5__branch4;
            }
            _ve_bl__res__vars = _ve_res__vars;
            goto _block5;
          }
        _block5__branch4: {}
          int _v_len31 = _v_len__rest;
          int _v_len32 = 0;
          if (_v_len31 < _v_len32)
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          int _v_len___dollar_tmp_m_328_m_12 = (_v_len31 - _v_len32);
          Expr _ve__dollar_tmp_m_328_m_12;
          _ve__dollar_tmp_m_328_m_12 = Expr (_ve_rest, 0, _v_len___dollar_tmp_m_328_m_12);
          _ve_bl__res__vars = empty;
        }
      _block5: {}
        Expr _ve_brv;
        for ( ; ; )
        {
          {
            if (_ve_bl__res__vars.get_len () != 0)
            {
              goto _iter2;
            }
            Expr _gs_auxcall7;
            RF_CALL (::refal::Arithm::Add, (_vs_num, _c_31), _gs_auxcall7);
            Expr _ge_branches__5;
            if (!RF_CALL (::refal::List::Map, (_c_32, (_gs_auxcall7 + _ve_vars () + _ve_brv ()), _ve_branches), _ge_branches__5))
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            {
              {
                int _v_len33 = _v_len__rest;
                int _v_len34 = 1;
                if (_v_len33 < _v_len34)
                {
                  goto _block6__branch1;
                }
                int _v_len___dollar_tmp_m_349_m_32 = (_v_len33 - _v_len34);
                if (_ve_rest.symbol_at (0))
                {
                  goto _block6__branch1;
                }
                Expr _v_deref__rest4 (Expr (_ve_rest, 0));
                int _v_len35 = _v_deref__rest4.get_len ();
                int _v_len36 = 1;
                if (_v_len35 < _v_len36)
                {
                  goto _block6__branch1;
                }
                int _v_len___dollar_tmp_m_349_m_29 = (_v_len35 - _v_len36);
                if (!_c_12.term_eq (_v_deref__rest4, 0))
                {
                  goto _block6__branch1;
                }
                Expr _ve__dollar_tmp_m_349_m_32;
                _ve__dollar_tmp_m_349_m_32 = Expr (_ve_rest, (0 + 1), _v_len___dollar_tmp_m_349_m_32);
                Expr _ve__dollar_tmp_m_349_m_29;
                _ve__dollar_tmp_m_349_m_29 = Expr (_v_deref__rest4, (0 + 1), _v_len___dollar_tmp_m_349_m_29);
                Expr _gs_auxcall8;
                RF_CALL (::refal::Arithm::Add, (_vs_num, _c_5), _gs_auxcall8);
                Expr _ge_auxcall9;
                RF_CALL (Rename_Vars, (_gs_auxcall8, _ve_vars, _ve_res__vars, _ve_rest), _ge_auxcall9);
                _ve_vars = empty;
                _ve_new__Snt = (_ve_new__Snt + (_vs_block + _ge_branches__5) () + _ge_auxcall9);
                _ge_Snt__0 = empty;
                goto _block6;
              }
            _block6__branch1: {}
              _ve_new__Snt = (_ve_new__Snt + (_vs_block + _ge_branches__5) ());
              _ge_Snt__0 = _ve_rest;
            }
          _block6: {}
            goto _exit__iter2;
          }
        _iter2: {}
          {
            {
              if (_ve_vars.get_len () < 1)
              {
                goto _block7__branch1;
              }
              if (_ve_vars.get_len () > ((_ve_vars.get_len () - 1) + (_ve_vars.get_len () - 1) + 1))
              {
                goto _block7__branch1;
              }
              if (_ve_bl__res__vars.get_len () < 1)
              {
                goto _block7__branch1;
              }
              if (_ve_bl__res__vars.get_len () > ((_ve_bl__res__vars.get_len () - 1) + (_ve_bl__res__vars.get_len () - 1) + 1))
              {
                goto _block7__branch1;
              }
              RF_lsplit (_ve_bl__res__vars, 0, _ve_1, _v_lsplit__bl__res__vars);
              for ( ; ; RF_iter(_ve_bl__res__vars)++)
              {
                {
                  if (!RF_iter(_ve_bl__res__vars))
                  {
                    goto _block7__branch1;
                  }
                  int _v_len37 = _v_lsplit__bl__res__vars.get_len ();
                  int _v_len38 = 1;
                  if (_v_len37 < _v_len38)
                  {
                    goto _block7__branch1;
                  }
                  int _v_len__2 = (_v_len37 - _v_len38);
                  if (_v_lsplit__bl__res__vars.symbol_at (0))
                  {
                    goto _continue1;
                  }
                  Expr _v_deref__lsplit__bl__res__vars (Expr (_v_lsplit__bl__res__vars, 0));
                  int _v_len39 = _v_deref__lsplit__bl__res__vars.get_len ();
                  int _v_len40 = 1;
                  if (_v_len39 < _v_len40)
                  {
                    goto _continue1;
                  }
                  int _v_len___dollar_tmp_m_336_m_32 = (_v_len39 - _v_len40);
                  Expr _ve_2;
                  _ve_2 = Expr (_v_lsplit__bl__res__vars, (0 + 1), _v_len__2);
                  Expr _ve__dollar_tmp_m_336_m_32;
                  _ve__dollar_tmp_m_336_m_32 = Expr (_v_deref__lsplit__bl__res__vars, 0, _v_len___dollar_tmp_m_336_m_32);
                  Expr _vt_name;
                  _vt_name = Expr (_v_deref__lsplit__bl__res__vars, (0 + _v_len___dollar_tmp_m_336_m_32), 1);
                  RF_lsplit (_ve_vars, 0, _ve__dollar_tmp_m_336_m_55, _v_lsplit__vars);
                  for ( ; ; RF_iter(_ve_vars)++)
                  {
                    {
                      if (!RF_iter(_ve_vars))
                      {
                        goto _continue1;
                      }
                      int _v_len41 = _v_lsplit__vars.get_len ();
                      int _v_len42 = 1;
                      if (_v_len41 < _v_len42)
                      {
                        goto _continue1;
                      }
                      int _v_len___dollar_tmp_m_336_m_68 = (_v_len41 - _v_len42);
                      if (_v_lsplit__vars.symbol_at (0))
                      {
                        goto _continue2;
                      }
                      Expr _v_deref__lsplit__vars (Expr (_v_lsplit__vars, 0));
                      int _v_len43 = _v_deref__lsplit__vars.get_len ();
                      int _v_len44 = 1;
                      if (_v_len43 < _v_len44)
                      {
                        goto _continue2;
                      }
                      int _v_len___dollar_tmp_m_336_m_58 = (_v_len43 - _v_len44);
                      if (!_vt_name.term_eq (_v_deref__lsplit__vars, (0 + _v_len___dollar_tmp_m_336_m_58)))
                      {
                        goto _continue2;
                      }
                      Expr _ve__dollar_tmp_m_336_m_68;
                      _ve__dollar_tmp_m_336_m_68 = Expr (_v_lsplit__vars, (0 + 1), _v_len___dollar_tmp_m_336_m_68);
                      Expr _ve__dollar_tmp_m_336_m_58;
                      _ve__dollar_tmp_m_336_m_58 = Expr (_v_deref__lsplit__vars, 0, _v_len___dollar_tmp_m_336_m_58);
                      _ve_brv = (_ve_brv + _ve_1);
                      _ve_bl__res__vars = _ve_2;
                      goto _exit2;
                    }
                _continue2: {}
                  }
                _exit2: {}
                  goto _exit1;
                }
            _continue1: {}
              }
            _exit1: {}
              goto _block7;
            }
          _block7__branch1: {}
            _ve_brv = (_ve_brv + _ve_bl__res__vars);
            _ve_bl__res__vars = empty;
          }
        _block7: {}
        }
      _exit__iter2: {}
        goto _block2;
      }
    _block2__branch3: {}
      {
        if (_vt_Statement.symbol_at (0))
        {
          goto _block2__branch4;
        }
        Expr _v_deref__Statement5 (Expr (_vt_Statement, 0));
        int _v_len45 = _v_deref__Statement5.get_len ();
        int _v_len46 = 1;
        if (_v_len45 < _v_len46)
        {
          goto _block2__branch4;
        }
        int _v_len__Sentence = (_v_len45 - _v_len46);
        if (!_c_2.term_eq (_v_deref__Statement5, 0))
        {
          goto _block2__branch4;
        }
        Expr _ve_Sentence;
        _ve_Sentence = Expr (_v_deref__Statement5, (0 + 1), _v_len__Sentence);
        Expr _ge_auxcall10;
        RF_CALL (Rename_Vars, (_vs_num, _ve_vars, _ve_res__vars, _ve_Sentence), _ge_auxcall10);
        _ve_vars = empty;
        _ve_new__Snt = (_ve_new__Snt + (_c_2 + _ge_auxcall10) ());
        _ge_Snt__0 = empty;
        goto _block2;
      }
    _block2__branch4: {}
      {
        if (_vt_Statement.symbol_at (0))
        {
          goto _block2__branch5;
        }
        Expr _v_deref__Statement6 (Expr (_vt_Statement, 0));
        if (_v_deref__Statement6.get_len () != 3)
        {
          goto _block2__branch5;
        }
        if (!_c_16.term_eq (_v_deref__Statement6, 0))
        {
          goto _block2__branch5;
        }
        Expr _vt_IterBody;
        _vt_IterBody = Expr (_v_deref__Statement6, (0 + 1), 1);
        Expr _vt_IterVars;
        _vt_IterVars = Expr (_v_deref__Statement6, (0 + 1 + 1), 1);
        Expr _v_Rename__Vars1;
        RF_CALL (Rename_Vars, (_vs_num, _ve_upper__vars, _ve_res__vars, (_vt_IterVars + _vt_IterBody)), _v_Rename__Vars1);
        int _v_len47 = _v_Rename__Vars1.get_len ();
        int _v_len48 = 1;
        if (_v_len47 < _v_len48)
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        int _v_len__new__body = (_v_len47 - _v_len48);
        Expr _vt_new__vars;
        _vt_new__vars = Expr (_v_Rename__Vars1, 0, 1);
        Expr _ve_new__body;
        _ve_new__body = Expr (_v_Rename__Vars1, (0 + 1), _v_len__new__body);
        Expr _v_Rename__Vars2;
        RF_CALL (Rename_Vars, (_vs_num, _ve_upper__vars, _ve_res__vars, (_vt_IterVars + _ve_rest)), _v_Rename__Vars2);
        int _v_len49 = _v_Rename__Vars2.get_len ();
        int _v_len50 = 1;
        if (_v_len49 < _v_len50)
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        int _v_len__new__rest = (_v_len49 - _v_len50);
        Expr _vt__dollar_tmp_m_363_m_14;
        _vt__dollar_tmp_m_363_m_14 = Expr (_v_Rename__Vars2, 0, 1);
        Expr _ve_new__rest;
        _ve_new__rest = Expr (_v_Rename__Vars2, (0 + 1), _v_len__new__rest);
        _ve_vars = empty;
        _ve_new__Snt = (_ve_new__Snt + (_c_16 + _ve_new__body + _vt_new__vars) () + _ve_new__rest);
        _ge_Snt__0 = empty;
        goto _block2;
      }
    _block2__branch5: {}
      {
        if (_vt_Statement.symbol_at (0))
        {
          goto _block2__branch6;
        }
        Expr _v_deref__Statement7 (Expr (_vt_Statement, 0));
        if (_v_deref__Statement7.get_len () != 3)
        {
          goto _block2__branch6;
        }
        if (!_c_17.term_eq (_v_deref__Statement7, 0))
        {
          goto _block2__branch6;
        }
        Expr _vt_TryBranch;
        _vt_TryBranch = Expr (_v_deref__Statement7, (0 + 1), 1);
        Expr _vt_CatchBranch;
        _vt_CatchBranch = Expr (_v_deref__Statement7, (0 + 1 + 1), 1);
        Expr _ve_TryBranch;
        RF_CALL (Rename_Vars, (_vs_num, _ve_upper__vars, _ve_res__vars, _vt_TryBranch), _ve_TryBranch);
        Expr _ve_CatchBranch;
        RF_CALL (Rename_Vars, (_vs_num, _ve_upper__vars, _ve_res__vars, _vt_CatchBranch), _ve_CatchBranch);
        _ve_vars = empty;
        _ve_new__Snt = (_ve_new__Snt + (_c_17 + _ve_TryBranch + _ve_CatchBranch) ());
        _ge_Snt__0 = empty;
        goto _block2;
      }
    _block2__branch6: {}
      {
        if (_vt_Statement.symbol_at (0))
        {
          goto _block2__branch7;
        }
        Expr _v_deref__Statement8 (Expr (_vt_Statement, 0));
        if (_v_deref__Statement8.get_len () != 2)
        {
          goto _block2__branch7;
        }
        if (!_c_15.term_eq (_v_deref__Statement8, 0))
        {
          goto _block2__branch7;
        }
        Expr _vt_branch;
        _vt_branch = Expr (_v_deref__Statement8, (0 + 1), 1);
        Expr _ge_auxcall11;
        RF_CALL (Rename_Vars, (_vs_num, _ve_vars, _ve_res__vars, _vt_branch), _ge_auxcall11);
        _ve_new__Snt = (_ve_new__Snt + (_c_15 + _ge_auxcall11) ());
        _ge_Snt__0 = _ve_rest;
        goto _block2;
      }
    _block2__branch7: {}
      _ve_new__Snt = (_ve_new__Snt + _vt_Statement);
      _ge_Snt__0 = _ve_rest;
    }
  _block2: {}
  }
_exit__iter1: {}
RF_END

RF_FUNC (IsOld_Var, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  int _v_len1 = _ge_arg1.get_len ();
  int _v_len2 = 1;
  if (_v_len1 < _v_len2)
  {
    RF_RETFAIL;
  }
  int _v_len__vars = (_v_len1 - _v_len2);
  if (_ge_arg1.symbol_at ((0 + _v_len__vars)))
  {
    RF_RETFAIL;
  }
  Expr _v_deref__arg1 (Expr (_ge_arg1, (0 + _v_len__vars)));
  int _v_len3 = _v_deref__arg1.get_len ();
  int _v_len4 = 1;
  if (_v_len3 < _v_len4)
  {
    RF_RETFAIL;
  }
  int _v_len___dollar_tmp_m_381_m_20 = (_v_len3 - _v_len4);
  Expr _ve_vars;
  _ve_vars = Expr (_ge_arg1, 0, _v_len__vars);
  Expr _ve__dollar_tmp_m_381_m_20;
  _ve__dollar_tmp_m_381_m_20 = Expr (_v_deref__arg1, 0, _v_len___dollar_tmp_m_381_m_20);
  Expr _vt_name;
  _vt_name = Expr (_v_deref__arg1, (0 + _v_len___dollar_tmp_m_381_m_20), 1);
  if (_v_len__vars < 1)
  {
    RF_RETFAIL;
  }
  RF_lsplit (_ve_vars, 0, _ve__dollar_tmp_m_381_m_41, _v_lsplit__vars);
  for ( ; ; RF_iter(_ve_vars)++)
  {
    {
      if (!RF_iter(_ve_vars))
      {
        RF_RETFAIL;
      }
      int _v_len5 = _v_lsplit__vars.get_len ();
      int _v_len6 = 1;
      if (_v_len5 < _v_len6)
      {
        RF_RETFAIL;
      }
      int _v_len___dollar_tmp_m_381_m_54 = (_v_len5 - _v_len6);
      if (_v_lsplit__vars.symbol_at (0))
      {
        goto _continue1;
      }
      Expr _v_deref__lsplit__vars (Expr (_v_lsplit__vars, 0));
      int _v_len7 = _v_deref__lsplit__vars.get_len ();
      int _v_len8 = 1;
      if (_v_len7 < _v_len8)
      {
        goto _continue1;
      }
      int _v_len___dollar_tmp_m_381_m_44 = (_v_len7 - _v_len8);
      if (!_vt_name.term_eq (_v_deref__lsplit__vars, (0 + _v_len___dollar_tmp_m_381_m_44)))
      {
        goto _continue1;
      }
      Expr _ve__dollar_tmp_m_381_m_54;
      _ve__dollar_tmp_m_381_m_54 = Expr (_v_lsplit__vars, (0 + 1), _v_len___dollar_tmp_m_381_m_54);
      Expr _ve__dollar_tmp_m_381_m_44;
      _ve__dollar_tmp_m_381_m_44 = Expr (_v_deref__lsplit__vars, 0, _v_len___dollar_tmp_m_381_m_44);
      _v_res1 = empty;
      goto _exit1;
    }
_continue1: {}
  }
_exit1: {}
RF_END

RF_FUNC (Rename, (RF_ARG _vs_num, _vs_tag, _ve_name;;), (RF_RES _v_res1, _v_res2, _v_res3;;))
  _v_res1 = _vs_tag;
  _v_res2 = _ve_name;
  _v_res3 = _vs_num;
RF_END

RF_FUNC (Build_Subst, (RF_ARG _ge_arg1, _ge_arg2, _ge_arg3;;), (RF_RES _v_res1, _v_res2;;))
  {
    {
      int _v_len1 = (_ge_arg3.get_len () + 2);
      int _v_len2 = 2;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      int _v_len__Snt = (_v_len1 - _v_len2);
      Expr _v_compose1 ((_ge_arg1 () + _ge_arg2 () + _ge_arg3));
      if (_v_compose1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      if (_v_compose1.symbol_at ((0 + 1)))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__compose1 (Expr (_v_compose1, 0));
      Expr _v_deref__compose12 (Expr (_v_compose1, (0 + 1)));
      int _v_len3 = _v_deref__compose12.get_len ();
      int _v_len4 = 1;
      if (_v_len3 < _v_len4)
      {
        goto _block1__branch1;
      }
      int _v_len__substs = (_v_len3 - _v_len4);
      int _v_len5 = _v_deref__compose1.get_len ();
      int _v_len6 = 1;
      if (_v_len5 < _v_len6)
      {
        goto _block1__branch1;
      }
      int _v_len__vars = (_v_len5 - _v_len6);
      if (_v_deref__compose1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      if (_v_deref__compose12.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__deref__compose1 (Expr (_v_deref__compose1, 0));
      Expr _v_deref__deref__compose12 (Expr (_v_deref__compose12, 0));
      int _v_len7 = _v_deref__deref__compose12.get_len ();
      int _v_len8 = 2;
      if (_v_len7 < _v_len8)
      {
        goto _block1__branch1;
      }
      int _v_len___dollar_tmp_m_389_m_34 = (_v_len7 - _v_len8);
      int _v_len9 = _v_deref__deref__compose1.get_len ();
      int _v_len10 = 2;
      if (_v_len9 < _v_len10)
      {
        goto _block1__branch1;
      }
      int _v_len___dollar_tmp_m_389_m_12 = (_v_len9 - _v_len10);
      if (!_v_deref__deref__compose1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      if (!_v_deref__deref__compose12.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _ve_Snt;
      _ve_Snt = Expr (_v_compose1, (0 + 1 + 1), _v_len__Snt);
      Expr _ve_vars;
      _ve_vars = Expr (_v_deref__compose1, (0 + 1), _v_len__vars);
      Expr _ve_substs;
      _ve_substs = Expr (_v_deref__compose12, (0 + 1), _v_len__substs);
      Expr _vs_tag;
      _vs_tag = Expr (_v_deref__deref__compose1, 0, 1);
      Expr _ve__dollar_tmp_m_389_m_12;
      _ve__dollar_tmp_m_389_m_12 = Expr (_v_deref__deref__compose1, (0 + 1), _v_len___dollar_tmp_m_389_m_12);
      Expr _vt_name;
      _vt_name = Expr (_v_deref__deref__compose1, (0 + 1 + _v_len___dollar_tmp_m_389_m_12), 1);
      Expr _vs__dollar_tmp_m_389_m_32;
      _vs__dollar_tmp_m_389_m_32 = Expr (_v_deref__deref__compose12, 0, 1);
      Expr _ve__dollar_tmp_m_389_m_34;
      _ve__dollar_tmp_m_389_m_34 = Expr (_v_deref__deref__compose12, (0 + 1), _v_len___dollar_tmp_m_389_m_34);
      Expr _vt_s;
      _vt_s = Expr (_v_deref__deref__compose12, (0 + 1 + _v_len___dollar_tmp_m_389_m_34), 1);
      Expr _ve_var__pats;
      Expr _ve_var__repls;
      RF_CALL (Var_Subst, (_vs_tag, _vt_name, _vt_s, _ve_Snt), (_ve_var__pats, _ve_var__repls));
      Expr _ve_pats;
      Expr _ve_repls;
      RF_CALL (Build_Subst, (_ve_vars, _ve_substs, _ve_Snt), (_ve_pats, _ve_repls));
      _v_res1 = (_ve_var__pats + _ve_pats);
      _v_res2 = (_ve_var__repls + _ve_repls);
      goto _block1;
    }
  _block1__branch1: {}
    int _v_len11 = (_ge_arg3.get_len () + 2);
    int _v_len12 = 2;
    if (_v_len11 < _v_len12)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    int _v_len___dollar_tmp_m_393_m_10 = (_v_len11 - _v_len12);
    Expr _v_compose2 ((_ge_arg1 () + _ge_arg2 () + _ge_arg3));
    if (!_c_33.eq (_v_compose2, 0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _ve__dollar_tmp_m_393_m_10;
    _ve__dollar_tmp_m_393_m_10 = Expr (_v_compose2, (0 + 1 + 1), _v_len___dollar_tmp_m_393_m_10);
    _v_res1 = empty;
    _v_res2 = empty;
  }
_block1: {}
RF_END

RF_FUNC (Var_Subst, (RF_ARG _vs_tag, _vt_n, _vt_s, _ve_Snt;;), (RF_RES _v_res1, _v_res2;;))
  {
    {
      int _v_len1 = _ve_Snt.get_len ();
      int _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      int _v_len__rest = (_v_len1 - _v_len2);
      Expr _vt_Statement;
      _vt_Statement = Expr (_ve_Snt, 0, 1);
      Expr _ve_rest;
      _ve_rest = Expr (_ve_Snt, (0 + 1), _v_len__rest);
      Expr _ve_st__pats;
      Expr _ve_st__repls;
      {
        {
          Expr _ve_p;
          Expr _vt_name;
          {
            {
              if (_vt_Statement.symbol_at (0))
              {
                goto _block3__branch1;
              }
              Expr _v_deref__Statement (Expr (_vt_Statement, 0));
              if (_v_deref__Statement.get_len () != 3)
              {
                goto _block3__branch1;
              }
              if (!_vs_tag.term_eq (_v_deref__Statement, 0))
              {
                goto _block3__branch1;
              }
              Expr _gt_p__6;
              _gt_p__6 = Expr (_v_deref__Statement, (0 + 1), 1);
              Expr _gt_name__6;
              _gt_name__6 = Expr (_v_deref__Statement, (0 + 1 + 1), 1);
              _ve_p = _gt_p__6;
              _vt_name = _gt_name__6;
              goto _block3;
            }
          _block3__branch1: {}
            if (_vt_Statement.symbol_at (0))
            {
              goto _block2__branch1;
            }
            Expr _v_deref__Statement2 (Expr (_vt_Statement, 0));
            if (_v_deref__Statement2.get_len () != 2)
            {
              goto _block2__branch1;
            }
            if (!_vs_tag.term_eq (_v_deref__Statement2, 0))
            {
              goto _block2__branch1;
            }
            Expr _gt_name__6;
            _gt_name__6 = Expr (_v_deref__Statement2, (0 + 1), 1);
            _ve_p = empty;
            _vt_name = _gt_name__6;
          }
        _block3: {}
          {
            {
              if (!_vt_n.term_eq (_vt_name, 0))
              {
                goto _block4__branch1;
              }
              _ve_st__pats = _vt_Statement;
              _ve_st__repls = (_vs_tag + _ve_p + _vt_s) () ();
              goto _block4;
            }
          _block4__branch1: {}
            _ve_st__pats = empty;
            _ve_st__repls = empty;
          }
        _block4: {}
          goto _block2;
        }
      _block2__branch1: {}
        {
          if (_vt_Statement.symbol_at (0))
          {
            goto _block2__branch2;
          }
          Expr _v_deref__Statement3 (Expr (_vt_Statement, 0));
          int _v_len3 = _v_deref__Statement3.get_len ();
          int _v_len4 = 0;
          if (_v_len3 < _v_len4)
          {
            goto _block2__branch2;
          }
          int _v_len__xpr = (_v_len3 - _v_len4);
          Expr _ve_xpr;
          _ve_xpr = Expr (_v_deref__Statement3, 0, _v_len__xpr);
          RF_CALL (Var_Subst, (_vs_tag, _vt_n, _vt_s, _ve_xpr), (_ve_st__pats, _ve_st__repls));
          goto _block2;
        }
      _block2__branch2: {}
        _ve_st__pats = empty;
        _ve_st__repls = empty;
      }
    _block2: {}
      Expr _ve_pats;
      Expr _ve_repls;
      RF_CALL (Var_Subst, (_vs_tag, _vt_n, _vt_s, _ve_rest), (_ve_pats, _ve_repls));
      _v_res1 = (_ve_st__pats + _ve_pats);
      _v_res2 = (_ve_st__repls + _ve_repls);
      goto _block1;
    }
  _block1__branch1: {}
    _v_res1 = empty;
    _v_res2 = empty;
  }
_block1: {}
RF_END

RF_FUNC (Rename_Vars_0, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  int _v_len1 = _ge_arg1.get_len ();
  int _v_len2 = 3;
  if (_v_len1 < _v_len2)
  {
    RF_ERROR (_c_34);
  }
  int _v_len__stub1 = (_v_len1 - _v_len2);
  if (_ge_arg1.symbol_at ((0 + 1)))
  {
    RF_ERROR (_c_34);
  }
  if (_ge_arg1.symbol_at ((0 + 1 + 1)))
  {
    RF_ERROR (_c_34);
  }
  Expr _v_deref__arg1 (Expr (_ge_arg1, (0 + 1)));
  Expr _v_deref__arg12 (Expr (_ge_arg1, (0 + 1 + 1)));
  int _v_len3 = _v_deref__arg12.get_len ();
  int _v_len4 = 0;
  if (_v_len3 < _v_len4)
  {
    RF_ERROR (_c_34);
  }
  int _v_len__stub2 = (_v_len3 - _v_len4);
  int _v_len5 = _v_deref__arg1.get_len ();
  int _v_len6 = 0;
  if (_v_len5 < _v_len6)
  {
    RF_ERROR (_c_34);
  }
  int _v_len__stub3 = (_v_len5 - _v_len6);
  if (!_ge_arg1.symbol_at (0))
  {
    RF_ERROR (_c_34);
  }
  Expr _v_stub4;
  _v_stub4 = Expr (_ge_arg1, 0, 1);
  Expr _v_stub1;
  _v_stub1 = Expr (_ge_arg1, (0 + 1 + 1 + 1), _v_len__stub1);
  Expr _v_stub3;
  _v_stub3 = Expr (_v_deref__arg1, 0, _v_len__stub3);
  Expr _v_stub2;
  _v_stub2 = Expr (_v_deref__arg12, 0, _v_len__stub2);
  RF_TAILCALL (Rename_Vars, (_v_stub4, _v_stub3, _v_stub2, _v_stub1), _v_res1);
RF_END

RF_FUNC (Rename_0, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  if (_ge_arg1.get_len () != 2)
  {
    RF_ERROR (_c_34);
  }
  if (_ge_arg1.symbol_at ((0 + 1)))
  {
    RF_ERROR (_c_34);
  }
  Expr _v_deref__arg1 (Expr (_ge_arg1, (0 + 1)));
  if (_v_deref__arg1.get_len () != 2)
  {
    RF_ERROR (_c_34);
  }
  if (_v_deref__arg1.symbol_at ((0 + 1)))
  {
    RF_ERROR (_c_34);
  }
  Expr _v_deref__deref__arg1 (Expr (_v_deref__arg1, (0 + 1)));
  int _v_len1 = _v_deref__deref__arg1.get_len ();
  int _v_len2 = 0;
  if (_v_len1 < _v_len2)
  {
    RF_ERROR (_c_34);
  }
  int _v_len__stub1 = (_v_len1 - _v_len2);
  if (!_ge_arg1.symbol_at (0))
  {
    RF_ERROR (_c_34);
  }
  if (!_v_deref__arg1.symbol_at (0))
  {
    RF_ERROR (_c_34);
  }
  Expr _v_stub2;
  _v_stub2 = Expr (_ge_arg1, 0, 1);
  Expr _v_stub3;
  _v_stub3 = Expr (_v_deref__arg1, 0, 1);
  Expr _v_stub1;
  _v_stub1 = Expr (_v_deref__deref__arg1, 0, _v_len__stub1);
  Expr _v_Rename1;
  Expr _v_Rename2;
  Expr _v_Rename3;
  RF_CALL (Rename, (_v_stub2, _v_stub3, _v_stub1), (_v_Rename1, _v_Rename2, _v_Rename3));
  _v_res1 = (_v_Rename1 + (_v_Rename2 + _c_35 + _v_Rename3) ()) ();
RF_END

}

}

}

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_as2as {

static void init_ () {
  Free_Idx = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Free_Idx");
  _c_0 = Expr::create<rftype::Word>("ITEMS");
  _c_1 = Expr::create<rftype::Word>("PRAGMA");
  _c_2 = Expr::create<rftype::Word>("BRANCH");
  _c_3 = Expr::create<rftype::Word>("DBG");
  _c_28 = Expr::create<rftype::Word>("RESULT") + (_c_1) ();
  _c_4 = Expr (_c_28, 0, 1);
  _c_5 = Expr::create<rftype::Integer>("1");
  _c_6 = Expr::create<rftype::Integer>("0");
  _c_7 = Expr::create<rftype::Word>("ALT");
  _c_8 = Expr::create<rftype::Word>("ALT?");
  _c_9 = Expr::create<rftype::Word>("LEFT");
  _c_10 = Expr::create<rftype::Word>("RIGHT");
  _c_11 = Expr::create<rftype::Word>("aux") + Expr::create<rftype::Word>("alt");
  _c_12 = Expr::create<rftype::Word>("FORMAT");
  _c_13 = Expr::create<rftype::Word>("Tail");
  _c_14 = Expr::create<rftype::Word>("FAIL");
  _c_15 = Expr::create<rftype::Word>("NOT");
  _c_16 = Expr::create<rftype::Word>("ITER");
  _c_17 = Expr::create<rftype::Word>("TRY");
  _c_18 = Expr::create<rftype::Word>("ERROR");
  _c_19 = (_c_14) ();
  _c_20 = Expr::create<rftype::Word>("aux") + Expr::create<rftype::Word>("block");
  _c_21 = Expr::create<rftype::Word>("CALL");
  _c_22 = Expr::create<rftype::Word>("Not-Tail");
  _c_23 = Expr::create<rftype::Word>("aux") + Expr::create<rftype::Word>("call");
  _c_24 = Expr::create<rftype::Word>("PAREN");
  _c_25 = Expr::create<rftype::Word>("With_pragmas");
  _c_26 = Expr::create<rftype::Word>("Without_pragmas");
  _c_27 = Expr::create<rftype::Word>("arg");
  _c_29 = Expr::create_sym<rftype::Func> (IsOld_Var);
  _c_30 = Expr::create_sym<rftype::Func> (Rename_0);
  _c_31 = Expr::create<rftype::Integer>("2");
  _c_32 = Expr::create_sym<rftype::Func> (Rename_Vars_0);
  _c_33 = (empty) () + (empty) ();
  _c_34 = Expr::create<rftype::Word>("Apply") + Expr::create<rftype::Word>("Apply") + Expr::create<rftype::Word>("Unexpected fail");
  _c_35 = Expr::create<rftype::Word>("_");
}

static AtStart init_registrator_ (&init_);

}

}

}

}

}
