
#include <rf_core.hh>

using namespace rfrt;

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_asail2asail {

RF_DECL (Cmp);

RF_DECL (Add_0);

RF_DECL (Eval_Div);

RF_DECL (Eval_Add);

RF_DECL (Eval_Rem);

RF_DECL (Eval_Mult);

RF_DECL (Free_Idx);

RF_DECL (GetR);

RF_DECL (IsInt_0);

RF_DECL (Gt_0);

RF_DECL (Process_Var);

RF_DECL (Ne_0);

RF_DECL (Lt_0);

RF_DECL (Remove_Unreachable2);

RF_DECL (Remove_Unreachable);

RF_DECL (Simplify_ASAIL);

RF_DECL (Simplify);

RF_DECL (Remove_Dupl_Decl);

RF_DECL (Eval__);

RF_DECL (Simplify_Infix);

RF_DECL (Simplify_Cmp);

}

}

}

}

}

namespace refal {

namespace Apply {

RF_DECL (Apply);

}

}

namespace refal {

namespace Arithm {

RF_DECL (Mult);

RF_DECL (Add);

}

}

namespace refal {

namespace Box {

RF_DECL (Put);

RF_DECL (Get);

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_asail2asail {

RF_DECL (Simplify_Infix_0);

}

}

}

}

}

namespace refal {

namespace Compare {

RF_DECL (Gt);

}

}

namespace refal {

namespace Class {

RF_DECL (IsInt);

}

}

namespace refal {

namespace Compare {

RF_DECL (Ne);

RF_DECL (Lt);

}

}

namespace refal {

namespace List {

RF_DECL (Foldr1);

RF_DECL (All);

}

}

namespace refal {

namespace Box {

RF_DECL (Store);

}

}

namespace refal {

namespace List {

RF_DECL (Paren);

}

}

namespace refal {

namespace Table {

RF_DECL (ClearTable);

RF_DECL (Bind);

RF_DECL (Lookup);

RF_DECL (Unbind);

RF_DECL (IsInTable);

}

}

namespace refal {

namespace List {

RF_DECL (Map);

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_asail2asail {

RF_DECL (Simplify_Arithm);

}

}

}

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_asail2asail {

static Expr Idx;

static Expr Blocks;

static Expr Breaks;

static Expr Last_Breaks;

static Expr _c_0;

static Expr _c_1;

static Expr _c_2;

static Expr _c_3;

static Expr _c_4;

static Expr _c_5;

static Expr _c_6;

static Expr _c_7;

static Expr _c_8;

static Expr _c_9;

static Expr _c_10;

static Expr _c_11;

static Expr _c_12;

static Expr _c_13;

static Expr _c_14;

static Expr _c_15;

static Expr _c_16;

static Expr _c_17;

static Expr _c_18;

static Expr _c_19;

static Expr _c_20;

static Expr _c_21;

static Expr _c_22;

static Expr _c_23;

static Expr _c_24;

static Expr _c_25;

static Expr _c_39;

static Expr _c_26;

static Expr _c_27;

static Expr _c_28;

static Expr _c_29;

static Expr _c_30;

static Expr _c_31;

static Expr _c_32;

static Expr _c_33;

static Expr _c_34;

static Expr _c_35;

static Expr _c_36;

static Expr _c_37;

static Expr _c_38;

static Expr _c_40;

static Expr _c_41;

static Expr _c_42;

static Expr _c_43;

static Expr _c_44;

static Expr _c_45;

static Expr _c_46;

static Expr _c_47;

static Expr _c_48;

static Expr _c_49;

static Expr _c_50;

RF_FUNC (Simplify_ASAIL, (RF_ARG _gt_arg1;;), (RF_RES _v_res1;;))
  if (_gt_arg1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _v_deref__arg1 (Expr (_gt_arg1, 0));
  int _v_len1 = _v_deref__arg1.get_len ();
  int _v_len2 = 2;
  if (_v_len1 < _v_len2)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  int _v_len__asail = (_v_len1 - _v_len2);
  if (!_c_0.term_eq (_v_deref__arg1, 0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _vt_ModuleName;
  _vt_ModuleName = Expr (_v_deref__arg1, (0 + 1), 1);
  Expr _ve_asail;
  _ve_asail = Expr (_v_deref__arg1, (0 + 1 + 1), _v_len__asail);
  RF_CALL (::refal::Box::Store, (Idx, empty), /*void*/);
  Expr _ge_auxcall1;
  RF_CALL (Simplify, _ve_asail, _ge_auxcall1);
  Expr _ge_auxcall2;
  RF_CALL (Remove_Unreachable, _ge_auxcall1, _ge_auxcall2);
  Expr _ge_auxcall3;
  RF_CALL (Remove_Dupl_Decl, (empty, empty, _ge_auxcall2), _ge_auxcall3);
  _v_res1 = (_c_0 + _vt_ModuleName + _ge_auxcall3) ();
RF_END

RF_FUNC (Simplify, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  {
    {
      int _v_len1 = _ge_arg1.get_len ();
      int _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      int _v_len__rest = (_v_len1 - _v_len2);
      Expr _vt_first;
      _vt_first = Expr (_ge_arg1, 0, 1);
      Expr _ve_rest;
      _ve_rest = Expr (_ge_arg1, (0 + 1), _v_len__rest);
      Expr _ge_first__3;
      {
        {
          if (_vt_first.symbol_at (0))
          {
            goto _block2__branch1;
          }
          Expr _v_deref__first (Expr (_vt_first, 0));
          int _v_len3 = _v_deref__first.get_len ();
          int _v_len4 = 4;
          if (_v_len3 < _v_len4)
          {
            goto _block2__branch1;
          }
          int _v_len__body = (_v_len3 - _v_len4);
          if (_v_deref__first.symbol_at ((0 + 1 + 1)))
          {
            goto _block2__branch1;
          }
          if (_v_deref__first.symbol_at ((0 + 1 + 1 + 1)))
          {
            goto _block2__branch1;
          }
          Expr _v_deref__deref__first (Expr (_v_deref__first, (0 + 1 + 1)));
          Expr _v_deref__deref__first2 (Expr (_v_deref__first, (0 + 1 + 1 + 1)));
          int _v_len5 = _v_deref__deref__first2.get_len ();
          int _v_len6 = 0;
          if (_v_len5 < _v_len6)
          {
            goto _block2__branch1;
          }
          int _v_len__arg2 = (_v_len5 - _v_len6);
          int _v_len7 = _v_deref__deref__first.get_len ();
          int _v_len8 = 0;
          if (_v_len7 < _v_len8)
          {
            goto _block2__branch1;
          }
          int _v_len__arg1 = (_v_len7 - _v_len8);
          if (!_c_1.term_eq (_v_deref__first, 0))
          {
            goto _block2__branch1;
          }
          if (!_v_deref__first.symbol_at ((0 + 1)))
          {
            goto _block2__branch1;
          }
          Expr _vs_op;
          _vs_op = Expr (_v_deref__first, (0 + 1), 1);
          Expr _ve_body;
          _ve_body = Expr (_v_deref__first, (0 + 1 + 1 + 1 + 1), _v_len__body);
          Expr _ve_arg1;
          _ve_arg1 = Expr (_v_deref__deref__first, 0, _v_len__arg1);
          Expr _ve_arg2;
          _ve_arg2 = Expr (_v_deref__deref__first2, 0, _v_len__arg2);
          {
            {
              Expr _ge_auxcall1;
              RF_CALL (Simplify_Arithm, _ve_arg1 (), _ge_auxcall1);
              Expr _ge_auxcall2;
              RF_CALL (Simplify_Arithm, _ve_arg2 (), _ge_auxcall2);
              Expr _v_Simplify__Cmp1;
              if (!RF_CALL (Simplify_Cmp, (_vs_op, _ge_auxcall1, _ge_auxcall2), _v_Simplify__Cmp1))
              {
                goto _block3__branch1;
              }
              {
                {
                  if (_v_Simplify__Cmp1.get_len () != 2)
                  {
                    goto _block4__branch1;
                  }
                  if (_v_Simplify__Cmp1.symbol_at (0))
                  {
                    goto _block4__branch1;
                  }
                  if (_v_Simplify__Cmp1.symbol_at ((0 + 1)))
                  {
                    goto _block4__branch1;
                  }
                  Expr _v_deref__Simplify__Cmp1 (Expr (_v_Simplify__Cmp1, 0));
                  Expr _v_deref__Simplify__Cmp12 (Expr (_v_Simplify__Cmp1, (0 + 1)));
                  int _v_len9 = _v_deref__Simplify__Cmp12.get_len ();
                  int _v_len10 = 0;
                  if (_v_len9 < _v_len10)
                  {
                    goto _block4__branch1;
                  }
                  int _v_len__2 = (_v_len9 - _v_len10);
                  int _v_len11 = _v_deref__Simplify__Cmp1.get_len ();
                  int _v_len12 = 0;
                  if (_v_len11 < _v_len12)
                  {
                    goto _block4__branch1;
                  }
                  int _v_len__1 = (_v_len11 - _v_len12);
                  Expr _ve_1;
                  _ve_1 = Expr (_v_deref__Simplify__Cmp1, 0, _v_len__1);
                  Expr _ve_2;
                  _ve_2 = Expr (_v_deref__Simplify__Cmp12, 0, _v_len__2);
                  Expr _ge_auxcall3;
                  RF_CALL (Simplify, _ve_body, _ge_auxcall3);
                  _ge_first__3 = (_c_1 + _vs_op + _ve_1 () + _ve_2 () + _ge_auxcall3) ();
                  goto _block4;
                }
              _block4__branch1: {}
                if (_v_Simplify__Cmp1.get_len () != 0)
                {
                  RF_FUNC_ERROR (unexpected_fail);
                }
                RF_CALL (Simplify, _ve_body, _ge_first__3);
              }
            _block4: {}
              goto _block3;
            }
          _block3__branch1: {}
            _ge_first__3 = empty;
          }
        _block3: {}
          goto _block2;
        }
      _block2__branch1: {}
        {
          if (_vt_first.symbol_at (0))
          {
            goto _block2__branch2;
          }
          Expr _v_deref__first2 (Expr (_vt_first, 0));
          int _v_len13 = _v_deref__first2.get_len ();
          int _v_len14 = 2;
          if (_v_len13 < _v_len14)
          {
            goto _block2__branch2;
          }
          int _v_len__body2 = (_v_len13 - _v_len14);
          if (!_c_2.term_eq (_v_deref__first2, 0))
          {
            goto _block2__branch2;
          }
          Expr _vt_cond;
          _vt_cond = Expr (_v_deref__first2, (0 + 1), 1);
          Expr _ve_body;
          _ve_body = Expr (_v_deref__first2, (0 + 1 + 1), _v_len__body2);
          Expr _ge_auxcall4;
          RF_CALL (Simplify, _ve_body, _ge_auxcall4);
          _ge_first__3 = (_c_2 + _vt_cond + _ge_auxcall4) ();
          goto _block2;
        }
      _block2__branch2: {}
        {
          if (_vt_first.symbol_at (0))
          {
            goto _block2__branch3;
          }
          Expr _v_deref__first3 (Expr (_vt_first, 0));
          int _v_len15 = _v_deref__first3.get_len ();
          int _v_len16 = 2;
          if (_v_len15 < _v_len16)
          {
            goto _block2__branch3;
          }
          int _v_len__expr = (_v_len15 - _v_len16);
          if (_v_deref__first3.symbol_at ((0 + 1)))
          {
            goto _block2__branch3;
          }
          Expr _v_deref__deref__first3 (Expr (_v_deref__first3, (0 + 1)));
          if (_v_deref__deref__first3.get_len () != 2)
          {
            goto _block2__branch3;
          }
          if (!_c_4.term_eq (_v_deref__first3, 0))
          {
            goto _block2__branch3;
          }
          if (!_c_3.term_eq (_v_deref__deref__first3, 0))
          {
            goto _block2__branch3;
          }
          Expr _ve_expr;
          _ve_expr = Expr (_v_deref__first3, (0 + 1 + 1), _v_len__expr);
          Expr _vt_var;
          _vt_var = Expr (_v_deref__deref__first3, (0 + 1), 1);
          Expr _ge_auxcall5;
          RF_CALL (Simplify_Arithm, _ve_expr (), _ge_auxcall5);
          _ge_first__3 = (_c_4 + (_c_3 + _vt_var) () + _ge_auxcall5) ();
          goto _block2;
        }
      _block2__branch3: {}
        {
          if (_vt_first.symbol_at (0))
          {
            goto _block2__branch4;
          }
          Expr _v_deref__first4 (Expr (_vt_first, 0));
          int _v_len17 = _v_deref__first4.get_len ();
          int _v_len18 = 2;
          if (_v_len17 < _v_len18)
          {
            goto _block2__branch4;
          }
          int _v_len__expr2 = (_v_len17 - _v_len18);
          if (_v_deref__first4.symbol_at ((0 + 1)))
          {
            goto _block2__branch4;
          }
          Expr _v_deref__deref__first4 (Expr (_v_deref__first4, (0 + 1)));
          if (_v_deref__deref__first4.get_len () != 2)
          {
            goto _block2__branch4;
          }
          if (!_c_5.term_eq (_v_deref__first4, 0))
          {
            goto _block2__branch4;
          }
          if (!_c_3.term_eq (_v_deref__deref__first4, 0))
          {
            goto _block2__branch4;
          }
          Expr _ve_expr;
          _ve_expr = Expr (_v_deref__first4, (0 + 1 + 1), _v_len__expr2);
          Expr _vt_var;
          _vt_var = Expr (_v_deref__deref__first4, (0 + 1), 1);
          Expr _ge_auxcall6;
          RF_CALL (Simplify_Arithm, _ve_expr (), _ge_auxcall6);
          _ge_first__3 = (_c_5 + (_c_3 + _vt_var) () + _ge_auxcall6) ();
          goto _block2;
        }
      _block2__branch4: {}
        {
          if (_vt_first.symbol_at (0))
          {
            goto _block2__branch5;
          }
          Expr _v_deref__first5 (Expr (_vt_first, 0));
          int _v_len19 = _v_deref__first5.get_len ();
          int _v_len20 = 0;
          if (_v_len19 < _v_len20)
          {
            goto _block2__branch5;
          }
          int _v_len__12 = (_v_len19 - _v_len20);
          Expr _ve_1;
          _ve_1 = Expr (_v_deref__first5, 0, _v_len__12);
          Expr _ge_auxcall7;
          RF_CALL (Simplify, _ve_1, _ge_auxcall7);
          _ge_first__3 = _ge_auxcall7 ();
          goto _block2;
        }
      _block2__branch5: {}
        if (!_vt_first.symbol_at (0))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        Expr _vs_1;
        _vs_1 = Expr (_vt_first, 0, 1);
        _ge_first__3 = _vs_1;
      }
    _block2: {}
      Expr _v_Simplify1;
      RF_CALL (Simplify, _ve_rest, _v_Simplify1);
      _v_res1 = (_ge_first__3 + _v_Simplify1);
      goto _block1;
    }
  _block1__branch1: {}
    if (_ge_arg1.get_len () != 0)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    _v_res1 = empty;
  }
_block1: {}
RF_END

RF_FUNC (GetR, (RF_ARG _vs_box;;), (RF_RES _v_res1;;))
  Expr _v_Get1;
  RF_CALL (::refal::Box::Get, _vs_box, _v_Get1);
  int _v_len1 = _v_Get1.get_len ();
  int _v_len2 = 1;
  if (_v_len1 < _v_len2)
  {
    RF_RETFAIL;
  }
  int _v_len__1 = (_v_len1 - _v_len2);
  Expr _ve_1;
  _ve_1 = Expr (_v_Get1, 0, _v_len__1);
  Expr _vt_2;
  _vt_2 = Expr (_v_Get1, (0 + _v_len__1), 1);
  RF_CALL (::refal::Box::Store, (_vs_box, _ve_1), /*void*/);
  _v_res1 = _vt_2;
RF_END

RF_FUNC (Remove_Unreachable, (RF_ARG _ve_asail;;), (RF_RES _v_res1;;))
  Expr _ve_head;
  Expr _ve_tail (_ve_asail);
  for ( ; ; )
  {
    {
      if (_ve_tail.get_len () != 0)
      {
        goto _iter1;
      }
      _v_res1 = _ve_head;
      goto _exit__iter1;
    }
  _iter1: {}
    Expr _v_Remove__Unreachable21;
    RF_CALL (Remove_Unreachable2, _ve_tail, (_v_Remove__Unreachable21, _ve_tail));
    _ve_head = (_ve_head + _v_Remove__Unreachable21);
  }
_exit__iter1: {}
RF_END

RF_FUNC (Remove_Unreachable2, (RF_ARG _ge_arg1;;), (RF_RES _v_res1, _v_res2;;))
  {
    {
      int _v_len1 = _ge_arg1.get_len ();
      int _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      int _v_len__2 = (_v_len1 - _v_len2);
      Expr _vt_1;
      _vt_1 = Expr (_ge_arg1, 0, 1);
      Expr _ve_2;
      _ve_2 = Expr (_ge_arg1, (0 + 1), _v_len__2);
      Expr _ve_body;
      {
        {
          if (_vt_1.symbol_at (0))
          {
            goto _block2__branch1;
          }
          Expr _v_deref__1 (Expr (_vt_1, 0));
          int _v_len3 = _v_deref__1.get_len ();
          int _v_len4 = 4;
          if (_v_len3 < _v_len4)
          {
            goto _block2__branch1;
          }
          int _v_len__body__4 = (_v_len3 - _v_len4);
          if (!_c_6.term_eq (_v_deref__1, 0))
          {
            goto _block2__branch1;
          }
          Expr _vt_name;
          _vt_name = Expr (_v_deref__1, (0 + 1), 1);
          Expr _vt_in;
          _vt_in = Expr (_v_deref__1, (0 + 1 + 1), 1);
          Expr _vt_out;
          _vt_out = Expr (_v_deref__1, (0 + 1 + 1 + 1), 1);
          Expr _ge_body__4;
          _ge_body__4 = Expr (_v_deref__1, (0 + 1 + 1 + 1 + 1), _v_len__body__4);
          RF_CALL (::refal::Box::Put, (Blocks, (_c_6 + _vt_name + _vt_in + _vt_out) ()), /*void*/);
          RF_CALL (::refal::Table::ClearTable, Breaks, /*void*/);
          _ve_body = _ge_body__4;
          goto _block2;
        }
      _block2__branch1: {}
        {
          if (_vt_1.symbol_at (0))
          {
            goto _block2__branch2;
          }
          Expr _v_deref__12 (Expr (_vt_1, 0));
          int _v_len5 = _v_deref__12.get_len ();
          int _v_len6 = 4;
          if (_v_len5 < _v_len6)
          {
            goto _block2__branch2;
          }
          int _v_len__body__42 = (_v_len5 - _v_len6);
          if (!_c_7.term_eq (_v_deref__12, 0))
          {
            goto _block2__branch2;
          }
          Expr _vt_name;
          _vt_name = Expr (_v_deref__12, (0 + 1), 1);
          Expr _vt_in;
          _vt_in = Expr (_v_deref__12, (0 + 1 + 1), 1);
          Expr _vt_out;
          _vt_out = Expr (_v_deref__12, (0 + 1 + 1 + 1), 1);
          Expr _ge_body__4;
          _ge_body__4 = Expr (_v_deref__12, (0 + 1 + 1 + 1 + 1), _v_len__body__42);
          RF_CALL (::refal::Box::Put, (Blocks, (_c_7 + _vt_name + _vt_in + _vt_out) ()), /*void*/);
          RF_CALL (::refal::Table::ClearTable, Breaks, /*void*/);
          _ve_body = _ge_body__4;
          goto _block2;
        }
      _block2__branch2: {}
        {
          if (_vt_1.symbol_at (0))
          {
            goto _block2__branch3;
          }
          Expr _v_deref__13 (Expr (_vt_1, 0));
          int _v_len7 = _v_deref__13.get_len ();
          int _v_len8 = 5;
          if (_v_len7 < _v_len8)
          {
            goto _block2__branch3;
          }
          int _v_len__body__43 = (_v_len7 - _v_len8);
          if (_v_deref__13.symbol_at ((0 + 1)))
          {
            goto _block2__branch3;
          }
          if (_v_deref__13.symbol_at ((0 + 1 + 1)))
          {
            goto _block2__branch3;
          }
          if (_v_deref__13.symbol_at ((0 + 1 + 1 + 1)))
          {
            goto _block2__branch3;
          }
          if (_v_deref__13.symbol_at ((0 + 1 + 1 + 1 + 1)))
          {
            goto _block2__branch3;
          }
          Expr _v_deref__deref__13 (Expr (_v_deref__13, (0 + 1)));
          Expr _v_deref__deref__132 (Expr (_v_deref__13, (0 + 1 + 1)));
          Expr _v_deref__deref__133 (Expr (_v_deref__13, (0 + 1 + 1 + 1)));
          Expr _v_deref__deref__134 (Expr (_v_deref__13, (0 + 1 + 1 + 1 + 1)));
          int _v_len9 = _v_deref__deref__13.get_len ();
          int _v_len10 = 0;
          if (_v_len9 < _v_len10)
          {
            goto _block2__branch3;
          }
          int _v_len__cont = (_v_len9 - _v_len10);
          int _v_len11 = _v_deref__deref__132.get_len ();
          int _v_len12 = 0;
          if (_v_len11 < _v_len12)
          {
            goto _block2__branch3;
          }
          int _v_len__break = (_v_len11 - _v_len12);
          int _v_len13 = _v_deref__deref__134.get_len ();
          int _v_len14 = 0;
          if (_v_len13 < _v_len14)
          {
            goto _block2__branch3;
          }
          int _v_len__step = (_v_len13 - _v_len14);
          int _v_len15 = _v_deref__deref__133.get_len ();
          int _v_len16 = 0;
          if (_v_len15 < _v_len16)
          {
            goto _block2__branch3;
          }
          int _v_len__cond = (_v_len15 - _v_len16);
          if (!_c_8.term_eq (_v_deref__13, 0))
          {
            goto _block2__branch3;
          }
          Expr _ge_body__4;
          _ge_body__4 = Expr (_v_deref__13, (0 + 1 + 1 + 1 + 1 + 1), _v_len__body__43);
          Expr _ve_cont;
          _ve_cont = Expr (_v_deref__deref__13, 0, _v_len__cont);
          Expr _ve_break;
          _ve_break = Expr (_v_deref__deref__132, 0, _v_len__break);
          Expr _ve_cond;
          _ve_cond = Expr (_v_deref__deref__133, 0, _v_len__cond);
          Expr _ve_step;
          _ve_step = Expr (_v_deref__deref__134, 0, _v_len__step);
          RF_CALL (::refal::Box::Put, (Blocks, (_c_8 + _ve_cont () + _ve_break () + _ve_cond () + _ve_step ()) ()), /*void*/);
          _ve_body = _ge_body__4;
          goto _block2;
        }
      _block2__branch3: {}
        {
          if (_vt_1.symbol_at (0))
          {
            goto _block2__branch4;
          }
          Expr _v_deref__14 (Expr (_vt_1, 0));
          int _v_len17 = _v_deref__14.get_len ();
          int _v_len18 = 2;
          if (_v_len17 < _v_len18)
          {
            goto _block2__branch4;
          }
          int _v_len__body__44 = (_v_len17 - _v_len18);
          if (_v_deref__14.symbol_at ((0 + 1)))
          {
            goto _block2__branch4;
          }
          Expr _v_deref__deref__14 (Expr (_v_deref__14, (0 + 1)));
          if (_v_deref__deref__14.get_len () != 1)
          {
            goto _block2__branch4;
          }
          if (!_c_9.term_eq (_v_deref__14, 0))
          {
            goto _block2__branch4;
          }
          Expr _ge_body__4;
          _ge_body__4 = Expr (_v_deref__14, (0 + 1 + 1), _v_len__body__44);
          Expr _vt_label;
          _vt_label = Expr (_v_deref__deref__14, 0, 1);
          RF_CALL (::refal::Box::Put, (Blocks, (_c_9 + _vt_label ()) ()), /*void*/);
          _ve_body = _ge_body__4;
          goto _block2;
        }
      _block2__branch4: {}
        {
          if (_vt_1.symbol_at (0))
          {
            goto _block2__branch5;
          }
          Expr _v_deref__15 (Expr (_vt_1, 0));
          int _v_len19 = _v_deref__15.get_len ();
          int _v_len20 = 2;
          if (_v_len19 < _v_len20)
          {
            goto _block2__branch5;
          }
          int _v_len__body__45 = (_v_len19 - _v_len20);
          if (!_c_2.term_eq (_v_deref__15, 0))
          {
            goto _block2__branch5;
          }
          Expr _vt_cond;
          _vt_cond = Expr (_v_deref__15, (0 + 1), 1);
          Expr _ge_body__4;
          _ge_body__4 = Expr (_v_deref__15, (0 + 1 + 1), _v_len__body__45);
          RF_CALL (::refal::Box::Put, (Blocks, (_c_2 + _vt_cond) ()), /*void*/);
          _ve_body = _ge_body__4;
          goto _block2;
        }
      _block2__branch5: {}
        {
          if (_vt_1.symbol_at (0))
          {
            goto _block2__branch6;
          }
          Expr _v_deref__16 (Expr (_vt_1, 0));
          int _v_len21 = _v_deref__16.get_len ();
          int _v_len22 = 4;
          if (_v_len21 < _v_len22)
          {
            goto _block2__branch6;
          }
          int _v_len__body__46 = (_v_len21 - _v_len22);
          if (!_c_1.term_eq (_v_deref__16, 0))
          {
            goto _block2__branch6;
          }
          if (!_v_deref__16.symbol_at ((0 + 1)))
          {
            goto _block2__branch6;
          }
          Expr _vs_op;
          _vs_op = Expr (_v_deref__16, (0 + 1), 1);
          Expr _vt_arg1;
          _vt_arg1 = Expr (_v_deref__16, (0 + 1 + 1), 1);
          Expr _vt_arg2;
          _vt_arg2 = Expr (_v_deref__16, (0 + 1 + 1 + 1), 1);
          Expr _ge_body__4;
          _ge_body__4 = Expr (_v_deref__16, (0 + 1 + 1 + 1 + 1), _v_len__body__46);
          RF_CALL (::refal::Box::Put, (Blocks, (_c_1 + _vs_op + _vt_arg1 + _vt_arg2) ()), /*void*/);
          _ve_body = _ge_body__4;
          goto _block2;
        }
      _block2__branch6: {}
        {
          if (_vt_1.symbol_at (0))
          {
            goto _block2__branch7;
          }
          Expr _v_deref__17 (Expr (_vt_1, 0));
          int _v_len23 = _v_deref__17.get_len ();
          int _v_len24 = 1;
          if (_v_len23 < _v_len24)
          {
            goto _block2__branch7;
          }
          int _v_len__body__47 = (_v_len23 - _v_len24);
          if (!_c_10.term_eq (_v_deref__17, 0))
          {
            goto _block2__branch7;
          }
          Expr _ge_body__4;
          _ge_body__4 = Expr (_v_deref__17, (0 + 1), _v_len__body__47);
          RF_CALL (::refal::Box::Put, (Blocks, _c_11), /*void*/);
          _ve_body = _ge_body__4;
          goto _block2;
        }
      _block2__branch7: {}
        if (_vt_1.symbol_at (0))
        {
          goto _block1__branch1;
        }
        Expr _v_deref__18 (Expr (_vt_1, 0));
        int _v_len25 = _v_deref__18.get_len ();
        int _v_len26 = 1;
        if (_v_len25 < _v_len26)
        {
          goto _block1__branch1;
        }
        int _v_len__body__48 = (_v_len25 - _v_len26);
        if (!_c_12.term_eq (_v_deref__18, 0))
        {
          goto _block1__branch1;
        }
        Expr _ge_body__4;
        _ge_body__4 = Expr (_v_deref__18, (0 + 1), _v_len__body__48);
        RF_CALL (::refal::Box::Put, (Blocks, _c_13), /*void*/);
        _ve_body = _ge_body__4;
      }
    _block2: {}
      RF_CALL (::refal::Box::Put, (Last_Breaks, _c_14), /*void*/);
      RF_CALL (Remove_Unreachable, _ve_body, _ve_body);
      Expr _v_GetR1;
      if (!RF_CALL (GetR, Blocks, _v_GetR1))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      Expr _ve_t1;
      Expr _ge_2__4;
      {
        {
          if (_v_GetR1.symbol_at (0))
          {
            goto _block3__branch1;
          }
          Expr _v_deref__GetR1 (Expr (_v_GetR1, 0));
          if (_v_deref__GetR1.get_len () != 2)
          {
            goto _block3__branch1;
          }
          if (_v_deref__GetR1.symbol_at ((0 + 1)))
          {
            goto _block3__branch1;
          }
          Expr _v_deref__deref__GetR1 (Expr (_v_deref__GetR1, (0 + 1)));
          if (_v_deref__deref__GetR1.get_len () != 1)
          {
            goto _block3__branch1;
          }
          if (!_c_9.term_eq (_v_deref__GetR1, 0))
          {
            goto _block3__branch1;
          }
          Expr _vt_label;
          _vt_label = Expr (_v_deref__deref__GetR1, 0, 1);
          {
            {
              if (!RF_CALL (::refal::Table::IsInTable, (Breaks, _vt_label), /*void*/))
              {
                goto _block4__branch1;
              }
              _ve_t1 = (_c_9 + _vt_label () + _ve_body) ();
              _ge_2__4 = _ve_2;
              goto _block4;
            }
          _block4__branch1: {}
            {
              {
                Expr _v_Get1;
                RF_CALL (::refal::Box::Get, Blocks, _v_Get1);
                int _v_len27 = _v_Get1.get_len ();
                int _v_len28 = 1;
                if (_v_len27 < _v_len28)
                {
                  goto _block5__branch1;
                }
                int _v_len___dollar_tmp_m_89_m_28 = (_v_len27 - _v_len28);
                if (_v_Get1.symbol_at ((0 + _v_len___dollar_tmp_m_89_m_28)))
                {
                  goto _block5__branch1;
                }
                Expr _v_deref__Get1 (Expr (_v_Get1, (0 + _v_len___dollar_tmp_m_89_m_28)));
                if (_v_deref__Get1.get_len () != 2)
                {
                  goto _block5__branch1;
                }
                if (_v_deref__Get1.symbol_at ((0 + 1)))
                {
                  goto _block5__branch1;
                }
                Expr _v_deref__deref__Get1 (Expr (_v_deref__Get1, (0 + 1)));
                if (_v_deref__deref__Get1.get_len () != 1)
                {
                  goto _block5__branch1;
                }
                if (!_c_9.term_eq (_v_deref__Get1, 0))
                {
                  goto _block5__branch1;
                }
                Expr _ve__dollar_tmp_m_89_m_28;
                _ve__dollar_tmp_m_89_m_28 = Expr (_v_Get1, 0, _v_len___dollar_tmp_m_89_m_28);
                Expr _vt_other__label;
                _vt_other__label = Expr (_v_deref__deref__Get1, 0, 1);
                Expr _v_Lookup1;
                if (!RF_CALL (::refal::Table::Lookup, (Breaks, _vt_other__label), _v_Lookup1))
                {
                  goto _block5__branch1;
                }
                if (_v_Lookup1.get_len () != 0)
                {
                  goto _block5__branch1;
                }
                RF_CALL (::refal::Table::Unbind, (Breaks, _vt_other__label), /*void*/);
                goto _block5;
              }
            _block5__branch1: {}
            }
          _block5: {}
            _ve_t1 = empty;
            _ge_2__4 = (_ve_body + _ve_2);
          }
        _block4: {}
          goto _block3;
        }
      _block3__branch1: {}
        {
          if (_v_GetR1.symbol_at (0))
          {
            goto _block3__branch2;
          }
          Expr _v_deref__GetR12 (Expr (_v_GetR1, 0));
          if (_v_deref__GetR12.get_len () != 5)
          {
            goto _block3__branch2;
          }
          if (_v_deref__GetR12.symbol_at ((0 + 1)))
          {
            goto _block3__branch2;
          }
          if (_v_deref__GetR12.symbol_at ((0 + 1 + 1)))
          {
            goto _block3__branch2;
          }
          if (_v_deref__GetR12.symbol_at ((0 + 1 + 1 + 1 + 1)))
          {
            goto _block3__branch2;
          }
          Expr _v_deref__deref__GetR12 (Expr (_v_deref__GetR12, (0 + 1)));
          Expr _v_deref__deref__GetR122 (Expr (_v_deref__GetR12, (0 + 1 + 1)));
          Expr _v_deref__deref__GetR123 (Expr (_v_deref__GetR12, (0 + 1 + 1 + 1 + 1)));
          int _v_len29 = _v_deref__deref__GetR12.get_len ();
          int _v_len30 = 0;
          if (_v_len29 < _v_len30)
          {
            goto _block3__branch2;
          }
          int _v_len__cont2 = (_v_len29 - _v_len30);
          int _v_len31 = _v_deref__deref__GetR123.get_len ();
          int _v_len32 = 0;
          if (_v_len31 < _v_len32)
          {
            goto _block3__branch2;
          }
          int _v_len__step2 = (_v_len31 - _v_len32);
          int _v_len33 = _v_deref__deref__GetR122.get_len ();
          int _v_len34 = 0;
          if (_v_len33 < _v_len34)
          {
            goto _block3__branch2;
          }
          int _v_len__break2 = (_v_len33 - _v_len34);
          if (!_c_8.term_eq (_v_deref__GetR12, 0))
          {
            goto _block3__branch2;
          }
          if (!_c_14.term_eq (_v_deref__GetR12, (0 + 1 + 1 + 1)))
          {
            goto _block3__branch2;
          }
          Expr _ve_cont;
          _ve_cont = Expr (_v_deref__deref__GetR12, 0, _v_len__cont2);
          Expr _ve_break;
          _ve_break = Expr (_v_deref__deref__GetR122, 0, _v_len__break2);
          Expr _ve_step;
          _ve_step = Expr (_v_deref__deref__GetR123, 0, _v_len__step2);
          {
            {
              if (!RF_CALL (::refal::Table::IsInTable, (Breaks, _ve_break), /*void*/))
              {
                goto _block6__branch1;
              }
              _ve_t1 = (_c_8 + _ve_cont () + _ve_break () + _c_14 + _ve_step () + _ve_body) ();
              _ge_2__4 = _ve_2;
              goto _block6;
            }
          _block6__branch1: {}
            _ve_t1 = (_c_8 + _ve_cont () + _ve_break () + _c_14 + _ve_step () + _ve_body) ();
            _ge_2__4 = empty;
          }
        _block6: {}
          goto _block3;
        }
      _block3__branch2: {}
        {
          if (!_v_GetR1.term_eq (_c_11, 0))
          {
            goto _block3__branch3;
          }
          {
            {
              Expr _v_Get2;
              RF_CALL (::refal::Box::Get, Last_Breaks, _v_Get2);
              int _v_len35 = _v_Get2.get_len ();
              int _v_len36 = 1;
              if (_v_len35 < _v_len36)
              {
                goto _block7__branch1;
              }
              int _v_len___dollar_tmp_m_101_m_31 = (_v_len35 - _v_len36);
              if (_v_Get2.symbol_at ((0 + _v_len___dollar_tmp_m_101_m_31)))
              {
                goto _block7__branch1;
              }
              Expr _v_deref__Get2 (Expr (_v_Get2, (0 + _v_len___dollar_tmp_m_101_m_31)));
              int _v_len37 = _v_deref__Get2.get_len ();
              int _v_len38 = 1;
              if (_v_len37 < _v_len38)
              {
                goto _block7__branch1;
              }
              int _v_len___dollar_tmp_m_101_m_34 = (_v_len37 - _v_len38);
              if (!_c_15.term_eq (_v_deref__Get2, (0 + _v_len___dollar_tmp_m_101_m_34)))
              {
                goto _block7__branch1;
              }
              Expr _ve__dollar_tmp_m_101_m_31;
              _ve__dollar_tmp_m_101_m_31 = Expr (_v_Get2, 0, _v_len___dollar_tmp_m_101_m_31);
              Expr _ve__dollar_tmp_m_101_m_34;
              _ve__dollar_tmp_m_101_m_34 = Expr (_v_deref__Get2, 0, _v_len___dollar_tmp_m_101_m_34);
              _ve_t1 = (_c_10 + _ve_body) ();
              _ge_2__4 = _ve_2;
              goto _block7;
            }
          _block7__branch1: {}
            int _v_len39 = _v_len__2;
            int _v_len40 = 1;
            if (_v_len39 < _v_len40)
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            int _v_len__3 = (_v_len39 - _v_len40);
            if (_ve_2.symbol_at (0))
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            Expr _v_deref__2 (Expr (_ve_2, 0));
            int _v_len41 = _v_deref__2.get_len ();
            int _v_len42 = 1;
            if (_v_len41 < _v_len42)
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            int _v_len__catch__body = (_v_len41 - _v_len42);
            if (!_c_12.term_eq (_v_deref__2, 0))
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            Expr _ve_3;
            _ve_3 = Expr (_ve_2, (0 + 1), _v_len__3);
            Expr _ve_catch__body;
            _ve_catch__body = Expr (_v_deref__2, (0 + 1), _v_len__catch__body);
            _ve_t1 = (_c_10 + _ve_body) ();
            _ge_2__4 = (_c_12 + _ve_catch__body + _ve_3) ();
          }
        _block7: {}
          goto _block3;
        }
      _block3__branch3: {}
        if (_v_GetR1.symbol_at (0))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        Expr _v_deref__GetR13 (Expr (_v_GetR1, 0));
        int _v_len43 = _v_deref__GetR13.get_len ();
        int _v_len44 = 0;
        if (_v_len43 < _v_len44)
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        int _v_len__item = (_v_len43 - _v_len44);
        Expr _ve_item;
        _ve_item = Expr (_v_deref__GetR13, 0, _v_len__item);
        _ve_t1 = (_ve_item + _ve_body) ();
        _ge_2__4 = _ve_2;
      }
    _block3: {}
      Expr _vt_breaks;
      if (!RF_CALL (GetR, Last_Breaks, _vt_breaks))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      {
        int _v_len45 = _ve_t1.get_len ();
        int _v_len46 = 0;
        if (_v_len45 < (_v_len46 + 1))
        {
          goto _block8__branch1;
        }
        int _v_len___dollar_tmp_m_110_m_15 = (_v_len45 - _v_len46);
        if (_vt_breaks.symbol_at (0))
        {
          goto _block8__branch1;
        }
        Expr _v_deref__breaks (Expr (_vt_breaks, 0));
        if (_v_deref__breaks.get_len () < 1)
        {
          goto _block8__branch1;
        }
        Expr _vv__dollar_tmp_m_110_m_15;
        _vv__dollar_tmp_m_110_m_15 = Expr (_ve_t1, 0, _v_len___dollar_tmp_m_110_m_15);
        RF_lsplit (_v_deref__breaks, 0, _ve__dollar_tmp_m_111_m_22, _v_lsplit__deref__breaks);
        for ( ; ; RF_iter(_v_deref__breaks)++)
        {
          {
            if (!RF_iter(_v_deref__breaks))
            {
              goto _block8__branch1;
            }
            int _v_len47 = _v_lsplit__deref__breaks.get_len ();
            int _v_len48 = 1;
            if (_v_len47 < _v_len48)
            {
              goto _block8__branch1;
            }
            int _v_len___dollar_tmp_m_111_m_28 = (_v_len47 - _v_len48);
            Expr _vt_l;
            _vt_l = Expr (_v_lsplit__deref__breaks, 0, 1);
            Expr _ve__dollar_tmp_m_111_m_28;
            _ve__dollar_tmp_m_111_m_28 = Expr (_v_lsplit__deref__breaks, (0 + 1), _v_len___dollar_tmp_m_111_m_28);
            RF_CALL (::refal::Table::Bind, (Breaks, _vt_l, _c_16), /*void*/);
          }
      _continue1: {}
        }
      _exit1: {}
      }
    _block8__branch1: {}
      _v_res1 = _ve_t1;
      _v_res2 = _ge_2__4;
      goto _block1;
    }
  _block1__branch1: {}
    {
      int _v_len49 = _ge_arg1.get_len ();
      int _v_len50 = 1;
      if (_v_len49 < _v_len50)
      {
        goto _block1__branch2;
      }
      int _v_len__22 = (_v_len49 - _v_len50);
      Expr _vt_1;
      _vt_1 = Expr (_ge_arg1, 0, 1);
      Expr _ve_2;
      _ve_2 = Expr (_ge_arg1, (0 + 1), _v_len__22);
      Expr _ge_1__3;
      {
        {
          if (_vt_1.symbol_at (0))
          {
            goto _block9__branch1;
          }
          Expr _v_deref__19 (Expr (_vt_1, 0));
          if (_v_deref__19.get_len () != 2)
          {
            goto _block9__branch1;
          }
          if (!_c_17.term_eq (_v_deref__19, 0))
          {
            goto _block9__branch1;
          }
          Expr _vt_label;
          _vt_label = Expr (_v_deref__19, (0 + 1), 1);
          Expr _v_GetR2;
          if (!RF_CALL (GetR, Last_Breaks, _v_GetR2))
          {
            goto _block1__branch2;
          }
          if (_v_GetR2.symbol_at (0))
          {
            goto _block1__branch2;
          }
          Expr _v_deref__GetR2 (Expr (_v_GetR2, 0));
          int _v_len51 = _v_deref__GetR2.get_len ();
          int _v_len52 = 0;
          if (_v_len51 < _v_len52)
          {
            goto _block1__branch2;
          }
          int _v_len__breaks = (_v_len51 - _v_len52);
          Expr _ve_breaks;
          _ve_breaks = Expr (_v_deref__GetR2, 0, _v_len__breaks);
          RF_CALL (::refal::Box::Put, (Last_Breaks, (_ve_breaks + _vt_label) ()), /*void*/);
          {
            {
              Expr _v_Get3;
              RF_CALL (::refal::Box::Get, Blocks, _v_Get3);
              int _v_len53 = _v_Get3.get_len ();
              int _v_len54 = 1;
              if (_v_len53 < _v_len54)
              {
                goto _block10__branch1;
              }
              int _v_len___dollar_tmp_m_121_m_26 = (_v_len53 - _v_len54);
              if (_v_Get3.symbol_at ((0 + _v_len___dollar_tmp_m_121_m_26)))
              {
                goto _block10__branch1;
              }
              Expr _v_deref__Get3 (Expr (_v_Get3, (0 + _v_len___dollar_tmp_m_121_m_26)));
              if (_v_deref__Get3.get_len () != 2)
              {
                goto _block10__branch1;
              }
              if (_v_deref__Get3.symbol_at ((0 + 1)))
              {
                goto _block10__branch1;
              }
              Expr _v_deref__deref__Get3 (Expr (_v_deref__Get3, (0 + 1)));
              if (_v_deref__deref__Get3.get_len () != 1)
              {
                goto _block10__branch1;
              }
              if (!_c_9.term_eq (_v_deref__Get3, 0))
              {
                goto _block10__branch1;
              }
              if (!_vt_label.term_eq (_v_deref__deref__Get3, 0))
              {
                goto _block10__branch1;
              }
              Expr _ve__dollar_tmp_m_121_m_26;
              _ve__dollar_tmp_m_121_m_26 = Expr (_v_Get3, 0, _v_len___dollar_tmp_m_121_m_26);
              _ge_1__3 = empty;
              goto _block10;
            }
          _block10__branch1: {}
            {
              Expr _v_Lookup2;
              if (!RF_CALL (::refal::Table::Lookup, (Breaks, _vt_label), _v_Lookup2))
              {
                goto _block10__branch2;
              }
              int _v_len55 = _v_Lookup2.get_len ();
              int _v_len56 = 0;
              if (_v_len55 < _v_len56)
              {
                goto _block10__branch2;
              }
              int _v_len___dollar_tmp_m_122_m_37 = (_v_len55 - _v_len56);
              Expr _ve__dollar_tmp_m_122_m_37;
              _ve__dollar_tmp_m_122_m_37 = Expr (_v_Lookup2, 0, _v_len___dollar_tmp_m_122_m_37);
              _ge_1__3 = _vt_1;
              goto _block10;
            }
          _block10__branch2: {}
            RF_CALL (::refal::Table::Bind, (Breaks, _vt_label, empty), /*void*/);
            _ge_1__3 = _vt_1;
          }
        _block10: {}
          goto _block9;
        }
      _block9__branch1: {}
        {
          if (_vt_1.symbol_at (0))
          {
            goto _block9__branch2;
          }
          Expr _v_deref__110 (Expr (_vt_1, 0));
          if (_v_deref__110.get_len () != 2)
          {
            goto _block9__branch2;
          }
          if (!_c_18.term_eq (_v_deref__110, 0))
          {
            goto _block9__branch2;
          }
          Expr _vt_label;
          _vt_label = Expr (_v_deref__110, (0 + 1), 1);
          {
            {
              Expr _v_Get4;
              RF_CALL (::refal::Box::Get, Blocks, _v_Get4);
              int _v_len57 = _v_Get4.get_len ();
              int _v_len58 = 1;
              if (_v_len57 < _v_len58)
              {
                goto _block11__branch1;
              }
              int _v_len___dollar_tmp_m_126_m_24 = (_v_len57 - _v_len58);
              if (_v_Get4.symbol_at ((0 + _v_len___dollar_tmp_m_126_m_24)))
              {
                goto _block11__branch1;
              }
              Expr _v_deref__Get4 (Expr (_v_Get4, (0 + _v_len___dollar_tmp_m_126_m_24)));
              if (_v_deref__Get4.get_len () != 5)
              {
                goto _block11__branch1;
              }
              if (_v_deref__Get4.symbol_at ((0 + 1)))
              {
                goto _block11__branch1;
              }
              if (_v_deref__Get4.symbol_at ((0 + 1 + 1)))
              {
                goto _block11__branch1;
              }
              if (_v_deref__Get4.symbol_at ((0 + 1 + 1 + 1)))
              {
                goto _block11__branch1;
              }
              if (_v_deref__Get4.symbol_at ((0 + 1 + 1 + 1 + 1)))
              {
                goto _block11__branch1;
              }
              Expr _v_deref__deref__Get4 (Expr (_v_deref__Get4, (0 + 1)));
              Expr _v_deref__deref__Get42 (Expr (_v_deref__Get4, (0 + 1 + 1)));
              Expr _v_deref__deref__Get43 (Expr (_v_deref__Get4, (0 + 1 + 1 + 1)));
              Expr _v_deref__deref__Get44 (Expr (_v_deref__Get4, (0 + 1 + 1 + 1 + 1)));
              if (_v_deref__deref__Get4.get_len () != 1)
              {
                goto _block11__branch1;
              }
              int _v_len59 = _v_deref__deref__Get42.get_len ();
              int _v_len60 = 0;
              if (_v_len59 < _v_len60)
              {
                goto _block11__branch1;
              }
              int _v_len__break3 = (_v_len59 - _v_len60);
              int _v_len61 = _v_deref__deref__Get44.get_len ();
              int _v_len62 = 0;
              if (_v_len61 < _v_len62)
              {
                goto _block11__branch1;
              }
              int _v_len__step3 = (_v_len61 - _v_len62);
              int _v_len63 = _v_deref__deref__Get43.get_len ();
              int _v_len64 = 0;
              if (_v_len63 < _v_len64)
              {
                goto _block11__branch1;
              }
              int _v_len__cond2 = (_v_len63 - _v_len64);
              if (!_c_8.term_eq (_v_deref__Get4, 0))
              {
                goto _block11__branch1;
              }
              if (!_vt_label.term_eq (_v_deref__deref__Get4, 0))
              {
                goto _block11__branch1;
              }
              Expr _ve__dollar_tmp_m_126_m_24;
              _ve__dollar_tmp_m_126_m_24 = Expr (_v_Get4, 0, _v_len___dollar_tmp_m_126_m_24);
              Expr _ve_break;
              _ve_break = Expr (_v_deref__deref__Get42, 0, _v_len__break3);
              Expr _ve_cond;
              _ve_cond = Expr (_v_deref__deref__Get43, 0, _v_len__cond2);
              Expr _ve_step;
              _ve_step = Expr (_v_deref__deref__Get44, 0, _v_len__step3);
              _ge_1__3 = empty;
              goto _block11;
            }
          _block11__branch1: {}
            _ge_1__3 = _vt_1;
          }
        _block11: {}
          goto _block9;
        }
      _block9__branch2: {}
        {
          if (!_vt_1.term_eq (_c_19, 0))
          {
            goto _block9__branch3;
          }
          _ge_1__3 = _vt_1;
          goto _block9;
        }
      _block9__branch3: {}
        {
          if (_vt_1.symbol_at (0))
          {
            goto _block9__branch4;
          }
          Expr _v_deref__111 (Expr (_vt_1, 0));
          int _v_len65 = _v_deref__111.get_len ();
          int _v_len66 = 1;
          if (_v_len65 < _v_len66)
          {
            goto _block9__branch4;
          }
          int _v_len___dollar_tmp_m_130_m_13 = (_v_len65 - _v_len66);
          if (!_c_20.term_eq (_v_deref__111, 0))
          {
            goto _block9__branch4;
          }
          Expr _ve__dollar_tmp_m_130_m_13;
          _ve__dollar_tmp_m_130_m_13 = Expr (_v_deref__111, (0 + 1), _v_len___dollar_tmp_m_130_m_13);
          _ge_1__3 = _vt_1;
          goto _block9;
        }
      _block9__branch4: {}
        if (!_vt_1.term_eq (_c_21, 0))
        {
          goto _block1__branch2;
        }
        _ge_1__3 = _vt_1;
      }
    _block9: {}
      _v_res1 = _ge_1__3;
      _v_res2 = empty;
      goto _block1;
    }
  _block1__branch2: {}
    {
      int _v_len67 = _ge_arg1.get_len ();
      int _v_len68 = 1;
      if (_v_len67 < _v_len68)
      {
        goto _block1__branch3;
      }
      int _v_len__23 = (_v_len67 - _v_len68);
      Expr _vt_1;
      _vt_1 = Expr (_ge_arg1, 0, 1);
      Expr _ve_2;
      _ve_2 = Expr (_ge_arg1, (0 + 1), _v_len__23);
      _v_res1 = _vt_1;
      _v_res2 = _ve_2;
      goto _block1;
    }
  _block1__branch3: {}
    if (_ge_arg1.get_len () != 0)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _ve_1;
    {
      {
        Expr _v_GetR3;
        if (!RF_CALL (GetR, Last_Breaks, _v_GetR3))
        {
          goto _block12__branch1;
        }
        if (_v_GetR3.symbol_at (0))
        {
          goto _block12__branch1;
        }
        Expr _v_deref__GetR3 (Expr (_v_GetR3, 0));
        int _v_len69 = _v_deref__GetR3.get_len ();
        int _v_len70 = 0;
        if (_v_len69 < _v_len70)
        {
          goto _block12__branch1;
        }
        int _v_len__breaks2 = (_v_len69 - _v_len70);
        Expr _ve_breaks;
        _ve_breaks = Expr (_v_deref__GetR3, 0, _v_len__breaks2);
        RF_CALL (::refal::Box::Put, (Last_Breaks, (_ve_breaks + _c_15) ()), /*void*/);
        _ve_1 = empty;
        goto _block12;
      }
    _block12__branch1: {}
      _ve_1 = empty;
    }
  _block12: {}
    _v_res1 = _ve_1;
    _v_res2 = empty;
  }
_block1: {}
RF_END

RF_FUNC (Remove_Dupl_Decl, (RF_ARG _ve_decls, _ve_subst, _ve_items;;), (RF_RES _v_res1;;))
  {
    {
      int _v_len1 = _ve_items.get_len ();
      int _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      int _v_len__rest = (_v_len1 - _v_len2);
      Expr _vt_1;
      _vt_1 = Expr (_ve_items, 0, 1);
      Expr _ve_rest;
      _ve_rest = Expr (_ve_items, (0 + 1), _v_len__rest);
      {
        {
          if (_vt_1.symbol_at (0))
          {
            goto _block2__branch1;
          }
          Expr _v_deref__1 (Expr (_vt_1, 0));
          int _v_len3 = _v_deref__1.get_len ();
          int _v_len4 = 3;
          if (_v_len3 < _v_len4)
          {
            goto _block2__branch1;
          }
          int _v_len__expr = (_v_len3 - _v_len4);
          if (!_c_5.term_eq (_v_deref__1, 0))
          {
            goto _block2__branch1;
          }
          if (!_v_deref__1.symbol_at ((0 + 1)))
          {
            goto _block2__branch1;
          }
          Expr _vs_type;
          _vs_type = Expr (_v_deref__1, (0 + 1), 1);
          Expr _vt_var;
          _vt_var = Expr (_v_deref__1, (0 + 1 + 1), 1);
          Expr _ve_expr;
          _ve_expr = Expr (_v_deref__1, (0 + 1 + 1 + 1), _v_len__expr);
          Expr _ve_d;
          Expr _ge_decls__4;
          Expr _ge_subst__4;
          RF_CALL (Process_Var, (_ve_decls, _ve_subst, _vs_type, _vt_var, _ve_expr), (_ve_d, _ge_decls__4, _ge_subst__4));
          Expr _v_Remove__Dupl__Decl1;
          RF_CALL (Remove_Dupl_Decl, (_ge_decls__4, _ge_subst__4, _ve_rest), _v_Remove__Dupl__Decl1);
          _v_res1 = (_ve_d + _v_Remove__Dupl__Decl1);
          goto _block2;
        }
      _block2__branch1: {}
        {
          if (_vt_1.symbol_at (0))
          {
            goto _block2__branch2;
          }
          Expr _v_deref__12 (Expr (_vt_1, 0));
          int _v_len5 = _v_deref__12.get_len ();
          int _v_len6 = 4;
          if (_v_len5 < _v_len6)
          {
            goto _block2__branch2;
          }
          int _v_len__xpr = (_v_len5 - _v_len6);
          if (_v_deref__12.symbol_at ((0 + 1 + _v_len__xpr)))
          {
            goto _block2__branch2;
          }
          Expr _v_deref__deref__12 (Expr (_v_deref__12, (0 + 1 + _v_len__xpr)));
          int _v_len7 = _v_deref__deref__12.get_len ();
          int _v_len8 = 0;
          if (_v_len7 < _v_len8)
          {
            goto _block2__branch2;
          }
          int _v_len__len = (_v_len7 - _v_len8);
          if (!_v_deref__12.symbol_at (0))
          {
            goto _block2__branch2;
          }
          Expr _vs_split;
          _vs_split = Expr (_v_deref__12, 0, 1);
          Expr _ve_xpr;
          _ve_xpr = Expr (_v_deref__12, (0 + 1), _v_len__xpr);
          Expr _vt_var1;
          _vt_var1 = Expr (_v_deref__12, (0 + 1 + _v_len__xpr + 1), 1);
          Expr _vt_var2;
          _vt_var2 = Expr (_v_deref__12, (0 + 1 + _v_len__xpr + 1 + 1), 1);
          Expr _ve_len;
          _ve_len = Expr (_v_deref__deref__12, 0, _v_len__len);
          {
            {
              if (!_vs_split.term_eq (_c_22, 0))
              {
                goto _block3__branch1;
              }
              goto _block3;
            }
          _block3__branch1: {}
            if (!_vs_split.term_eq (_c_23, 0))
            {
              goto _block2__branch2;
            }
          }
        _block3: {}
          RF_CALL (Remove_Dupl_Decl, (_ve_decls, _ve_subst, (_ve_xpr + _ve_len ())), _ve_xpr);
          Expr _ve_decl1;
          Expr _ge_decls__4;
          Expr _ge_subst__4;
          RF_CALL (Process_Var, (_ve_decls, _ve_subst, _c_24, _vt_var1, empty), (_ve_decl1, _ge_decls__4, _ge_subst__4));
          Expr _gt_var1__5;
          {
            {
              if (_ve_decl1.get_len () != 1)
              {
                goto _block4__branch1;
              }
              if (_ve_decl1.symbol_at (0))
              {
                goto _block4__branch1;
              }
              Expr _v_deref__decl1 (Expr (_ve_decl1, 0));
              int _v_len9 = _v_deref__decl1.get_len ();
              int _v_len10 = 3;
              if (_v_len9 < _v_len10)
              {
                goto _block4__branch1;
              }
              int _v_len___dollar_tmp_m_151_m_43 = (_v_len9 - _v_len10);
              if (!_c_5.term_eq (_v_deref__decl1, 0))
              {
                goto _block4__branch1;
              }
              if (!_v_deref__decl1.symbol_at ((0 + 1)))
              {
                goto _block4__branch1;
              }
              Expr _vs_type;
              _vs_type = Expr (_v_deref__decl1, (0 + 1), 1);
              Expr _vt_new__var;
              _vt_new__var = Expr (_v_deref__decl1, (0 + 1 + 1), 1);
              Expr _ve__dollar_tmp_m_151_m_43;
              _ve__dollar_tmp_m_151_m_43 = Expr (_v_deref__decl1, (0 + 1 + 1 + 1), _v_len___dollar_tmp_m_151_m_43);
              _gt_var1__5 = _vt_new__var;
              goto _block4;
            }
          _block4__branch1: {}
            _gt_var1__5 = _vt_var1;
          }
        _block4: {}
          Expr _ve_decl2;
          Expr _ge_decls__4__5;
          Expr _ge_subst__4__5;
          RF_CALL (Process_Var, (_ge_decls__4, _ge_subst__4, _c_24, _vt_var2, empty), (_ve_decl2, _ge_decls__4__5, _ge_subst__4__5));
          Expr _gt_var2__6;
          {
            {
              if (_ve_decl2.get_len () != 1)
              {
                goto _block5__branch1;
              }
              if (_ve_decl2.symbol_at (0))
              {
                goto _block5__branch1;
              }
              Expr _v_deref__decl2 (Expr (_ve_decl2, 0));
              int _v_len11 = _v_deref__decl2.get_len ();
              int _v_len12 = 3;
              if (_v_len11 < _v_len12)
              {
                goto _block5__branch1;
              }
              int _v_len___dollar_tmp_m_156_m_43 = (_v_len11 - _v_len12);
              if (!_c_5.term_eq (_v_deref__decl2, 0))
              {
                goto _block5__branch1;
              }
              if (!_v_deref__decl2.symbol_at ((0 + 1)))
              {
                goto _block5__branch1;
              }
              Expr _vs_type;
              _vs_type = Expr (_v_deref__decl2, (0 + 1), 1);
              Expr _vt_new__var;
              _vt_new__var = Expr (_v_deref__decl2, (0 + 1 + 1), 1);
              Expr _ve__dollar_tmp_m_156_m_43;
              _ve__dollar_tmp_m_156_m_43 = Expr (_v_deref__decl2, (0 + 1 + 1 + 1), _v_len___dollar_tmp_m_156_m_43);
              _gt_var2__6 = _vt_new__var;
              goto _block5;
            }
          _block5__branch1: {}
            _gt_var2__6 = _vt_var2;
          }
        _block5: {}
          Expr _v_Remove__Dupl__Decl2;
          RF_CALL (Remove_Dupl_Decl, (_ge_decls__4__5, _ge_subst__4__5, _ve_rest), _v_Remove__Dupl__Decl2);
          _v_res1 = ((_vs_split + _ve_xpr + _gt_var1__5 + _gt_var2__6) () + _v_Remove__Dupl__Decl2);
          goto _block2;
        }
      _block2__branch2: {}
        {
          if (_ve_subst.get_len () < 1)
          {
            goto _block2__branch3;
          }
          RF_lsplit (_ve_subst, 0, _ve__dollar_tmp_m_160_m_16, _v_lsplit__subst);
          for ( ; ; RF_iter(_ve_subst)++)
          {
            {
              if (!RF_iter(_ve_subst))
              {
                goto _block2__branch3;
              }
              int _v_len13 = _v_lsplit__subst.get_len ();
              int _v_len14 = 1;
              if (_v_len13 < _v_len14)
              {
                goto _block2__branch3;
              }
              int _v_len___dollar_tmp_m_160_m_33 = (_v_len13 - _v_len14);
              if (_v_lsplit__subst.symbol_at (0))
              {
                goto _continue1;
              }
              Expr _v_deref__lsplit__subst (Expr (_v_lsplit__subst, 0));
              if (_v_deref__lsplit__subst.get_len () != 2)
              {
                goto _continue1;
              }
              if (!_vt_1.term_eq (_v_deref__lsplit__subst, 0))
              {
                goto _continue1;
              }
              Expr _ve__dollar_tmp_m_160_m_33;
              _ve__dollar_tmp_m_160_m_33 = Expr (_v_lsplit__subst, (0 + 1), _v_len___dollar_tmp_m_160_m_33);
              Expr _vt_new__var;
              _vt_new__var = Expr (_v_deref__lsplit__subst, (0 + 1), 1);
              RF_TAILCALL (Remove_Dupl_Decl, (_ve_decls, _ve_subst, (_vt_new__var + _ve_rest)), _v_res1);
              goto _exit1;
            }
        _continue1: {}
          }
        _exit1: {}
          goto _block2;
        }
      _block2__branch3: {}
        {
          if (_vt_1.symbol_at (0))
          {
            goto _block2__branch4;
          }
          Expr _v_deref__13 (Expr (_vt_1, 0));
          int _v_len15 = _v_deref__13.get_len ();
          int _v_len16 = 0;
          if (_v_len15 < _v_len16)
          {
            goto _block2__branch4;
          }
          int _v_len__2 = (_v_len15 - _v_len16);
          Expr _ve_2;
          _ve_2 = Expr (_v_deref__13, 0, _v_len__2);
          Expr _ge_auxcall1;
          RF_CALL (Remove_Dupl_Decl, (_ve_decls, _ve_subst, _ve_2), _ge_auxcall1);
          Expr _v_Remove__Dupl__Decl3;
          RF_CALL (Remove_Dupl_Decl, (_ve_decls, _ve_subst, _ve_rest), _v_Remove__Dupl__Decl3);
          _v_res1 = (_ge_auxcall1 () + _v_Remove__Dupl__Decl3);
          goto _block2;
        }
      _block2__branch4: {}
        Expr _v_Remove__Dupl__Decl4;
        RF_CALL (Remove_Dupl_Decl, (_ve_decls, _ve_subst, _ve_rest), _v_Remove__Dupl__Decl4);
        _v_res1 = (_vt_1 + _v_Remove__Dupl__Decl4);
      }
    _block2: {}
      goto _block1;
    }
  _block1__branch1: {}
    if (_ve_items.get_len () != 0)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    _v_res1 = empty;
  }
_block1: {}
RF_END

RF_FUNC (Process_Var, (RF_ARG _ve_decls, _ve_subst, _vs_type, _vt_var, _ve_expr;;), (RF_RES _v_res1, _v_res2, _v_res3;;))
  {
    {
      if (_ve_decls.get_len () < 1)
      {
        goto _block1__branch1;
      }
      RF_rsplit (_ve_decls, 0, _v_rsplit__decls, _ve__dollar_tmp_m_170_m_38);
      for ( ; ; RF_iter(_ve_decls)--)
      {
        {
          if (!RF_iter(_ve_decls))
          {
            goto _block1__branch1;
          }
          int _v_len1 = _v_rsplit__decls.get_len ();
          int _v_len2 = 1;
          if (_v_len1 < _v_len2)
          {
            goto _block1__branch1;
          }
          int _v_len___dollar_tmp_m_170_m_17 = (_v_len1 - _v_len2);
          if (_v_rsplit__decls.symbol_at ((0 + _v_len___dollar_tmp_m_170_m_17)))
          {
            goto _continue1;
          }
          Expr _v_deref__rsplit__decls (Expr (_v_rsplit__decls, (0 + _v_len___dollar_tmp_m_170_m_17)));
          if (_v_deref__rsplit__decls.get_len () != 2)
          {
            goto _continue1;
          }
          if (!_v_deref__rsplit__decls.symbol_at (0))
          {
            goto _continue1;
          }
          if (!_vt_var.term_eq (_v_deref__rsplit__decls, (0 + 1)))
          {
            goto _continue1;
          }
          Expr _ve__dollar_tmp_m_170_m_17;
          _ve__dollar_tmp_m_170_m_17 = Expr (_v_rsplit__decls, 0, _v_len___dollar_tmp_m_170_m_17);
          Expr _vs_type__old;
          _vs_type__old = Expr (_v_deref__rsplit__decls, 0, 1);
          {
            {
              if (!_vs_type__old.term_eq (_vs_type, 0))
              {
                goto _block2__branch1;
              }
              {
                {
                  if (_ve_expr.get_len () != 0)
                  {
                    goto _block3__branch1;
                  }
                  _v_res1 = empty;
                  _v_res2 = _ve_decls;
                  _v_res3 = _ve_subst;
                  goto _block3;
                }
              _block3__branch1: {}
                _v_res1 = (_c_4 + _vt_var + _ve_expr) ();
                _v_res2 = _ve_decls;
                _v_res3 = _ve_subst;
              }
            _block3: {}
              goto _block2;
            }
          _block2__branch1: {}
            if (_vt_var.symbol_at (0))
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            Expr _v_deref__var (Expr (_vt_var, 0));
            int _v_len3 = _v_deref__var.get_len ();
            int _v_len4 = 2;
            if (_v_len3 < _v_len4)
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            int _v_len___dollar_tmp_m_175_m_21 = (_v_len3 - _v_len4);
            if (_v_deref__var.symbol_at ((0 + 1 + _v_len___dollar_tmp_m_175_m_21)))
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            Expr _v_deref__deref__var (Expr (_v_deref__var, (0 + 1 + _v_len___dollar_tmp_m_175_m_21)));
            int _v_len5 = _v_deref__deref__var.get_len ();
            int _v_len6 = 0;
            if (_v_len5 < _v_len6)
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            int _v_len__name = (_v_len5 - _v_len6);
            if (!_v_deref__var.symbol_at (0))
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            Expr _vs_tag;
            _vs_tag = Expr (_v_deref__var, 0, 1);
            Expr _ve__dollar_tmp_m_175_m_21;
            _ve__dollar_tmp_m_175_m_21 = Expr (_v_deref__var, (0 + 1), _v_len___dollar_tmp_m_175_m_21);
            Expr _ve_name;
            _ve_name = Expr (_v_deref__deref__var, 0, _v_len__name);
            Expr _gs_auxcall1;
            RF_CALL (Free_Idx, /*void*/, _gs_auxcall1);
            Expr _vt_new__var ((_vs_tag + _c_25 + (_ve_name + _gs_auxcall1) ()) ());
            Expr _ge_expr__5;
            {
              {
                if (_ve_expr.get_len () != 0)
                {
                  goto _block4__branch1;
                }
                _ge_expr__5 = _vt_var;
                goto _block4;
              }
            _block4__branch1: {}
              _ge_expr__5 = _ve_expr;
            }
          _block4: {}
            _v_res1 = (_c_5 + _vs_type + _vt_new__var + _ge_expr__5) ();
            _v_res2 = (_ve_decls + (_vs_type + _vt_new__var) ());
            _v_res3 = (_ve_subst + (_vt_var + _vt_new__var) ());
          }
        _block2: {}
          goto _exit1;
        }
    _continue1: {}
      }
    _exit1: {}
      goto _block1;
    }
  _block1__branch1: {}
    _v_res1 = (_c_5 + _vs_type + _vt_var + _ve_expr) ();
    _v_res2 = (_ve_decls + (_vs_type + _vt_var) ());
    _v_res3 = _ve_subst;
  }
_block1: {}
RF_END

RF_FUNC (Simplify_Infix, (RF_ARG _gt_arg1;;), (RF_RES _v_res1;;))
  {
    {
      if (_gt_arg1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__arg1 (Expr (_gt_arg1, 0));
      int _v_len1 = _v_deref__arg1.get_len ();
      int _v_len2 = 2;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      int _v_len__args = (_v_len1 - _v_len2);
      if (!_c_26.term_eq (_v_deref__arg1, 0))
      {
        goto _block1__branch1;
      }
      if (!_v_deref__arg1.symbol_at ((0 + 1)))
      {
        goto _block1__branch1;
      }
      Expr _vs_op;
      _vs_op = Expr (_v_deref__arg1, (0 + 1), 1);
      Expr _ve_args;
      _ve_args = Expr (_v_deref__arg1, (0 + 1 + 1), _v_len__args);
      Expr _ge_auxalt6;
      {
        {
          if (!_vs_op.term_eq (_c_27, 0))
          {
            goto _block2__branch1;
          }
          Expr _ge_auxcall1;
          if (!RF_CALL (::refal::List::Map, (_c_28, empty, _ve_args), _ge_auxcall1))
          {
            goto _block1__branch1;
          }
          RF_CALL (::refal::List::Foldr1, (_c_29, empty, _ge_auxcall1), _ge_auxalt6);
          goto _block2;
        }
      _block2__branch1: {}
        {
          if (!_vs_op.term_eq (_c_30, 0))
          {
            goto _block2__branch2;
          }
          Expr _ge_auxcall2;
          if (!RF_CALL (::refal::List::Map, (_c_28, empty, _ve_args), _ge_auxcall2))
          {
            goto _block1__branch1;
          }
          RF_CALL (::refal::List::Foldr1, (_c_31, empty, _ge_auxcall2), _ge_auxalt6);
          goto _block2;
        }
      _block2__branch2: {}
        {
          if (!_vs_op.term_eq (_c_32, 0))
          {
            goto _block2__branch3;
          }
          Expr _ge_auxcall3;
          if (!RF_CALL (::refal::List::Map, (_c_28, empty, _ve_args), _ge_auxcall3))
          {
            goto _block1__branch1;
          }
          RF_CALL (::refal::List::Foldr1, (_c_33, empty, _ge_auxcall3), _ge_auxalt6);
          goto _block2;
        }
      _block2__branch3: {}
        {
          if (!_vs_op.term_eq (_c_34, 0))
          {
            goto _block2__branch4;
          }
          Expr _ge_auxcall4;
          if (!RF_CALL (::refal::List::Map, (_c_28, empty, _ve_args), _ge_auxcall4))
          {
            goto _block1__branch1;
          }
          RF_CALL (::refal::List::Foldr1, (_c_35, empty, _ge_auxcall4), _ge_auxalt6);
          goto _block2;
        }
      _block2__branch4: {}
        {
          if (!_vs_op.term_eq (_c_36, 0))
          {
            goto _block2__branch5;
          }
          Expr _ge_auxcall5;
          if (!RF_CALL (::refal::List::Map, (_c_28, empty, _ve_args), _ge_auxcall5))
          {
            goto _block1__branch1;
          }
          RF_CALL (::refal::List::Foldr1, (_c_37, empty, _ge_auxcall5), _ge_auxalt6);
          goto _block2;
        }
      _block2__branch5: {}
        if (!_vs_op.symbol_at (0))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        Expr _vs__dollar_tmp_m_198_m_6;
        _vs__dollar_tmp_m_198_m_6 = Expr (_vs_op, 0, 1);
        if (!RF_CALL (::refal::List::Map, (_c_28, empty, _ve_args), _ge_auxalt6))
        {
          goto _block1__branch1;
        }
      }
    _block2: {}
      {
        {
          if (_ge_auxalt6.get_len () != 1)
          {
            goto _block3__branch1;
          }
          Expr _vt_1;
          _vt_1 = Expr (_ge_auxalt6, 0, 1);
          _v_res1 = _vt_1;
          goto _block3;
        }
      _block3__branch1: {}
        int _v_len3 = _ge_auxalt6.get_len ();
        int _v_len4 = 0;
        if (_v_len3 < _v_len4)
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        int _v_len__1 = (_v_len3 - _v_len4);
        Expr _ve_1;
        _ve_1 = Expr (_ge_auxalt6, 0, _v_len__1);
        Expr _ge_auxcall7;
        RF_CALL (::refal::List::Paren, _ve_1, _ge_auxcall7);
        _v_res1 = (_c_26 + _vs_op + _ge_auxcall7) ();
      }
    _block3: {}
      goto _block1;
    }
  _block1__branch1: {}
    {
      if (_gt_arg1.symbol_at (0))
      {
        goto _block1__branch2;
      }
      Expr _v_deref__arg12 (Expr (_gt_arg1, 0));
      int _v_len5 = _v_deref__arg12.get_len ();
      int _v_len6 = 0;
      if (_v_len5 < _v_len6)
      {
        goto _block1__branch2;
      }
      int _v_len__12 = (_v_len5 - _v_len6);
      Expr _ve_1;
      _ve_1 = Expr (_v_deref__arg12, 0, _v_len__12);
      Expr _ge_auxcall8;
      if (!RF_CALL (::refal::List::Map, (_c_38, empty, _ve_1), _ge_auxcall8))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      _v_res1 = _ge_auxcall8 ();
      goto _block1;
    }
  _block1__branch2: {}
    if (!_gt_arg1.symbol_at (0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _vs_1;
    _vs_1 = Expr (_gt_arg1, 0, 1);
    _v_res1 = _vs_1;
  }
_block1: {}
RF_END

RF_FUNC (Simplify_Arithm, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  if (_ge_arg1.get_len () != 1)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (_ge_arg1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _v_deref__arg1 (Expr (_ge_arg1, 0));
  int _v_len1 = _v_deref__arg1.get_len ();
  int _v_len2 = 0;
  if (_v_len1 < _v_len2)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  int _v_len__args = (_v_len1 - _v_len2);
  Expr _ve_args;
  _ve_args = Expr (_v_deref__arg1, 0, _v_len__args);
  Expr _ge_auxcall1;
  if (!RF_CALL (::refal::List::Map, (_c_38, empty, _ve_args), _ge_auxcall1))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _v_Foldr11;
  RF_CALL (::refal::List::Foldr1, (_c_35, empty, _ge_auxcall1), _v_Foldr11);
  {
    {
      if (_v_Foldr11.get_len () != 1)
      {
        goto _block1__branch1;
      }
      Expr _vt_1;
      _vt_1 = Expr (_v_Foldr11, 0, 1);
      _v_res1 = _vt_1;
      goto _block1;
    }
  _block1__branch1: {}
    int _v_len3 = _v_Foldr11.get_len ();
    int _v_len4 = 0;
    if (_v_len3 < _v_len4)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    int _v_len__1 = (_v_len3 - _v_len4);
    Expr _ve_1;
    _ve_1 = Expr (_v_Foldr11, 0, _v_len__1);
    Expr _ge_auxcall2;
    RF_CALL (::refal::List::Paren, _ve_1, _ge_auxcall2);
    _v_res1 = (_c_39 + _ge_auxcall2) ();
  }
_block1: {}
RF_END

RF_FUNC (Eval_Mult, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  {
    {
      int _v_len1 = _ge_arg1.get_len ();
      int _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      int _v_len___dollar_tmp_m_214_m_7 = (_v_len1 - _v_len2);
      if (!_c_40.term_eq (_ge_arg1, 0))
      {
        goto _block1__branch1;
      }
      Expr _ve__dollar_tmp_m_214_m_7;
      _ve__dollar_tmp_m_214_m_7 = Expr (_ge_arg1, (0 + 1), _v_len___dollar_tmp_m_214_m_7);
      _v_res1 = _c_40;
      goto _block1;
    }
  _block1__branch1: {}
    {
      int _v_len3 = _ge_arg1.get_len ();
      int _v_len4 = 1;
      if (_v_len3 < _v_len4)
      {
        goto _block1__branch2;
      }
      int _v_len___dollar_tmp_m_215_m_4 = (_v_len3 - _v_len4);
      if (!_c_40.term_eq (_ge_arg1, (0 + _v_len___dollar_tmp_m_215_m_4)))
      {
        goto _block1__branch2;
      }
      Expr _ve__dollar_tmp_m_215_m_4;
      _ve__dollar_tmp_m_215_m_4 = Expr (_ge_arg1, 0, _v_len___dollar_tmp_m_215_m_4);
      _v_res1 = _c_40;
      goto _block1;
    }
  _block1__branch2: {}
    {
      int _v_len5 = _ge_arg1.get_len ();
      int _v_len6 = 1;
      if (_v_len5 < _v_len6)
      {
        goto _block1__branch3;
      }
      int _v_len__2 = (_v_len5 - _v_len6);
      if (!_c_41.term_eq (_ge_arg1, 0))
      {
        goto _block1__branch3;
      }
      Expr _ve_2;
      _ve_2 = Expr (_ge_arg1, (0 + 1), _v_len__2);
      _v_res1 = _ve_2;
      goto _block1;
    }
  _block1__branch3: {}
    {
      int _v_len7 = _ge_arg1.get_len ();
      int _v_len8 = 1;
      if (_v_len7 < _v_len8)
      {
        goto _block1__branch4;
      }
      int _v_len__1 = (_v_len7 - _v_len8);
      if (!_c_41.term_eq (_ge_arg1, (0 + _v_len__1)))
      {
        goto _block1__branch4;
      }
      Expr _ve_1;
      _ve_1 = Expr (_ge_arg1, 0, _v_len__1);
      _v_res1 = _ve_1;
      goto _block1;
    }
  _block1__branch4: {}
    {
      int _v_len9 = _ge_arg1.get_len ();
      int _v_len10 = 2;
      if (_v_len9 < _v_len10)
      {
        goto _block1__branch5;
      }
      int _v_len__22 = (_v_len9 - _v_len10);
      if (!_ge_arg1.symbol_at (0))
      {
        goto _block1__branch5;
      }
      if (!_ge_arg1.symbol_at ((0 + 1 + _v_len__22)))
      {
        goto _block1__branch5;
      }
      Expr _vs_1;
      _vs_1 = Expr (_ge_arg1, 0, 1);
      Expr _ve_2;
      _ve_2 = Expr (_ge_arg1, (0 + 1), _v_len__22);
      Expr _vs_3;
      _vs_3 = Expr (_ge_arg1, (0 + 1 + _v_len__22), 1);
      Expr _v_Mult1;
      RF_CALL (::refal::Arithm::Mult, (_vs_1, _vs_3), _v_Mult1);
      _v_res1 = (_ve_2 + _v_Mult1);
      goto _block1;
    }
  _block1__branch5: {}
    {
      int _v_len11 = _ge_arg1.get_len ();
      int _v_len12 = 1;
      if (_v_len11 < _v_len12)
      {
        goto _block1__branch6;
      }
      int _v_len__23 = (_v_len11 - _v_len12);
      if (!_ge_arg1.symbol_at (0))
      {
        goto _block1__branch6;
      }
      Expr _vs_1;
      _vs_1 = Expr (_ge_arg1, 0, 1);
      Expr _ve_2;
      _ve_2 = Expr (_ge_arg1, (0 + 1), _v_len__23);
      _v_res1 = (_ve_2 + _vs_1);
      goto _block1;
    }
  _block1__branch6: {}
    _v_res1 = _ge_arg1;
  }
_block1: {}
RF_END

RF_FUNC (Eval_Add, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  {
    {
      int _v_len1 = _ge_arg1.get_len ();
      int _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      int _v_len__2 = (_v_len1 - _v_len2);
      if (!_c_40.term_eq (_ge_arg1, 0))
      {
        goto _block1__branch1;
      }
      Expr _ve_2;
      _ve_2 = Expr (_ge_arg1, (0 + 1), _v_len__2);
      _v_res1 = _ve_2;
      goto _block1;
    }
  _block1__branch1: {}
    {
      int _v_len3 = _ge_arg1.get_len ();
      int _v_len4 = 1;
      if (_v_len3 < _v_len4)
      {
        goto _block1__branch2;
      }
      int _v_len__1 = (_v_len3 - _v_len4);
      if (!_c_40.term_eq (_ge_arg1, (0 + _v_len__1)))
      {
        goto _block1__branch2;
      }
      Expr _ve_1;
      _ve_1 = Expr (_ge_arg1, 0, _v_len__1);
      _v_res1 = _ve_1;
      goto _block1;
    }
  _block1__branch2: {}
    {
      int _v_len5 = _ge_arg1.get_len ();
      int _v_len6 = 2;
      if (_v_len5 < _v_len6)
      {
        goto _block1__branch3;
      }
      int _v_len__22 = (_v_len5 - _v_len6);
      if (!_ge_arg1.symbol_at (0))
      {
        goto _block1__branch3;
      }
      if (!_ge_arg1.symbol_at ((0 + 1 + _v_len__22)))
      {
        goto _block1__branch3;
      }
      Expr _vs_1;
      _vs_1 = Expr (_ge_arg1, 0, 1);
      Expr _ve_2;
      _ve_2 = Expr (_ge_arg1, (0 + 1), _v_len__22);
      Expr _vs_3;
      _vs_3 = Expr (_ge_arg1, (0 + 1 + _v_len__22), 1);
      Expr _v_Add1;
      RF_CALL (::refal::Arithm::Add, (_vs_1, _vs_3), _v_Add1);
      _v_res1 = (_ve_2 + _v_Add1);
      goto _block1;
    }
  _block1__branch3: {}
    {
      int _v_len7 = _ge_arg1.get_len ();
      int _v_len8 = 1;
      if (_v_len7 < _v_len8)
      {
        goto _block1__branch4;
      }
      int _v_len__23 = (_v_len7 - _v_len8);
      if (!_ge_arg1.symbol_at (0))
      {
        goto _block1__branch4;
      }
      Expr _vs_1;
      _vs_1 = Expr (_ge_arg1, 0, 1);
      Expr _ve_2;
      _ve_2 = Expr (_ge_arg1, (0 + 1), _v_len__23);
      _v_res1 = (_ve_2 + _vs_1);
      goto _block1;
    }
  _block1__branch4: {}
    _v_res1 = _ge_arg1;
  }
_block1: {}
RF_END

RF_FUNC (Eval_Div, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  {
    {
      int _v_len1 = _ge_arg1.get_len ();
      int _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      int _v_len__1 = (_v_len1 - _v_len2);
      if (!_c_41.term_eq (_ge_arg1, (0 + _v_len__1)))
      {
        goto _block1__branch1;
      }
      Expr _ve_1;
      _ve_1 = Expr (_ge_arg1, 0, _v_len__1);
      _v_res1 = _ve_1;
      goto _block1;
    }
  _block1__branch1: {}
    _v_res1 = _ge_arg1;
  }
_block1: {}
RF_END

RF_FUNC (Eval_Rem, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  {
    {
      int _v_len1 = _ge_arg1.get_len ();
      int _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      int _v_len__1 = (_v_len1 - _v_len2);
      if (!_c_41.term_eq (_ge_arg1, (0 + _v_len__1)))
      {
        goto _block1__branch1;
      }
      Expr _ve_1;
      _ve_1 = Expr (_ge_arg1, 0, _v_len__1);
      _v_res1 = _c_40;
      goto _block1;
    }
  _block1__branch1: {}
    _v_res1 = _ge_arg1;
  }
_block1: {}
RF_END

RF_FUNC (Eval__, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  {
    {
      int _v_len1 = _ge_arg1.get_len ();
      int _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      int _v_len__1 = (_v_len1 - _v_len2);
      if (!_c_40.term_eq (_ge_arg1, (0 + _v_len__1)))
      {
        goto _block1__branch1;
      }
      Expr _ve_1;
      _ve_1 = Expr (_ge_arg1, 0, _v_len__1);
      _v_res1 = _ve_1;
      goto _block1;
    }
  _block1__branch1: {}
    _v_res1 = _ge_arg1;
  }
_block1: {}
RF_END

RF_FUNC (Simplify_Cmp, (RF_ARG _vs_op, _ve_xpr1, _ve_xpr2;;), (RF_RES _v_res1;;))
  Expr _gs_op__1;
  {
    {
      if (!_vs_op.term_eq (_c_42, 0))
      {
        goto _block1__branch1;
      }
      _gs_op__1 = _c_43;
      goto _block1;
    }
  _block1__branch1: {}
    {
      if (!_vs_op.term_eq (_c_44, 0))
      {
        goto _block1__branch2;
      }
      _gs_op__1 = _c_45;
      goto _block1;
    }
  _block1__branch2: {}
    if (!_vs_op.term_eq (_c_46, 0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    _gs_op__1 = _c_47;
  }
_block1: {}
  RF_TAILCALL (Cmp, (_gs_op__1, _ve_xpr1, _ve_xpr2), _v_res1);
RF_END

RF_FUNC (Cmp, (RF_ARG _gs_arg1, _ge_arg2, _ge_arg3;;), (RF_RES _v_res1;;))
  {
    {
      Expr _v_compose1 ((_gs_arg1 + _ge_arg2 () + _ge_arg3 ()));
      if (_v_compose1.symbol_at ((0 + 1)))
      {
        goto _block1__branch1;
      }
      if (_v_compose1.symbol_at ((0 + 1 + 1)))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__compose1 (Expr (_v_compose1, (0 + 1)));
      Expr _v_deref__compose12 (Expr (_v_compose1, (0 + 1 + 1)));
      if (_v_deref__compose12.get_len () < 1)
      {
        goto _block1__branch1;
      }
      if (_v_deref__compose12.get_len () > ((_v_deref__compose12.get_len () - 1) + (_v_deref__compose12.get_len () - 1) + 1))
      {
        goto _block1__branch1;
      }
      if (_v_deref__compose1.get_len () < 1)
      {
        goto _block1__branch1;
      }
      if (_v_deref__compose1.get_len () > ((_v_deref__compose1.get_len () - 1) + (_v_deref__compose1.get_len () - 1) + 1))
      {
        goto _block1__branch1;
      }
      if (!_v_compose1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _vs_fn;
      _vs_fn = Expr (_v_compose1, 0, 1);
      RF_lsplit (_v_deref__compose1, 0, _ve_11, _v_lsplit__deref__compose1);
      for ( ; ; RF_iter(_v_deref__compose1)++)
      {
        {
          if (!RF_iter(_v_deref__compose1))
          {
            goto _block1__branch1;
          }
          int _v_len1 = _v_lsplit__deref__compose1.get_len ();
          int _v_len2 = 1;
          if (_v_len1 < _v_len2)
          {
            goto _block1__branch1;
          }
          int _v_len__12 = (_v_len1 - _v_len2);
          Expr _vt_x;
          _vt_x = Expr (_v_lsplit__deref__compose1, 0, 1);
          Expr _ve_12;
          _ve_12 = Expr (_v_lsplit__deref__compose1, (0 + 1), _v_len__12);
          RF_lsplit (_v_deref__compose12, 0, _ve_21, _v_lsplit__deref__compose12);
          for ( ; ; RF_iter(_v_deref__compose12)++)
          {
            {
              if (!RF_iter(_v_deref__compose12))
              {
                goto _continue1;
              }
              int _v_len3 = _v_lsplit__deref__compose12.get_len ();
              int _v_len4 = 1;
              if (_v_len3 < _v_len4)
              {
                goto _continue1;
              }
              int _v_len__22 = (_v_len3 - _v_len4);
              if (!_vt_x.term_eq (_v_lsplit__deref__compose12, 0))
              {
                goto _continue2;
              }
              Expr _ve_22;
              _ve_22 = Expr (_v_lsplit__deref__compose12, (0 + 1), _v_len__22);
              RF_TAILCALL (Cmp, (_vs_fn, (_ve_11 + _ve_12), (_ve_21 + _ve_22)), _v_res1);
              goto _exit2;
            }
        _continue2: {}
          }
        _exit2: {}
          goto _exit1;
        }
    _continue1: {}
      }
    _exit1: {}
      goto _block1;
    }
  _block1__branch1: {}
    {
      if (!RF_CALL (::refal::List::All, (_c_48, empty, _ge_arg2), /*void*/))
      {
        goto _block1__branch2;
      }
      if (!RF_CALL (::refal::List::All, (_c_48, empty, _ge_arg3), /*void*/))
      {
        goto _block1__branch2;
      }
      Expr _ge_auxcall1;
      RF_CALL (::refal::List::Foldr1, (_c_49, empty, _ge_arg2), _ge_auxcall1);
      Expr _ge_auxcall2;
      RF_CALL (::refal::List::Foldr1, (_c_49, empty, _ge_arg3), _ge_auxcall2);
      RF_TAILCALL (::refal::Apply::Apply, (_gs_arg1, (_ge_auxcall1 () + _ge_auxcall2 ())), _v_res1);
      goto _block1;
    }
  _block1__branch2: {}
    _v_res1 = (_ge_arg2 () + _ge_arg3 ());
  }
_block1: {}
RF_END

RF_FUNC (Free_Idx, RF_VOID, (RF_RES _v_res1;;))
  Expr _vs_1;
  {
    {
      Expr _v_Get1;
      RF_CALL (::refal::Box::Get, Idx, _v_Get1);
      if (_v_Get1.get_len () != 1)
      {
        goto _block1__branch1;
      }
      if (!_v_Get1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _gs_1__2;
      _gs_1__2 = Expr (_v_Get1, 0, 1);
      RF_CALL (::refal::Arithm::Add, (_gs_1__2, _c_41), _vs_1);
      goto _block1;
    }
  _block1__branch1: {}
    _vs_1 = _c_41;
  }
_block1: {}
  RF_CALL (::refal::Box::Store, (Idx, _vs_1), /*void*/);
  _v_res1 = _vs_1;
RF_END

RF_FUNC (Simplify_Infix_0, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  if (_ge_arg1.get_len () != 1)
  {
    RF_ERROR (_c_50);
  }
  Expr _v_stub1;
  _v_stub1 = Expr (_ge_arg1, 0, 1);
  RF_CALL (Simplify_Infix, _v_stub1, _v_res1);
RF_END

RF_FUNC (IsInt_0, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  int _v_len1 = _ge_arg1.get_len ();
  int _v_len2 = 0;
  if (_v_len1 < _v_len2)
  {
    RF_ERROR (_c_50);
  }
  int _v_len__stub1 = (_v_len1 - _v_len2);
  Expr _v_stub1;
  _v_stub1 = Expr (_ge_arg1, 0, _v_len__stub1);
  if (!RF_CALL (::refal::Class::IsInt, _v_stub1, /*void*/))
  {
    RF_RETFAIL;
  }
  _v_res1 = empty;
RF_END

RF_FUNC (Add_0, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  if (_ge_arg1.get_len () != 2)
  {
    RF_ERROR (_c_50);
  }
  if (!_ge_arg1.symbol_at (0))
  {
    RF_ERROR (_c_50);
  }
  if (!_ge_arg1.symbol_at ((0 + 1)))
  {
    RF_ERROR (_c_50);
  }
  Expr _v_stub1;
  _v_stub1 = Expr (_ge_arg1, 0, 1);
  Expr _v_stub2;
  _v_stub2 = Expr (_ge_arg1, (0 + 1), 1);
  RF_CALL (::refal::Arithm::Add, (_v_stub1, _v_stub2), _v_res1);
RF_END

RF_FUNC (Lt_0, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  if (_ge_arg1.get_len () != 2)
  {
    RF_ERROR (_c_50);
  }
  if (_ge_arg1.symbol_at (0))
  {
    RF_ERROR (_c_50);
  }
  if (_ge_arg1.symbol_at ((0 + 1)))
  {
    RF_ERROR (_c_50);
  }
  Expr _v_deref__arg1 (Expr (_ge_arg1, 0));
  Expr _v_deref__arg12 (Expr (_ge_arg1, (0 + 1)));
  int _v_len1 = _v_deref__arg12.get_len ();
  int _v_len2 = 0;
  if (_v_len1 < _v_len2)
  {
    RF_ERROR (_c_50);
  }
  int _v_len__stub1 = (_v_len1 - _v_len2);
  int _v_len3 = _v_deref__arg1.get_len ();
  int _v_len4 = 0;
  if (_v_len3 < _v_len4)
  {
    RF_ERROR (_c_50);
  }
  int _v_len__stub2 = (_v_len3 - _v_len4);
  Expr _v_stub2;
  _v_stub2 = Expr (_v_deref__arg1, 0, _v_len__stub2);
  Expr _v_stub1;
  _v_stub1 = Expr (_v_deref__arg12, 0, _v_len__stub1);
  if (!RF_CALL (::refal::Compare::Lt, (_v_stub2, _v_stub1), /*void*/))
  {
    RF_RETFAIL;
  }
  _v_res1 = empty;
RF_END

RF_FUNC (Ne_0, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  if (_ge_arg1.get_len () != 2)
  {
    RF_ERROR (_c_50);
  }
  if (_ge_arg1.symbol_at (0))
  {
    RF_ERROR (_c_50);
  }
  if (_ge_arg1.symbol_at ((0 + 1)))
  {
    RF_ERROR (_c_50);
  }
  Expr _v_deref__arg1 (Expr (_ge_arg1, 0));
  Expr _v_deref__arg12 (Expr (_ge_arg1, (0 + 1)));
  int _v_len1 = _v_deref__arg12.get_len ();
  int _v_len2 = 0;
  if (_v_len1 < _v_len2)
  {
    RF_ERROR (_c_50);
  }
  int _v_len__stub1 = (_v_len1 - _v_len2);
  int _v_len3 = _v_deref__arg1.get_len ();
  int _v_len4 = 0;
  if (_v_len3 < _v_len4)
  {
    RF_ERROR (_c_50);
  }
  int _v_len__stub2 = (_v_len3 - _v_len4);
  Expr _v_stub2;
  _v_stub2 = Expr (_v_deref__arg1, 0, _v_len__stub2);
  Expr _v_stub1;
  _v_stub1 = Expr (_v_deref__arg12, 0, _v_len__stub1);
  if (!RF_CALL (::refal::Compare::Ne, (_v_stub2, _v_stub1), /*void*/))
  {
    RF_RETFAIL;
  }
  _v_res1 = empty;
RF_END

RF_FUNC (Gt_0, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  if (_ge_arg1.get_len () != 2)
  {
    RF_ERROR (_c_50);
  }
  if (_ge_arg1.symbol_at (0))
  {
    RF_ERROR (_c_50);
  }
  if (_ge_arg1.symbol_at ((0 + 1)))
  {
    RF_ERROR (_c_50);
  }
  Expr _v_deref__arg1 (Expr (_ge_arg1, 0));
  Expr _v_deref__arg12 (Expr (_ge_arg1, (0 + 1)));
  int _v_len1 = _v_deref__arg12.get_len ();
  int _v_len2 = 0;
  if (_v_len1 < _v_len2)
  {
    RF_ERROR (_c_50);
  }
  int _v_len__stub1 = (_v_len1 - _v_len2);
  int _v_len3 = _v_deref__arg1.get_len ();
  int _v_len4 = 0;
  if (_v_len3 < _v_len4)
  {
    RF_ERROR (_c_50);
  }
  int _v_len__stub2 = (_v_len3 - _v_len4);
  Expr _v_stub2;
  _v_stub2 = Expr (_v_deref__arg1, 0, _v_len__stub2);
  Expr _v_stub1;
  _v_stub1 = Expr (_v_deref__arg12, 0, _v_len__stub1);
  if (!RF_CALL (::refal::Compare::Gt, (_v_stub2, _v_stub1), /*void*/))
  {
    RF_RETFAIL;
  }
  _v_res1 = empty;
RF_END

}

}

}

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_asail2asail {

static void init_ () {
  Idx = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Idx");
  Blocks = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Blocks");
  Breaks = new rftype::StaticObject<rftype::Table>(L"Breaks");
  Last_Breaks = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Last_Breaks");
  _c_0 = Expr::create<rftype::Word>("MODULE");
  _c_1 = Expr::create<rftype::Word>("IF-INT-CMP");
  _c_2 = Expr::create<rftype::Word>("IF");
  _c_3 = Expr::create<rftype::Word>("INT");
  _c_4 = Expr::create<rftype::Word>("ASSIGN");
  _c_5 = Expr::create<rftype::Word>("DECL");
  _c_6 = Expr::create<rftype::Word>("FUNC");
  _c_7 = Expr::create<rftype::Word>("FUNC?");
  _c_8 = Expr::create<rftype::Word>("FOR");
  _c_9 = Expr::create<rftype::Word>("LABEL");
  _c_10 = Expr::create<rftype::Word>("TRY");
  _c_11 = (_c_10) ();
  _c_12 = Expr::create<rftype::Word>("CATCH-ERROR");
  _c_13 = (_c_12) ();
  _c_14 = (empty) ();
  _c_15 = Expr::create<rftype::Word>("Normal-Exit");
  _c_16 = Expr::create<rftype::Word>("Persistent");
  _c_17 = Expr::create<rftype::Word>("BREAK");
  _c_18 = Expr::create<rftype::Word>("CONTINUE");
  _c_19 = Expr::create<rftype::Word>("RETFAIL");
  _c_20 = Expr::create<rftype::Word>("ERROR");
  _c_21 = Expr::create<rftype::Word>("FATAL");
  _c_22 = Expr::create<rftype::Word>("LSPLIT");
  _c_23 = Expr::create<rftype::Word>("RSPLIT");
  _c_24 = Expr::create<rftype::Word>("Split");
  _c_25 = rftype::Char::create_expr (L"dd");
  _c_39 = Expr::create<rftype::Word>("INFIX") + Expr::create<rftype::Word>("+");
  _c_26 = Expr (_c_39, 0, 1);
  _c_27 = Expr::create<rftype::Word>("*");
  _c_28 = Expr::create_sym<rftype::Func> (Simplify_Arithm);
  _c_29 = Expr::create_sym<rftype::Func> (Eval_Mult);
  _c_30 = Expr::create<rftype::Word>("/");
  _c_31 = Expr::create_sym<rftype::Func> (Eval_Div);
  _c_32 = Expr::create<rftype::Word>("%");
  _c_33 = Expr::create_sym<rftype::Func> (Eval_Rem);
  _c_34 = Expr (_c_39, 1, 1);
  _c_35 = Expr::create_sym<rftype::Func> (Eval_Add);
  _c_36 = Expr::create<rftype::Word>("-");
  _c_37 = Expr::create_sym<rftype::Func> (Eval__);
  _c_38 = Expr::create_sym<rftype::Func> (Simplify_Infix_0);
  _c_40 = Expr::create<rftype::Integer>("0");
  _c_41 = Expr::create<rftype::Integer>("1");
  _c_42 = Expr::create<rftype::Word>("!=");
  _c_43 = Expr::create_sym<rftype::Func> (Ne_0);
  _c_44 = Expr::create<rftype::Word>(">");
  _c_45 = Expr::create_sym<rftype::Func> (Gt_0);
  _c_46 = Expr::create<rftype::Word>("<");
  _c_47 = Expr::create_sym<rftype::Func> (Lt_0);
  _c_48 = Expr::create_sym<rftype::Func> (IsInt_0);
  _c_49 = Expr::create_sym<rftype::Func> (Add_0);
  _c_50 = Expr::create<rftype::Word>("Apply") + Expr::create<rftype::Word>("Apply") + Expr::create<rftype::Word>("Unexpected fail");
}

static AtStart init_registrator_ (&init_);

}

}

}

}

}
