
#include <rf_core.hh>

using namespace rfrt;

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_const {

RF_DECL (Bind_Static);

RF_DECL (Comp_Consts);

RF_DECL (Bind_Subexprs);

RF_DECL (Get_Static);

RF_DECL (Create_Static);

RF_DECL (Name);

RF_DECL (IsSubexpr);

RF_DECL (Subexprs_To_Constexprs);

}

}

}

}

}

namespace refal {

namespace Arithm {

RF_DECL (Add);

}

}

namespace refal {

namespace Access {

RF_DECL (Length);

}

}

namespace refal {

namespace Box {

RF_DECL (Put);

RF_DECL (Get);

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_const {

RF_DECL (Static_To_Constexprs);

RF_DECL (Init_Consts);

}

}

}

}

}

namespace refal {

namespace List {

RF_DECL (Map);

}

}

namespace refal {

namespace Table {

RF_DECL (Bind);

RF_DECL (Domain);

RF_DECL (ClearTable);

RF_DECL (Lookup);

}

}

namespace refal {

namespace Box {

RF_DECL (Store);

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_const {

static Expr Static;

static Expr St_Table;

static Expr FreeIdx;

static Expr _c_0;

static Expr _c_1;

static Expr _c_2;

static Expr _c_3;

static Expr _c_4;

static Expr _c_5;

static Expr _c_6;

static Expr _c_7;

static Expr _c_8;

static Expr _c_9;

static Expr _c_10;

static Expr _c_11;

static Expr _c_12;

static Expr _c_13;

RF_FUNC (Init_Consts, RF_VOID, RF_VOID)
  RF_TAILCALL (::refal::Box::Store, (Static, empty), /*void*/);
RF_END

RF_FUNC (Create_Static, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  {
    {
      if (_ge_arg1.get_len () != 0)
      {
        goto _block1__branch1;
      }
      _v_res1 = empty;
      goto _block1;
    }
  _block1__branch1: {}
    {
      if (_ge_arg1.get_len () != 1)
      {
        goto _block1__branch2;
      }
      if (_ge_arg1.symbol_at (0))
      {
        goto _block1__branch2;
      }
      Expr _v_deref__arg1 (Expr (_ge_arg1, 0));
      if (_v_deref__arg1.get_len () != 2)
      {
        goto _block1__branch2;
      }
      if (!_c_0.term_eq (_v_deref__arg1, 0))
      {
        goto _block1__branch2;
      }
      Expr _vt_name;
      _vt_name = Expr (_v_deref__arg1, (0 + 1), 1);
      _v_res1 = (_c_0 + _vt_name) ();
      goto _block1;
    }
  _block1__branch2: {}
    {
      {
        Expr _v_Get1;
        RF_CALL (::refal::Box::Get, Static, _v_Get1);
        if (_v_Get1.get_len () < 1)
        {
          goto _block2__branch1;
        }
        RF_lsplit (_v_Get1, 0, _ve__dollar_tmp_m_22_m_22, _v_lsplit__Get1);
        for ( ; ; RF_iter(_v_Get1)++)
        {
          {
            if (!RF_iter(_v_Get1))
            {
              goto _block2__branch1;
            }
            int _v_len1 = _v_lsplit__Get1.get_len ();
            int _v_len2 = 1;
            if (_v_len1 < _v_len2)
            {
              goto _block2__branch1;
            }
            int _v_len___dollar_tmp_m_22_m_38 = (_v_len1 - _v_len2);
            if (_v_lsplit__Get1.symbol_at (0))
            {
              goto _continue1;
            }
            Expr _v_deref__lsplit__Get1 (Expr (_v_lsplit__Get1, 0));
            if (_v_deref__lsplit__Get1.get_len () != (_ge_arg1.get_len () + 1))
            {
              goto _continue1;
            }
            if (!_ge_arg1.eq (_v_deref__lsplit__Get1, (0 + 1)))
            {
              goto _continue1;
            }
            Expr _ve__dollar_tmp_m_22_m_38;
            _ve__dollar_tmp_m_22_m_38 = Expr (_v_lsplit__Get1, (0 + 1), _v_len___dollar_tmp_m_22_m_38);
            Expr _vt_name;
            _vt_name = Expr (_v_deref__lsplit__Get1, 0, 1);
            _v_res1 = (_c_1 + _vt_name) ();
            goto _exit1;
          }
      _continue1: {}
        }
      _exit1: {}
        goto _block2;
      }
    _block2__branch1: {}
      Expr _ge_auxcall1;
      RF_CALL (::refal::Box::Get, Static, _ge_auxcall1);
      Expr _gs_auxcall2;
      RF_CALL (::refal::Access::Length, _ge_auxcall1, _gs_auxcall2);
      Expr _vt_name (_gs_auxcall2 ());
      RF_CALL (::refal::Box::Put, (Static, (_vt_name + _ge_arg1) ()), /*void*/);
      _v_res1 = (_c_1 + _vt_name) ();
    }
  _block2: {}
  }
_block1: {}
RF_END

RF_FUNC (Get_Static, (RF_ARG _gt_arg1;;), (RF_RES _v_res1;;))
  if (_gt_arg1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _v_deref__arg1 (Expr (_gt_arg1, 0));
  if (_v_deref__arg1.get_len () != 2)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_c_1.term_eq (_v_deref__arg1, 0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _vt_name;
  _vt_name = Expr (_v_deref__arg1, (0 + 1), 1);
  Expr _v_Get1;
  RF_CALL (::refal::Box::Get, Static, _v_Get1);
  if (_v_Get1.get_len () < 1)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  RF_lsplit (_v_Get1, 0, _ve__dollar_tmp_m_32_m_46, _v_lsplit__Get1);
  for ( ; ; RF_iter(_v_Get1)++)
  {
    {
      if (!RF_iter(_v_Get1))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      int _v_len1 = _v_lsplit__Get1.get_len ();
      int _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      int _v_len___dollar_tmp_m_32_m_62 = (_v_len1 - _v_len2);
      if (_v_lsplit__Get1.symbol_at (0))
      {
        goto _continue1;
      }
      Expr _v_deref__lsplit__Get1 (Expr (_v_lsplit__Get1, 0));
      int _v_len3 = _v_deref__lsplit__Get1.get_len ();
      int _v_len4 = 1;
      if (_v_len3 < _v_len4)
      {
        goto _continue1;
      }
      int _v_len__xpr = (_v_len3 - _v_len4);
      if (!_vt_name.term_eq (_v_deref__lsplit__Get1, 0))
      {
        goto _continue1;
      }
      Expr _ve__dollar_tmp_m_32_m_62;
      _ve__dollar_tmp_m_32_m_62 = Expr (_v_lsplit__Get1, (0 + 1), _v_len___dollar_tmp_m_32_m_62);
      Expr _ve_xpr;
      _ve_xpr = Expr (_v_deref__lsplit__Get1, (0 + 1), _v_len__xpr);
      _v_res1 = _ve_xpr;
      goto _exit1;
    }
_continue1: {}
  }
_exit1: {}
RF_END

RF_FUNC (IsSubexpr, (RF_ARG _ve_1, _ve_2;;), RF_VOID)
  {
    {
      if (_ve_1.get_len () != _ve_2.get_len ())
      {
        goto _block1__branch1;
      }
      if (!_ve_2.eq (_ve_1, 0))
      {
        goto _block1__branch1;
      }
      goto _block1;
    }
  _block1__branch1: {}
    if (_ve_2.get_len () < 1)
    {
      RF_RETFAIL;
    }
    RF_lsplit (_ve_2, 0, _ve_3, _v_lsplit__2);
    for ( ; ; RF_iter(_ve_2)++)
    {
      {
        if (!RF_iter(_ve_2))
        {
          RF_RETFAIL;
        }
        int _v_len1 = _v_lsplit__2.get_len ();
        int _v_len2 = 1;
        if (_v_len1 < _v_len2)
        {
          RF_RETFAIL;
        }
        int _v_len__5 = (_v_len1 - _v_len2);
        if (_v_lsplit__2.symbol_at (0))
        {
          goto _continue1;
        }
        Expr _v_deref__lsplit__2 (Expr (_v_lsplit__2, 0));
        int _v_len3 = _v_deref__lsplit__2.get_len ();
        int _v_len4 = 1;
        if (_v_len3 < _v_len4)
        {
          goto _continue1;
        }
        int _v_len__4 = (_v_len3 - _v_len4);
        if (!_c_2.term_eq (_v_deref__lsplit__2, 0))
        {
          goto _continue1;
        }
        Expr _ve_5;
        _ve_5 = Expr (_v_lsplit__2, (0 + 1), _v_len__5);
        Expr _ve_4;
        _ve_4 = Expr (_v_deref__lsplit__2, (0 + 1), _v_len__4);
        if (!RF_CALL (IsSubexpr, (_ve_1, _ve_4), /*void*/))
        {
          goto _continue1;
        }
        goto _exit1;
      }
  _continue1: {}
    }
  _exit1: {}
  }
_block1: {}
RF_END

RF_FUNC (Bind_Subexprs, (RF_ARG _gs_arg1, _gt_arg2, _ge_arg3, _ge_arg4, _ge_arg5;;), (RF_RES _v_res1;;))
  int _v_len1 = (_ge_arg5.get_len () + 4);
  int _v_len2 = 4;
  if (_v_len1 < _v_len2)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  int _v_len__xpr = (_v_len1 - _v_len2);
  Expr _v_compose1 ((_gs_arg1 + _gt_arg2 + _ge_arg3 () + _ge_arg4 () + _ge_arg5));
  if (_v_compose1.symbol_at ((0 + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (_v_compose1.symbol_at ((0 + 1 + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (_v_compose1.symbol_at ((0 + 1 + 1 + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _v_deref__compose1 (Expr (_v_compose1, (0 + 1)));
  Expr _v_deref__compose12 (Expr (_v_compose1, (0 + 1 + 1)));
  Expr _v_deref__compose13 (Expr (_v_compose1, (0 + 1 + 1 + 1)));
  int _v_len3 = _v_deref__compose1.get_len ();
  int _v_len4 = 0;
  if (_v_len3 < _v_len4)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  int _v_len__name = (_v_len3 - _v_len4);
  int _v_len5 = _v_deref__compose13.get_len ();
  int _v_len6 = 0;
  if (_v_len5 < _v_len6)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  int _v_len__current = (_v_len5 - _v_len6);
  int _v_len7 = _v_deref__compose12.get_len ();
  int _v_len8 = 0;
  if (_v_len7 < _v_len8)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  int _v_len__context = (_v_len7 - _v_len8);
  if (!_v_compose1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _vs_Isnew;
  _vs_Isnew = Expr (_v_compose1, 0, 1);
  Expr _ve_xpr;
  _ve_xpr = Expr (_v_compose1, (0 + 1 + 1 + 1 + 1), _v_len__xpr);
  Expr _ve_name;
  _ve_name = Expr (_v_deref__compose1, 0, _v_len__name);
  Expr _ve_context;
  _ve_context = Expr (_v_deref__compose12, 0, _v_len__context);
  Expr _ve_current;
  _ve_current = Expr (_v_deref__compose13, 0, _v_len__current);
  {
    {
      if (_v_len__xpr < 1)
      {
        goto _block1__branch1;
      }
      RF_lsplit (_ve_xpr, 0, _ve_1, _v_lsplit__xpr);
      for ( ; ; RF_iter(_ve_xpr)++)
      {
        {
          if (!RF_iter(_ve_xpr))
          {
            goto _block1__branch1;
          }
          int _v_len9 = _v_lsplit__xpr.get_len ();
          int _v_len10 = 1;
          if (_v_len9 < _v_len10)
          {
            goto _block1__branch1;
          }
          int _v_len__3 = (_v_len9 - _v_len10);
          if (_v_lsplit__xpr.symbol_at (0))
          {
            goto _continue1;
          }
          Expr _v_deref__lsplit__xpr (Expr (_v_lsplit__xpr, 0));
          int _v_len11 = _v_deref__lsplit__xpr.get_len ();
          int _v_len12 = 1;
          if (_v_len11 < _v_len12)
          {
            goto _continue1;
          }
          int _v_len__2 = (_v_len11 - _v_len12);
          if (!_c_2.term_eq (_v_deref__lsplit__xpr, 0))
          {
            goto _continue1;
          }
          Expr _ve_3;
          _ve_3 = Expr (_v_lsplit__xpr, (0 + 1), _v_len__3);
          Expr _ve_2;
          _ve_2 = Expr (_v_deref__lsplit__xpr, (0 + 1), _v_len__2);
          Expr _gs_auxcall1;
          RF_CALL (Bind_Subexprs, (_c_3, _c_4, _ve_current, _ve_2, _ve_2), _gs_auxcall1);
          RF_TAILCALL (Bind_Subexprs, (_gs_auxcall1, _ve_name (), _ve_context, _ve_current, _ve_3), _v_res1);
          goto _exit1;
        }
    _continue1: {}
      }
    _exit1: {}
      goto _block1;
    }
  _block1__branch1: {}
    {
      if (!_vs_Isnew.term_eq (_c_3, 0))
      {
        goto _block1__branch2;
      }
      Expr _v_Lookup1;
      if (!RF_CALL (::refal::Table::Lookup, (St_Table, _ve_current), _v_Lookup1))
      {
        goto _block1__branch2;
      }
      if (_v_Lookup1.get_len () != 3)
      {
        goto _block1__branch2;
      }
      if (_v_Lookup1.symbol_at (0))
      {
        goto _block1__branch2;
      }
      if (_v_Lookup1.symbol_at ((0 + 1)))
      {
        goto _block1__branch2;
      }
      Expr _v_deref__Lookup1 (Expr (_v_Lookup1, 0));
      Expr _v_deref__Lookup12 (Expr (_v_Lookup1, (0 + 1)));
      int _v_len13 = _v_deref__Lookup12.get_len ();
      int _v_len14 = 0;
      if (_v_len13 < _v_len14)
      {
        goto _block1__branch2;
      }
      int _v_len__tbl__context = (_v_len13 - _v_len14);
      int _v_len15 = _v_deref__Lookup1.get_len ();
      int _v_len16 = 0;
      if (_v_len15 < _v_len16)
      {
        goto _block1__branch2;
      }
      int _v_len__tbl__name = (_v_len15 - _v_len16);
      Expr _vt_tbl__pos;
      _vt_tbl__pos = Expr (_v_Lookup1, (0 + 1 + 1), 1);
      Expr _ve_tbl__name;
      _ve_tbl__name = Expr (_v_deref__Lookup1, 0, _v_len__tbl__name);
      Expr _ve_tbl__context;
      _ve_tbl__context = Expr (_v_deref__Lookup12, 0, _v_len__tbl__context);
      Expr _ge_tbl__name__3;
      {
        {
          if (_v_len__tbl__name != 0)
          {
            goto _block2__branch1;
          }
          _ge_tbl__name__3 = _ve_name;
          goto _block2;
        }
      _block2__branch1: {}
        _ge_tbl__name__3 = _ve_tbl__name;
      }
    _block2: {}
      Expr _ge_tbl__context__4;
      Expr _gs_Isnew__4;
      {
        {
          if (_v_len__tbl__context != 0)
          {
            goto _block3__branch1;
          }
          _ge_tbl__context__4 = _ve_tbl__context;
          _gs_Isnew__4 = _c_3;
          goto _block3;
        }
      _block3__branch1: {}
        {
          if (_v_len__tbl__context != _v_len__context)
          {
            goto _block3__branch2;
          }
          if (!_ve_context.eq (_ve_tbl__context, 0))
          {
            goto _block3__branch2;
          }
          _ge_tbl__context__4 = _ve_tbl__context;
          _gs_Isnew__4 = _c_3;
          goto _block3;
        }
      _block3__branch2: {}
        _ge_tbl__context__4 = empty;
        _gs_Isnew__4 = _c_5;
      }
    _block3: {}
      RF_CALL (::refal::Table::Bind, (St_Table, _ve_current, (_ge_tbl__name__3 () + _ge_tbl__context__4 () + _vt_tbl__pos)), /*void*/);
      _v_res1 = _gs_Isnew__4;
      goto _block1;
    }
  _block1__branch2: {}
    Expr _ge_auxcall2;
    RF_CALL (::refal::Table::Domain, St_Table, _ge_auxcall2);
    Expr _ve_domain (_ge_auxcall2);
    Expr _vs_Isneeded (_c_6);
    Expr _vt_pos (_c_4);
    for ( ; ; )
    {
      {
        if (_ve_domain.get_len () != 0)
        {
          goto _iter1;
        }
        Expr _ge_context__3;
        {
          {
            if (!_vs_Isneeded.term_eq (_c_7, 0))
            {
              goto _block4__branch1;
            }
            _ge_context__3 = empty;
            goto _block4;
          }
        _block4__branch1: {}
          _ge_context__3 = _ve_context;
        }
      _block4: {}
        RF_CALL (::refal::Table::Bind, (St_Table, _ve_current, (_ve_name () + _ge_context__3 () + _vt_pos)), /*void*/);
        _v_res1 = _c_5;
        goto _exit__iter1;
      }
    _iter1: {}
      int _v_len17 = _ve_domain.get_len ();
      int _v_len18 = 1;
      if (_v_len17 < _v_len18)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      int _v_len__rest = (_v_len17 - _v_len18);
      if (_ve_domain.symbol_at (0))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      Expr _v_deref__domain (Expr (_ve_domain, 0));
      int _v_len19 = _v_deref__domain.get_len ();
      int _v_len20 = 0;
      if (_v_len19 < _v_len20)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      int _v_len__key = (_v_len19 - _v_len20);
      Expr _ve_rest;
      _ve_rest = Expr (_ve_domain, (0 + 1), _v_len__rest);
      Expr _ve_key;
      _ve_key = Expr (_v_deref__domain, 0, _v_len__key);
      {
        {
          Expr _v_Lookup2;
          if (!RF_CALL (::refal::Table::Lookup, (St_Table, _ve_key), _v_Lookup2))
          {
            goto _block6__branch1;
          }
          int _v_len21 = _v_Lookup2.get_len ();
          int _v_len22 = 1;
          if (_v_len21 < _v_len22)
          {
            goto _block6__branch1;
          }
          int _v_len__tbl__params = (_v_len21 - _v_len22);
          if (_v_len__current < _v_len__key)
          {
            goto _block6__branch1;
          }
          if (!_c_4.term_eq (_v_Lookup2, (0 + _v_len__tbl__params)))
          {
            goto _block6__branch1;
          }
          Expr _ve_tbl__params;
          _ve_tbl__params = Expr (_v_Lookup2, 0, _v_len__tbl__params);
          RF_lsplit (_ve_current, 0, _ve_1, _v_lsplit__current);
          for ( ; ; RF_iter(_ve_current)++)
          {
            {
              if (!RF_iter(_ve_current))
              {
                goto _block6__branch1;
              }
              int _v_len23 = _v_lsplit__current.get_len ();
              int _v_len24 = _v_len__key;
              if (_v_len23 < _v_len24)
              {
                goto _block6__branch1;
              }
              int _v_len__22 = (_v_len23 - _v_len24);
              if (!_ve_key.eq (_v_lsplit__current, 0))
              {
                goto _continue2;
              }
              Expr _ve_2;
              _ve_2 = Expr (_v_lsplit__current, (0 + _v_len__key), _v_len__22);
              {
                if (!RF_CALL (IsSubexpr, (_ve_key, _ve_current), /*void*/))
                {
                  goto _negation1;
                }
                goto _continue2;
              }
            _negation1: {}
              Expr _gs_auxcall3;
              RF_CALL (::refal::Access::Length, _ve_1, _gs_auxcall3);
              Expr _gs_auxcall4;
              RF_CALL (::refal::Access::Length, _ve_key, _gs_auxcall4);
              RF_CALL (::refal::Table::Bind, (St_Table, _ve_key, (_ve_tbl__params + (_gs_auxcall3 + _gs_auxcall4 + _ve_current) ())), /*void*/);
              _ve_domain = _ve_rest;
              _vs_Isneeded = _c_7;
              goto _exit2;
            }
        _continue2: {}
          }
        _exit2: {}
          goto _block6;
        }
      _block6__branch1: {}
        {
          if (_v_len__key < _v_len__current)
          {
            goto _block6__branch2;
          }
          if (!_vs_Isnew.term_eq (_c_3, 0))
          {
            goto _block6__branch2;
          }
          if (!_vt_pos.term_eq (_c_4, 0))
          {
            goto _block6__branch2;
          }
          RF_lsplit (_ve_key, 0, _ve_1, _v_lsplit__key);
          for ( ; ; RF_iter(_ve_key)++)
          {
            {
              if (!RF_iter(_ve_key))
              {
                goto _block6__branch2;
              }
              int _v_len25 = _v_lsplit__key.get_len ();
              int _v_len26 = _v_len__current;
              if (_v_len25 < _v_len26)
              {
                goto _block6__branch2;
              }
              int _v_len__23 = (_v_len25 - _v_len26);
              if (!_ve_current.eq (_v_lsplit__key, 0))
              {
                goto _continue3;
              }
              Expr _ve_2;
              _ve_2 = Expr (_v_lsplit__key, (0 + _v_len__current), _v_len__23);
              Expr _v_Lookup3;
              if (!RF_CALL (::refal::Table::Lookup, (St_Table, _ve_key), _v_Lookup3))
              {
                RF_FUNC_ERROR (unexpected_fail);
              }
              if (_v_Lookup3.get_len () != 3)
              {
                RF_FUNC_ERROR (unexpected_fail);
              }
              Expr _vt_tbl__name;
              _vt_tbl__name = Expr (_v_Lookup3, 0, 1);
              Expr _vt_tbl__context;
              _vt_tbl__context = Expr (_v_Lookup3, (0 + 1), 1);
              Expr _vt_tbl__pos;
              _vt_tbl__pos = Expr (_v_Lookup3, (0 + 1 + 1), 1);
              RF_CALL (::refal::Table::Bind, (St_Table, _ve_key, (_vt_tbl__name + _c_4 + _vt_tbl__pos)), /*void*/);
              Expr _gs_auxcall5;
              RF_CALL (::refal::Access::Length, _ve_1, _gs_auxcall5);
              Expr _gs_auxcall6;
              RF_CALL (::refal::Access::Length, _ve_current, _gs_auxcall6);
              _ve_domain = _ve_rest;
              _vt_pos = (_gs_auxcall5 + _gs_auxcall6 + _ve_key) ();
              goto _exit3;
            }
        _continue3: {}
          }
        _exit3: {}
          goto _block6;
        }
      _block6__branch2: {}
        _ve_domain = _ve_rest;
      }
    _block6: {}
    }
  _exit__iter1: {}
  }
_block1: {}
RF_END

RF_FUNC (Bind_Static, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  if (_ge_arg1.get_len () != 1)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (_ge_arg1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _v_deref__arg1 (Expr (_ge_arg1, 0));
  int _v_len1 = _v_deref__arg1.get_len ();
  int _v_len2 = 1;
  if (_v_len1 < _v_len2)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  int _v_len__xpr = (_v_len1 - _v_len2);
  Expr _vt_name;
  _vt_name = Expr (_v_deref__arg1, 0, 1);
  Expr _ve_xpr;
  _ve_xpr = Expr (_v_deref__arg1, (0 + 1), _v_len__xpr);
  Expr _v_Bind__Subexprs1;
  RF_CALL (Bind_Subexprs, (_c_3, _vt_name, empty, _ve_xpr, _ve_xpr), _v_Bind__Subexprs1);
  int _v_len3 = 1;
  int _v_len4 = 0;
  if (_v_len3 < _v_len4)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  int _v_len___dollar_tmp_m_234_m_74 = (_v_len3 - _v_len4);
  Expr _ve__dollar_tmp_m_234_m_74;
  _ve__dollar_tmp_m_234_m_74 = Expr (_v_Bind__Subexprs1, 0, _v_len___dollar_tmp_m_234_m_74);
  _v_res1 = empty;
RF_END

RF_FUNC (Name, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  {
    {
      if (_ge_arg1.get_len () != 0)
      {
        goto _block1__branch1;
      }
      Expr _v_Get1;
      RF_CALL (::refal::Box::Get, FreeIdx, _v_Get1);
      if (_v_Get1.get_len () != 1)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      if (!_v_Get1.symbol_at (0))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      Expr _vs_free;
      _vs_free = Expr (_v_Get1, 0, 1);
      Expr _gs_auxcall1;
      RF_CALL (::refal::Arithm::Add, (_vs_free, _c_8), _gs_auxcall1);
      RF_CALL (::refal::Box::Store, (FreeIdx, _gs_auxcall1), /*void*/);
      _v_res1 = (_c_1 + _vs_free ()) ();
      goto _block1;
    }
  _block1__branch1: {}
    if (_ge_arg1.get_len () != 1)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    if (!_ge_arg1.symbol_at (0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _vs_idx;
    _vs_idx = Expr (_ge_arg1, 0, 1);
    _v_res1 = (_c_1 + _vs_idx ()) ();
  }
_block1: {}
RF_END

RF_FUNC (Subexprs_To_Constexprs, (RF_ARG _ge_arg1;;), (RF_RES _v_res1, _v_res2;;))
  {
    {
      if (_ge_arg1.get_len () != 0)
      {
        goto _block1__branch1;
      }
      _v_res1 = empty;
      _v_res2 = empty;
      goto _block1;
    }
  _block1__branch1: {}
    Expr _v_Lookup1;
    if (!RF_CALL (::refal::Table::Lookup, (St_Table, _ge_arg1), _v_Lookup1))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    {
      {
        int _v_len1 = _v_Lookup1.get_len ();
        int _v_len2 = 1;
        if (_v_len1 < _v_len2)
        {
          goto _block2__branch1;
        }
        int _v_len__const = (_v_len1 - _v_len2);
        if (!_c_9.term_eq (_v_Lookup1, 0))
        {
          goto _block2__branch1;
        }
        Expr _ve_const;
        _ve_const = Expr (_v_Lookup1, (0 + 1), _v_len__const);
        _v_res1 = empty;
        _v_res2 = _ve_const;
        goto _block2;
      }
    _block2__branch1: {}
      if (_v_Lookup1.get_len () != 3)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      if (_v_Lookup1.symbol_at (0))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      if (_v_Lookup1.symbol_at ((0 + 1)))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      if (_v_Lookup1.symbol_at ((0 + 1 + 1)))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      Expr _v_deref__Lookup1 (Expr (_v_Lookup1, 0));
      Expr _v_deref__Lookup12 (Expr (_v_Lookup1, (0 + 1)));
      Expr _v_deref__Lookup13 (Expr (_v_Lookup1, (0 + 1 + 1)));
      int _v_len3 = _v_deref__Lookup1.get_len ();
      int _v_len4 = 0;
      if (_v_len3 < _v_len4)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      int _v_len__name = (_v_len3 - _v_len4);
      int _v_len5 = _v_deref__Lookup13.get_len ();
      int _v_len6 = 0;
      if (_v_len5 < _v_len6)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      int _v_len__pos = (_v_len5 - _v_len6);
      int _v_len7 = _v_deref__Lookup12.get_len ();
      int _v_len8 = 0;
      if (_v_len7 < _v_len8)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      int _v_len__context = (_v_len7 - _v_len8);
      Expr _ve_name;
      _ve_name = Expr (_v_deref__Lookup1, 0, _v_len__name);
      Expr _ve_context;
      _ve_context = Expr (_v_deref__Lookup12, 0, _v_len__context);
      Expr _ve_pos;
      _ve_pos = Expr (_v_deref__Lookup13, 0, _v_len__pos);
      Expr _ve_constexprs;
      Expr _ve_const;
      {
        {
          int _v_len9 = _v_len__pos;
          int _v_len10 = 2;
          if (_v_len9 < _v_len10)
          {
            goto _block3__branch1;
          }
          int _v_len__source = (_v_len9 - _v_len10);
          if (!_ve_pos.symbol_at (0))
          {
            goto _block3__branch1;
          }
          if (!_ve_pos.symbol_at ((0 + 1)))
          {
            goto _block3__branch1;
          }
          Expr _vs_left;
          _vs_left = Expr (_ve_pos, 0, 1);
          Expr _vs_len;
          _vs_len = Expr (_ve_pos, (0 + 1), 1);
          Expr _ve_source;
          _ve_source = Expr (_ve_pos, (0 + 1 + 1), _v_len__source);
          Expr _ge_constexprs__6;
          RF_CALL (Subexprs_To_Constexprs, _ve_source, (_ge_constexprs__6, _ve_source));
          _ve_constexprs = _ge_constexprs__6;
          _ve_const = (_c_10 + _ve_source + _vs_left + _vs_len) ();
          goto _block3;
        }
      _block3__branch1: {}
        Expr _ge_arg1__6 (_ge_arg1);
        Expr _ge_constexprs__6;
        Expr _ge_const__6;
        for ( ; ; )
        {
          {
            if (_ge_arg1__6.get_len () != 0)
            {
              goto _iter1;
            }
            _ve_constexprs = _ge_constexprs__6;
            _ve_const = _ge_const__6;
            goto _exit__iter1;
          }
        _iter1: {}
          {
            {
              if (_ge_arg1__6.get_len () < 1)
              {
                goto _block4__branch1;
              }
              RF_lsplit (_ge_arg1__6, 0, _ve_1, _v_lsplit__arg1__6);
              for ( ; ; RF_iter(_ge_arg1__6)++)
              {
                {
                  if (!RF_iter(_ge_arg1__6))
                  {
                    goto _block4__branch1;
                  }
                  int _v_len11 = _v_lsplit__arg1__6.get_len ();
                  int _v_len12 = 1;
                  if (_v_len11 < _v_len12)
                  {
                    goto _block4__branch1;
                  }
                  int _v_len__3 = (_v_len11 - _v_len12);
                  if (_v_lsplit__arg1__6.symbol_at (0))
                  {
                    goto _continue1;
                  }
                  Expr _v_deref__lsplit__arg1__6 (Expr (_v_lsplit__arg1__6, 0));
                  int _v_len13 = _v_deref__lsplit__arg1__6.get_len ();
                  int _v_len14 = 1;
                  if (_v_len13 < _v_len14)
                  {
                    goto _continue1;
                  }
                  int _v_len__2 = (_v_len13 - _v_len14);
                  if (!_c_2.term_eq (_v_deref__lsplit__arg1__6, 0))
                  {
                    goto _continue1;
                  }
                  Expr _ve_3;
                  _ve_3 = Expr (_v_lsplit__arg1__6, (0 + 1), _v_len__3);
                  Expr _ve_2;
                  _ve_2 = Expr (_v_deref__lsplit__arg1__6, (0 + 1), _v_len__2);
                  Expr _ve_2__consts;
                  RF_CALL (Subexprs_To_Constexprs, _ve_2, (_ve_2__consts, _ve_2));
                  _ge_arg1__6 = _ve_3;
                  _ge_constexprs__6 = (_ge_constexprs__6 + _ve_2__consts);
                  _ge_const__6 = (_ge_const__6 + _ve_1 + (_c_2 + _ve_2) ());
                  goto _exit1;
                }
            _continue1: {}
              }
            _exit1: {}
              goto _block4;
            }
          _block4__branch1: {}
            _ge_const__6 = (_ge_const__6 + _ge_arg1__6);
            _ge_arg1__6 = empty;
          }
        _block4: {}
        }
      _exit__iter1: {}
      }
    _block3: {}
      Expr _ge_constexprs__6;
      Expr _ge_const__6;
      {
        {
          if (_v_len__context != 0)
          {
            goto _block5__branch1;
          }
          Expr _gt_name__7;
          RF_CALL (Name, _ve_name, _gt_name__7);
          _ge_constexprs__6 = (_ve_constexprs + (_c_11 + _gt_name__7 + _ge_arg1 () + _ve_const) ());
          _ge_const__6 = _gt_name__7;
          goto _block5;
        }
      _block5__branch1: {}
        _ge_constexprs__6 = _ve_constexprs;
        _ge_const__6 = _ve_const;
      }
    _block5: {}
      RF_CALL (::refal::Table::Bind, (St_Table, _ge_arg1, (_c_9 + _ge_const__6)), /*void*/);
      _v_res1 = _ge_constexprs__6;
      _v_res2 = _ge_const__6;
    }
  _block2: {}
  }
_block1: {}
RF_END

RF_FUNC (Static_To_Constexprs, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  if (_ge_arg1.get_len () != 1)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (_ge_arg1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _v_deref__arg1 (Expr (_ge_arg1, 0));
  int _v_len1 = _v_deref__arg1.get_len ();
  int _v_len2 = 1;
  if (_v_len1 < _v_len2)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  int _v_len__xpr = (_v_len1 - _v_len2);
  Expr _vt_name;
  _vt_name = Expr (_v_deref__arg1, 0, 1);
  Expr _ve_xpr;
  _ve_xpr = Expr (_v_deref__arg1, (0 + 1), _v_len__xpr);
  Expr _ve_constexprs;
  Expr _ve__dollar_tmp_m_313_m_52;
  RF_CALL (Subexprs_To_Constexprs, _ve_xpr, (_ve_constexprs, _ve__dollar_tmp_m_313_m_52));
  _v_res1 = _ve_constexprs;
RF_END

RF_FUNC (Comp_Consts, RF_VOID, (RF_RES _v_res1;;))
  RF_CALL (::refal::Table::ClearTable, St_Table, /*void*/);
  Expr _ge_auxcall1;
  RF_CALL (::refal::Box::Get, Static, _ge_auxcall1);
  Expr _gs_auxcall2;
  RF_CALL (::refal::Access::Length, _ge_auxcall1, _gs_auxcall2);
  RF_CALL (::refal::Box::Store, (FreeIdx, _gs_auxcall2), /*void*/);
  Expr _ge_auxcall3;
  RF_CALL (::refal::Box::Get, Static, _ge_auxcall3);
  Expr _v_Map1;
  if (!RF_CALL (::refal::List::Map, (_c_12, empty, _ge_auxcall3), _v_Map1))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  int _v_len1 = _v_Map1.get_len ();
  int _v_len2 = 0;
  if (_v_len1 < _v_len2)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  int _v_len___dollar_tmp_m_322_m_41 = (_v_len1 - _v_len2);
  Expr _ve__dollar_tmp_m_322_m_41;
  _ve__dollar_tmp_m_322_m_41 = Expr (_v_Map1, 0, _v_len___dollar_tmp_m_322_m_41);
  Expr _ge_auxcall4;
  RF_CALL (::refal::Box::Get, Static, _ge_auxcall4);
  if (!RF_CALL (::refal::List::Map, (_c_13, empty, _ge_auxcall4), _v_res1))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
RF_END

}

}

}

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_const {

static void init_ () {
  Static = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Static");
  St_Table = new rftype::StaticObject<rftype::Table>(L"St_Table");
  FreeIdx = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"FreeIdx");
  _c_0 = Expr::create<rftype::Word>("REF");
  _c_1 = Expr::create<rftype::Word>("STATIC");
  _c_2 = Expr::create<rftype::Word>("PAREN");
  _c_3 = Expr::create<rftype::Word>("Old");
  _c_4 = (empty) ();
  _c_5 = Expr::create<rftype::Word>("New");
  _c_6 = Expr::create<rftype::Word>("Not-Needed");
  _c_7 = Expr::create<rftype::Word>("Needed");
  _c_8 = Expr::create<rftype::Integer>("1");
  _c_9 = Expr::create<rftype::Word>("Constructed");
  _c_10 = Expr::create<rftype::Word>("SUBEXPR");
  _c_11 = Expr::create<rftype::Word>("CONSTEXPR") + Expr::create<rftype::Word>("LOCAL");
  _c_12 = Expr::create_sym<rftype::Func> (Bind_Static);
  _c_13 = Expr::create_sym<rftype::Func> (Static_To_Constexprs);
}

static AtStart init_registrator_ (&init_);

}

}

}

}

}
