
#include <rf_core.hh>

using namespace rfrt;

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_helper {

RF_DECL (Del_Pragmas);

RF_DECL (IsRFP_Debug);

RF_DECL (IsIn);

RF_DECL (PrintConstDefinition);

RF_DECL (Make_Name);

RF_DECL (PrintObjectDefinition);

RF_DECL (PrintFunctionFormat);

RF_DECL (PrintFormat);

RF_DECL (Lookup_Func);

RF_DECL (RFP_Double_Copy);

RF_DECL (Subst);

RF_DECL (RFP_Extract_Qualifiers);

RF_DECL (RFP_Double_Unbind);

RF_DECL (Print_Name);

}

}

}

}

}

namespace refal {

namespace Access {

RF_DECL (L);

}

}

namespace refal {

namespace Class {

RF_DECL (IsChar);

}

}

namespace refal {

namespace Access {

RF_DECL (Length);

}

}

namespace refal {

namespace Class {

RF_DECL (IsWord);

RF_DECL (IsInt);

}

}

namespace refal {

namespace Convert {

RF_DECL (ToWord);

}

}

namespace refal {

namespace List {

RF_DECL (Concat);

RF_DECL (MapIn);

RF_DECL (Intersperse);

}

}

namespace refal {

namespace Convert {

RF_DECL (ToChars);

}

}

namespace refal {

namespace Table {

RF_DECL (Bind);

RF_DECL (IsInTable);

RF_DECL (Domain);

}

}

namespace refal {

namespace List {

RF_DECL (Separate);

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_helper {

RF_DECL (ToWord_0);

}

}

}

}

}

namespace refal {

namespace Table {

RF_DECL (Table);

RF_DECL (Unbind);

RF_DECL (TableCopy);

RF_DECL (Lookup);

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_helper {

Expr Fun;

Expr IsFun;

Expr Const;

Expr Object;

Expr RFP_Options;

Expr RFP_Module_Subst;

static Expr _c_0;

static Expr _c_1;

static Expr _c_2;

static Expr _c_3;

static Expr _c_4;

static Expr _c_5;

static Expr _c_6;

static Expr _c_7;

static Expr _c_8;

static Expr _c_9;

static Expr _c_10;

static Expr _c_11;

static Expr _c_12;

static Expr _c_13;

static Expr _c_14;

static Expr _c_15;

static Expr _c_16;

static Expr _c_17;

static Expr _c_18;

static Expr _c_19;

static Expr _c_20;

static Expr _c_21;

static Expr _c_22;

static Expr _c_23;

static Expr _c_24;

static Expr _c_25;

static Expr _c_26;

static Expr _c_27;

static Expr _c_28;

static Expr _c_29;

static Expr _c_30;

static Expr _c_31;

static Expr _c_32;

static Expr _c_33;

static Expr _c_34;

static Expr _c_35;

static Expr _c_36;

static Expr _c_37;

static Expr _c_38;

static Expr _c_39;

static Expr _c_40;

static Expr _c_41;

static Expr _c_42;

RF_FUNC (Lookup_Func, (RF_ARG _vt_Fname;;), (RF_RES _v_res1, _v_res2, _v_res3, _v_res4;;))
  Expr _ge_auxalt1;
  {
    {
      if (!RF_CALL (::refal::Table::Lookup, (Fun, _vt_Fname), _ge_auxalt1))
      {
        goto _block1__branch1;
      }
      goto _block1;
    }
  _block1__branch1: {}
    if (!RF_CALL (::refal::Table::Lookup, (IsFun, _vt_Fname), _ge_auxalt1))
    {
      RF_RETFAIL;
    }
  }
_block1: {}
  if (_ge_auxalt1.get_len () != 4)
  {
    RF_RETFAIL;
  }
  if (_ge_auxalt1.symbol_at ((0 + 1 + 1)))
  {
    RF_RETFAIL;
  }
  if (_ge_auxalt1.symbol_at ((0 + 1 + 1 + 1)))
  {
    RF_RETFAIL;
  }
  Expr _v_deref__auxalt1 (Expr (_ge_auxalt1, (0 + 1 + 1)));
  Expr _v_deref__auxalt12 (Expr (_ge_auxalt1, (0 + 1 + 1 + 1)));
  int _v_len1 = _v_deref__auxalt12.get_len ();
  int _v_len2 = 0;
  if (_v_len1 < _v_len2)
  {
    RF_RETFAIL;
  }
  int _v_len__Fout = (_v_len1 - _v_len2);
  int _v_len3 = _v_deref__auxalt1.get_len ();
  int _v_len4 = 0;
  if (_v_len3 < _v_len4)
  {
    RF_RETFAIL;
  }
  int _v_len__Fin = (_v_len3 - _v_len4);
  if (!_ge_auxalt1.symbol_at (0))
  {
    RF_RETFAIL;
  }
  if (!_ge_auxalt1.symbol_at ((0 + 1)))
  {
    RF_RETFAIL;
  }
  Expr _vs_linkage;
  _vs_linkage = Expr (_ge_auxalt1, 0, 1);
  Expr _vs_tag;
  _vs_tag = Expr (_ge_auxalt1, (0 + 1), 1);
  Expr _ve_Fin;
  _ve_Fin = Expr (_v_deref__auxalt1, 0, _v_len__Fin);
  Expr _ve_Fout;
  _ve_Fout = Expr (_v_deref__auxalt12, 0, _v_len__Fout);
  _v_res1 = _vs_linkage;
  _v_res2 = _vs_tag;
  _v_res3 = _ve_Fin;
  _v_res4 = _ve_Fout;
RF_END

RF_FUNC (IsRFP_Debug, RF_VOID, RF_VOID)
  RF_TAILCALL (::refal::Table::IsInTable, (RFP_Options, _c_0), /*void*/);
RF_END

RF_FUNC (RFP_Double_Copy, (RF_ARG _vs_tab;;), (RF_RES _v_res1;;))
  Expr _vs_new__tab;
  RF_CALL (::refal::Table::Table, /*void*/, _vs_new__tab);
  {
    Expr _v_Domain1;
    RF_CALL (::refal::Table::Domain, _vs_tab, _v_Domain1);
    if (_v_Domain1.get_len () < 1)
    {
      goto _block1__branch1;
    }
    RF_lsplit (_v_Domain1, 0, _ve__dollar_tmp_m_16_m_23, _v_lsplit__Domain1);
    for ( ; ; RF_iter(_v_Domain1)++)
    {
      {
        if (!RF_iter(_v_Domain1))
        {
          goto _block1__branch1;
        }
        int _v_len1 = _v_lsplit__Domain1.get_len ();
        int _v_len2 = 1;
        if (_v_len1 < _v_len2)
        {
          goto _block1__branch1;
        }
        int _v_len___dollar_tmp_m_16_m_33 = (_v_len1 - _v_len2);
        if (_v_lsplit__Domain1.symbol_at (0))
        {
          goto _continue1;
        }
        Expr _v_deref__lsplit__Domain1 (Expr (_v_lsplit__Domain1, 0));
        int _v_len3 = _v_deref__lsplit__Domain1.get_len ();
        int _v_len4 = 0;
        if (_v_len3 < _v_len4)
        {
          goto _continue1;
        }
        int _v_len__key = (_v_len3 - _v_len4);
        Expr _ve__dollar_tmp_m_16_m_33;
        _ve__dollar_tmp_m_16_m_33 = Expr (_v_lsplit__Domain1, (0 + 1), _v_len___dollar_tmp_m_16_m_33);
        Expr _ve_key;
        _ve_key = Expr (_v_deref__lsplit__Domain1, 0, _v_len__key);
        Expr _v_Lookup1;
        if (!RF_CALL (::refal::Table::Lookup, (_vs_tab, _ve_key), _v_Lookup1))
        {
          goto _continue1;
        }
        if (_v_Lookup1.get_len () != 1)
        {
          goto _continue1;
        }
        if (!_v_Lookup1.symbol_at (0))
        {
          goto _continue1;
        }
        Expr _vs_tab1;
        _vs_tab1 = Expr (_v_Lookup1, 0, 1);
        Expr _gs_auxcall1;
        RF_CALL (::refal::Table::TableCopy, _vs_tab1, _gs_auxcall1);
        RF_CALL (::refal::Table::Bind, (_vs_new__tab, _ve_key, _gs_auxcall1), /*void*/);
      }
  _continue1: {}
    }
  _exit1: {}
  }
_block1__branch1: {}
  _v_res1 = _vs_new__tab;
RF_END

RF_FUNC (RFP_Double_Unbind, (RF_ARG _vs_tab, _ve_keys;;), RF_VOID)
  {
    if (_ve_keys.get_len () < 1)
    {
      goto _block1__branch1;
    }
    RF_lsplit (_ve_keys, 0, _ve__dollar_tmp_m_25_m_15, _v_lsplit__keys);
    for ( ; ; RF_iter(_ve_keys)++)
    {
      {
        if (!RF_iter(_ve_keys))
        {
          goto _block1__branch1;
        }
        int _v_len1 = _v_lsplit__keys.get_len ();
        int _v_len2 = 1;
        if (_v_len1 < _v_len2)
        {
          goto _block1__branch1;
        }
        int _v_len___dollar_tmp_m_25_m_23 = (_v_len1 - _v_len2);
        Expr _vt_key;
        _vt_key = Expr (_v_lsplit__keys, 0, 1);
        Expr _ve__dollar_tmp_m_25_m_23;
        _ve__dollar_tmp_m_25_m_23 = Expr (_v_lsplit__keys, (0 + 1), _v_len___dollar_tmp_m_25_m_23);
        RF_CALL (::refal::Table::Unbind, (_vs_tab, _vt_key), /*void*/);
      }
  _continue1: {}
    }
  _exit1: {}
  }
_block1__branch1: {}
RF_END

RF_FUNC (RFP_Extract_Qualifiers, (RF_ARG _gt_arg1;;), (RF_RES _v_res1, _v_res2;;))
  {
    {
      if (_gt_arg1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__arg1 (Expr (_gt_arg1, 0));
      if (_v_deref__arg1.get_len () < 2)
      {
        goto _block1__branch1;
      }
      RF_lsplit (_v_deref__arg1, 0, _ve_1, _v_lsplit__deref__arg1);
      for ( ; ; RF_iter(_v_deref__arg1)++)
      {
        {
          if (!RF_iter(_v_deref__arg1))
          {
            goto _block1__branch1;
          }
          int _v_len1 = _v_lsplit__deref__arg1.get_len ();
          int _v_len2 = 2;
          if (_v_len1 < _v_len2)
          {
            goto _block1__branch1;
          }
          int _v_len__4 = (_v_len1 - _v_len2);
          if (!_v_lsplit__deref__arg1.symbol_at (0))
          {
            goto _continue1;
          }
          if (!_v_lsplit__deref__arg1.symbol_at ((0 + 1)))
          {
            goto _continue1;
          }
          Expr _vs_2;
          _vs_2 = Expr (_v_lsplit__deref__arg1, 0, 1);
          Expr _vs_3;
          _vs_3 = Expr (_v_lsplit__deref__arg1, (0 + 1), 1);
          Expr _ve_4;
          _ve_4 = Expr (_v_lsplit__deref__arg1, (0 + 1 + 1), _v_len__4);
          if (!RF_CALL (::refal::Class::IsInt, _vs_3, /*void*/))
          {
            goto _continue1;
          }
          _v_res1 = _ve_1;
          _v_res2 = (_vs_2 + _vs_3 + _ve_4);
          goto _exit1;
        }
    _continue1: {}
      }
    _exit1: {}
      goto _block1;
    }
  _block1__branch1: {}
    {
      if (_gt_arg1.symbol_at (0))
      {
        goto _block1__branch2;
      }
      Expr _v_deref__arg12 (Expr (_gt_arg1, 0));
      int _v_len3 = _v_deref__arg12.get_len ();
      int _v_len4 = 1;
      if (_v_len3 < _v_len4)
      {
        goto _block1__branch2;
      }
      int _v_len__1 = (_v_len3 - _v_len4);
      if (!_v_deref__arg12.symbol_at ((0 + _v_len__1)))
      {
        goto _block1__branch2;
      }
      Expr _ve_1;
      _ve_1 = Expr (_v_deref__arg12, 0, _v_len__1);
      Expr _vs_2;
      _vs_2 = Expr (_v_deref__arg12, (0 + _v_len__1), 1);
      _v_res1 = _ve_1;
      _v_res2 = _vs_2;
      goto _block1;
    }
  _block1__branch2: {}
    if (_gt_arg1.symbol_at (0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _v_deref__arg13 (Expr (_gt_arg1, 0));
    int _v_len5 = _v_deref__arg13.get_len ();
    int _v_len6 = 0;
    if (_v_len5 < _v_len6)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    int _v_len__12 = (_v_len5 - _v_len6);
    Expr _ve_1;
    _ve_1 = Expr (_v_deref__arg13, 0, _v_len__12);
    _v_res1 = empty;
    _v_res2 = _ve_1;
  }
_block1: {}
RF_END

RF_FUNC (Subst, (RF_ARG _ve_patterns, _ve_replaces, _ve_xpr;;), (RF_RES _v_res1;;))
  {
    {
      if (_ve_xpr.get_len () < 1)
      {
        goto _block1__branch1;
      }
      RF_lsplit (_ve_xpr, 0, _ve_1, _v_lsplit__xpr);
      for ( ; ; RF_iter(_ve_xpr)++)
      {
        {
          if (!RF_iter(_ve_xpr))
          {
            goto _block1__branch1;
          }
          int _v_len1 = _v_lsplit__xpr.get_len ();
          int _v_len2 = 1;
          if (_v_len1 < _v_len2)
          {
            goto _block1__branch1;
          }
          int _v_len__3 = (_v_len1 - _v_len2);
          Expr _vt_2;
          _vt_2 = Expr (_v_lsplit__xpr, 0, 1);
          Expr _ve_3;
          _ve_3 = Expr (_v_lsplit__xpr, (0 + 1), _v_len__3);
          Expr _ve_9;
          Expr _ve_10;
          {
            {
              if (_ve_patterns.get_len () < 1)
              {
                goto _block2__branch1;
              }
              RF_rsplit (_ve_patterns, 0, _v_rsplit__patterns, _ve_5);
              for ( ; ; RF_iter(_ve_patterns)--)
              {
                {
                  if (!RF_iter(_ve_patterns))
                  {
                    goto _block2__branch1;
                  }
                  int _v_len3 = _v_rsplit__patterns.get_len ();
                  int _v_len4 = 1;
                  if (_v_len3 < _v_len4)
                  {
                    goto _block2__branch1;
                  }
                  int _v_len__4 = (_v_len3 - _v_len4);
                  if (!_vt_2.term_eq (_v_rsplit__patterns, (0 + _v_len__4)))
                  {
                    goto _continue2;
                  }
                  Expr _ve_4;
                  _ve_4 = Expr (_v_rsplit__patterns, 0, _v_len__4);
                  Expr _gs_auxcall1;
                  RF_CALL (::refal::Access::Length, _ve_4, _gs_auxcall1);
                  Expr _v_L1;
                  if (!RF_CALL (::refal::Access::L, (_gs_auxcall1, _ve_replaces), _v_L1))
                  {
                    goto _continue1;
                  }
                  if (_v_L1.symbol_at (0))
                  {
                    goto _continue1;
                  }
                  Expr _v_deref__L1 (Expr (_v_L1, 0));
                  int _v_len5 = _v_deref__L1.get_len ();
                  int _v_len6 = 0;
                  if (_v_len5 < _v_len6)
                  {
                    goto _continue1;
                  }
                  int _v_len__6 = (_v_len5 - _v_len6);
                  Expr _ve_6;
                  _ve_6 = Expr (_v_deref__L1, 0, _v_len__6);
                  _ve_9 = _ve_1;
                  _ve_10 = (_ve_6 + _ve_3);
                  goto _exit2;
                }
            _continue2: {}
              }
            _exit2: {}
              goto _block2;
            }
          _block2__branch1: {}
            if (_vt_2.symbol_at (0))
            {
              goto _continue1;
            }
            Expr _v_deref__2 (Expr (_vt_2, 0));
            int _v_len7 = _v_deref__2.get_len ();
            int _v_len8 = 0;
            if (_v_len7 < _v_len8)
            {
              goto _continue1;
            }
            int _v_len__7 = (_v_len7 - _v_len8);
            Expr _ve_7;
            _ve_7 = Expr (_v_deref__2, 0, _v_len__7);
            Expr _v_Subst1;
            RF_CALL (Subst, (_ve_patterns, _ve_replaces, _ve_7), _v_Subst1);
            {
              {
                if (_v_Subst1.get_len () != _v_len__7)
                {
                  goto _block3__branch1;
                }
                if (!_ve_7.eq (_v_Subst1, 0))
                {
                  goto _block3__branch1;
                }
                _ve_9 = (_ve_1 + _vt_2);
                _ve_10 = _ve_3;
                goto _block3;
              }
            _block3__branch1: {}
              int _v_len9 = _v_Subst1.get_len ();
              int _v_len10 = 0;
              if (_v_len9 < _v_len10)
              {
                RF_FUNC_ERROR (unexpected_fail);
              }
              int _v_len__8 = (_v_len9 - _v_len10);
              Expr _ve_8;
              _ve_8 = Expr (_v_Subst1, 0, _v_len__8);
              _ve_9 = _ve_1;
              _ve_10 = (_ve_8 () + _ve_3);
            }
          _block3: {}
          }
        _block2: {}
          Expr _v_Subst2;
          RF_CALL (Subst, (_ve_patterns, _ve_replaces, _ve_10), _v_Subst2);
          _v_res1 = (_ve_9 + _v_Subst2);
          goto _exit1;
        }
    _continue1: {}
      }
    _exit1: {}
      goto _block1;
    }
  _block1__branch1: {}
    _v_res1 = _ve_xpr;
  }
_block1: {}
RF_END

RF_FUNC (IsIn, (RF_ARG _ge_arg1, _ge_arg2;;), RF_VOID)
  {
    {
      if ((_ge_arg2.get_len () + 1) < 1)
      {
        goto _block1__branch1;
      }
      Expr _v_compose1 ((_ge_arg1 () + _ge_arg2));
      if (_v_compose1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__compose1 (Expr (_v_compose1, 0));
      int _v_len1 = _v_deref__compose1.get_len ();
      int _v_len2 = 0;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      int _v_len__pattern = (_v_len1 - _v_len2);
      if (_v_compose1.get_len () < (_v_len__pattern + 1))
      {
        goto _block1__branch1;
      }
      Expr _ve_pattern;
      _ve_pattern = Expr (_v_deref__compose1, 0, _v_len__pattern);
      Expr _v_subexpr__compose1 (Expr (_v_compose1, (0 + 1), (_v_compose1.get_len () - (0 + 1 + 0))));
      RF_lsplit (_v_subexpr__compose1, 0, _ve__dollar_tmp_m_63_m_16, _v_lsplit__compose1);
      for ( ; ; RF_iter(_v_subexpr__compose1)++)
      {
        {
          if (!RF_iter(_v_subexpr__compose1))
          {
            goto _block1__branch1;
          }
          int _v_len3 = _v_lsplit__compose1.get_len ();
          int _v_len4 = _v_len__pattern;
          if (_v_len3 < _v_len4)
          {
            goto _block1__branch1;
          }
          int _v_len___dollar_tmp_m_63_m_28 = (_v_len3 - _v_len4);
          if (!_ve_pattern.eq (_v_lsplit__compose1, 0))
          {
            goto _continue1;
          }
          Expr _ve__dollar_tmp_m_63_m_28;
          _ve__dollar_tmp_m_63_m_28 = Expr (_v_lsplit__compose1, (0 + _v_len__pattern), _v_len___dollar_tmp_m_63_m_28);
          goto _exit1;
        }
    _continue1: {}
      }
    _exit1: {}
      goto _block1;
    }
  _block1__branch1: {}
    if ((_ge_arg2.get_len () + 1) < 2)
    {
      RF_RETFAIL;
    }
    Expr _v_compose2 ((_ge_arg1 () + _ge_arg2));
    if (_v_compose2.symbol_at (0))
    {
      RF_RETFAIL;
    }
    Expr _v_deref__compose2 (Expr (_v_compose2, 0));
    int _v_len5 = _v_deref__compose2.get_len ();
    int _v_len6 = 0;
    if (_v_len5 < _v_len6)
    {
      RF_RETFAIL;
    }
    int _v_len__pattern2 = (_v_len5 - _v_len6);
    Expr _ve_pattern;
    _ve_pattern = Expr (_v_deref__compose2, 0, _v_len__pattern2);
    Expr _v_subexpr__compose2 (Expr (_v_compose2, (0 + 1), (_v_compose2.get_len () - (0 + 1 + 0))));
    RF_lsplit (_v_subexpr__compose2, 0, _ve__dollar_tmp_m_64_m_16, _v_lsplit__compose2);
    for ( ; ; RF_iter(_v_subexpr__compose2)++)
    {
      {
        if (!RF_iter(_v_subexpr__compose2))
        {
          RF_RETFAIL;
        }
        int _v_len7 = _v_lsplit__compose2.get_len ();
        int _v_len8 = 1;
        if (_v_len7 < _v_len8)
        {
          RF_RETFAIL;
        }
        int _v_len___dollar_tmp_m_64_m_25 = (_v_len7 - _v_len8);
        if (_v_lsplit__compose2.symbol_at (0))
        {
          goto _continue2;
        }
        Expr _v_deref__lsplit__compose2 (Expr (_v_lsplit__compose2, 0));
        int _v_len9 = _v_deref__lsplit__compose2.get_len ();
        int _v_len10 = 0;
        if (_v_len9 < _v_len10)
        {
          goto _continue2;
        }
        int _v_len__xpr = (_v_len9 - _v_len10);
        Expr _ve__dollar_tmp_m_64_m_25;
        _ve__dollar_tmp_m_64_m_25 = Expr (_v_lsplit__compose2, (0 + 1), _v_len___dollar_tmp_m_64_m_25);
        Expr _ve_xpr;
        _ve_xpr = Expr (_v_deref__lsplit__compose2, 0, _v_len__xpr);
        if (!RF_CALL (IsIn, (_ve_pattern, _ve_xpr), /*void*/))
        {
          goto _continue2;
        }
        goto _exit2;
      }
  _continue2: {}
    }
  _exit2: {}
  }
_block1: {}
RF_END

RF_FUNC (Make_Name, (RF_ARG _ve_origname;;), (RF_RES _v_res1;;))
  Expr _ge_auxcall1;
  RF_CALL (::refal::List::Separate, (_c_1, _ve_origname), _ge_auxcall1);
  Expr _ge_auxcall2;
  if (!RF_CALL (::refal::List::MapIn, (_c_2, empty, _ge_auxcall1), _ge_auxcall2))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  RF_TAILCALL (::refal::List::Concat, _ge_auxcall2, _v_res1);
RF_END

RF_FUNC (Print_Name, (RF_ARG _ve_name;;), (RF_RES _v_res1;;))
  Expr _ge_auxcall1;
  RF_CALL (::refal::List::Intersperse, (_c_1, _ve_name), _ge_auxcall1);
  RF_TAILCALL (::refal::Convert::ToChars, _ge_auxcall1, _v_res1);
RF_END

RF_FUNC (PrintFormat, (RF_ARG _ve_format;;), (RF_RES _v_res1;;))
  Expr _ge_format__0 (_ve_format);
  Expr _ve_res;
  for ( ; ; )
  {
    {
      if (_ge_format__0.get_len () != 0)
      {
        goto _iter1;
      }
      _v_res1 = _ve_res;
      goto _exit__iter1;
    }
  _iter1: {}
    int _v_len1 = _ge_format__0.get_len ();
    int _v_len2 = 1;
    if (_v_len1 < _v_len2)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    int _v_len__rest = (_v_len1 - _v_len2);
    Expr _vt_item;
    _vt_item = Expr (_ge_format__0, 0, 1);
    Expr _ve_rest;
    _ve_rest = Expr (_ge_format__0, (0 + 1), _v_len__rest);
    Expr _ve_subres;
    Expr _ge_rest__3;
    {
      {
        if (!RF_CALL (::refal::Class::IsChar, _vt_item, /*void*/))
        {
          goto _block2__branch1;
        }
        Expr _ve_items (_vt_item);
        Expr _ge_rest__4 (_ve_rest);
        Expr _vs_tag (_c_3);
        for ( ; ; )
        {
          {
            if (!_vs_tag.term_eq (_c_4, 0))
            {
              goto _iter2;
            }
            _ve_subres = (_c_5 + _ve_items + _c_5);
            _ge_rest__3 = _ge_rest__4;
            goto _exit__iter2;
          }
        _iter2: {}
          {
            {
              int _v_len3 = _ge_rest__4.get_len ();
              int _v_len4 = 1;
              if (_v_len3 < _v_len4)
              {
                goto _block3__branch1;
              }
              int _v_len__tail = (_v_len3 - _v_len4);
              Expr _vt_head;
              _vt_head = Expr (_ge_rest__4, 0, 1);
              Expr _ve_tail;
              _ve_tail = Expr (_ge_rest__4, (0 + 1), _v_len__tail);
              if (!RF_CALL (::refal::Class::IsChar, _vt_head, /*void*/))
              {
                goto _block3__branch1;
              }
              _ve_items = (_ve_items + _vt_head);
              _ge_rest__4 = _ve_tail;
              _vs_tag = _c_3;
              goto _block3;
            }
          _block3__branch1: {}
            _vs_tag = _c_4;
          }
        _block3: {}
        }
      _exit__iter2: {}
        goto _block2;
      }
    _block2__branch1: {}
      Expr _ge_subres__5;
      {
        {
          if (!_vt_item.symbol_at (0))
          {
            goto _block4__branch1;
          }
          Expr _vs_object;
          _vs_object = Expr (_vt_item, 0, 1);
          if (!RF_CALL (::refal::Class::IsChar, _vs_object, /*void*/))
          {
            goto _block4__branch1;
          }
          _ge_subres__5 = (_c_5 + _vs_object + _c_5);
          goto _block4;
        }
      _block4__branch1: {}
        {
          if (!_vt_item.symbol_at (0))
          {
            goto _block4__branch2;
          }
          Expr _vs_object;
          _vs_object = Expr (_vt_item, 0, 1);
          if (!RF_CALL (::refal::Class::IsWord, _vs_object, /*void*/))
          {
            goto _block4__branch2;
          }
          _ge_subres__5 = (_c_6 + _vs_object + _c_6);
          goto _block4;
        }
      _block4__branch2: {}
        {
          if (!_vt_item.symbol_at (0))
          {
            goto _block4__branch3;
          }
          Expr _vs_object;
          _vs_object = Expr (_vt_item, 0, 1);
          if (!RF_CALL (::refal::Class::IsInt, _vs_object, /*void*/))
          {
            goto _block4__branch3;
          }
          _ge_subres__5 = _vs_object;
          goto _block4;
        }
      _block4__branch3: {}
        {
          if (_vt_item.symbol_at (0))
          {
            goto _block4__branch4;
          }
          Expr _v_deref__item (Expr (_vt_item, 0));
          if (_v_deref__item.get_len () != 2)
          {
            goto _block4__branch4;
          }
          if (_v_deref__item.symbol_at ((0 + 1)))
          {
            goto _block4__branch4;
          }
          Expr _v_deref__deref__item (Expr (_v_deref__item, (0 + 1)));
          int _v_len5 = _v_deref__deref__item.get_len ();
          int _v_len6 = 1;
          if (_v_len5 < _v_len6)
          {
            goto _block4__branch4;
          }
          int _v_len___dollar_tmp_m_94_m_20 = (_v_len5 - _v_len6);
          if (!_c_7.term_eq (_v_deref__item, 0))
          {
            goto _block4__branch4;
          }
          if (!_v_deref__deref__item.symbol_at ((0 + _v_len___dollar_tmp_m_94_m_20)))
          {
            goto _block4__branch4;
          }
          Expr _ve__dollar_tmp_m_94_m_20;
          _ve__dollar_tmp_m_94_m_20 = Expr (_v_deref__deref__item, 0, _v_len___dollar_tmp_m_94_m_20);
          Expr _vs_name;
          _vs_name = Expr (_v_deref__deref__item, (0 + _v_len___dollar_tmp_m_94_m_20), 1);
          _ge_subres__5 = (_c_8 + _vs_name);
          goto _block4;
        }
      _block4__branch4: {}
        {
          if (_vt_item.symbol_at (0))
          {
            goto _block4__branch5;
          }
          Expr _v_deref__item2 (Expr (_vt_item, 0));
          if (_v_deref__item2.get_len () != 2)
          {
            goto _block4__branch5;
          }
          if (_v_deref__item2.symbol_at ((0 + 1)))
          {
            goto _block4__branch5;
          }
          Expr _v_deref__deref__item2 (Expr (_v_deref__item2, (0 + 1)));
          int _v_len7 = _v_deref__deref__item2.get_len ();
          int _v_len8 = 1;
          if (_v_len7 < _v_len8)
          {
            goto _block4__branch5;
          }
          int _v_len___dollar_tmp_m_95_m_18 = (_v_len7 - _v_len8);
          if (!_c_9.term_eq (_v_deref__item2, 0))
          {
            goto _block4__branch5;
          }
          if (!_v_deref__deref__item2.symbol_at ((0 + _v_len___dollar_tmp_m_95_m_18)))
          {
            goto _block4__branch5;
          }
          Expr _ve__dollar_tmp_m_95_m_18;
          _ve__dollar_tmp_m_95_m_18 = Expr (_v_deref__deref__item2, 0, _v_len___dollar_tmp_m_95_m_18);
          Expr _vs_name;
          _vs_name = Expr (_v_deref__deref__item2, (0 + _v_len___dollar_tmp_m_95_m_18), 1);
          _ge_subres__5 = (_c_8 + _vs_name);
          goto _block4;
        }
      _block4__branch5: {}
        {
          if (_vt_item.symbol_at (0))
          {
            goto _block4__branch6;
          }
          Expr _v_deref__item3 (Expr (_vt_item, 0));
          int _v_len9 = _v_deref__item3.get_len ();
          int _v_len10 = 1;
          if (_v_len9 < _v_len10)
          {
            goto _block4__branch6;
          }
          int _v_len__subformat = (_v_len9 - _v_len10);
          if (!_c_10.term_eq (_v_deref__item3, 0))
          {
            goto _block4__branch6;
          }
          Expr _ve_subformat;
          _ve_subformat = Expr (_v_deref__item3, (0 + 1), _v_len__subformat);
          Expr _ge_auxcall1;
          RF_CALL (PrintFormat, _ve_subformat, _ge_auxcall1);
          _ge_subres__5 = (_c_12 + _ge_auxcall1 + _c_11);
          goto _block4;
        }
      _block4__branch6: {}
        {
          if (_vt_item.symbol_at (0))
          {
            goto _block4__branch7;
          }
          Expr _v_deref__item4 (Expr (_vt_item, 0));
          int _v_len11 = _v_deref__item4.get_len ();
          int _v_len12 = 1;
          if (_v_len11 < _v_len12)
          {
            goto _block4__branch7;
          }
          int _v_len___dollar_tmp_m_97_m_18 = (_v_len11 - _v_len12);
          if (!_c_13.term_eq (_v_deref__item4, 0))
          {
            goto _block4__branch7;
          }
          Expr _ve__dollar_tmp_m_97_m_18;
          _ve__dollar_tmp_m_97_m_18 = Expr (_v_deref__item4, (0 + 1), _v_len___dollar_tmp_m_97_m_18);
          _ge_subres__5 = _c_14;
          goto _block4;
        }
      _block4__branch7: {}
        {
          if (_vt_item.symbol_at (0))
          {
            goto _block4__branch8;
          }
          Expr _v_deref__item5 (Expr (_vt_item, 0));
          int _v_len13 = _v_deref__item5.get_len ();
          int _v_len14 = 1;
          if (_v_len13 < _v_len14)
          {
            goto _block4__branch8;
          }
          int _v_len___dollar_tmp_m_98_m_18 = (_v_len13 - _v_len14);
          if (!_c_15.term_eq (_v_deref__item5, 0))
          {
            goto _block4__branch8;
          }
          Expr _ve__dollar_tmp_m_98_m_18;
          _ve__dollar_tmp_m_98_m_18 = Expr (_v_deref__item5, (0 + 1), _v_len___dollar_tmp_m_98_m_18);
          _ge_subres__5 = _c_16;
          goto _block4;
        }
      _block4__branch8: {}
        {
          if (_vt_item.symbol_at (0))
          {
            goto _block4__branch9;
          }
          Expr _v_deref__item6 (Expr (_vt_item, 0));
          int _v_len15 = _v_deref__item6.get_len ();
          int _v_len16 = 1;
          if (_v_len15 < _v_len16)
          {
            goto _block4__branch9;
          }
          int _v_len___dollar_tmp_m_99_m_18 = (_v_len15 - _v_len16);
          if (!_c_17.term_eq (_v_deref__item6, 0))
          {
            goto _block4__branch9;
          }
          Expr _ve__dollar_tmp_m_99_m_18;
          _ve__dollar_tmp_m_99_m_18 = Expr (_v_deref__item6, (0 + 1), _v_len___dollar_tmp_m_99_m_18);
          _ge_subres__5 = _c_18;
          goto _block4;
        }
      _block4__branch9: {}
        {
          if (_vt_item.symbol_at (0))
          {
            goto _block4__branch10;
          }
          Expr _v_deref__item7 (Expr (_vt_item, 0));
          int _v_len17 = _v_deref__item7.get_len ();
          int _v_len18 = 1;
          if (_v_len17 < _v_len18)
          {
            goto _block4__branch10;
          }
          int _v_len___dollar_tmp_m_100_m_18 = (_v_len17 - _v_len18);
          if (!_c_19.term_eq (_v_deref__item7, 0))
          {
            goto _block4__branch10;
          }
          Expr _ve__dollar_tmp_m_100_m_18;
          _ve__dollar_tmp_m_100_m_18 = Expr (_v_deref__item7, (0 + 1), _v_len___dollar_tmp_m_100_m_18);
          _ge_subres__5 = _c_20;
          goto _block4;
        }
      _block4__branch10: {}
        int _v_len19 = 1;
        int _v_len20 = 0;
        if (_v_len19 < _v_len20)
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        int _v_len___dollar_tmp_m_101_m_12 = (_v_len19 - _v_len20);
        Expr _ve__dollar_tmp_m_101_m_12;
        _ve__dollar_tmp_m_101_m_12 = Expr (_vt_item, 0, _v_len___dollar_tmp_m_101_m_12);
        _ge_subres__5 = _c_21;
      }
    _block4: {}
      _ve_subres = _ge_subres__5;
      _ge_rest__3 = _ve_rest;
    }
  _block2: {}
    Expr _ge_res__4;
    {
      {
        if (_ve_res.get_len () != 0)
        {
          goto _block5__branch1;
        }
        _ge_res__4 = _ve_subres;
        goto _block5;
      }
    _block5__branch1: {}
      _ge_res__4 = (_ve_res + _c_22 + _ve_subres);
    }
  _block5: {}
    _ge_format__0 = _ge_rest__3;
    _ve_res = _ge_res__4;
  }
_exit__iter1: {}
RF_END

RF_FUNC (PrintFunctionFormat, (RF_ARG _vt_name;;), (RF_RES _v_res1;;))
  Expr _vs_linkage;
  Expr _vs_tag;
  Expr _ve_Fin;
  Expr _ve_Fout;
  if (!RF_CALL (Lookup_Func, _vt_name, (_vs_linkage, _vs_tag, _ve_Fin, _ve_Fout)))
  {
    RF_RETFAIL;
  }
  if (_vt_name.symbol_at (0))
  {
    RF_RETFAIL;
  }
  Expr _v_deref__name (Expr (_vt_name, 0));
  int _v_len1 = _v_deref__name.get_len ();
  int _v_len2 = 1;
  if (_v_len1 < _v_len2)
  {
    RF_RETFAIL;
  }
  int _v_len___dollar_tmp_m_116_m_14 = (_v_len1 - _v_len2);
  if (!_v_deref__name.symbol_at ((0 + _v_len___dollar_tmp_m_116_m_14)))
  {
    RF_RETFAIL;
  }
  Expr _ve__dollar_tmp_m_116_m_14;
  _ve__dollar_tmp_m_116_m_14 = Expr (_v_deref__name, 0, _v_len___dollar_tmp_m_116_m_14);
  Expr _vs_funcName;
  _vs_funcName = Expr (_v_deref__name, (0 + _v_len___dollar_tmp_m_116_m_14), 1);
  Expr _vs_funcType;
  {
    {
      if (!_vs_tag.term_eq (_c_23, 0))
      {
        goto _block1__branch1;
      }
      _vs_funcType = _c_24;
      goto _block1;
    }
  _block1__branch1: {}
    if (!_vs_tag.term_eq (_c_25, 0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    _vs_funcType = _c_26;
  }
_block1: {}
  Expr _ve_in;
  RF_CALL (PrintFormat, _ve_Fin, _ve_in);
  Expr _ge_in__2;
  {
    {
      if (_ve_in.get_len () != 0)
      {
        goto _block2__branch1;
      }
      _ge_in__2 = empty;
      goto _block2;
    }
  _block2__branch1: {}
    _ge_in__2 = (_ve_in + _c_22);
  }
_block2: {}
  Expr _ve_out;
  RF_CALL (PrintFormat, _ve_Fout, _ve_out);
  RF_TAILCALL (::refal::Convert::ToWord, (_vs_funcType + _c_22 + _vs_funcName + _c_22 + _ge_in__2 + _c_28 + _ve_out + _c_27), _v_res1);
RF_END

RF_FUNC (PrintConstDefinition, (RF_ARG _vt_name;;), (RF_RES _v_res1;;))
  Expr _v_Lookup1;
  if (!RF_CALL (::refal::Table::Lookup, (Const, _vt_name), _v_Lookup1))
  {
    RF_RETFAIL;
  }
  int _v_len1 = _v_Lookup1.get_len ();
  int _v_len2 = 2;
  if (_v_len1 < _v_len2)
  {
    RF_RETFAIL;
  }
  int _v_len__def = (_v_len1 - _v_len2);
  if (!_v_Lookup1.symbol_at (0))
  {
    RF_RETFAIL;
  }
  if (!_v_Lookup1.symbol_at ((0 + 1)))
  {
    RF_RETFAIL;
  }
  Expr _vs_linkage;
  _vs_linkage = Expr (_v_Lookup1, 0, 1);
  Expr _vs_tag;
  _vs_tag = Expr (_v_Lookup1, (0 + 1), 1);
  Expr _ve_def;
  _ve_def = Expr (_v_Lookup1, (0 + 1 + 1), _v_len__def);
  if (_vt_name.symbol_at (0))
  {
    RF_RETFAIL;
  }
  Expr _v_deref__name (Expr (_vt_name, 0));
  int _v_len3 = _v_deref__name.get_len ();
  int _v_len4 = 1;
  if (_v_len3 < _v_len4)
  {
    RF_RETFAIL;
  }
  int _v_len___dollar_tmp_m_128_m_14 = (_v_len3 - _v_len4);
  if (!_v_deref__name.symbol_at ((0 + _v_len___dollar_tmp_m_128_m_14)))
  {
    RF_RETFAIL;
  }
  Expr _ve__dollar_tmp_m_128_m_14;
  _ve__dollar_tmp_m_128_m_14 = Expr (_v_deref__name, 0, _v_len___dollar_tmp_m_128_m_14);
  Expr _vs_constName;
  _vs_constName = Expr (_v_deref__name, (0 + _v_len___dollar_tmp_m_128_m_14), 1);
  Expr _ge_auxcall1;
  RF_CALL (PrintFormat, _ve_def, _ge_auxcall1);
  RF_TAILCALL (::refal::Convert::ToWord, (_c_30 + _vs_constName + _c_29 + _ge_auxcall1 + _c_27), _v_res1);
RF_END

RF_FUNC (PrintObjectDefinition, (RF_ARG _vt_name;;), (RF_RES _v_res1;;))
  Expr _v_Lookup1;
  if (!RF_CALL (::refal::Table::Lookup, (Object, _vt_name), _v_Lookup1))
  {
    RF_RETFAIL;
  }
  int _v_len1 = _v_Lookup1.get_len ();
  int _v_len2 = 2;
  if (_v_len1 < _v_len2)
  {
    RF_RETFAIL;
  }
  int _v_len__def = (_v_len1 - _v_len2);
  if (!_v_Lookup1.symbol_at (0))
  {
    RF_RETFAIL;
  }
  if (!_v_Lookup1.symbol_at ((0 + 1)))
  {
    RF_RETFAIL;
  }
  Expr _vs_linkage;
  _vs_linkage = Expr (_v_Lookup1, 0, 1);
  Expr _vs_tag;
  _vs_tag = Expr (_v_Lookup1, (0 + 1), 1);
  Expr _ve_def;
  _ve_def = Expr (_v_Lookup1, (0 + 1 + 1), _v_len__def);
  if (_vt_name.symbol_at (0))
  {
    RF_RETFAIL;
  }
  Expr _v_deref__name (Expr (_vt_name, 0));
  int _v_len3 = _v_deref__name.get_len ();
  int _v_len4 = 1;
  if (_v_len3 < _v_len4)
  {
    RF_RETFAIL;
  }
  int _v_len___dollar_tmp_m_133_m_14 = (_v_len3 - _v_len4);
  if (!_v_deref__name.symbol_at ((0 + _v_len___dollar_tmp_m_133_m_14)))
  {
    RF_RETFAIL;
  }
  Expr _ve__dollar_tmp_m_133_m_14;
  _ve__dollar_tmp_m_133_m_14 = Expr (_v_deref__name, 0, _v_len___dollar_tmp_m_133_m_14);
  Expr _vs_objectName;
  _vs_objectName = Expr (_v_deref__name, (0 + _v_len___dollar_tmp_m_133_m_14), 1);
  Expr _vs_type;
  {
    {
      if (!_vs_tag.term_eq (_c_31, 0))
      {
        goto _block1__branch1;
      }
      _vs_type = _c_32;
      goto _block1;
    }
  _block1__branch1: {}
    {
      if (!_vs_tag.term_eq (_c_33, 0))
      {
        goto _block1__branch2;
      }
      _vs_type = _c_34;
      goto _block1;
    }
  _block1__branch2: {}
    {
      if (!_vs_tag.term_eq (_c_35, 0))
      {
        goto _block1__branch3;
      }
      _vs_type = _c_36;
      goto _block1;
    }
  _block1__branch3: {}
    {
      if (!_vs_tag.term_eq (_c_37, 0))
      {
        goto _block1__branch4;
      }
      _vs_type = _c_38;
      goto _block1;
    }
  _block1__branch4: {}
    if (!_vs_tag.term_eq (_c_39, 0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    _vs_type = _c_40;
  }
_block1: {}
  RF_TAILCALL (::refal::Convert::ToWord, (_vs_type + _c_22 + _vs_objectName + _c_27), _v_res1);
RF_END

RF_FUNC (Del_Pragmas, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  {
    {
      if (_ge_arg1.get_len () < 1)
      {
        goto _block1__branch1;
      }
      RF_lsplit (_ge_arg1, 0, _ve_L, _v_lsplit__arg1);
      for ( ; ; RF_iter(_ge_arg1)++)
      {
        {
          if (!RF_iter(_ge_arg1))
          {
            goto _block1__branch1;
          }
          int _v_len1 = _v_lsplit__arg1.get_len ();
          int _v_len2 = 1;
          if (_v_len1 < _v_len2)
          {
            goto _block1__branch1;
          }
          int _v_len__R = (_v_len1 - _v_len2);
          Expr _vt_Item;
          _vt_Item = Expr (_v_lsplit__arg1, 0, 1);
          Expr _ve_R;
          _ve_R = Expr (_v_lsplit__arg1, (0 + 1), _v_len__R);
          {
            {
              if (_vt_Item.symbol_at (0))
              {
                goto _block2__branch1;
              }
              Expr _v_deref__Item (Expr (_vt_Item, 0));
              int _v_len3 = _v_deref__Item.get_len ();
              int _v_len4 = 1;
              if (_v_len3 < _v_len4)
              {
                goto _block2__branch1;
              }
              int _v_len___dollar_tmp_m_145_m_14 = (_v_len3 - _v_len4);
              if (!_c_41.term_eq (_v_deref__Item, 0))
              {
                goto _block2__branch1;
              }
              Expr _ve__dollar_tmp_m_145_m_14;
              _ve__dollar_tmp_m_145_m_14 = Expr (_v_deref__Item, (0 + 1), _v_len___dollar_tmp_m_145_m_14);
              Expr _v_Del__Pragmas1;
              RF_CALL (Del_Pragmas, _ve_R, _v_Del__Pragmas1);
              _v_res1 = (_ve_L + _v_Del__Pragmas1);
              goto _block2;
            }
          _block2__branch1: {}
            if (_vt_Item.symbol_at (0))
            {
              goto _continue1;
            }
            Expr _v_deref__Item2 (Expr (_vt_Item, 0));
            int _v_len5 = _v_deref__Item2.get_len ();
            int _v_len6 = 0;
            if (_v_len5 < _v_len6)
            {
              goto _continue1;
            }
            int _v_len__xpr = (_v_len5 - _v_len6);
            Expr _ve_xpr;
            _ve_xpr = Expr (_v_deref__Item2, 0, _v_len__xpr);
            Expr _ge_auxcall1;
            RF_CALL (Del_Pragmas, _ve_xpr, _ge_auxcall1);
            Expr _v_Del__Pragmas2;
            RF_CALL (Del_Pragmas, _ve_R, _v_Del__Pragmas2);
            _v_res1 = (_ve_L + _ge_auxcall1 () + _v_Del__Pragmas2);
          }
        _block2: {}
          goto _exit1;
        }
    _continue1: {}
      }
    _exit1: {}
      goto _block1;
    }
  _block1__branch1: {}
    _v_res1 = _ge_arg1;
  }
_block1: {}
RF_END

RF_FUNC (ToWord_0, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  int _v_len1 = _ge_arg1.get_len ();
  int _v_len2 = 0;
  if (_v_len1 < _v_len2)
  {
    RF_ERROR (_c_42);
  }
  int _v_len__stub1 = (_v_len1 - _v_len2);
  Expr _v_stub1;
  _v_stub1 = Expr (_ge_arg1, 0, _v_len__stub1);
  RF_CALL (::refal::Convert::ToWord, _v_stub1, _v_res1);
RF_END

}

}

}

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_helper {

static void init_ () {
  Fun = new rftype::StaticObject<rftype::Table>(L"Fun");
  IsFun = new rftype::StaticObject<rftype::Table>(L"IsFun");
  Const = new rftype::StaticObject<rftype::Table>(L"Const");
  Object = new rftype::StaticObject<rftype::Table>(L"Object");
  RFP_Options = new rftype::StaticObject<rftype::Table>(L"RFP_Options");
  RFP_Module_Subst = new rftype::StaticObject<rftype::Table>(L"RFP_Module_Subst");
  _c_0 = Expr::create<rftype::Word>("DEBUG");
  _c_1 = rftype::Char::create_expr (L".");
  _c_2 = Expr::create_sym<rftype::Func> (ToWord_0);
  _c_3 = Expr::create<rftype::Word>("F");
  _c_4 = Expr::create<rftype::Word>("T");
  _c_5 = rftype::Char::create_expr (L"'");
  _c_6 = rftype::Char::create_expr (L"\"");
  _c_7 = Expr::create<rftype::Word>("CONST");
  _c_8 = Expr::create<rftype::Word>("&");
  _c_9 = Expr::create<rftype::Word>("REF");
  _c_10 = Expr::create<rftype::Word>("PAREN");
  _c_11 = Expr::create<rftype::Word>(")");
  _c_12 = Expr::create<rftype::Word>("(");
  _c_13 = Expr::create<rftype::Word>("SVAR");
  _c_14 = Expr::create<rftype::Word>("s");
  _c_15 = Expr::create<rftype::Word>("TVAR");
  _c_16 = Expr::create<rftype::Word>("t");
  _c_17 = Expr::create<rftype::Word>("VVAR");
  _c_18 = Expr::create<rftype::Word>("v");
  _c_19 = Expr::create<rftype::Word>("EVAR");
  _c_20 = Expr::create<rftype::Word>("e");
  _c_21 = Expr::create<rftype::Word>("UNKNOWN");
  _c_22 = Expr::create<rftype::Word>(" ");
  _c_23 = Expr::create<rftype::Word>("FUNC");
  _c_24 = Expr::create<rftype::Word>("$func");
  _c_25 = Expr::create<rftype::Word>("FUNC?");
  _c_26 = Expr::create<rftype::Word>("$func?");
  _c_27 = Expr::create<rftype::Word>(";");
  _c_28 = Expr::create<rftype::Word>("= ");
  _c_29 = Expr::create<rftype::Word>(" = ");
  _c_30 = Expr::create<rftype::Word>("$const ");
  _c_31 = Expr::create<rftype::Word>("BOX");
  _c_32 = Expr::create<rftype::Word>("$box");
  _c_33 = Expr::create<rftype::Word>("TABLE");
  _c_34 = Expr::create<rftype::Word>("$table");
  _c_35 = Expr::create<rftype::Word>("VECTOR");
  _c_36 = Expr::create<rftype::Word>("$vector");
  _c_37 = Expr::create<rftype::Word>("STRING");
  _c_38 = Expr::create<rftype::Word>("$string");
  _c_39 = Expr::create<rftype::Word>("CHANNEL");
  _c_40 = Expr::create<rftype::Word>("$channel");
  _c_41 = Expr::create<rftype::Word>("PRAGMA");
  _c_42 = Expr::create<rftype::Word>("Apply") + Expr::create<rftype::Word>("Apply") + Expr::create<rftype::Word>("Unexpected fail");
}

static AtStart init_registrator_ (&init_);

}

}

}

}

}
