
#include <rf_core.hh>

using namespace rfrt;

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_helper {

RF_DECL (IsRFP_Debug);

}

}

}

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_src {

RF_DECL (Arg_GetImplementationReader);

}

}

}

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_helper {

RF_DECL (Make_Name);

}

}

}

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_src {

RF_DECL (BRclose);

RF_DECL (Arg_GetInterfaceReader);

RF_DECL (BufferedReader);

RF_DECL (BRreadLine);

RF_DECL (GetInterfaceReader);

RF_DECL (GetSystemResourceAsStream);

RF_DECL (Get_Line_From_Reader);

RF_DECL (InitPosition);

RF_DECL (Get_Line_From_Reader_0);

RF_DECL (Get_Line_From_File);

RF_DECL (NextColumn);

RF_DECL (IsCaseInsensitive);

RF_DECL (PositionToChars);

RF_DECL (RFP_Src_InitFromArgs);

RF_DECL (NextRow);

RF_DECL (InputStreamReader);

RF_DECL (GetImplementationReader);

RF_DECL (ReadFormatsFromClass);

RF_DECL (Reader_Close);

RF_DECL (ReadFormatsFromFile);

RF_DECL (VarSymbol);

RF_DECL (Try_Open);

RF_DECL (WordSymbol);

RF_DECL (WordFirstSymbol);

RF_DECL (Reader_GetLine);

}

}

}

}

}

namespace refal {

namespace Arithm {

RF_DECL (Add);

}

}

namespace refal {

namespace Box {

RF_DECL (Get);

}

}

namespace refal {

namespace Class {

RF_DECL (IsChannel);

}

}

namespace refal {

namespace Convert {

RF_DECL (ToUpper);

RF_DECL (ToChars);

}

}

namespace refal {

namespace Box {

RF_DECL (Store);

}

}

namespace refal {

namespace Dir {

RF_DECL (ReadDir);

RF_DECL (OpenDir);

}

}

namespace refal {

namespace StdIO {

RF_DECL (Channel);

}

}

namespace refal {

namespace List {

RF_DECL (Intersperse);

}

}

namespace refal {

namespace Java {

RF_DECL (Null);

}

}

namespace refal {

namespace Convert {

RF_DECL (ToWord);

}

}

namespace refal {

namespace Apply {

RF_DECL (Apply);

}

}

namespace refal {

namespace StdIO {

RF_DECL (OpenFile);

RF_DECL (ReadLineCh);

}

}

namespace refal {

namespace Table {

RF_DECL (Lookup);

RF_DECL (IsInTable);

}

}

namespace refal {

namespace StdIO {

RF_DECL (PrintLn);

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_helper {

extern Expr RFP_Options;

}

}

}

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfpc {

extern Expr RFP_Boot_Path;

}

}

}

}

}

namespace refal {

namespace File {

extern Expr DirSeparator;

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfpc {

extern Expr RFP_Include_Path;

}

}

}

}

}

namespace refal {

namespace StdIO {

RF_DECL (CloseChannel);

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_src {

RF_DECL (ReadFormatsFromBox);

}

}

}

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_src {

static Expr Env;

static Expr Package;

static Expr FormatsFromClass;

static Expr _c_6;

static Expr _c_0;

static Expr _c_1;

static Expr _c_2;

static Expr _c_4;

static Expr _c_3;

static Expr _c_5;

static Expr _c_7;

static Expr _c_8;

static Expr _c_9;

static Expr _c_10;

static Expr _c_11;

static Expr _c_12;

static Expr _c_13;

static Expr _c_14;

static Expr _c_15;

static Expr _c_16;

static Expr _c_17;

static Expr _c_18;

static Expr _c_21;

static Expr _c_19;

static Expr _c_22;

static Expr _c_20;

static Expr _c_23;

static Expr _c_24;

static Expr _c_25;

static Expr _c_26;

RF_FUNC (BRclose, (RF_ARG _gs_arg1;;), RF_VOID)
  RF_ERROR ((Expr::create<rftype::Word>("org") + Expr::create<rftype::Word>("refal") + Expr::create<rftype::Word>("plus") + Expr::create<rftype::Word>("compiler") + Expr::create<rftype::Word>("rfp_src") + Expr::create<rftype::Word>("BRclose") + Expr::create<rftype::Word>("Not available")));
RF_END

RF_FUNC (BRreadLine, (RF_ARG _gs_arg1;;), (RF_RES _gs_res1;;))
  RF_ERROR ((Expr::create<rftype::Word>("org") + Expr::create<rftype::Word>("refal") + Expr::create<rftype::Word>("plus") + Expr::create<rftype::Word>("compiler") + Expr::create<rftype::Word>("rfp_src") + Expr::create<rftype::Word>("BRreadLine") + Expr::create<rftype::Word>("Not available")));
RF_END

RF_FUNC (BufferedReader, (RF_ARG _gs_arg1;;), (RF_RES _gs_res1;;))
  RF_ERROR ((Expr::create<rftype::Word>("org") + Expr::create<rftype::Word>("refal") + Expr::create<rftype::Word>("plus") + Expr::create<rftype::Word>("compiler") + Expr::create<rftype::Word>("rfp_src") + Expr::create<rftype::Word>("BufferedReader") + Expr::create<rftype::Word>("Not available")));
RF_END

RF_FUNC (InputStreamReader, (RF_ARG _gs_arg1;;), (RF_RES _gs_res1;;))
  RF_ERROR ((Expr::create<rftype::Word>("org") + Expr::create<rftype::Word>("refal") + Expr::create<rftype::Word>("plus") + Expr::create<rftype::Word>("compiler") + Expr::create<rftype::Word>("rfp_src") + Expr::create<rftype::Word>("InputStreamReader") + Expr::create<rftype::Word>("Not available")));
RF_END

RF_FUNC (GetSystemResourceAsStream, (RF_ARG _gs_arg1;;), (RF_RES _gs_res1;;))
  RF_ERROR ((Expr::create<rftype::Word>("org") + Expr::create<rftype::Word>("refal") + Expr::create<rftype::Word>("plus") + Expr::create<rftype::Word>("compiler") + Expr::create<rftype::Word>("rfp_src") + Expr::create<rftype::Word>("GetSystemResourceAsStream") + Expr::create<rftype::Word>("Not available")));
RF_END

RF_FUNC (Reader_GetLine, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  if (_ge_arg1.get_len () != 4)
  {
    RF_RETFAIL;
  }
  if (_ge_arg1.symbol_at ((0 + 1 + 1)))
  {
    RF_RETFAIL;
  }
  if (_ge_arg1.symbol_at ((0 + 1 + 1 + 1)))
  {
    RF_RETFAIL;
  }
  Expr _v_deref__arg1 (Expr (_ge_arg1, (0 + 1 + 1)));
  Expr _v_deref__arg12 (Expr (_ge_arg1, (0 + 1 + 1 + 1)));
  int _v_len1 = _v_deref__arg12.get_len ();
  int _v_len2 = 0;
  if (_v_len1 < _v_len2)
  {
    RF_RETFAIL;
  }
  int _v_len__src = (_v_len1 - _v_len2);
  int _v_len3 = _v_deref__arg1.get_len ();
  int _v_len4 = 0;
  if (_v_len3 < _v_len4)
  {
    RF_RETFAIL;
  }
  int _v_len__name = (_v_len3 - _v_len4);
  if (!_ge_arg1.symbol_at (0))
  {
    RF_RETFAIL;
  }
  if (!_ge_arg1.symbol_at ((0 + 1)))
  {
    RF_RETFAIL;
  }
  Expr _vs_srctype;
  _vs_srctype = Expr (_ge_arg1, 0, 1);
  Expr _vs_getline__func;
  _vs_getline__func = Expr (_ge_arg1, (0 + 1), 1);
  Expr _ve_name;
  _ve_name = Expr (_v_deref__arg1, 0, _v_len__name);
  Expr _ve_src;
  _ve_src = Expr (_v_deref__arg12, 0, _v_len__src);
  RF_TAILCALL (::refal::Apply::Apply, (_vs_getline__func, _ve_src), _v_res1);
RF_END

RF_FUNC (Reader_Close, (RF_ARG _ge_arg1;;), RF_VOID)
  if (_ge_arg1.get_len () != 4)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (_ge_arg1.symbol_at ((0 + 1 + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (_ge_arg1.symbol_at ((0 + 1 + 1 + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _v_deref__arg1 (Expr (_ge_arg1, (0 + 1 + 1)));
  Expr _v_deref__arg12 (Expr (_ge_arg1, (0 + 1 + 1 + 1)));
  int _v_len1 = _v_deref__arg12.get_len ();
  int _v_len2 = 0;
  if (_v_len1 < _v_len2)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  int _v_len__src = (_v_len1 - _v_len2);
  int _v_len3 = _v_deref__arg1.get_len ();
  int _v_len4 = 0;
  if (_v_len3 < _v_len4)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  int _v_len__name = (_v_len3 - _v_len4);
  if (!_ge_arg1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_ge_arg1.symbol_at ((0 + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _vs_srctype;
  _vs_srctype = Expr (_ge_arg1, 0, 1);
  Expr _vs_getline__func;
  _vs_getline__func = Expr (_ge_arg1, (0 + 1), 1);
  Expr _ve_name;
  _ve_name = Expr (_v_deref__arg1, 0, _v_len__name);
  Expr _ve_src;
  _ve_src = Expr (_v_deref__arg12, 0, _v_len__src);
  {
    {
      if (!_vs_srctype.term_eq (_c_0, 0))
      {
        goto _block1__branch1;
      }
      {
        {
          if (_v_len__src != 1)
          {
            goto _block2__branch1;
          }
          if (!_ve_src.symbol_at (0))
          {
            goto _block2__branch1;
          }
          Expr _vs_channel;
          _vs_channel = Expr (_ve_src, 0, 1);
          {
            {
              if (!RF_CALL (::refal::Class::IsChannel, _vs_channel, /*void*/))
              {
                goto _block3__branch1;
              }
              RF_TAILCALL (::refal::StdIO::CloseChannel, _vs_channel, /*void*/);
              goto _block3;
            }
          _block3__branch1: {}
            RF_TAILCALL (BRclose, _vs_channel, /*void*/);
          }
        _block3: {}
          goto _block2;
        }
      _block2__branch1: {}
        if (_v_len__src != 0)
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
      }
    _block2: {}
      goto _block1;
    }
  _block1__branch1: {}
    if (!_vs_srctype.term_eq (_c_1, 0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
  }
_block1: {}
RF_END

RF_FUNC (GetImplementationReader, (RF_ARG _vt_fileId;;), (RF_RES _v_res1, _v_res2, _v_res3;;))
  RF_TAILCALL (Arg_GetImplementationReader, _vt_fileId, (_v_res1, _v_res2, _v_res3));
RF_END

RF_FUNC (GetInterfaceReader, (RF_ARG _ve_name;;), (RF_RES _v_res1;;))
  RF_TAILCALL (Arg_GetInterfaceReader, _ve_name, _v_res1);
RF_END

RF_FUNC (RFP_Src_InitFromArgs, (RF_ARG _ve_files;;), RF_VOID)
  {
    {
      Expr _ge_auxcall1;
      if (!RF_CALL (::refal::Table::Lookup, (org::refal::plus::compiler::rfp_helper::RFP_Options, _c_2), _ge_auxcall1))
      {
        goto _block1__branch1;
      }
      Expr _ge_auxcall2;
      RF_CALL (org::refal::plus::compiler::rfp_helper::Make_Name, _ge_auxcall1, _ge_auxcall2);
      RF_TAILCALL (::refal::Box::Store, (Package, _ge_auxcall2), /*void*/);
      goto _block1;
    }
  _block1__branch1: {}
    RF_TAILCALL (::refal::Box::Store, (Package, empty), /*void*/);
  }
_block1: {}
RF_END

RF_FUNC (Arg_GetImplementationReader, (RF_ARG _gt_arg1;;), (RF_RES _v_res1, _v_res2, _v_res3;;))
  if (_gt_arg1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _v_deref__arg1 (Expr (_gt_arg1, 0));
  int _v_len1 = _v_deref__arg1.get_len ();
  int _v_len2 = 0;
  if (_v_len1 < _v_len2)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  int _v_len__file = (_v_len1 - _v_len2);
  Expr _ve_file;
  _ve_file = Expr (_v_deref__arg1, 0, _v_len__file);
  Expr _v_Get1;
  RF_CALL (::refal::Box::Get, ::refal::File::DirSeparator, _v_Get1);
  if (_v_Get1.get_len () != 1)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_v_Get1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _vs_dir__separator;
  _vs_dir__separator = Expr (_v_Get1, 0, 1);
  Expr _ve_name;
  {
    {
      if (_v_len__file < 2)
      {
        goto _block1__branch1;
      }
      RF_rsplit (_ve_file, 0, _v_rsplit__file, _ve__dollar_tmp_m_77_m_38);
      for ( ; ; RF_iter(_ve_file)--)
      {
        {
          if (!RF_iter(_ve_file))
          {
            goto _block1__branch1;
          }
          if (_v_rsplit__file.get_len () < 2)
          {
            goto _block1__branch1;
          }
          if (!_c_3.term_eq (_v_rsplit__file, (_v_rsplit__file.get_len () - (0 + 1))))
          {
            goto _continue1;
          }
          Expr _v_subexpr__rsplit__file (Expr (_v_rsplit__file, 0, (_v_rsplit__file.get_len () - (0 + 0 + 1))));
          RF_rsplit (_v_subexpr__rsplit__file, 0, _v_rsplit__rsplit__file, _ge_name__2);
          for ( ; ; RF_iter(_v_subexpr__rsplit__file)--)
          {
            {
              if (!RF_iter(_v_subexpr__rsplit__file))
              {
                goto _continue1;
              }
              int _v_len3 = _v_rsplit__rsplit__file.get_len ();
              int _v_len4 = 1;
              if (_v_len3 < _v_len4)
              {
                goto _continue1;
              }
              int _v_len___dollar_tmp_m_77_m_9 = (_v_len3 - _v_len4);
              if (!_vs_dir__separator.term_eq (_v_rsplit__rsplit__file, (0 + _v_len___dollar_tmp_m_77_m_9)))
              {
                goto _continue2;
              }
              Expr _ve__dollar_tmp_m_77_m_9;
              _ve__dollar_tmp_m_77_m_9 = Expr (_v_rsplit__rsplit__file, 0, _v_len___dollar_tmp_m_77_m_9);
              _ve_name = _ge_name__2;
              goto _exit2;
            }
        _continue2: {}
          }
        _exit2: {}
          goto _exit1;
        }
    _continue1: {}
      }
    _exit1: {}
      goto _block1;
    }
  _block1__branch1: {}
    if (_v_len__file < 1)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    RF_rsplit (_ve_file, 0, _v_rsplit__file2, _ve__dollar_tmp_m_78_m_20);
    for ( ; ; RF_iter(_ve_file)--)
    {
      {
        if (!RF_iter(_ve_file))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        int _v_len5 = _v_rsplit__file2.get_len ();
        int _v_len6 = 1;
        if (_v_len5 < _v_len6)
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        int _v_len__name__2 = (_v_len5 - _v_len6);
        if (!_c_3.term_eq (_v_rsplit__file2, (0 + _v_len__name__2)))
        {
          goto _continue3;
        }
        Expr _ge_name__2;
        _ge_name__2 = Expr (_v_rsplit__file2, 0, _v_len__name__2);
        _ve_name = _ge_name__2;
        goto _exit3;
      }
  _continue3: {}
    }
  _exit3: {}
  }
_block1: {}
  Expr _ge_auxcall1;
  RF_CALL (::refal::Box::Get, Package, _ge_auxcall1);
  Expr _v_ToWord1;
  RF_CALL (::refal::Convert::ToWord, _ve_name, _v_ToWord1);
  Expr _ve_qname ((_ge_auxcall1 + _v_ToWord1));
  if (_v_len__file < 1)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  RF_rsplit (_ve_file, 0, _v_rsplit__file3, _ve__dollar_tmp_m_81_m_27);
  for ( ; ; RF_iter(_ve_file)--)
  {
    {
      if (!RF_iter(_ve_file))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      int _v_len7 = _v_rsplit__file3.get_len ();
      int _v_len8 = 1;
      if (_v_len7 < _v_len8)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      int _v_len__head = (_v_len7 - _v_len8);
      if (!_c_3.term_eq (_v_rsplit__file3, (0 + _v_len__head)))
      {
        goto _continue4;
      }
      Expr _ve_head;
      _ve_head = Expr (_v_rsplit__file3, 0, _v_len__head);
      Expr _ve_inter__reader;
      {
        {
          if (!RF_CALL (Try_Open, (_ve_head + _c_4), _ve_inter__reader))
          {
            goto _block2__branch1;
          }
          goto _block2;
        }
      _block2__branch1: {}
        _ve_inter__reader = empty;
      }
    _block2: {}
      Expr _ve_implem__reader;
      {
        {
          if (!RF_CALL (Try_Open, _ve_file, _ve_implem__reader))
          {
            goto _block3__branch1;
          }
          goto _block3;
        }
      _block3__branch1: {}
        _ve_implem__reader = empty;
      }
    _block3: {}
      _v_res1 = _ve_qname;
      _v_res2 = _ve_inter__reader;
      _v_res3 = _ve_implem__reader;
      goto _exit4;
    }
_continue4: {}
  }
_exit4: {}
RF_END

RF_FUNC (ReadFormatsFromClass, (RF_ARG _gs_arg1;;), (RF_RES _gs_res1;;))
  RF_ERROR ((Expr::create<rftype::Word>("org") + Expr::create<rftype::Word>("refal") + Expr::create<rftype::Word>("plus") + Expr::create<rftype::Word>("compiler") + Expr::create<rftype::Word>("rfp_src") + Expr::create<rftype::Word>("ReadFormatsFromClass") + Expr::create<rftype::Word>("Not available")));
RF_END

RF_FUNC (ReadFormatsFromFile, (RF_ARG _gs_arg1;;), (RF_RES _gs_res1;;))
  RF_ERROR ((Expr::create<rftype::Word>("org") + Expr::create<rftype::Word>("refal") + Expr::create<rftype::Word>("plus") + Expr::create<rftype::Word>("compiler") + Expr::create<rftype::Word>("rfp_src") + Expr::create<rftype::Word>("ReadFormatsFromFile") + Expr::create<rftype::Word>("Not available")));
RF_END

RF_FUNC (Arg_GetInterfaceReader, (RF_ARG _ve_qname;;), (RF_RES _v_res1;;))
  RF_CALL (::refal::Box::Store, (FormatsFromClass, empty), /*void*/);
  Expr _v_Get1;
  RF_CALL (::refal::Box::Get, ::refal::File::DirSeparator, _v_Get1);
  if (_v_Get1.get_len () != 1)
  {
    RF_RETFAIL;
  }
  if (!_v_Get1.symbol_at (0))
  {
    RF_RETFAIL;
  }
  Expr _vs_dir__separator;
  _vs_dir__separator = Expr (_v_Get1, 0, 1);
  {
    {
      Expr _ve_fname;
      RF_CALL (::refal::List::Intersperse, (_vs_dir__separator, _ve_qname), _ve_fname);
      Expr _v_Get2;
      RF_CALL (::refal::Box::Get, org::refal::plus::compiler::rfpc::RFP_Include_Path, _v_Get2);
      if (_v_Get2.get_len () < 1)
      {
        goto _block1__branch1;
      }
      RF_lsplit (_v_Get2, 0, _ve__dollar_tmp_m_106_m_34, _v_lsplit__Get2);
      for ( ; ; RF_iter(_v_Get2)++)
      {
        {
          if (!RF_iter(_v_Get2))
          {
            goto _block1__branch1;
          }
          int _v_len1 = _v_lsplit__Get2.get_len ();
          int _v_len2 = 1;
          if (_v_len1 < _v_len2)
          {
            goto _block1__branch1;
          }
          int _v_len___dollar_tmp_m_106_m_48 = (_v_len1 - _v_len2);
          if (_v_lsplit__Get2.symbol_at (0))
          {
            goto _continue1;
          }
          Expr _v_deref__lsplit__Get2 (Expr (_v_lsplit__Get2, 0));
          int _v_len3 = _v_deref__lsplit__Get2.get_len ();
          int _v_len4 = 0;
          if (_v_len3 < _v_len4)
          {
            goto _continue1;
          }
          int _v_len__dirname = (_v_len3 - _v_len4);
          Expr _ve__dollar_tmp_m_106_m_48;
          _ve__dollar_tmp_m_106_m_48 = Expr (_v_lsplit__Get2, (0 + 1), _v_len___dollar_tmp_m_106_m_48);
          Expr _ve_dirname;
          _ve_dirname = Expr (_v_deref__lsplit__Get2, 0, _v_len__dirname);
          if (!RF_CALL (Try_Open, (_ve_dirname + _ve_fname + _c_4), _v_res1))
          {
            goto _continue1;
          }
          goto _exit1;
        }
    _continue1: {}
      }
    _exit1: {}
      goto _block1;
    }
  _block1__branch1: {}
    RF_TRAP
    {
      {
        {
          Expr _ge_auxcall1;
          RF_CALL (::refal::List::Intersperse, (_c_5, _ve_qname), _ge_auxcall1);
          Expr _ve_fname ((_ge_auxcall1 + _c_4));
          Expr _gs_auxcall2;
          RF_CALL (::refal::Convert::ToWord, _ve_fname, _gs_auxcall2);
          Expr _gs_auxcall3;
          RF_CALL (GetSystemResourceAsStream, _gs_auxcall2, _gs_auxcall3);
          Expr _v_Null1;
          RF_CALL (::refal::Java::Null, /*void*/, _v_Null1);
          {
            Expr _v_compose1 ((_gs_auxcall3 + _v_Null1));
            if (!_v_compose1.symbol_at (0))
            {
              goto _block3__branch1;
            }
            Expr _vs_null;
            _vs_null = Expr (_v_compose1, 0, 1);
            if (!_vs_null.term_eq (_v_compose1, (0 + 1)))
            {
              goto _block3__branch1;
            }
            goto _block2__branch1;
          }
        _block3__branch1: {}
          Expr _v_compose2 ((_gs_auxcall3 + _v_Null1));
          if (!_v_compose2.symbol_at (0))
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          if (!_v_compose2.symbol_at ((0 + 1)))
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          Expr _vs_is;
          _vs_is = Expr (_v_compose2, 0, 1);
          Expr _vs_null;
          _vs_null = Expr (_v_compose2, (0 + 1), 1);
          Expr _gs_auxcall4;
          RF_CALL (InputStreamReader, _vs_is, _gs_auxcall4);
          Expr _gs_auxcall5;
          RF_CALL (BufferedReader, _gs_auxcall4, _gs_auxcall5);
          _v_res1 = (_c_6 + _ve_fname () + _gs_auxcall5 ());
          goto _block2;
        }
      _block2__branch1: {}
        {
          Expr _ve_fname;
          RF_CALL (::refal::List::Intersperse, (_vs_dir__separator, _ve_qname), _ve_fname);
          Expr _v_Get3;
          RF_CALL (::refal::Box::Get, org::refal::plus::compiler::rfpc::RFP_Include_Path, _v_Get3);
          if (_v_Get3.get_len () < 1)
          {
            goto _block2__branch2;
          }
          RF_lsplit (_v_Get3, 0, _ve__dollar_tmp_m_115_m_36, _v_lsplit__Get3);
          for ( ; ; RF_iter(_v_Get3)++)
          {
            {
              if (!RF_iter(_v_Get3))
              {
                goto _block2__branch2;
              }
              int _v_len5 = _v_lsplit__Get3.get_len ();
              int _v_len6 = 1;
              if (_v_len5 < _v_len6)
              {
                goto _block2__branch2;
              }
              int _v_len___dollar_tmp_m_115_m_50 = (_v_len5 - _v_len6);
              if (_v_lsplit__Get3.symbol_at (0))
              {
                goto _continue2;
              }
              Expr _v_deref__lsplit__Get3 (Expr (_v_lsplit__Get3, 0));
              int _v_len7 = _v_deref__lsplit__Get3.get_len ();
              int _v_len8 = 0;
              if (_v_len7 < _v_len8)
              {
                goto _continue2;
              }
              int _v_len__dirname2 = (_v_len7 - _v_len8);
              Expr _ve__dollar_tmp_m_115_m_50;
              _ve__dollar_tmp_m_115_m_50 = Expr (_v_lsplit__Get3, (0 + 1), _v_len___dollar_tmp_m_115_m_50);
              Expr _ve_dirname;
              _ve_dirname = Expr (_v_deref__lsplit__Get3, 0, _v_len__dirname2);
              Expr _gs_auxcall6;
              RF_CALL (::refal::Convert::ToWord, (_ve_dirname + _ve_fname + _c_7), _gs_auxcall6);
              Expr _gs_auxcall7;
              RF_CALL (ReadFormatsFromFile, _gs_auxcall6, _gs_auxcall7);
              Expr _v_Null2;
              RF_CALL (::refal::Java::Null, /*void*/, _v_Null2);
              {
                Expr _v_compose3 ((_gs_auxcall7 + _v_Null2));
                if (!_v_compose3.symbol_at (0))
                {
                  goto _block4__branch1;
                }
                Expr _vs_null;
                _vs_null = Expr (_v_compose3, 0, 1);
                if (!_vs_null.term_eq (_v_compose3, (0 + 1)))
                {
                  goto _block4__branch1;
                }
                goto _continue2;
              }
            _block4__branch1: {}
              Expr _v_compose4 ((_gs_auxcall7 + _v_Null2));
              if (!_v_compose4.symbol_at (0))
              {
                RF_FUNC_ERROR (unexpected_fail);
              }
              if (!_v_compose4.symbol_at ((0 + 1)))
              {
                RF_FUNC_ERROR (unexpected_fail);
              }
              Expr _vs_str;
              _vs_str = Expr (_v_compose4, 0, 1);
              Expr _vs_null;
              _vs_null = Expr (_v_compose4, (0 + 1), 1);
              Expr _ge_auxcall8;
              RF_CALL (::refal::Convert::ToChars, _vs_str, _ge_auxcall8);
              RF_CALL (::refal::Box::Store, (FormatsFromClass, _ge_auxcall8), /*void*/);
              _v_res1 = (_c_9 + (_ve_dirname + _ve_fname + _c_7) () + _c_8);
              goto _exit2;
            }
        _continue2: {}
          }
        _exit2: {}
          goto _block2;
        }
      _block2__branch2: {}
        Expr _ve_fname;
        RF_CALL (::refal::List::Intersperse, (_c_5, _ve_qname), _ve_fname);
        Expr _gs_auxcall9;
        RF_CALL (::refal::Convert::ToWord, _ve_fname, _gs_auxcall9);
        Expr _gs_auxcall10;
        RF_CALL (ReadFormatsFromClass, _gs_auxcall9, _gs_auxcall10);
        Expr _v_Null3;
        RF_CALL (::refal::Java::Null, /*void*/, _v_Null3);
        {
          Expr _v_compose5 ((_gs_auxcall10 + _v_Null3));
          if (!_v_compose5.symbol_at (0))
          {
            goto _block5__branch1;
          }
          Expr _vs_null;
          _vs_null = Expr (_v_compose5, 0, 1);
          if (!_vs_null.term_eq (_v_compose5, (0 + 1)))
          {
            goto _block5__branch1;
          }
          RF_FUNC_ERROR (unexpected_fail);
        }
      _block5__branch1: {}
        Expr _v_compose6 ((_gs_auxcall10 + _v_Null3));
        if (!_v_compose6.symbol_at (0))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        if (!_v_compose6.symbol_at ((0 + 1)))
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        Expr _vs_str;
        _vs_str = Expr (_v_compose6, 0, 1);
        Expr _vs_null;
        _vs_null = Expr (_v_compose6, (0 + 1), 1);
        Expr _ge_auxcall11;
        RF_CALL (::refal::Convert::ToChars, _vs_str, _ge_auxcall11);
        RF_CALL (::refal::Box::Store, (FormatsFromClass, _ge_auxcall11), /*void*/);
        _v_res1 = (_c_9 + (_ve_fname + _c_7) () + _c_8);
      }
    _block2: {}
    }
    RF_WITH
    {
      RF_CLEANUP;
      int _v_len9 = _ve_qname.get_len ();
      int _v_len10 = 2;
      if (_v_len9 < _v_len10)
      {
        RF_RETFAIL;
      }
      int _v_len__lib = (_v_len9 - _v_len10);
      int _v_len11 = err.get_len ();
      int _v_len12 = 1;
      if (_v_len11 < _v_len12)
      {
        RF_RETFAIL;
      }
      int _v_len___dollar_tmp_m_129_m_8 = (_v_len11 - _v_len12);
      if (!_c_10.term_eq (err, (0 + _v_len___dollar_tmp_m_129_m_8)))
      {
        RF_RETFAIL;
      }
      if (!_c_11.eq (_ve_qname, 0))
      {
        RF_RETFAIL;
      }
      Expr _ve__dollar_tmp_m_129_m_8;
      _ve__dollar_tmp_m_129_m_8 = Expr (err, 0, _v_len___dollar_tmp_m_129_m_8);
      Expr _ve_lib;
      _ve_lib = Expr (_ve_qname, (0 + 1 + 1), _v_len__lib);
      RF_CALL (::refal::List::Intersperse, (_vs_dir__separator, _ve_lib), _ve_lib);
      Expr _v_Get4;
      RF_CALL (::refal::Box::Get, org::refal::plus::compiler::rfpc::RFP_Boot_Path, _v_Get4);
      if (_v_Get4.get_len () < 1)
      {
        RF_RETFAIL;
      }
      RF_lsplit (_v_Get4, 0, _ve__dollar_tmp_m_132_m_33, _v_lsplit__Get4);
      for ( ; ; RF_iter(_v_Get4)++)
      {
        {
          if (!RF_iter(_v_Get4))
          {
            RF_RETFAIL;
          }
          int _v_len13 = _v_lsplit__Get4.get_len ();
          int _v_len14 = 1;
          if (_v_len13 < _v_len14)
          {
            RF_RETFAIL;
          }
          int _v_len___dollar_tmp_m_132_m_47 = (_v_len13 - _v_len14);
          if (_v_lsplit__Get4.symbol_at (0))
          {
            goto _continue3;
          }
          Expr _v_deref__lsplit__Get4 (Expr (_v_lsplit__Get4, 0));
          int _v_len15 = _v_deref__lsplit__Get4.get_len ();
          int _v_len16 = 0;
          if (_v_len15 < _v_len16)
          {
            goto _continue3;
          }
          int _v_len__dirname3 = (_v_len15 - _v_len16);
          Expr _ve__dollar_tmp_m_132_m_47;
          _ve__dollar_tmp_m_132_m_47 = Expr (_v_lsplit__Get4, (0 + 1), _v_len___dollar_tmp_m_132_m_47);
          Expr _ve_dirname;
          _ve_dirname = Expr (_v_deref__lsplit__Get4, 0, _v_len__dirname3);
          if (!RF_CALL (Try_Open, (_ve_dirname + _ve_lib + _c_4), _v_res1))
          {
            goto _continue3;
          }
          goto _exit3;
        }
    _continue3: {}
      }
    _exit3: {}
    }
  }
_block1: {}
RF_END

RF_FUNC (Try_Open, (RF_ARG _ve_filename;;), (RF_RES _v_res1;;))
  {
    {
      if (!RF_CALL (org::refal::plus::compiler::rfp_helper::IsRFP_Debug, /*void*/, /*void*/))
      {
        goto _block1__branch1;
      }
      RF_CALL (::refal::StdIO::PrintLn, (_c_13 + _ve_filename + _c_12), /*void*/);
      goto _block1;
    }
  _block1__branch1: {}
  }
_block1: {}
  Expr _ge_filename__1;
  Expr _vs_chl;
  {
    {
      if (!RF_CALL (IsCaseInsensitive, /*void*/, /*void*/))
      {
        goto _block2__branch1;
      }
      Expr _v_Get1;
      RF_CALL (::refal::Box::Get, ::refal::File::DirSeparator, _v_Get1);
      if (_v_Get1.get_len () != 1)
      {
        goto _block2__branch1;
      }
      if (!_v_Get1.symbol_at (0))
      {
        goto _block2__branch1;
      }
      Expr _vs_dir__separator;
      _vs_dir__separator = Expr (_v_Get1, 0, 1);
      Expr _ve_dirname;
      Expr _ve_fname;
      {
        {
          if (_ve_filename.get_len () < 1)
          {
            goto _block3__branch1;
          }
          RF_rsplit (_ve_filename, 0, _v_rsplit__filename, _ge_fname__4);
          for ( ; ; RF_iter(_ve_filename)--)
          {
            {
              if (!RF_iter(_ve_filename))
              {
                goto _block3__branch1;
              }
              int _v_len1 = _v_rsplit__filename.get_len ();
              int _v_len2 = 1;
              if (_v_len1 < _v_len2)
              {
                goto _block3__branch1;
              }
              int _v_len__dirname__4 = (_v_len1 - _v_len2);
              if (!_vs_dir__separator.term_eq (_v_rsplit__filename, (0 + _v_len__dirname__4)))
              {
                goto _continue1;
              }
              Expr _ge_dirname__4;
              _ge_dirname__4 = Expr (_v_rsplit__filename, 0, _v_len__dirname__4);
              _ve_dirname = _ge_dirname__4;
              _ve_fname = _ge_fname__4;
              goto _exit1;
            }
        _continue1: {}
          }
        _exit1: {}
          goto _block3;
        }
      _block3__branch1: {}
        _ve_dirname = _c_3;
        _ve_fname = _ve_filename;
      }
    _block3: {}
      Expr _ge_auxcall1;
      RF_CALL (::refal::Convert::ToChars, _ve_fname, _ge_auxcall1);
      RF_CALL (::refal::Convert::ToUpper, _ge_auxcall1, _ve_fname);
      Expr _vs_dir;
      RF_CALL (::refal::Dir::OpenDir, _ve_dirname, _vs_dir);
      for ( ; ; )
      {
        {
          Expr _ge_filename__4;
          {
            {
              if (!RF_CALL (::refal::Dir::ReadDir, _vs_dir, _ge_filename__4))
              {
                goto _block4__branch1;
              }
              goto _block4;
            }
          _block4__branch1: {}
            goto _block2__branch1;
          }
        _block4: {}
          Expr _v_ToUpper1;
          RF_CALL (::refal::Convert::ToUpper, _ge_filename__4, _v_ToUpper1);
          if (_v_ToUpper1.get_len () != _ve_fname.get_len ())
          {
            goto _iter1;
          }
          if (!_ve_fname.eq (_v_ToUpper1, 0))
          {
            goto _iter1;
          }
          Expr _gs_chl__4;
          RF_CALL (::refal::StdIO::Channel, /*void*/, _gs_chl__4);
          if (!RF_CALL (::refal::StdIO::OpenFile, (_gs_chl__4, (_ve_dirname + _vs_dir__separator + _ge_filename__4), _c_14), /*void*/))
          {
            goto _iter1;
          }
          _ge_filename__1 = (_ve_dirname + _vs_dir__separator + _ge_filename__4);
          _vs_chl = _gs_chl__4;
          goto _exit__iter1;
        }
      _iter1: {}
      }
    _exit__iter1: {}
      goto _block2;
    }
  _block2__branch1: {}
    Expr _gs_chl__2;
    RF_CALL (::refal::StdIO::Channel, /*void*/, _gs_chl__2);
    if (!RF_CALL (::refal::StdIO::OpenFile, (_gs_chl__2, _ve_filename, _c_14), /*void*/))
    {
      RF_RETFAIL;
    }
    _ge_filename__1 = _ve_filename;
    _vs_chl = _gs_chl__2;
  }
_block2: {}
  {
    {
      if (!RF_CALL (org::refal::plus::compiler::rfp_helper::IsRFP_Debug, /*void*/, /*void*/))
      {
        goto _block5__branch1;
      }
      RF_CALL (::refal::StdIO::PrintLn, (_c_12 + _ge_filename__1 + _c_15), /*void*/);
      goto _block5;
    }
  _block5__branch1: {}
  }
_block5: {}
  _v_res1 = (_c_16 + _ge_filename__1 () + _vs_chl ());
RF_END

RF_FUNC (Get_Line_From_File, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  if (_ge_arg1.get_len () != 1)
  {
    RF_RETFAIL;
  }
  if (!_ge_arg1.symbol_at (0))
  {
    RF_RETFAIL;
  }
  Expr _vs_channel;
  _vs_channel = Expr (_ge_arg1, 0, 1);
  RF_TAILCALL (::refal::StdIO::ReadLineCh, _vs_channel, _v_res1);
RF_END

RF_FUNC (ReadFormatsFromBox, (RF_ARG _ve__dollar_tmp_m_171_m_21;;), (RF_RES _v_res1;;))
  Expr _v_Get1;
  RF_CALL (::refal::Box::Get, FormatsFromClass, _v_Get1);
  int _v_len1 = _v_Get1.get_len ();
  int _v_len2 = 0;
  if (_v_len1 < (_v_len2 + 1))
  {
    RF_RETFAIL;
  }
  int _v_len__formats = (_v_len1 - _v_len2);
  Expr _vv_formats;
  _vv_formats = Expr (_v_Get1, 0, _v_len__formats);
  RF_CALL (::refal::Box::Store, (FormatsFromClass, empty), /*void*/);
  _v_res1 = _vv_formats;
RF_END

RF_FUNC (Get_Line_From_Reader, (RF_ARG _vs_reader;;), (RF_RES _v_res1;;))
  Expr _vs_string;
  RF_CALL (BRreadLine, _vs_reader, _vs_string);
  {
    Expr _v_Null1;
    RF_CALL (::refal::Java::Null, /*void*/, _v_Null1);
    if (!_vs_string.term_eq (_v_Null1, 0))
    {
      goto _block1__branch1;
    }
    RF_RETFAIL;
  }
_block1__branch1: {}
  RF_TAILCALL (::refal::Convert::ToChars, _vs_string, _v_res1);
RF_END

RF_FUNC (IsCaseInsensitive, RF_VOID, RF_VOID)
  RF_TAILCALL (::refal::Table::IsInTable, (org::refal::plus::compiler::rfp_helper::RFP_Options, _c_17), /*void*/);
RF_END

RF_FUNC (WordFirstSymbol, RF_VOID, (RF_RES _v_res1;;))
  {
    {
      if (!RF_CALL (::refal::Table::IsInTable, (org::refal::plus::compiler::rfp_helper::RFP_Options, _c_18), /*void*/))
      {
        goto _block1__branch1;
      }
      _v_res1 = _c_19;
      goto _block1;
    }
  _block1__branch1: {}
    _v_res1 = _c_20;
  }
_block1: {}
RF_END

RF_FUNC (WordSymbol, RF_VOID, (RF_RES _v_res1;;))
  {
    {
      if (!RF_CALL (::refal::Table::IsInTable, (org::refal::plus::compiler::rfp_helper::RFP_Options, _c_18), /*void*/))
      {
        goto _block1__branch1;
      }
      _v_res1 = _c_21;
      goto _block1;
    }
  _block1__branch1: {}
    _v_res1 = _c_22;
  }
_block1: {}
RF_END

RF_FUNC (VarSymbol, RF_VOID, (RF_RES _v_res1;;))
  {
    {
      if (!RF_CALL (::refal::Table::IsInTable, (org::refal::plus::compiler::rfp_helper::RFP_Options, _c_18), /*void*/))
      {
        goto _block1__branch1;
      }
      _v_res1 = _c_21;
      goto _block1;
    }
  _block1__branch1: {}
    _v_res1 = _c_20;
  }
_block1: {}
RF_END

RF_FUNC (InitPosition, RF_VOID, (RF_RES _v_res1;;))
  _v_res1 = _c_23;
RF_END

RF_FUNC (NextRow, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  if (_ge_arg1.get_len () != 2)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_ge_arg1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_ge_arg1.symbol_at ((0 + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _vs_row;
  _vs_row = Expr (_ge_arg1, 0, 1);
  Expr _vs_col;
  _vs_col = Expr (_ge_arg1, (0 + 1), 1);
  Expr _gs_auxcall1;
  RF_CALL (::refal::Arithm::Add, (_vs_row, _c_24), _gs_auxcall1);
  _v_res1 = (_gs_auxcall1 + _c_24);
RF_END

RF_FUNC (NextColumn, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  if (_ge_arg1.get_len () != 2)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_ge_arg1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_ge_arg1.symbol_at ((0 + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _vs_row;
  _vs_row = Expr (_ge_arg1, 0, 1);
  Expr _vs_col;
  _vs_col = Expr (_ge_arg1, (0 + 1), 1);
  Expr _v_Add1;
  RF_CALL (::refal::Arithm::Add, (_vs_col, _c_24), _v_Add1);
  _v_res1 = (_vs_row + _v_Add1);
RF_END

RF_FUNC (PositionToChars, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  if (_ge_arg1.get_len () != 2)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_ge_arg1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_ge_arg1.symbol_at ((0 + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _vs_row;
  _vs_row = Expr (_ge_arg1, 0, 1);
  Expr _vs_col;
  _vs_col = Expr (_ge_arg1, (0 + 1), 1);
  RF_TAILCALL (::refal::Convert::ToChars, (_vs_row + _c_25 + _vs_col), _v_res1);
RF_END

RF_FUNC (Get_Line_From_Reader_0, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  if (_ge_arg1.get_len () != 1)
  {
    RF_ERROR (_c_26);
  }
  if (!_ge_arg1.symbol_at (0))
  {
    RF_ERROR (_c_26);
  }
  Expr _v_stub1;
  _v_stub1 = Expr (_ge_arg1, 0, 1);
  RF_TAILCALL (Get_Line_From_Reader, _v_stub1, _v_res1);
RF_END

}

}

}

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_src {

static void init_ () {
  Env = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Env");
  Package = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Package");
  FormatsFromClass = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"FormatsFromClass");
  _c_6 = Expr::create<rftype::Word>("FILE") + Expr::create_sym<rftype::Func> (Get_Line_From_Reader_0);
  _c_0 = Expr (_c_6, 0, 1);
  _c_1 = Expr::create<rftype::Word>("STDIN");
  _c_2 = Expr::create<rftype::Word>("PACKAGE");
  _c_4 = rftype::Char::create_expr (L".rfi");
  _c_3 = Expr (_c_4, 0, 1);
  _c_5 = rftype::Char::create_expr (L"/");
  _c_7 = rftype::Char::create_expr (L".class");
  _c_8 = (empty) ();
  _c_9 = Expr::create<rftype::Word>("FILE") + Expr::create_sym<rftype::Func> (ReadFormatsFromBox);
  _c_10 = Expr::create<rftype::Word>("Not available");
  _c_11 = Expr::create<rftype::Word>("refal") + Expr::create<rftype::Word>("plus");
  _c_12 = Expr::create<rftype::Word>("'");
  _c_13 = Expr::create<rftype::Word>("Trying to open '");
  _c_14 = Expr::create<rftype::Word>("r");
  _c_15 = Expr::create<rftype::Word>("' successfully opened");
  _c_16 = Expr::create<rftype::Word>("FILE") + Expr::create_sym<rftype::Func> (Get_Line_From_File);
  _c_17 = Expr::create<rftype::Word>("CASE-INSENSITIVE");
  _c_18 = Expr::create<rftype::Word>("IDENT-COMPATIBILITY");
  _c_21 = rftype::Char::create_expr (L"?!-");
  _c_19 = Expr (_c_21, 0, 2);
  _c_22 = rftype::Char::create_expr (L"_.");
  _c_20 = Expr (_c_22, 0, 1);
  _c_23 = Expr::create<rftype::Integer>("0") + Expr::create<rftype::Integer>("1");
  _c_24 = Expr (_c_23, 1, 1);
  _c_25 = Expr (_c_21, 2, 1);
  _c_26 = Expr::create<rftype::Word>("Apply") + Expr::create<rftype::Word>("Apply") + Expr::create<rftype::Word>("Unexpected fail");
}

static AtStart init_registrator_ (&init_);

}

}

}

}

}
