
#include <rf_core.hh>

using namespace rfrt;

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_as2as {

RF_DECL (RFP_As2As_Transform);

}

}

}

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_asail_java {

RF_DECL (RFP_ASAIL_To_Java);

}

}

}

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_asail_cpp {

RF_DECL (RFP_ASAIL_To_CPP);

}

}

}

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_asail2asail {

RF_DECL (Simplify_ASAIL);

}

}

}

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_asail_tpp {

RF_DECL (RFP_ASAIL_To_TPP);

}

}

}

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_check {

RF_DECL (RFP_Check);

}

}

}

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_format {

RF_DECL (Format_Exp);

}

}

}

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_helper {

RF_DECL (Make_Name);

}

}

}

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_parse {

RF_DECL (RFP_Parser_Errors);

RF_DECL (RFP_Parser);

}

}

}

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_compile {

RF_DECL (RFP_Compile);

}

}

}

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_asail_jbc {

RF_DECL (RFP_ASAIL_To_JBC);

}

}

}

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfpc {

RF_DECL (CPP_Pretty_Print);

RF_DECL (Append_0);

RF_DECL (Compilation_Failed);

RF_DECL (Display_Help);

RF_DECL (CompileASToJBCWithOptions);

RF_DECL (CompileASToJBC);

RF_DECL (CloseStream);

RF_DECL (Init_Options);

RF_DECL (Get_Ready_For_Compilation);

RF_DECL (Open_Channel);

RF_DECL (Main);

RF_DECL (IsInTable_0);

RF_DECL (FileOutputStream);

}

}

}

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_src {

RF_DECL (RFP_Src_InitFromArgs);

}

}

}

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfpc {

RF_DECL (RFP_Pretty_Print);

RF_DECL (Set_Path);

RF_DECL (Version);

RF_DECL (Verbose);

}

}

}

}

}

namespace refal {

namespace Access {

RF_DECL (Left);

RF_DECL (Length);

}

}

namespace refal {

namespace Arithm {

RF_DECL (Sub);

RF_DECL (Add);

}

}

namespace refal {

namespace Access {

RF_DECL (R);

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfpc {

RF_DECL (WriteToStream);

}

}

}

}

}

namespace refal {

namespace Box {

RF_DECL (Put);

RF_DECL (Get);

}

}

namespace refal {

namespace Class {

RF_DECL (IsChannel);

}

}

namespace refal {

namespace Compare {

RF_DECL (Gt);

}

}

namespace refal {

namespace Convert {

RF_DECL (ToChars);

RF_DECL (ToInt);

}

}

namespace refal {

namespace Compare {

RF_DECL (Le);

}

}

namespace refal {

namespace Box {

RF_DECL (Store);

RF_DECL (Box);

}

}

namespace refal {

namespace Dos {

RF_DECL (Arg);

RF_DECL (Time);

RF_DECL (Exit);

}

}

namespace refal {

namespace List {

RF_DECL (Append);

RF_DECL (MapIn);

RF_DECL (Intersperse);

RF_DECL (Any);

}

}

namespace refal {

namespace StdIO {

RF_DECL (Channel);

RF_DECL (OpenFile);

RF_DECL (CloseChannel);

}

}

namespace refal {

namespace List {

RF_DECL (Replicate);

}

}

namespace refal {

namespace StdIO {

RF_DECL (PrintCh);

RF_DECL (PrintLn);

RF_DECL (WriteCh);

RF_DECL (ReadCh);

}

}

namespace refal {

namespace Table {

RF_DECL (ClearTable);

RF_DECL (Bind);

}

}

namespace refal {

namespace StdIO {

RF_DECL (PrintLnCh);

RF_DECL (Print);

}

}

namespace refal {

namespace Convert {

RF_DECL (ToWord);

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfpc {

RF_DECL (Parse_Args);

}

}

}

}

}

namespace refal {

namespace Table {

RF_DECL (Lookup);

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_helper {

extern Expr Const;

extern Expr Object;

extern Expr IsFun;

extern Expr Fun;

}

}

}

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_err {

extern Expr Error_Counter;

}

}

}

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_helper {

extern Expr RFP_Options;

extern Expr RFP_Module_Subst;

}

}

}

}

}

namespace refal {

namespace StdIO {

extern Expr StdOut;

extern Expr StdErr;

}

}

namespace refal {

namespace File {

extern Expr DirSeparator;

}

}

namespace refal {

namespace Table {

RF_DECL (IsInTable);

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfpc {

Expr RFP_Root;

Expr RFP_Default_Boot_Path;

Expr RFP_Boot_Path;

Expr RFP_Include_Path;

Expr RFP_Trace;

Expr RFP_Includes;

static Expr RevDate;

static Expr Options;

static Expr Tab;

static Expr _c_125;

static Expr _c_0;

static Expr _c_14;

static Expr _c_1;

static Expr _c_2;

static Expr _c_3;

static Expr _c_126;

static Expr _c_127;

static Expr _c_128;

static Expr _c_129;

static Expr _c_4;

static Expr _c_5;

static Expr _c_6;

static Expr _c_7;

static Expr _c_8;

static Expr _c_9;

static Expr _c_10;

static Expr _c_11;

static Expr _c_12;

static Expr _c_13;

static Expr _c_15;

static Expr _c_16;

static Expr _c_130;

static Expr _c_131;

static Expr _c_132;

static Expr _c_17;

static Expr _c_19;

static Expr _c_18;

static Expr _c_20;

static Expr _c_21;

static Expr _c_22;

static Expr _c_23;

static Expr _c_24;

static Expr _c_25;

static Expr _c_26;

static Expr _c_27;

static Expr _c_28;

static Expr _c_29;

static Expr _c_133;

static Expr _c_30;

static Expr _c_31;

static Expr _c_32;

static Expr _c_33;

static Expr _c_45;

static Expr _c_34;

static Expr _c_35;

static Expr _c_36;

static Expr _c_37;

static Expr _c_38;

static Expr _c_39;

static Expr _c_40;

static Expr _c_134;

static Expr _c_41;

static Expr _c_42;

static Expr _c_43;

static Expr _c_44;

static Expr _c_135;

static Expr _c_46;

static Expr _c_47;

static Expr _c_48;

static Expr _c_49;

static Expr _c_50;

static Expr _c_51;

static Expr _c_52;

static Expr _c_53;

static Expr _c_54;

static Expr _c_55;

static Expr _c_56;

static Expr _c_57;

static Expr _c_58;

static Expr _c_59;

static Expr _c_60;

static Expr _c_61;

static Expr _c_62;

static Expr _c_63;

static Expr _c_64;

static Expr _c_65;

static Expr _c_66;

static Expr _c_67;

static Expr _c_68;

static Expr _c_69;

static Expr _c_70;

static Expr _c_71;

static Expr _c_72;

static Expr _c_136;

static Expr _c_137;

static Expr _c_138;

static Expr _c_139;

static Expr _c_140;

static Expr _c_141;

static Expr _c_142;

static Expr _c_143;

static Expr _c_144;

static Expr _c_145;

static Expr _c_146;

static Expr _c_147;

static Expr _c_148;

static Expr _c_149;

static Expr _c_150;

static Expr _c_151;

static Expr _c_152;

static Expr _c_153;

static Expr _c_154;

static Expr _c_73;

static Expr _c_74;

static Expr _c_75;

static Expr _c_76;

static Expr _c_77;

static Expr _c_78;

static Expr _c_79;

static Expr _c_80;

static Expr _c_81;

static Expr _c_82;

static Expr _c_83;

static Expr _c_84;

static Expr _c_85;

static Expr _c_86;

static Expr _c_87;

static Expr _c_88;

static Expr _c_89;

static Expr _c_90;

static Expr _c_91;

static Expr _c_92;

static Expr _c_93;

static Expr _c_94;

static Expr _c_95;

static Expr _c_96;

static Expr _c_97;

static Expr _c_98;

static Expr _c_99;

static Expr _c_100;

static Expr _c_155;

static Expr _c_112;

static Expr _c_101;

static Expr _c_102;

static Expr _c_103;

static Expr _c_107;

static Expr _c_104;

static Expr _c_105;

static Expr _c_106;

static Expr _c_108;

static Expr _c_109;

static Expr _c_110;

static Expr _c_111;

static Expr _c_113;

static Expr _c_114;

static Expr _c_115;

static Expr _c_116;

static Expr _c_117;

static Expr _c_118;

static Expr _c_119;

static Expr _c_120;

static Expr _c_121;

static Expr _c_122;

static Expr _c_123;

static Expr _c_124;

RF_FUNC (FileOutputStream, (RF_ARG _gs_arg1;;), (RF_RES _gs_res1;;))
  RF_ERROR ((Expr::create<rftype::Word>("org") + Expr::create<rftype::Word>("refal") + Expr::create<rftype::Word>("plus") + Expr::create<rftype::Word>("compiler") + Expr::create<rftype::Word>("rfpc") + Expr::create<rftype::Word>("FileOutputStream") + Expr::create<rftype::Word>("Not available")));
RF_END

RF_FUNC (WriteToStream, (RF_ARG _gs_arg1, _gs_arg2;;), RF_VOID)
  RF_ERROR ((Expr::create<rftype::Word>("org") + Expr::create<rftype::Word>("refal") + Expr::create<rftype::Word>("plus") + Expr::create<rftype::Word>("compiler") + Expr::create<rftype::Word>("rfpc") + Expr::create<rftype::Word>("WriteToStream") + Expr::create<rftype::Word>("Not available")));
RF_END

RF_FUNC (CloseStream, (RF_ARG _gs_arg1;;), RF_VOID)
  RF_ERROR ((Expr::create<rftype::Word>("org") + Expr::create<rftype::Word>("refal") + Expr::create<rftype::Word>("plus") + Expr::create<rftype::Word>("compiler") + Expr::create<rftype::Word>("rfpc") + Expr::create<rftype::Word>("CloseStream") + Expr::create<rftype::Word>("Not available")));
RF_END

RF_FUNC (CompileASToJBCWithOptions, (RF_ARG _vs_varNames, _vs_lineNumber, _vs_source, _vt_as;;), (RF_RES _v_res1;;))
  if (_vt_as.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _v_deref__as (Expr (_vt_as, 0));
  int _v_len1 = _v_deref__as.get_len ();
  int _v_len2 = 2;
  if (_v_len1 < _v_len2)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  int _v_len__Items = (_v_len1 - _v_len2);
  if (!_v_deref__as.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _vs__dollar_tmp_m_57_m_12;
  _vs__dollar_tmp_m_57_m_12 = Expr (_v_deref__as, 0, 1);
  Expr _vt_ModuleName;
  _vt_ModuleName = Expr (_v_deref__as, (0 + 1), 1);
  Expr _ve_Items;
  _ve_Items = Expr (_v_deref__as, (0 + 1 + 1), _v_len__Items);
  RF_CALL (Get_Ready_For_Compilation, _ve_Items, /*void*/);
  RF_CALL (org::refal::plus::compiler::rfp_as2as::RFP_As2As_Transform, _ve_Items, _ve_Items);
  Expr _vt_module;
  RF_CALL (org::refal::plus::compiler::rfp_compile::RFP_Compile, (_vt_ModuleName, _ve_Items), _vt_module);
  Expr _gt_module__1;
  {
    {
      if (!RF_CALL (::refal::Table::IsInTable, (org::refal::plus::compiler::rfp_helper::RFP_Options, _c_0), /*void*/))
      {
        goto _block1__branch1;
      }
      _gt_module__1 = _vt_module;
      goto _block1;
    }
  _block1__branch1: {}
    RF_CALL (org::refal::plus::compiler::rfp_asail2asail::Simplify_ASAIL, _vt_module, _gt_module__1);
  }
_block1: {}
  Expr _ge_auxcall1;
  RF_CALL (org::refal::plus::compiler::rfp_asail_jbc::RFP_ASAIL_To_JBC, (_vs_varNames, _vs_lineNumber, _vs_source, _gt_module__1), _ge_auxcall1);
  Expr _ve_jbcs;
  Expr _ve_out (_ge_auxcall1);
  for ( ; ; )
  {
    {
      if (_ve_out.get_len () != 0)
      {
        goto _iter1;
      }
      _v_res1 = _ve_jbcs;
      goto _exit__iter1;
    }
  _iter1: {}
    int _v_len3 = _ve_out.get_len ();
    int _v_len4 = 1;
    if (_v_len3 < _v_len4)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    int _v_len__outtail = (_v_len3 - _v_len4);
    if (_ve_out.symbol_at (0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _v_deref__out (Expr (_ve_out, 0));
    int _v_len5 = _v_deref__out.get_len ();
    int _v_len6 = 1;
    if (_v_len5 < _v_len6)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    int _v_len__java__module__name = (_v_len5 - _v_len6);
    if (!_v_deref__out.symbol_at (0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _ve_outtail;
    _ve_outtail = Expr (_ve_out, (0 + 1), _v_len__outtail);
    Expr _vs_bytecode;
    _vs_bytecode = Expr (_v_deref__out, 0, 1);
    Expr _ve_java__module__name;
    _ve_java__module__name = Expr (_v_deref__out, (0 + 1), _v_len__java__module__name);
    Expr _ge_auxcall2;
    RF_CALL (::refal::List::Intersperse, (_c_1, _ve_java__module__name), _ge_auxcall2);
    Expr _gs_auxcall3;
    RF_CALL (::refal::Convert::ToWord, _ge_auxcall2, _gs_auxcall3);
    _ve_jbcs = (_ve_jbcs + (_gs_auxcall3 + _vs_bytecode) ());
    _ve_out = _ve_outtail;
  }
_exit__iter1: {}
RF_END

RF_FUNC (CompileASToJBC, (RF_ARG _vt_as;;), (RF_RES _v_res1;;))
  RF_TAILCALL (CompileASToJBCWithOptions, (_c_2, _c_2, _c_2, _vt_as), _v_res1);
RF_END

RF_FUNC (Main, RF_VOID, (RF_RES _v_res1;;))
  RF_CALL (Init_Options, /*void*/, /*void*/);
  Expr _ve_files;
  RF_CALL (Parse_Args, (empty, empty, _c_3), _ve_files);
  RF_CALL (Set_Path, /*void*/, /*void*/);
  RF_CALL (org::refal::plus::compiler::rfp_src::RFP_Src_InitFromArgs, _ve_files, /*void*/);
  Expr _v_Get1;
  RF_CALL (::refal::Box::Get, ::refal::File::DirSeparator, _v_Get1);
  if (_v_Get1.get_len () != 1)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_v_Get1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _vs_dir__separator;
  _vs_dir__separator = Expr (_v_Get1, 0, 1);
  {
    {
      if (_ve_files.get_len () != 0)
      {
        goto _block1__branch1;
      }
      {
        {
          if (!RF_CALL (::refal::Table::IsInTable, (org::refal::plus::compiler::rfp_helper::RFP_Options, _c_4), /*void*/))
          {
            goto _block2__branch1;
          }
          _v_res1 = empty;
          goto _block2;
        }
      _block2__branch1: {}
        Expr _ge_auxcall1;
        RF_CALL (Version, /*void*/, _ge_auxcall1);
        RF_CALL (::refal::StdIO::PrintLn, (_c_5 + _ge_auxcall1), /*void*/);
        Expr _ve_start (_c_6);
        Expr _vs_st__len;
        RF_CALL (::refal::Access::Length, _ve_start, _vs_st__len);
        RF_CALL (::refal::StdIO::Print, _ve_start, /*void*/);
        Expr _vs_len;
        RF_CALL (::refal::Box::Box, empty, _vs_len);
        RF_CALL (::refal::Box::Store, (_vs_len, _vs_st__len), /*void*/);
        {
          Expr _v_Get2;
          RF_CALL (::refal::Box::Get, Options, _v_Get2);
          if (_v_Get2.get_len () < 1)
          {
            goto _block3__branch1;
          }
          RF_lsplit (_v_Get2, 0, _ve__dollar_tmp_m_90_m_31, _v_lsplit__Get2);
          for ( ; ; RF_iter(_v_Get2)++)
          {
            {
              if (!RF_iter(_v_Get2))
              {
                goto _block3__branch1;
              }
              int _v_len1 = _v_lsplit__Get2.get_len ();
              int _v_len2 = 1;
              if (_v_len1 < _v_len2)
              {
                goto _block3__branch1;
              }
              int _v_len___dollar_tmp_m_90_m_58 = (_v_len1 - _v_len2);
              if (_v_lsplit__Get2.symbol_at (0))
              {
                goto _continue1;
              }
              Expr _v_deref__lsplit__Get2 (Expr (_v_lsplit__Get2, 0));
              int _v_len3 = _v_deref__lsplit__Get2.get_len ();
              int _v_len4 = 2;
              if (_v_len3 < _v_len4)
              {
                goto _continue1;
              }
              int _v_len__descr = (_v_len3 - _v_len4);
              if (_v_deref__lsplit__Get2.symbol_at (0))
              {
                goto _continue1;
              }
              Expr _v_deref__deref__lsplit__Get2 (Expr (_v_deref__lsplit__Get2, 0));
              int _v_len5 = _v_deref__deref__lsplit__Get2.get_len ();
              int _v_len6 = 1;
              if (_v_len5 < _v_len6)
              {
                goto _continue1;
              }
              int _v_len___dollar_tmp_m_90_m_44 = (_v_len5 - _v_len6);
              if (_v_deref__deref__lsplit__Get2.symbol_at (0))
              {
                goto _continue1;
              }
              Expr _v_deref__deref__deref__lsplit__Get2 (Expr (_v_deref__deref__lsplit__Get2, 0));
              int _v_len7 = _v_deref__deref__deref__lsplit__Get2.get_len ();
              int _v_len8 = 0;
              if (_v_len7 < _v_len8)
              {
                goto _continue1;
              }
              int _v_len__next = (_v_len7 - _v_len8);
              Expr _ve__dollar_tmp_m_90_m_58;
              _ve__dollar_tmp_m_90_m_58 = Expr (_v_lsplit__Get2, (0 + 1), _v_len___dollar_tmp_m_90_m_58);
              Expr _vt__dollar_tmp_m_90_m_47;
              _vt__dollar_tmp_m_90_m_47 = Expr (_v_deref__lsplit__Get2, (0 + 1), 1);
              Expr _ve_descr;
              _ve_descr = Expr (_v_deref__lsplit__Get2, (0 + 1 + 1), _v_len__descr);
              Expr _ve__dollar_tmp_m_90_m_44;
              _ve__dollar_tmp_m_90_m_44 = Expr (_v_deref__deref__lsplit__Get2, (0 + 1), _v_len___dollar_tmp_m_90_m_44);
              Expr _ve_next;
              _ve_next = Expr (_v_deref__deref__deref__lsplit__Get2, 0, _v_len__next);
              Expr _gs_auxcall2;
              RF_CALL (::refal::Access::Length, _ve_next, _gs_auxcall2);
              if (!RF_CALL (::refal::Compare::Le, (_gs_auxcall2, _c_7), /*void*/))
              {
                goto _continue1;
              }
              Expr _ge_next__7;
              {
                {
                  int _v_len9 = _v_len__descr;
                  int _v_len10 = 1;
                  if (_v_len9 < _v_len10)
                  {
                    goto _block4__branch1;
                  }
                  int _v_len___dollar_tmp_m_93_m_36 = (_v_len9 - _v_len10);
                  if (_ve_descr.symbol_at (0))
                  {
                    goto _block4__branch1;
                  }
                  Expr _v_deref__descr (Expr (_ve_descr, 0));
                  int _v_len11 = _v_deref__descr.get_len ();
                  int _v_len12 = 0;
                  if (_v_len11 < _v_len12)
                  {
                    goto _block4__branch1;
                  }
                  int _v_len__arg = (_v_len11 - _v_len12);
                  Expr _ve__dollar_tmp_m_93_m_36;
                  _ve__dollar_tmp_m_93_m_36 = Expr (_ve_descr, (0 + 1), _v_len___dollar_tmp_m_93_m_36);
                  Expr _ve_arg;
                  _ve_arg = Expr (_v_deref__descr, 0, _v_len__arg);
                  _ge_next__7 = (_c_10 + _ve_next + _c_9 + _ve_arg + _c_8);
                  goto _block4;
                }
              _block4__branch1: {}
                _ge_next__7 = (_c_10 + _ve_next + _c_11);
              }
            _block4: {}
              Expr _vs_n__len;
              RF_CALL (::refal::Access::Length, _ge_next__7, _vs_n__len);
              Expr _ge_auxcall3;
              RF_CALL (::refal::Box::Get, _vs_len, _ge_auxcall3);
              Expr _gs_auxcall4;
              if (!RF_CALL (::refal::Convert::ToInt, _ge_auxcall3, _gs_auxcall4))
              {
                goto _continue1;
              }
              Expr _vs_new;
              RF_CALL (::refal::Arithm::Add, (_gs_auxcall4, _vs_n__len), _vs_new);
              {
                {
                  if (!RF_CALL (::refal::Compare::Gt, (_vs_new, _c_12), /*void*/))
                  {
                    goto _block5__branch1;
                  }
                  Expr _gs_auxcall5;
                  RF_CALL (::refal::Arithm::Add, (_vs_st__len, _vs_n__len), _gs_auxcall5);
                  RF_CALL (::refal::Box::Store, (_vs_len, _gs_auxcall5), /*void*/);
                  RF_CALL (::refal::StdIO::PrintLn, empty, /*void*/);
                  Expr _ge_auxcall6;
                  RF_CALL (::refal::List::Replicate, (_vs_st__len, _c_13), _ge_auxcall6);
                  RF_CALL (::refal::StdIO::Print, _ge_auxcall6, /*void*/);
                  goto _block5;
                }
              _block5__branch1: {}
                RF_CALL (::refal::Box::Store, (_vs_len, _vs_new), /*void*/);
              }
            _block5: {}
              RF_CALL (::refal::StdIO::Print, _ge_next__7, /*void*/);
            }
        _continue1: {}
          }
        _exit1: {}
        }
      _block3__branch1: {}
        RF_CALL (::refal::StdIO::PrintLn, _c_14, /*void*/);
        RF_CALL (::refal::StdIO::PrintLn, empty, /*void*/);
        RF_CALL (::refal::StdIO::PrintLnCh, (::refal::StdIO::StdErr, _c_15), /*void*/);
        _v_res1 = empty;
      }
    _block2: {}
      goto _block1;
    }
  _block1__branch1: {}
    {
      if (_ve_files.get_len () < 1)
      {
        goto _block1__branch2;
      }
      RF_lsplit (_ve_files, 0, _ve_01, _v_lsplit__files);
      for ( ; ; RF_iter(_ve_files)++)
      {
        {
          if (!RF_iter(_ve_files))
          {
            goto _block1__branch2;
          }
          int _v_len13 = _v_lsplit__files.get_len ();
          int _v_len14 = 1;
          if (_v_len13 < _v_len14)
          {
            goto _block1__branch2;
          }
          int _v_len__02 = (_v_len13 - _v_len14);
          if (_v_lsplit__files.symbol_at (0))
          {
            goto _continue2;
          }
          Expr _v_deref__lsplit__files (Expr (_v_lsplit__files, 0));
          int _v_len15 = _v_deref__lsplit__files.get_len ();
          int _v_len16 = 0;
          if (_v_len15 < _v_len16)
          {
            goto _continue2;
          }
          int _v_len__file = (_v_len15 - _v_len16);
          Expr _ve_02;
          _ve_02 = Expr (_v_lsplit__files, (0 + 1), _v_len__02);
          Expr _ve_file;
          _ve_file = Expr (_v_deref__lsplit__files, 0, _v_len__file);
          Expr _ve_in__basename;
          Expr _ve_ext;
          {
            {
              if (_v_len__file < 1)
              {
                goto _block6__branch1;
              }
              RF_rsplit (_ve_file, 0, _v_rsplit__file, _ge_ext__4);
              for ( ; ; RF_iter(_ve_file)--)
              {
                {
                  if (!RF_iter(_ve_file))
                  {
                    goto _block6__branch1;
                  }
                  int _v_len17 = _v_rsplit__file.get_len ();
                  int _v_len18 = 1;
                  if (_v_len17 < _v_len18)
                  {
                    goto _block6__branch1;
                  }
                  int _v_len__basename = (_v_len17 - _v_len18);
                  if (!_c_1.term_eq (_v_rsplit__file, (0 + _v_len__basename)))
                  {
                    goto _continue3;
                  }
                  Expr _ve_basename;
                  _ve_basename = Expr (_v_rsplit__file, 0, _v_len__basename);
                  _ve_in__basename = _ve_basename;
                  _ve_ext = (_c_16 + _ge_ext__4);
                  goto _exit3;
                }
            _continue3: {}
              }
            _exit3: {}
              goto _block6;
            }
          _block6__branch1: {}
            _ve_in__basename = _ve_file;
            _ve_ext = empty;
          }
        _block6: {}
          Expr _ve_basename;
          {
            {
              if (_ve_01.get_len () != 0)
              {
                goto _block7__branch1;
              }
              if (!RF_CALL (::refal::Table::Lookup, (org::refal::plus::compiler::rfp_helper::RFP_Options, _c_17), _ve_basename))
              {
                goto _block7__branch1;
              }
              goto _block7;
            }
          _block7__branch1: {}
            _ve_basename = _ve_in__basename;
          }
        _block7: {}
          Expr _ve_headname;
          {
            {
              if (!RF_CALL (::refal::Class::IsChannel, _ve_basename, /*void*/))
              {
                goto _block8__branch1;
              }
              _ve_headname = _ve_in__basename;
              goto _block8;
            }
          _block8__branch1: {}
            _ve_headname = _ve_basename;
          }
        _block8: {}
          Expr _ve_dirname;
          Expr _ve_filename;
          {
            {
              if (_ve_headname.get_len () < 1)
              {
                goto _block9__branch1;
              }
              RF_rsplit (_ve_headname, 0, _v_rsplit__headname, _ge_filename__7);
              for ( ; ; RF_iter(_ve_headname)--)
              {
                {
                  if (!RF_iter(_ve_headname))
                  {
                    goto _block9__branch1;
                  }
                  int _v_len19 = _v_rsplit__headname.get_len ();
                  int _v_len20 = 1;
                  if (_v_len19 < _v_len20)
                  {
                    goto _block9__branch1;
                  }
                  int _v_len__dirname__7 = (_v_len19 - _v_len20);
                  if (!_vs_dir__separator.term_eq (_v_rsplit__headname, (0 + _v_len__dirname__7)))
                  {
                    goto _continue4;
                  }
                  Expr _ge_dirname__7;
                  _ge_dirname__7 = Expr (_v_rsplit__headname, 0, _v_len__dirname__7);
                  _ve_dirname = _ge_dirname__7;
                  _ve_filename = _ge_filename__7;
                  goto _exit4;
                }
            _continue4: {}
              }
            _exit4: {}
              goto _block9;
            }
          _block9__branch1: {}
            _ve_dirname = _c_1;
            _ve_filename = _ve_headname;
          }
        _block9: {}
          Expr _ge_auxalt10;
          {
            {
              {
                {
                  if (_ve_ext.get_len () != 4)
                  {
                    goto _block11__branch1;
                  }
                  if (!_c_18.eq (_ve_ext, 0))
                  {
                    goto _block11__branch1;
                  }
                  goto _block11;
                }
              _block11__branch1: {}
                if (_ve_ext.get_len () != 5)
                {
                  goto _block10__branch1;
                }
                if (!_c_19.eq (_ve_ext, 0))
                {
                  goto _block10__branch1;
                }
              }
            _block11: {}
              RF_CALL (Verbose, (_ve_file + _c_20), /*void*/);
              Expr _vt_as;
              {
                {
                  if (!RF_CALL (org::refal::plus::compiler::rfp_parse::RFP_Parser, _ve_file (), _vt_as))
                  {
                    goto _block12__branch1;
                  }
                  goto _block12;
                }
              _block12__branch1: {}
                _vt_as = _c_21;
              }
            _block12: {}
              {
                {
                  Expr _v_RFP__Parser__Errors1;
                  RF_CALL (org::refal::plus::compiler::rfp_parse::RFP_Parser_Errors, /*void*/, _v_RFP__Parser__Errors1);
                  if (_v_RFP__Parser__Errors1.get_len () < 1)
                  {
                    goto _block13__branch1;
                  }
                  RF_lsplit (_v_RFP__Parser__Errors1, 0, _ve__dollar_tmp_m_138_m_36, _v_lsplit__RFP__Parser__Errors1);
                  for ( ; ; RF_iter(_v_RFP__Parser__Errors1)++)
                  {
                    {
                      if (!RF_iter(_v_RFP__Parser__Errors1))
                      {
                        goto _block13__branch1;
                      }
                      int _v_len21 = _v_lsplit__RFP__Parser__Errors1.get_len ();
                      int _v_len22 = 1;
                      if (_v_len21 < _v_len22)
                      {
                        goto _block13__branch1;
                      }
                      int _v_len___dollar_tmp_m_138_m_48 = (_v_len21 - _v_len22);
                      if (_v_lsplit__RFP__Parser__Errors1.symbol_at (0))
                      {
                        goto _continue5;
                      }
                      Expr _v_deref__lsplit__RFP__Parser__Errors1 (Expr (_v_lsplit__RFP__Parser__Errors1, 0));
                      int _v_len23 = _v_deref__lsplit__RFP__Parser__Errors1.get_len ();
                      int _v_len24 = 0;
                      if (_v_len23 < _v_len24)
                      {
                        goto _continue5;
                      }
                      int _v_len__error = (_v_len23 - _v_len24);
                      Expr _ve__dollar_tmp_m_138_m_48;
                      _ve__dollar_tmp_m_138_m_48 = Expr (_v_lsplit__RFP__Parser__Errors1, (0 + 1), _v_len___dollar_tmp_m_138_m_48);
                      Expr _ve_error;
                      _ve_error = Expr (_v_deref__lsplit__RFP__Parser__Errors1, 0, _v_len__error);
                      {
                        {
                          if (_v_len__error != 3)
                          {
                            goto _block14__branch1;
                          }
                          if (_ve_error.symbol_at ((0 + 1)))
                          {
                            goto _block14__branch1;
                          }
                          if (_ve_error.symbol_at ((0 + 1 + 1)))
                          {
                            goto _block14__branch1;
                          }
                          Expr _v_deref__error (Expr (_ve_error, (0 + 1)));
                          Expr _v_deref__error2 (Expr (_ve_error, (0 + 1 + 1)));
                          if (_v_deref__error.get_len () != 2)
                          {
                            goto _block14__branch1;
                          }
                          int _v_len25 = _v_deref__error2.get_len ();
                          int _v_len26 = 0;
                          if (_v_len25 < _v_len26)
                          {
                            goto _block14__branch1;
                          }
                          int _v_len__message = (_v_len25 - _v_len26);
                          if (_v_deref__error.symbol_at (0))
                          {
                            goto _block14__branch1;
                          }
                          if (_v_deref__error.symbol_at ((0 + 1)))
                          {
                            goto _block14__branch1;
                          }
                          Expr _v_deref__deref__error (Expr (_v_deref__error, 0));
                          Expr _v_deref__deref__error2 (Expr (_v_deref__error, (0 + 1)));
                          if (_v_deref__deref__error2.get_len () != 2)
                          {
                            goto _block14__branch1;
                          }
                          int _v_len27 = _v_deref__deref__error.get_len ();
                          int _v_len28 = 0;
                          if (_v_len27 < _v_len28)
                          {
                            goto _block14__branch1;
                          }
                          int _v_len__efile = (_v_len27 - _v_len28);
                          if (_v_deref__deref__error2.symbol_at (0))
                          {
                            goto _block14__branch1;
                          }
                          Expr _v_deref__deref__deref__error2 (Expr (_v_deref__deref__error2, 0));
                          if (_v_deref__deref__deref__error2.get_len () != 2)
                          {
                            goto _block14__branch1;
                          }
                          if (!_c_22.term_eq (_ve_error, 0))
                          {
                            goto _block14__branch1;
                          }
                          if (!_v_deref__deref__deref__error2.symbol_at (0))
                          {
                            goto _block14__branch1;
                          }
                          if (!_v_deref__deref__deref__error2.symbol_at ((0 + 1)))
                          {
                            goto _block14__branch1;
                          }
                          Expr _ve_message;
                          _ve_message = Expr (_v_deref__error2, 0, _v_len__message);
                          Expr _ve_efile;
                          _ve_efile = Expr (_v_deref__deref__error, 0, _v_len__efile);
                          Expr _vt__dollar_tmp_m_140_m_53;
                          _vt__dollar_tmp_m_140_m_53 = Expr (_v_deref__deref__error2, (0 + 1), 1);
                          Expr _vs_row;
                          _vs_row = Expr (_v_deref__deref__deref__error2, 0, 1);
                          Expr _vs_column;
                          _vs_column = Expr (_v_deref__deref__deref__error2, (0 + 1), 1);
                          int _v_len29 = _v_len__efile;
                          int _v_len30 = 1;
                          if (_v_len29 < _v_len30)
                          {
                            goto _continue5;
                          }
                          int _v_len__efilename = (_v_len29 - _v_len30);
                          if (!_ve_efile.symbol_at (0))
                          {
                            goto _continue5;
                          }
                          Expr _vs_efiletype;
                          _vs_efiletype = Expr (_ve_efile, 0, 1);
                          Expr _ve_efilename;
                          _ve_efilename = Expr (_ve_efile, (0 + 1), _v_len__efilename);
                          Expr _ge_auxcall7;
                          RF_CALL (::refal::List::Intersperse, (_c_1, _ve_efilename), _ge_auxcall7);
                          RF_CALL (::refal::StdIO::PrintLn, (_ge_auxcall7 + _c_26 + _vs_efiletype + _c_25 + _vs_row + _c_24 + _vs_column + _c_23 + _ve_message), /*void*/);
                          goto _block14;
                        }
                      _block14__branch1: {}
                        if (_v_len__error != 3)
                        {
                          RF_FUNC_ERROR (unexpected_fail);
                        }
                        if (_ve_error.symbol_at ((0 + 1)))
                        {
                          RF_FUNC_ERROR (unexpected_fail);
                        }
                        if (_ve_error.symbol_at ((0 + 1 + 1)))
                        {
                          RF_FUNC_ERROR (unexpected_fail);
                        }
                        Expr _v_deref__error3 (Expr (_ve_error, (0 + 1)));
                        Expr _v_deref__error4 (Expr (_ve_error, (0 + 1 + 1)));
                        if (_v_deref__error3.get_len () != 2)
                        {
                          RF_FUNC_ERROR (unexpected_fail);
                        }
                        int _v_len31 = _v_deref__error4.get_len ();
                        int _v_len32 = 0;
                        if (_v_len31 < _v_len32)
                        {
                          RF_FUNC_ERROR (unexpected_fail);
                        }
                        int _v_len__message2 = (_v_len31 - _v_len32);
                        if (_v_deref__error3.symbol_at (0))
                        {
                          RF_FUNC_ERROR (unexpected_fail);
                        }
                        if (_v_deref__error3.symbol_at ((0 + 1)))
                        {
                          RF_FUNC_ERROR (unexpected_fail);
                        }
                        Expr _v_deref__deref__error3 (Expr (_v_deref__error3, 0));
                        Expr _v_deref__deref__error32 (Expr (_v_deref__error3, (0 + 1)));
                        if (_v_deref__deref__error32.get_len () != 2)
                        {
                          RF_FUNC_ERROR (unexpected_fail);
                        }
                        int _v_len33 = _v_deref__deref__error3.get_len ();
                        int _v_len34 = 0;
                        if (_v_len33 < _v_len34)
                        {
                          RF_FUNC_ERROR (unexpected_fail);
                        }
                        int _v_len__efile2 = (_v_len33 - _v_len34);
                        if (_v_deref__deref__error32.symbol_at (0))
                        {
                          RF_FUNC_ERROR (unexpected_fail);
                        }
                        Expr _v_deref__deref__deref__error32 (Expr (_v_deref__deref__error32, 0));
                        if (_v_deref__deref__deref__error32.get_len () != 2)
                        {
                          RF_FUNC_ERROR (unexpected_fail);
                        }
                        if (!_c_27.term_eq (_ve_error, 0))
                        {
                          RF_FUNC_ERROR (unexpected_fail);
                        }
                        if (!_v_deref__deref__deref__error32.symbol_at (0))
                        {
                          RF_FUNC_ERROR (unexpected_fail);
                        }
                        if (!_v_deref__deref__deref__error32.symbol_at ((0 + 1)))
                        {
                          RF_FUNC_ERROR (unexpected_fail);
                        }
                        Expr _ve_message;
                        _ve_message = Expr (_v_deref__error4, 0, _v_len__message2);
                        Expr _ve_efile;
                        _ve_efile = Expr (_v_deref__deref__error3, 0, _v_len__efile2);
                        Expr _vt__dollar_tmp_m_143_m_55;
                        _vt__dollar_tmp_m_143_m_55 = Expr (_v_deref__deref__error32, (0 + 1), 1);
                        Expr _vs_row;
                        _vs_row = Expr (_v_deref__deref__deref__error32, 0, 1);
                        Expr _vs_column;
                        _vs_column = Expr (_v_deref__deref__deref__error32, (0 + 1), 1);
                        int _v_len35 = _v_len__efile2;
                        int _v_len36 = 1;
                        if (_v_len35 < _v_len36)
                        {
                          goto _continue5;
                        }
                        int _v_len__efilename2 = (_v_len35 - _v_len36);
                        if (!_ve_efile.symbol_at (0))
                        {
                          goto _continue5;
                        }
                        Expr _vs_efiletype;
                        _vs_efiletype = Expr (_ve_efile, 0, 1);
                        Expr _ve_efilename;
                        _ve_efilename = Expr (_ve_efile, (0 + 1), _v_len__efilename2);
                        Expr _ge_auxcall8;
                        RF_CALL (::refal::List::Intersperse, (_c_1, _ve_efilename), _ge_auxcall8);
                        RF_CALL (::refal::StdIO::PrintLn, (_ge_auxcall8 + _c_26 + _vs_efiletype + _c_25 + _vs_row + _c_24 + _vs_column + _c_28 + _ve_message), /*void*/);
                      }
                    _block14: {}
                    }
                _continue5: {}
                  }
                _exit5: {}
                }
              _block13__branch1: {}
                {
                  if (!_vt_as.term_eq (_c_21, 0))
                  {
                    goto _block13__branch2;
                  }
                  if (!RF_CALL (Compilation_Failed, /*void*/, /*void*/))
                  {
                    goto _continue2;
                  }
                  _ge_auxalt10 = empty;
                  goto _block13;
                }
              _block13__branch2: {}
                RF_CALL (Verbose, (_ve_file + _c_29), /*void*/);
                _ge_auxalt10 = (_c_30 + _vt_as);
              }
            _block13: {}
              goto _block10;
            }
          _block10__branch1: {}
            {
              if (_ve_ext.get_len () != 5)
              {
                goto _block10__branch2;
              }
              if (!_c_31.eq (_ve_ext, 0))
              {
                goto _block10__branch2;
              }
              Expr _vs_channel;
              RF_CALL (::refal::StdIO::Channel, /*void*/, _vs_channel);
              if (!RF_CALL (::refal::StdIO::OpenFile, (_vs_channel, _ve_file, _c_32), /*void*/))
              {
                goto _continue2;
              }
              Expr _v_ReadCh1;
              if (!RF_CALL (::refal::StdIO::ReadCh, _vs_channel, _v_ReadCh1))
              {
                goto _continue2;
              }
              _ge_auxalt10 = (_c_30 + _v_ReadCh1);
              goto _block10;
            }
          _block10__branch2: {}
            {
              if (_ve_ext.get_len () != 5)
              {
                goto _block10__branch3;
              }
              if (!_c_33.eq (_ve_ext, 0))
              {
                goto _block10__branch3;
              }
              Expr _vs_channel;
              RF_CALL (::refal::StdIO::Channel, /*void*/, _vs_channel);
              if (!RF_CALL (::refal::StdIO::OpenFile, (_vs_channel, _ve_file, _c_32), /*void*/))
              {
                goto _continue2;
              }
              Expr _v_ReadCh2;
              if (!RF_CALL (::refal::StdIO::ReadCh, _vs_channel, _v_ReadCh2))
              {
                goto _continue2;
              }
              _ge_auxalt10 = (_c_34 + _v_ReadCh2);
              goto _block10;
            }
          _block10__branch3: {}
            {
              if (_ve_ext.get_len () != 5)
              {
                goto _block10__branch4;
              }
              if (!_c_35.eq (_ve_ext, 0))
              {
                goto _block10__branch4;
              }
              Expr _vs_channel;
              RF_CALL (::refal::StdIO::Channel, /*void*/, _vs_channel);
              if (!RF_CALL (::refal::StdIO::OpenFile, (_vs_channel, _ve_file, _c_32), /*void*/))
              {
                goto _continue2;
              }
              Expr _gt_auxcall9;
              if (!RF_CALL (::refal::StdIO::ReadCh, _vs_channel, _gt_auxcall9))
              {
                goto _continue2;
              }
              _ge_auxalt10 = (_c_37 + (_c_36 + _gt_auxcall9) ());
              goto _block10;
            }
          _block10__branch4: {}
            RF_CALL (::refal::StdIO::PrintLnCh, (::refal::StdIO::StdErr, (_c_39 + _ve_ext + _c_38 + _ve_file)), /*void*/);
            if (!RF_CALL (Compilation_Failed, /*void*/, /*void*/))
            {
              goto _continue2;
            }
            _ge_auxalt10 = empty;
          }
        _block10: {}
          if (_ge_auxalt10.get_len () != 2)
          {
            goto _continue2;
          }
          if (_ge_auxalt10.symbol_at ((0 + 1)))
          {
            goto _continue2;
          }
          Expr _v_deref__auxalt10 (Expr (_ge_auxalt10, (0 + 1)));
          int _v_len37 = _v_deref__auxalt10.get_len ();
          int _v_len38 = 2;
          if (_v_len37 < _v_len38)
          {
            goto _continue2;
          }
          int _v_len__Items = (_v_len37 - _v_len38);
          if (!_ge_auxalt10.symbol_at (0))
          {
            goto _continue2;
          }
          if (!_v_deref__auxalt10.symbol_at (0))
          {
            goto _continue2;
          }
          Expr _vs_type;
          _vs_type = Expr (_ge_auxalt10, 0, 1);
          Expr _vs_tag;
          _vs_tag = Expr (_v_deref__auxalt10, 0, 1);
          Expr _vt_ModuleName;
          _vt_ModuleName = Expr (_v_deref__auxalt10, (0 + 1), 1);
          Expr _ve_Items;
          _ve_Items = Expr (_v_deref__auxalt10, (0 + 1 + 1), _v_len__Items);
          {
            {
              if (!_vs_type.term_eq (_c_37, 0))
              {
                goto _block15__branch1;
              }
              goto _block15;
            }
          _block15__branch1: {}
            RF_CALL (Get_Ready_For_Compilation, _ve_Items, /*void*/);
          }
        _block15: {}
          for ( ; ; )
          {
            {
              {
                if (!_vs_type.term_eq (_c_30, 0))
                {
                  goto _block16__branch1;
                }
                {
                  {
                    if (!RF_CALL (::refal::Table::IsInTable, (org::refal::plus::compiler::rfp_helper::RFP_Options, _c_30), /*void*/))
                    {
                      goto _block17__branch1;
                    }
                    Expr _vs_channel;
                    Expr _vs_Isneed__close;
                    RF_CALL (Open_Channel, (_ve_basename, _c_40), (_vs_channel, _vs_Isneed__close));
                    RF_CALL (RFP_Pretty_Print, (_vs_channel, empty, (_vs_tag + _vt_ModuleName + _ve_Items) ()), /*void*/);
                    {
                      {
                        if (!_vs_Isneed__close.term_eq (_c_3, 0))
                        {
                          goto _block18__branch1;
                        }
                        RF_CALL (::refal::StdIO::CloseChannel, _vs_channel, /*void*/);
                        goto _block18;
                      }
                    _block18__branch1: {}
                    }
                  _block18: {}
                    goto _block17;
                  }
                _block17__branch1: {}
                }
              _block17: {}
                {
                  {
                    Expr _v_Get3;
                    RF_CALL (::refal::Box::Get, org::refal::plus::compiler::rfp_err::Error_Counter, _v_Get3);
                    if (_v_Get3.get_len () != 0)
                    {
                      goto _block19__branch1;
                    }
                    goto _block19;
                  }
                _block19__branch1: {}
                  if (!RF_CALL (Compilation_Failed, /*void*/, /*void*/))
                  {
                    goto _continue2;
                  }
                }
              _block19: {}
                {
                  {
                    if (!RF_CALL (::refal::Table::IsInTable, (org::refal::plus::compiler::rfp_helper::RFP_Options, _c_41), /*void*/))
                    {
                      goto _block20__branch1;
                    }
                    goto _block20;
                  }
                _block20__branch1: {}
                  RF_CALL (Verbose, _c_42, /*void*/);
                  RF_CALL (org::refal::plus::compiler::rfp_check::RFP_Check, _ve_Items, /*void*/);
                  RF_CALL (Verbose, _c_43, /*void*/);
                  {
                    {
                      Expr _v_Get4;
                      RF_CALL (::refal::Box::Get, org::refal::plus::compiler::rfp_err::Error_Counter, _v_Get4);
                      if (_v_Get4.get_len () != 0)
                      {
                        goto _block21__branch1;
                      }
                      goto _block21;
                    }
                  _block21__branch1: {}
                    if (!RF_CALL (Compilation_Failed, /*void*/, /*void*/))
                    {
                      goto _continue2;
                    }
                  }
                _block21: {}
                }
              _block20: {}
                if (!RF_CALL (::refal::List::Any, (_c_44, org::refal::plus::compiler::rfp_helper::RFP_Options, _c_45), /*void*/))
                {
                  goto _continue2;
                }
                Expr _ge_Items__10;
                {
                  {
                    if (!RF_CALL (::refal::Table::IsInTable, (org::refal::plus::compiler::rfp_helper::RFP_Options, _c_46), /*void*/))
                    {
                      goto _block22__branch1;
                    }
                    _ge_Items__10 = _ve_Items;
                    goto _block22;
                  }
                _block22__branch1: {}
                  RF_CALL (Verbose, _c_47, /*void*/);
                  Expr _ge_Items__11;
                  RF_CALL (org::refal::plus::compiler::rfp_as2as::RFP_As2As_Transform, _ve_Items, _ge_Items__11);
                  RF_CALL (Verbose, _c_48, /*void*/);
                  _ge_Items__10 = _ge_Items__11;
                }
              _block22: {}
                _vs_type = _c_34;
                _ve_Items = _ge_Items__10;
                goto _block16;
              }
            _block16__branch1: {}
              {
                if (!_vs_type.term_eq (_c_34, 0))
                {
                  goto _block16__branch2;
                }
                {
                  {
                    if (!RF_CALL (::refal::Table::IsInTable, (org::refal::plus::compiler::rfp_helper::RFP_Options, _c_34), /*void*/))
                    {
                      goto _block23__branch1;
                    }
                    Expr _vs_channel;
                    Expr _vs_Isneed__close;
                    RF_CALL (Open_Channel, (_ve_basename, _c_49), (_vs_channel, _vs_Isneed__close));
                    RF_CALL (RFP_Pretty_Print, (_vs_channel, empty, (_vs_tag + _vt_ModuleName + _ve_Items) ()), /*void*/);
                    {
                      {
                        if (!_vs_Isneed__close.term_eq (_c_3, 0))
                        {
                          goto _block24__branch1;
                        }
                        RF_CALL (::refal::StdIO::CloseChannel, _vs_channel, /*void*/);
                        goto _block24;
                      }
                    _block24__branch1: {}
                    }
                  _block24: {}
                    goto _block23;
                  }
                _block23__branch1: {}
                }
              _block23: {}
                if (!RF_CALL (::refal::List::Any, (_c_44, org::refal::plus::compiler::rfp_helper::RFP_Options, _c_50), /*void*/))
                {
                  goto _continue2;
                }
                RF_CALL (Verbose, _c_51, /*void*/);
                Expr _vt_asail;
                RF_CALL (org::refal::plus::compiler::rfp_compile::RFP_Compile, (_vt_ModuleName, _ve_Items), _vt_asail);
                RF_CALL (Verbose, _c_52, /*void*/);
                _vs_type = _c_37;
                _ve_Items = _vt_asail;
                goto _block16;
              }
            _block16__branch2: {}
              if (!_vs_type.term_eq (_c_37, 0))
              {
                RF_FUNC_ERROR (unexpected_fail);
              }
              if (_ve_Items.get_len () != 1)
              {
                goto _continue2;
              }
              Expr _vt_module;
              _vt_module = Expr (_ve_Items, 0, 1);
              Expr _gt_module__10;
              {
                {
                  if (!RF_CALL (::refal::Table::IsInTable, (org::refal::plus::compiler::rfp_helper::RFP_Options, _c_0), /*void*/))
                  {
                    goto _block25__branch1;
                  }
                  _gt_module__10 = _vt_module;
                  goto _block25;
                }
              _block25__branch1: {}
                RF_CALL (Verbose, _c_53, /*void*/);
                Expr _gt_module__11;
                RF_CALL (org::refal::plus::compiler::rfp_asail2asail::Simplify_ASAIL, _vt_module, _gt_module__11);
                RF_CALL (Verbose, _c_54, /*void*/);
                _gt_module__10 = _gt_module__11;
              }
            _block25: {}
              {
                {
                  if (!RF_CALL (::refal::Table::IsInTable, (org::refal::plus::compiler::rfp_helper::RFP_Options, _c_37), /*void*/))
                  {
                    goto _block26__branch1;
                  }
                  Expr _vs_channel;
                  Expr _vs_Isneed__close;
                  RF_CALL (Open_Channel, (_ve_basename, _c_55), (_vs_channel, _vs_Isneed__close));
                  RF_CALL (RFP_Pretty_Print, (_vs_channel, empty, _gt_module__10), /*void*/);
                  {
                    {
                      if (!_vs_Isneed__close.term_eq (_c_3, 0))
                      {
                        goto _block27__branch1;
                      }
                      RF_CALL (::refal::StdIO::CloseChannel, _vs_channel, /*void*/);
                      goto _block27;
                    }
                  _block27__branch1: {}
                  }
                _block27: {}
                  goto _block26;
                }
              _block26__branch1: {}
              }
            _block26: {}
              {
                if (!RF_CALL (::refal::Table::IsInTable, (org::refal::plus::compiler::rfp_helper::RFP_Options, _c_56), /*void*/))
                {
                  goto _block28__branch1;
                }
                RF_CALL (Verbose, _c_57, /*void*/);
                Expr _ge_module__12;
                RF_CALL (org::refal::plus::compiler::rfp_asail_cpp::RFP_ASAIL_To_CPP, _gt_module__10, _ge_module__12);
                RF_CALL (Verbose, _c_58, /*void*/);
                Expr _vs_channel;
                Expr _vs_Isneed__close;
                RF_CALL (Open_Channel, (_ve_basename, _c_59), (_vs_channel, _vs_Isneed__close));
                RF_CALL (CPP_Pretty_Print, (_c_60, _vs_channel, empty, _ge_module__12), /*void*/);
                {
                  {
                    if (!_vs_Isneed__close.term_eq (_c_3, 0))
                    {
                      goto _block29__branch1;
                    }
                    RF_CALL (::refal::StdIO::CloseChannel, _vs_channel, /*void*/);
                    goto _block29;
                  }
                _block29__branch1: {}
                }
              _block29: {}
              }
            _block28__branch1: {}
              {
                if (!RF_CALL (::refal::Table::IsInTable, (org::refal::plus::compiler::rfp_helper::RFP_Options, _c_61), /*void*/))
                {
                  goto _block28__branch2;
                }
                RF_CALL (Verbose, _c_62, /*void*/);
                Expr _ge_module__12;
                RF_CALL (org::refal::plus::compiler::rfp_asail_tpp::RFP_ASAIL_To_TPP, _gt_module__10, _ge_module__12);
                RF_CALL (Verbose, _c_63, /*void*/);
                Expr _vs_channel;
                Expr _vs_Isneed__close;
                RF_CALL (Open_Channel, (_ve_basename, _c_64), (_vs_channel, _vs_Isneed__close));
                RF_CALL (CPP_Pretty_Print, (_c_60, _vs_channel, empty, _ge_module__12), /*void*/);
                {
                  {
                    if (!_vs_Isneed__close.term_eq (_c_3, 0))
                    {
                      goto _block30__branch1;
                    }
                    RF_CALL (::refal::StdIO::CloseChannel, _vs_channel, /*void*/);
                    goto _block30;
                  }
                _block30__branch1: {}
                }
              _block30: {}
              }
            _block28__branch2: {}
              {
                if (!RF_CALL (::refal::Table::IsInTable, (org::refal::plus::compiler::rfp_helper::RFP_Options, _c_65), /*void*/))
                {
                  goto _block28__branch3;
                }
                RF_CALL (Verbose, _c_66, /*void*/);
                Expr _ve_javaModuleName;
                Expr _ge_module__12;
                RF_CALL (org::refal::plus::compiler::rfp_asail_java::RFP_ASAIL_To_Java, _gt_module__10, (_ve_javaModuleName, _ge_module__12));
                Expr _vs_channel;
                Expr _vs_Isneed__close;
                {
                  {
                    if (!RF_CALL (::refal::Class::IsChannel, _ve_basename, /*void*/))
                    {
                      goto _block31__branch1;
                    }
                    RF_CALL (Open_Channel, (_ve_basename, _c_67), (_vs_channel, _vs_Isneed__close));
                    goto _block31;
                  }
                _block31__branch1: {}
                  Expr _gt_auxcall11;
                  if (!RF_CALL (::refal::Access::R, (_c_60, _ve_javaModuleName), _gt_auxcall11))
                  {
                    RF_FUNC_ERROR (unexpected_fail);
                  }
                  RF_CALL (Open_Channel, ((_ve_dirname + _vs_dir__separator + _gt_auxcall11), _c_67), (_vs_channel, _vs_Isneed__close));
                }
              _block31: {}
                RF_CALL (CPP_Pretty_Print, (_c_60, _vs_channel, empty, _ge_module__12), /*void*/);
                {
                  {
                    if (!_vs_Isneed__close.term_eq (_c_3, 0))
                    {
                      goto _block32__branch1;
                    }
                    RF_CALL (::refal::StdIO::CloseChannel, _vs_channel, /*void*/);
                    goto _block32;
                  }
                _block32__branch1: {}
                }
              _block32: {}
                RF_CALL (Verbose, _c_68, /*void*/);
              }
            _block28__branch3: {}
              if (!RF_CALL (::refal::Table::IsInTable, (org::refal::plus::compiler::rfp_helper::RFP_Options, _c_69), /*void*/))
              {
                goto _continue2;
              }
              RF_CALL (Verbose, _c_70, /*void*/);
              {
                Expr _v_RFP__ASAIL__To__JBC1;
                RF_CALL (org::refal::plus::compiler::rfp_asail_jbc::RFP_ASAIL_To_JBC, (_c_2, _c_2, _c_2, _gt_module__10), _v_RFP__ASAIL__To__JBC1);
                if (_v_RFP__ASAIL__To__JBC1.get_len () < 1)
                {
                  goto _block33__branch1;
                }
                RF_lsplit (_v_RFP__ASAIL__To__JBC1, 0, _ve__dollar_tmp_m_275_m_63, _v_lsplit__RFP__ASAIL__To__JBC1);
                for ( ; ; RF_iter(_v_RFP__ASAIL__To__JBC1)++)
                {
                  {
                    if (!RF_iter(_v_RFP__ASAIL__To__JBC1))
                    {
                      goto _block33__branch1;
                    }
                    int _v_len39 = _v_lsplit__RFP__ASAIL__To__JBC1.get_len ();
                    int _v_len40 = 1;
                    if (_v_len39 < _v_len40)
                    {
                      goto _block33__branch1;
                    }
                    int _v_len___dollar_tmp_m_275_m_95 = (_v_len39 - _v_len40);
                    if (_v_lsplit__RFP__ASAIL__To__JBC1.symbol_at (0))
                    {
                      goto _continue6;
                    }
                    Expr _v_deref__lsplit__RFP__ASAIL__To__JBC1 (Expr (_v_lsplit__RFP__ASAIL__To__JBC1, 0));
                    int _v_len41 = _v_deref__lsplit__RFP__ASAIL__To__JBC1.get_len ();
                    int _v_len42 = 1;
                    if (_v_len41 < _v_len42)
                    {
                      goto _continue6;
                    }
                    int _v_len__javaModuleName = (_v_len41 - _v_len42);
                    if (!_v_deref__lsplit__RFP__ASAIL__To__JBC1.symbol_at (0))
                    {
                      goto _continue6;
                    }
                    Expr _ve__dollar_tmp_m_275_m_95;
                    _ve__dollar_tmp_m_275_m_95 = Expr (_v_lsplit__RFP__ASAIL__To__JBC1, (0 + 1), _v_len___dollar_tmp_m_275_m_95);
                    Expr _vs_bytecode;
                    _vs_bytecode = Expr (_v_deref__lsplit__RFP__ASAIL__To__JBC1, 0, 1);
                    Expr _ve_javaModuleName;
                    _ve_javaModuleName = Expr (_v_deref__lsplit__RFP__ASAIL__To__JBC1, (0 + 1), _v_len__javaModuleName);
                    Expr _gt_auxcall12;
                    if (!RF_CALL (::refal::Access::R, (_c_60, _ve_javaModuleName), _gt_auxcall12))
                    {
                      goto _continue6;
                    }
                    Expr _gs_auxcall13;
                    RF_CALL (::refal::Convert::ToWord, (_ve_dirname + _vs_dir__separator + _gt_auxcall12 + _c_71), _gs_auxcall13);
                    Expr _vs_stream;
                    RF_CALL (FileOutputStream, _gs_auxcall13, _vs_stream);
                    RF_CALL (WriteToStream, (_vs_stream, _vs_bytecode), /*void*/);
                    RF_CALL (CloseStream, _vs_stream, /*void*/);
                  }
              _continue6: {}
                }
              _exit6: {}
              }
            _block33__branch1: {}
              RF_CALL (Verbose, _c_72, /*void*/);
              goto _continue2;
            }
          _block16: {}
          }
        _exit__iter1: {}
        }
    _continue2: {}
      }
    _exit2: {}
    }
  _block1__branch2: {}
    int _v_len43 = _ve_files.get_len ();
    int _v_len44 = 0;
    if (_v_len43 < _v_len44)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    int _v_len__all__files__have__gone = (_v_len43 - _v_len44);
    Expr _ve_all__files__have__gone;
    _ve_all__files__have__gone = Expr (_ve_files, 0, _v_len__all__files__have__gone);
    _v_res1 = empty;
  }
_block1: {}
RF_END

RF_FUNC (Init_Options, RF_VOID, RF_VOID)
  RF_TAILCALL (::refal::Box::Store, (Options, _c_73), /*void*/);
RF_END

RF_FUNC (Display_Help, RF_VOID, RF_VOID)
  Expr _vs_line;
  RF_CALL (::refal::Box::Box, empty, _vs_line);
  Expr _ve_start1 (_c_13);
  Expr _vs_2nd__col (_c_74);
  Expr _ve_start2;
  RF_CALL (::refal::List::Replicate, (_vs_2nd__col, _c_13), _ve_start2);
  Expr _ge_auxcall1;
  RF_CALL (Version, /*void*/, _ge_auxcall1);
  RF_CALL (::refal::StdIO::PrintLn, (_c_75 + _ge_auxcall1), /*void*/);
  RF_CALL (::refal::StdIO::PrintLn, _c_76, /*void*/);
  RF_CALL (::refal::StdIO::PrintLn, empty, /*void*/);
  RF_CALL (::refal::StdIO::PrintLn, _c_77, /*void*/);
  RF_CALL (::refal::StdIO::PrintLn, _c_78, /*void*/);
  {
    Expr _v_Get1;
    RF_CALL (::refal::Box::Get, Options, _v_Get1);
    if (_v_Get1.get_len () < 1)
    {
      goto _block1__branch1;
    }
    RF_lsplit (_v_Get1, 0, _ve__dollar_tmp_m_354_m_23, _v_lsplit__Get1);
    for ( ; ; RF_iter(_v_Get1)++)
    {
      {
        if (!RF_iter(_v_Get1))
        {
          goto _block1__branch1;
        }
        int _v_len1 = _v_lsplit__Get1.get_len ();
        int _v_len2 = 1;
        if (_v_len1 < _v_len2)
        {
          goto _block1__branch1;
        }
        int _v_len___dollar_tmp_m_354_m_53 = (_v_len1 - _v_len2);
        if (_v_lsplit__Get1.symbol_at (0))
        {
          goto _continue1;
        }
        Expr _v_deref__lsplit__Get1 (Expr (_v_lsplit__Get1, 0));
        int _v_len3 = _v_deref__lsplit__Get1.get_len ();
        int _v_len4 = 2;
        if (_v_len3 < _v_len4)
        {
          goto _continue1;
        }
        int _v_len__descr = (_v_len3 - _v_len4);
        if (_v_deref__lsplit__Get1.symbol_at (0))
        {
          goto _continue1;
        }
        Expr _v_deref__deref__lsplit__Get1 (Expr (_v_deref__lsplit__Get1, 0));
        int _v_len5 = _v_deref__deref__lsplit__Get1.get_len ();
        int _v_len6 = 1;
        if (_v_len5 < _v_len6)
        {
          goto _continue1;
        }
        int _v_len__opts = (_v_len5 - _v_len6);
        if (_v_deref__deref__lsplit__Get1.symbol_at (0))
        {
          goto _continue1;
        }
        Expr _v_deref__deref__deref__lsplit__Get1 (Expr (_v_deref__deref__lsplit__Get1, 0));
        int _v_len7 = _v_deref__deref__deref__lsplit__Get1.get_len ();
        int _v_len8 = 0;
        if (_v_len7 < _v_len8)
        {
          goto _continue1;
        }
        int _v_len__op = (_v_len7 - _v_len8);
        Expr _ve__dollar_tmp_m_354_m_53;
        _ve__dollar_tmp_m_354_m_53 = Expr (_v_lsplit__Get1, (0 + 1), _v_len___dollar_tmp_m_354_m_53);
        Expr _vt__dollar_tmp_m_354_m_42;
        _vt__dollar_tmp_m_354_m_42 = Expr (_v_deref__lsplit__Get1, (0 + 1), 1);
        Expr _ve_descr;
        _ve_descr = Expr (_v_deref__lsplit__Get1, (0 + 1 + 1), _v_len__descr);
        Expr _ve_opts;
        _ve_opts = Expr (_v_deref__deref__lsplit__Get1, (0 + 1), _v_len__opts);
        Expr _ve_op;
        _ve_op = Expr (_v_deref__deref__deref__lsplit__Get1, 0, _v_len__op);
        RF_CALL (::refal::Box::Store, (_vs_line, (_ve_start1 + _c_79 + _ve_op)), /*void*/);
        {
          if (_v_len__opts < 1)
          {
            goto _block2__branch1;
          }
          RF_lsplit (_ve_opts, 0, _ve__dollar_tmp_m_357_m_19, _v_lsplit__opts);
          for ( ; ; RF_iter(_ve_opts)++)
          {
            {
              if (!RF_iter(_ve_opts))
              {
                goto _block2__branch1;
              }
              int _v_len9 = _v_lsplit__opts.get_len ();
              int _v_len10 = 1;
              if (_v_len9 < _v_len10)
              {
                goto _block2__branch1;
              }
              int _v_len___dollar_tmp_m_357_m_30 = (_v_len9 - _v_len10);
              if (_v_lsplit__opts.symbol_at (0))
              {
                goto _continue2;
              }
              Expr _v_deref__lsplit__opts (Expr (_v_lsplit__opts, 0));
              int _v_len11 = _v_deref__lsplit__opts.get_len ();
              int _v_len12 = 0;
              if (_v_len11 < _v_len12)
              {
                goto _continue2;
              }
              int _v_len__next = (_v_len11 - _v_len12);
              Expr _ve__dollar_tmp_m_357_m_30;
              _ve__dollar_tmp_m_357_m_30 = Expr (_v_lsplit__opts, (0 + 1), _v_len___dollar_tmp_m_357_m_30);
              Expr _ve_next;
              _ve_next = Expr (_v_deref__lsplit__opts, 0, _v_len__next);
              RF_CALL (::refal::Box::Put, (_vs_line, (_c_80 + _ve_next)), /*void*/);
            }
        _continue2: {}
          }
        _exit2: {}
        }
      _block2__branch1: {}
        Expr _ge_auxalt3;
        {
          {
            int _v_len13 = _v_len__descr;
            int _v_len14 = 1;
            if (_v_len13 < _v_len14)
            {
              goto _block3__branch1;
            }
            int _v_len__rest = (_v_len13 - _v_len14);
            if (_ve_descr.symbol_at (0))
            {
              goto _block3__branch1;
            }
            Expr _v_deref__descr (Expr (_ve_descr, 0));
            int _v_len15 = _v_deref__descr.get_len ();
            int _v_len16 = 0;
            if (_v_len15 < _v_len16)
            {
              goto _block3__branch1;
            }
            int _v_len__params = (_v_len15 - _v_len16);
            Expr _ve_rest;
            _ve_rest = Expr (_ve_descr, (0 + 1), _v_len__rest);
            Expr _ve_params;
            _ve_params = Expr (_v_deref__descr, 0, _v_len__params);
            {
              if (_v_len__params < 1)
              {
                goto _block4__branch1;
              }
              RF_lsplit (_ve_params, 0, _ve__dollar_tmp_m_364_m_25, _v_lsplit__params);
              for ( ; ; RF_iter(_ve_params)++)
              {
                {
                  if (!RF_iter(_ve_params))
                  {
                    goto _block4__branch1;
                  }
                  int _v_len17 = _v_lsplit__params.get_len ();
                  int _v_len18 = 1;
                  if (_v_len17 < _v_len18)
                  {
                    goto _block4__branch1;
                  }
                  int _v_len___dollar_tmp_m_364_m_33 = (_v_len17 - _v_len18);
                  if (!_v_lsplit__params.symbol_at (0))
                  {
                    goto _continue3;
                  }
                  Expr _vs_par;
                  _vs_par = Expr (_v_lsplit__params, 0, 1);
                  Expr _ve__dollar_tmp_m_364_m_33;
                  _ve__dollar_tmp_m_364_m_33 = Expr (_v_lsplit__params, (0 + 1), _v_len___dollar_tmp_m_364_m_33);
                  Expr _ge_auxcall2;
                  RF_CALL (::refal::Convert::ToChars, _vs_par, _ge_auxcall2);
                  RF_CALL (::refal::Box::Put, (_vs_line, (_c_9 + _ge_auxcall2 + _c_81)), /*void*/);
                }
            _continue3: {}
              }
            _exit3: {}
            }
          _block4__branch1: {}
            _ge_auxalt3 = _ve_rest;
            goto _block3;
          }
        _block3__branch1: {}
          _ge_auxalt3 = _ve_descr;
        }
      _block3: {}
        {
          int _v_len19 = _ge_auxalt3.get_len ();
          int _v_len20 = 1;
          if (_v_len19 < _v_len20)
          {
            goto _block5__branch1;
          }
          int _v_len___dollar_tmp_m_371_m_19 = (_v_len19 - _v_len20);
          if (!_ge_auxalt3.symbol_at (0))
          {
            goto _block5__branch1;
          }
          Expr _vs_phrase;
          _vs_phrase = Expr (_ge_auxalt3, 0, 1);
          Expr _ve__dollar_tmp_m_371_m_19;
          _ve__dollar_tmp_m_371_m_19 = Expr (_ge_auxalt3, (0 + 1), _v_len___dollar_tmp_m_371_m_19);
          Expr _ge_auxcall4;
          RF_CALL (::refal::Box::Get, _vs_line, _ge_auxcall4);
          Expr _ge_auxcall5;
          RF_CALL (::refal::Box::Get, _vs_line, _ge_auxcall5);
          Expr _gs_auxcall6;
          RF_CALL (::refal::Access::Length, _ge_auxcall5, _gs_auxcall6);
          Expr _gs_auxcall7;
          RF_CALL (::refal::Arithm::Sub, (_vs_2nd__col, _gs_auxcall6), _gs_auxcall7);
          Expr _ge_auxcall8;
          RF_CALL (::refal::List::Replicate, (_gs_auxcall7, _c_13), _ge_auxcall8);
          RF_CALL (::refal::StdIO::PrintLn, (_ge_auxcall4 + _ge_auxcall8 + _vs_phrase), /*void*/);
        }
      _block5__branch1: {}
        if (_ge_auxalt3.get_len () < 2)
        {
          goto _continue1;
        }
        RF_lsplit (_ge_auxalt3, 0, _ve__dollar_tmp_m_378_m_10, _v_lsplit__auxalt3);
        for ( ; ; RF_iter(_ge_auxalt3)++)
        {
          {
            if (!RF_iter(_ge_auxalt3))
            {
              goto _continue1;
            }
            int _v_len21 = _v_lsplit__auxalt3.get_len ();
            int _v_len22 = 2;
            if (_v_len21 < _v_len22)
            {
              goto _continue1;
            }
            int _v_len___dollar_tmp_m_378_m_23 = (_v_len21 - _v_len22);
            if (!_v_lsplit__auxalt3.symbol_at (0))
            {
              goto _continue4;
            }
            if (!_v_lsplit__auxalt3.symbol_at ((0 + 1)))
            {
              goto _continue4;
            }
            Expr _vs__dollar_tmp_m_378_m_12;
            _vs__dollar_tmp_m_378_m_12 = Expr (_v_lsplit__auxalt3, 0, 1);
            Expr _vs_phrase;
            _vs_phrase = Expr (_v_lsplit__auxalt3, (0 + 1), 1);
            Expr _ve__dollar_tmp_m_378_m_23;
            _ve__dollar_tmp_m_378_m_23 = Expr (_v_lsplit__auxalt3, (0 + 1 + 1), _v_len___dollar_tmp_m_378_m_23);
            RF_CALL (::refal::StdIO::PrintLn, (_ve_start2 + _vs_phrase), /*void*/);
          }
      _continue4: {}
        }
      _exit4: {}
      }
  _continue1: {}
    }
  _exit1: {}
  }
_block1__branch1: {}
RF_END

RF_FUNC (Parse_Args, (RF_ARG _ve_files, _ve_prevarg, _vs_index;;), (RF_RES _v_res1;;))
  {
    {
      Expr _v_Arg1;
      RF_CALL (::refal::Dos::Arg, _vs_index, _v_Arg1);
      int _v_len1 = _v_Arg1.get_len ();
      int _v_len2 = 0;
      if (_v_len1 < (_v_len2 + 1))
      {
        goto _block1__branch1;
      }
      int _v_len__arg = (_v_len1 - _v_len2);
      Expr _vv_arg;
      _vv_arg = Expr (_v_Arg1, 0, _v_len__arg);
      Expr _gs_index__2;
      RF_CALL (::refal::Arithm::Add, (_vs_index, _c_3), _gs_index__2);
      {
        {
          int _v_len3 = _ve_prevarg.get_len ();
          int _v_len4 = 0;
          if (_v_len3 < (_v_len4 + 1))
          {
            goto _block2__branch1;
          }
          int _v_len___dollar_tmp_m_388_m_20 = (_v_len3 - _v_len4);
          Expr _vv__dollar_tmp_m_388_m_20;
          _vv__dollar_tmp_m_388_m_20 = Expr (_ve_prevarg, 0, _v_len___dollar_tmp_m_388_m_20);
          Expr _ge_prevarg__5;
          {
            {
              if (_ve_prevarg.get_len () != 1)
              {
                goto _block3__branch1;
              }
              if (!_c_82.term_eq (_ve_prevarg, 0))
              {
                goto _block3__branch1;
              }
              Expr _ge_auxcall1;
              RF_CALL (::refal::Box::Get, RFP_Include_Path, _ge_auxcall1);
              RF_CALL (::refal::Box::Store, (RFP_Include_Path, (_ge_auxcall1 + _vv_arg ())), /*void*/);
              _ge_prevarg__5 = empty;
              goto _block3;
            }
          _block3__branch1: {}
            {
              if (_ve_prevarg.get_len () != 1)
              {
                goto _block3__branch2;
              }
              if (!_c_83.term_eq (_ve_prevarg, 0))
              {
                goto _block3__branch2;
              }
              Expr _ge_auxcall2;
              RF_CALL (::refal::Box::Get, RFP_Boot_Path, _ge_auxcall2);
              RF_CALL (::refal::Box::Store, (RFP_Boot_Path, (_ge_auxcall2 + _vv_arg ())), /*void*/);
              _ge_prevarg__5 = empty;
              goto _block3;
            }
          _block3__branch2: {}
            {
              if (_ve_prevarg.get_len () != 1)
              {
                goto _block3__branch3;
              }
              if (!_c_84.term_eq (_ve_prevarg, 0))
              {
                goto _block3__branch3;
              }
              Expr _ve_items;
              {
                {
                  if (!RF_CALL (::refal::Table::Lookup, (org::refal::plus::compiler::rfp_helper::RFP_Options, _c_85), _ve_items))
                  {
                    goto _block4__branch1;
                  }
                  goto _block4;
                }
              _block4__branch1: {}
                _ve_items = empty;
              }
            _block4: {}
              Expr _ge_auxcall3;
              RF_CALL (org::refal::plus::compiler::rfp_helper::Make_Name, _vv_arg, _ge_auxcall3);
              RF_CALL (::refal::Table::Bind, (org::refal::plus::compiler::rfp_helper::RFP_Options, _c_85, (_ve_items + _ge_auxcall3 ())), /*void*/);
              _ge_prevarg__5 = empty;
              goto _block3;
            }
          _block3__branch3: {}
            {
              if (_ve_prevarg.get_len () != 1)
              {
                goto _block3__branch4;
              }
              if (!_c_86.term_eq (_ve_prevarg, 0))
              {
                goto _block3__branch4;
              }
              Expr _ve_entries;
              {
                {
                  if (!RF_CALL (::refal::Table::Lookup, (org::refal::plus::compiler::rfp_helper::RFP_Options, _c_87), _ve_entries))
                  {
                    goto _block5__branch1;
                  }
                  goto _block5;
                }
              _block5__branch1: {}
                _ve_entries = empty;
              }
            _block5: {}
              Expr _ge_auxcall4;
              RF_CALL (org::refal::plus::compiler::rfp_helper::Make_Name, _vv_arg, _ge_auxcall4);
              RF_CALL (::refal::Table::Bind, (org::refal::plus::compiler::rfp_helper::RFP_Options, _c_87, (_ve_entries + _ge_auxcall4 ())), /*void*/);
              _ge_prevarg__5 = empty;
              goto _block3;
            }
          _block3__branch4: {}
            {
              if (_ve_prevarg.get_len () != 1)
              {
                goto _block3__branch5;
              }
              if (!_c_88.term_eq (_ve_prevarg, 0))
              {
                goto _block3__branch5;
              }
              Expr _ge_auxcall5;
              RF_CALL (org::refal::plus::compiler::rfp_helper::Make_Name, _vv_arg, _ge_auxcall5);
              RF_CALL (::refal::Table::Bind, (RFP_Trace, _ge_auxcall5, empty), /*void*/);
              _ge_prevarg__5 = empty;
              goto _block3;
            }
          _block3__branch5: {}
            {
              if (_ve_prevarg.get_len () != 1)
              {
                goto _block3__branch6;
              }
              if (!_c_17.term_eq (_ve_prevarg, 0))
              {
                goto _block3__branch6;
              }
              Expr _gv_arg__7;
              {
                {
                  if (_v_len__arg != 1)
                  {
                    goto _block6__branch1;
                  }
                  if (!_c_79.term_eq (_vv_arg, 0))
                  {
                    goto _block6__branch1;
                  }
                  _gv_arg__7 = ::refal::StdIO::StdOut;
                  goto _block6;
                }
              _block6__branch1: {}
                _gv_arg__7 = _vv_arg;
              }
            _block6: {}
              RF_CALL (::refal::Table::Bind, (org::refal::plus::compiler::rfp_helper::RFP_Options, _c_17, _gv_arg__7), /*void*/);
              _ge_prevarg__5 = empty;
              goto _block3;
            }
          _block3__branch6: {}
            {
              if (_ve_prevarg.get_len () != 1)
              {
                goto _block3__branch7;
              }
              if (!_c_89.term_eq (_ve_prevarg, 0))
              {
                goto _block3__branch7;
              }
              RF_CALL (::refal::Table::Bind, (org::refal::plus::compiler::rfp_helper::RFP_Options, _c_89, _vv_arg), /*void*/);
              _ge_prevarg__5 = empty;
              goto _block3;
            }
          _block3__branch7: {}
            {
              if (_ve_prevarg.get_len () != 1)
              {
                goto _block3__branch8;
              }
              if (!_c_90.term_eq (_ve_prevarg, 0))
              {
                goto _block3__branch8;
              }
              RF_CALL (::refal::Table::Bind, (org::refal::plus::compiler::rfp_helper::RFP_Options, _c_90, _vv_arg), /*void*/);
              _ge_prevarg__5 = empty;
              goto _block3;
            }
          _block3__branch8: {}
            {
              if (_ve_prevarg.get_len () != 1)
              {
                goto _block3__branch9;
              }
              if (!_c_91.term_eq (_ve_prevarg, 0))
              {
                goto _block3__branch9;
              }
              _ge_prevarg__5 = (_c_92 + _vv_arg);
              goto _block3;
            }
          _block3__branch9: {}
            int _v_len5 = _ve_prevarg.get_len ();
            int _v_len6 = 1;
            if (_v_len5 < _v_len6)
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            int _v_len__mod1 = (_v_len5 - _v_len6);
            if (!_c_92.term_eq (_ve_prevarg, 0))
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            Expr _ve_mod1;
            _ve_mod1 = Expr (_ve_prevarg, (0 + 1), _v_len__mod1);
            RF_CALL (::refal::Table::Bind, (org::refal::plus::compiler::rfp_helper::RFP_Module_Subst, _ve_mod1, _vv_arg), /*void*/);
            _ge_prevarg__5 = empty;
          }
        _block3: {}
          RF_TAILCALL (Parse_Args, (_ve_files, _ge_prevarg__5, _gs_index__2), _v_res1);
          goto _block2;
        }
      _block2__branch1: {}
        {
          int _v_len7 = _v_len__arg;
          int _v_len8 = 1;
          if (_v_len7 < _v_len8)
          {
            goto _block2__branch2;
          }
          int _v_len__opt = (_v_len7 - _v_len8);
          if (!_c_79.term_eq (_vv_arg, 0))
          {
            goto _block2__branch2;
          }
          Expr _ve_opt;
          _ve_opt = Expr (_vv_arg, (0 + 1), _v_len__opt);
          {
            {
              Expr _gt_auxalt6;
              {
                {
                  Expr _v_Get1;
                  RF_CALL (::refal::Box::Get, Options, _v_Get1);
                  if (_v_Get1.get_len () < 1)
                  {
                    goto _block8__branch1;
                  }
                  RF_lsplit (_v_Get1, 0, _ve__dollar_tmp_m_426_m_31, _v_lsplit__Get1);
                  for ( ; ; RF_iter(_v_Get1)++)
                  {
                    {
                      if (!RF_iter(_v_Get1))
                      {
                        goto _block8__branch1;
                      }
                      int _v_len9 = _v_lsplit__Get1.get_len ();
                      int _v_len10 = 1;
                      if (_v_len9 < _v_len10)
                      {
                        goto _block8__branch1;
                      }
                      int _v_len___dollar_tmp_m_426_m_60 = (_v_len9 - _v_len10);
                      if (_v_lsplit__Get1.symbol_at (0))
                      {
                        goto _continue1;
                      }
                      Expr _v_deref__lsplit__Get1 (Expr (_v_lsplit__Get1, 0));
                      int _v_len11 = _v_deref__lsplit__Get1.get_len ();
                      int _v_len12 = 2;
                      if (_v_len11 < _v_len12)
                      {
                        goto _continue1;
                      }
                      int _v_len___dollar_tmp_m_426_m_57 = (_v_len11 - _v_len12);
                      if (_v_deref__lsplit__Get1.symbol_at (0))
                      {
                        goto _continue1;
                      }
                      Expr _v_deref__deref__lsplit__Get1 (Expr (_v_deref__lsplit__Get1, 0));
                      if (_v_deref__deref__lsplit__Get1.get_len () < 1)
                      {
                        goto _continue1;
                      }
                      Expr _ve__dollar_tmp_m_426_m_60;
                      _ve__dollar_tmp_m_426_m_60 = Expr (_v_lsplit__Get1, (0 + 1), _v_len___dollar_tmp_m_426_m_60);
                      Expr _vt_action;
                      _vt_action = Expr (_v_deref__lsplit__Get1, (0 + 1), 1);
                      Expr _ve__dollar_tmp_m_426_m_57;
                      _ve__dollar_tmp_m_426_m_57 = Expr (_v_deref__lsplit__Get1, (0 + 1 + 1), _v_len___dollar_tmp_m_426_m_57);
                      RF_lsplit (_v_deref__deref__lsplit__Get1, 0, _ve__dollar_tmp_m_426_m_35, _v_lsplit__deref__deref__lsplit__Get1);
                      for ( ; ; RF_iter(_v_deref__deref__lsplit__Get1)++)
                      {
                        {
                          if (!RF_iter(_v_deref__deref__lsplit__Get1))
                          {
                            goto _continue1;
                          }
                          int _v_len13 = _v_lsplit__deref__deref__lsplit__Get1.get_len ();
                          int _v_len14 = 1;
                          if (_v_len13 < _v_len14)
                          {
                            goto _continue1;
                          }
                          int _v_len___dollar_tmp_m_426_m_45 = (_v_len13 - _v_len14);
                          if (_v_lsplit__deref__deref__lsplit__Get1.symbol_at (0))
                          {
                            goto _continue2;
                          }
                          Expr _v_deref__lsplit__deref__deref__lsplit__Get1 (Expr (_v_lsplit__deref__deref__lsplit__Get1, 0));
                          if (_v_deref__lsplit__deref__deref__lsplit__Get1.get_len () != _v_len__opt)
                          {
                            goto _continue2;
                          }
                          if (!_ve_opt.eq (_v_deref__lsplit__deref__deref__lsplit__Get1, 0))
                          {
                            goto _continue2;
                          }
                          Expr _ve__dollar_tmp_m_426_m_45;
                          _ve__dollar_tmp_m_426_m_45 = Expr (_v_lsplit__deref__deref__lsplit__Get1, (0 + 1), _v_len___dollar_tmp_m_426_m_45);
                          _gt_auxalt6 = _vt_action;
                          goto _exit2;
                        }
                    _continue2: {}
                      }
                    _exit2: {}
                      goto _exit1;
                    }
                _continue1: {}
                  }
                _exit1: {}
                  goto _block8;
                }
              _block8__branch1: {}
                int _v_len15 = _v_len__opt;
                int _v_len16 = 1;
                if (_v_len15 < _v_len16)
                {
                  goto _block7__branch1;
                }
                int _v_len__o = (_v_len15 - _v_len16);
                if (!_c_79.term_eq (_ve_opt, 0))
                {
                  goto _block7__branch1;
                }
                Expr _ve_o;
                _ve_o = Expr (_ve_opt, (0 + 1), _v_len__o);
                Expr _v_Get2;
                RF_CALL (::refal::Box::Get, Options, _v_Get2);
                if (_v_Get2.get_len () < 1)
                {
                  goto _block7__branch1;
                }
                RF_lsplit (_v_Get2, 0, _ve__dollar_tmp_m_428_m_33, _v_lsplit__Get2);
                for ( ; ; RF_iter(_v_Get2)++)
                {
                  {
                    if (!RF_iter(_v_Get2))
                    {
                      goto _block7__branch1;
                    }
                    int _v_len17 = _v_lsplit__Get2.get_len ();
                    int _v_len18 = 1;
                    if (_v_len17 < _v_len18)
                    {
                      goto _block7__branch1;
                    }
                    int _v_len___dollar_tmp_m_428_m_60 = (_v_len17 - _v_len18);
                    if (_v_lsplit__Get2.symbol_at (0))
                    {
                      goto _continue3;
                    }
                    Expr _v_deref__lsplit__Get2 (Expr (_v_lsplit__Get2, 0));
                    int _v_len19 = _v_deref__lsplit__Get2.get_len ();
                    int _v_len20 = 2;
                    if (_v_len19 < _v_len20)
                    {
                      goto _continue3;
                    }
                    int _v_len___dollar_tmp_m_428_m_57 = (_v_len19 - _v_len20);
                    if (_v_deref__lsplit__Get2.symbol_at (0))
                    {
                      goto _continue3;
                    }
                    Expr _v_deref__deref__lsplit__Get2 (Expr (_v_deref__lsplit__Get2, 0));
                    if (_v_deref__deref__lsplit__Get2.get_len () < 1)
                    {
                      goto _continue3;
                    }
                    Expr _ve__dollar_tmp_m_428_m_60;
                    _ve__dollar_tmp_m_428_m_60 = Expr (_v_lsplit__Get2, (0 + 1), _v_len___dollar_tmp_m_428_m_60);
                    Expr _vt_action;
                    _vt_action = Expr (_v_deref__lsplit__Get2, (0 + 1), 1);
                    Expr _ve__dollar_tmp_m_428_m_57;
                    _ve__dollar_tmp_m_428_m_57 = Expr (_v_deref__lsplit__Get2, (0 + 1 + 1), _v_len___dollar_tmp_m_428_m_57);
                    RF_lsplit (_v_deref__deref__lsplit__Get2, 0, _ve__dollar_tmp_m_428_m_37, _v_lsplit__deref__deref__lsplit__Get2);
                    for ( ; ; RF_iter(_v_deref__deref__lsplit__Get2)++)
                    {
                      {
                        if (!RF_iter(_v_deref__deref__lsplit__Get2))
                        {
                          goto _continue3;
                        }
                        int _v_len21 = _v_lsplit__deref__deref__lsplit__Get2.get_len ();
                        int _v_len22 = 1;
                        if (_v_len21 < _v_len22)
                        {
                          goto _continue3;
                        }
                        int _v_len___dollar_tmp_m_428_m_45 = (_v_len21 - _v_len22);
                        if (_v_lsplit__deref__deref__lsplit__Get2.symbol_at (0))
                        {
                          goto _continue4;
                        }
                        Expr _v_deref__lsplit__deref__deref__lsplit__Get2 (Expr (_v_lsplit__deref__deref__lsplit__Get2, 0));
                        if (_v_deref__lsplit__deref__deref__lsplit__Get2.get_len () != _v_len__o)
                        {
                          goto _continue4;
                        }
                        if (!_ve_o.eq (_v_deref__lsplit__deref__deref__lsplit__Get2, 0))
                        {
                          goto _continue4;
                        }
                        Expr _ve__dollar_tmp_m_428_m_45;
                        _ve__dollar_tmp_m_428_m_45 = Expr (_v_lsplit__deref__deref__lsplit__Get2, (0 + 1), _v_len___dollar_tmp_m_428_m_45);
                        _gt_auxalt6 = _vt_action;
                        goto _exit4;
                      }
                  _continue4: {}
                    }
                  _exit4: {}
                    goto _exit3;
                  }
              _continue3: {}
                }
              _exit3: {}
              }
            _block8: {}
              Expr _ge_prevarg__8;
              {
                {
                  if (_gt_auxalt6.symbol_at (0))
                  {
                    goto _block9__branch1;
                  }
                  Expr _v_deref__auxalt6 (Expr (_gt_auxalt6, 0));
                  if (_v_deref__auxalt6.get_len () != 2)
                  {
                    goto _block9__branch1;
                  }
                  if (!_c_93.term_eq (_v_deref__auxalt6, 0))
                  {
                    goto _block9__branch1;
                  }
                  if (!_v_deref__auxalt6.symbol_at ((0 + 1)))
                  {
                    goto _block9__branch1;
                  }
                  Expr _vs_option;
                  _vs_option = Expr (_v_deref__auxalt6, (0 + 1), 1);
                  RF_CALL (::refal::Table::Bind, (org::refal::plus::compiler::rfp_helper::RFP_Options, _vs_option, empty), /*void*/);
                  _ge_prevarg__8 = empty;
                  goto _block9;
                }
              _block9__branch1: {}
                {
                  if (!_gt_auxalt6.term_eq (_c_4, 0))
                  {
                    goto _block9__branch2;
                  }
                  RF_CALL (::refal::Table::Bind, (org::refal::plus::compiler::rfp_helper::RFP_Options, _c_4, empty), /*void*/);
                  RF_CALL (Display_Help, /*void*/, /*void*/);
                  _ge_prevarg__8 = empty;
                  goto _block9;
                }
              _block9__branch2: {}
                if (!_gt_auxalt6.symbol_at (0))
                {
                  RF_FUNC_ERROR (unexpected_fail);
                }
                Expr _vs_other;
                _vs_other = Expr (_gt_auxalt6, 0, 1);
                _ge_prevarg__8 = _vs_other;
              }
            _block9: {}
              RF_TAILCALL (Parse_Args, (_ve_files, _ge_prevarg__8, _gs_index__2), _v_res1);
              goto _block7;
            }
          _block7__branch1: {}
            RF_CALL (::refal::StdIO::PrintLnCh, (::refal::StdIO::StdErr, (_c_95 + _ve_opt + _c_94)), /*void*/);
            RF_TAILCALL (Parse_Args, (_ve_files, empty, _gs_index__2), _v_res1);
          }
        _block7: {}
          goto _block2;
        }
      _block2__branch2: {}
        RF_TAILCALL (Parse_Args, ((_ve_files + _vv_arg ()), empty, _gs_index__2), _v_res1);
      }
    _block2: {}
      goto _block1;
    }
  _block1__branch1: {}
    {
      int _v_len23 = _ve_prevarg.get_len ();
      int _v_len24 = 0;
      if (_v_len23 < (_v_len24 + 1))
      {
        goto _block1__branch2;
      }
      int _v_len___dollar_tmp_m_440_m_16 = (_v_len23 - _v_len24);
      Expr _vv__dollar_tmp_m_440_m_16;
      _vv__dollar_tmp_m_440_m_16 = Expr (_ve_prevarg, 0, _v_len___dollar_tmp_m_440_m_16);
      RF_CALL (::refal::StdIO::PrintLnCh, (::refal::StdIO::StdErr, _c_96), /*void*/);
      RF_CALL (::refal::Dos::Exit, _c_3, /*void*/);
      _v_res1 = empty;
      goto _block1;
    }
  _block1__branch2: {}
    {
      {
        if (!RF_CALL (::refal::List::Any, (_c_44, org::refal::plus::compiler::rfp_helper::RFP_Options, _c_97), /*void*/))
        {
          goto _block10__branch1;
        }
        goto _block10;
      }
    _block10__branch1: {}
      RF_CALL (::refal::Table::Bind, (org::refal::plus::compiler::rfp_helper::RFP_Options, _c_56, empty), /*void*/);
      RF_CALL (::refal::Table::Bind, (org::refal::plus::compiler::rfp_helper::RFP_Options, _c_98, empty), /*void*/);
    }
  _block10: {}
    _v_res1 = _ve_files;
  }
_block1: {}
RF_END

RF_FUNC (Set_Path, RF_VOID, RF_VOID)
  Expr _ge_auxcall1;
  RF_CALL (::refal::Box::Get, ::refal::File::DirSeparator, _ge_auxcall1);
  Expr _ge_auxcall2;
  RF_CALL (::refal::Box::Get, RFP_Boot_Path, _ge_auxcall2);
  Expr _ge_auxcall3;
  if (!RF_CALL (::refal::List::MapIn, (_c_99, _ge_auxcall1 (), (_ge_auxcall2 + RFP_Default_Boot_Path)), _ge_auxcall3))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  RF_CALL (::refal::Box::Store, (RFP_Boot_Path, _ge_auxcall3), /*void*/);
  Expr _ge_auxcall4;
  RF_CALL (::refal::Box::Get, ::refal::File::DirSeparator, _ge_auxcall4);
  Expr _ge_auxcall5;
  RF_CALL (::refal::Box::Get, RFP_Include_Path, _ge_auxcall5);
  Expr _ge_auxcall6;
  if (!RF_CALL (::refal::List::MapIn, (_c_99, _ge_auxcall4 (), _ge_auxcall5), _ge_auxcall6))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  RF_TAILCALL (::refal::Box::Store, (RFP_Include_Path, _ge_auxcall6), /*void*/);
RF_END

RF_FUNC (Get_Ready_For_Compilation, (RF_ARG _ve_Items;;), RF_VOID)
  RF_CALL (::refal::Table::ClearTable, org::refal::plus::compiler::rfp_helper::Fun, /*void*/);
  RF_CALL (::refal::Table::ClearTable, org::refal::plus::compiler::rfp_helper::IsFun, /*void*/);
  RF_CALL (::refal::Table::ClearTable, org::refal::plus::compiler::rfp_helper::Const, /*void*/);
  RF_CALL (::refal::Table::ClearTable, org::refal::plus::compiler::rfp_helper::Object, /*void*/);
  {
    if (_ve_Items.get_len () < 1)
    {
      goto _block1__branch1;
    }
    RF_lsplit (_ve_Items, 0, _ve__dollar_tmp_m_460_m_16, _v_lsplit__Items);
    for ( ; ; RF_iter(_ve_Items)++)
    {
      {
        if (!RF_iter(_ve_Items))
        {
          goto _block1__branch1;
        }
        int _v_len1 = _v_lsplit__Items.get_len ();
        int _v_len2 = 1;
        if (_v_len1 < _v_len2)
        {
          goto _block1__branch1;
        }
        int _v_len___dollar_tmp_m_460_m_25 = (_v_len1 - _v_len2);
        Expr _vt_Item;
        _vt_Item = Expr (_v_lsplit__Items, 0, 1);
        Expr _ve__dollar_tmp_m_460_m_25;
        _ve__dollar_tmp_m_460_m_25 = Expr (_v_lsplit__Items, (0 + 1), _v_len___dollar_tmp_m_460_m_25);
        {
          {
            Expr _gt_auxalt1;
            {
              {
                if (_vt_Item.symbol_at (0))
                {
                  goto _block3__branch1;
                }
                Expr _v_deref__Item (Expr (_vt_Item, 0));
                int _v_len3 = _v_deref__Item.get_len ();
                int _v_len4 = 4;
                if (_v_len3 < _v_len4)
                {
                  goto _block3__branch1;
                }
                int _v_len__ItemBody = (_v_len3 - _v_len4);
                if (_v_deref__Item.symbol_at ((0 + 1 + 1)))
                {
                  goto _block3__branch1;
                }
                Expr _v_deref__deref__Item (Expr (_v_deref__Item, (0 + 1 + 1)));
                int _v_len5 = _v_deref__deref__Item.get_len ();
                int _v_len6 = 2;
                if (_v_len5 < _v_len6)
                {
                  goto _block3__branch1;
                }
                int _v_len___dollar_tmp_m_466_m_44 = (_v_len5 - _v_len6);
                if (_v_deref__deref__Item.symbol_at ((0 + 1)))
                {
                  goto _block3__branch1;
                }
                Expr _v_deref__deref__deref__Item (Expr (_v_deref__deref__Item, (0 + 1)));
                int _v_len7 = _v_deref__deref__deref__Item.get_len ();
                int _v_len8 = 0;
                if (_v_len7 < _v_len8)
                {
                  goto _block3__branch1;
                }
                int _v_len___dollar_tmp_m_466_m_41 = (_v_len7 - _v_len8);
                if (!_v_deref__Item.symbol_at (0))
                {
                  goto _block3__branch1;
                }
                if (!_v_deref__Item.symbol_at ((0 + 1)))
                {
                  goto _block3__branch1;
                }
                if (!_c_100.term_eq (_v_deref__deref__Item, 0))
                {
                  goto _block3__branch1;
                }
                Expr _vs_Linkage;
                _vs_Linkage = Expr (_v_deref__Item, 0, 1);
                Expr _vs_ItemType;
                _vs_ItemType = Expr (_v_deref__Item, (0 + 1), 1);
                Expr _vt_ItemName;
                _vt_ItemName = Expr (_v_deref__Item, (0 + 1 + 1 + 1), 1);
                Expr _ve_ItemBody;
                _ve_ItemBody = Expr (_v_deref__Item, (0 + 1 + 1 + 1 + 1), _v_len__ItemBody);
                Expr _ve__dollar_tmp_m_466_m_44;
                _ve__dollar_tmp_m_466_m_44 = Expr (_v_deref__deref__Item, (0 + 1 + 1), _v_len___dollar_tmp_m_466_m_44);
                Expr _ve__dollar_tmp_m_466_m_41;
                _ve__dollar_tmp_m_466_m_41 = Expr (_v_deref__deref__deref__Item, 0, _v_len___dollar_tmp_m_466_m_41);
                _gt_auxalt1 = (_vs_Linkage + _vs_ItemType + _vt_ItemName + _ve_ItemBody) ();
                goto _block3;
              }
            _block3__branch1: {}
              Expr _vt__dollar_tmp_m_468_m_10;
              _vt__dollar_tmp_m_468_m_10 = Expr (_vt_Item, 0, 1);
              _gt_auxalt1 = _vt_Item;
            }
          _block3: {}
            if (_gt_auxalt1.symbol_at (0))
            {
              goto _block2__branch1;
            }
            Expr _v_deref__auxalt1 (Expr (_gt_auxalt1, 0));
            int _v_len9 = _v_deref__auxalt1.get_len ();
            int _v_len10 = 3;
            if (_v_len9 < _v_len10)
            {
              goto _block2__branch1;
            }
            int _v_len__ItemBody2 = (_v_len9 - _v_len10);
            if (!_v_deref__auxalt1.symbol_at (0))
            {
              goto _block2__branch1;
            }
            if (!_v_deref__auxalt1.symbol_at ((0 + 1)))
            {
              goto _block2__branch1;
            }
            Expr _vs_Linkage;
            _vs_Linkage = Expr (_v_deref__auxalt1, 0, 1);
            Expr _vs_ItemType;
            _vs_ItemType = Expr (_v_deref__auxalt1, (0 + 1), 1);
            Expr _vt_ItemName;
            _vt_ItemName = Expr (_v_deref__auxalt1, (0 + 1 + 1), 1);
            Expr _ve_ItemBody;
            _ve_ItemBody = Expr (_v_deref__auxalt1, (0 + 1 + 1 + 1), _v_len__ItemBody2);
            Expr _vs_tab;
            Expr _ve_ItemDef;
            {
              {
                if (!_vs_ItemType.term_eq (_c_101, 0))
                {
                  goto _block4__branch1;
                }
                Expr _v_Left1;
                if (!RF_CALL (::refal::Access::Left, (_c_60, _c_102, _ve_ItemBody), _v_Left1))
                {
                  goto _continue1;
                }
                if (_v_Left1.get_len () != 2)
                {
                  goto _continue1;
                }
                if (_v_Left1.symbol_at (0))
                {
                  goto _continue1;
                }
                if (_v_Left1.symbol_at ((0 + 1)))
                {
                  goto _continue1;
                }
                Expr _v_deref__Left1 (Expr (_v_Left1, 0));
                Expr _v_deref__Left12 (Expr (_v_Left1, (0 + 1)));
                int _v_len11 = _v_deref__Left12.get_len ();
                int _v_len12 = 0;
                if (_v_len11 < _v_len12)
                {
                  goto _continue1;
                }
                int _v_len__out = (_v_len11 - _v_len12);
                int _v_len13 = _v_deref__Left1.get_len ();
                int _v_len14 = 0;
                if (_v_len13 < _v_len14)
                {
                  goto _continue1;
                }
                int _v_len__in = (_v_len13 - _v_len14);
                Expr _ve_in;
                _ve_in = Expr (_v_deref__Left1, 0, _v_len__in);
                Expr _ve_out;
                _ve_out = Expr (_v_deref__Left12, 0, _v_len__out);
                Expr _ge_auxcall2;
                RF_CALL (org::refal::plus::compiler::rfp_format::Format_Exp, _ve_in, _ge_auxcall2);
                Expr _ge_auxcall3;
                RF_CALL (org::refal::plus::compiler::rfp_format::Format_Exp, _ve_out, _ge_auxcall3);
                _vs_tab = org::refal::plus::compiler::rfp_helper::Fun;
                _ve_ItemDef = (_ge_auxcall2 () + _ge_auxcall3 ());
                goto _block4;
              }
            _block4__branch1: {}
              {
                if (!_vs_ItemType.term_eq (_c_103, 0))
                {
                  goto _block4__branch2;
                }
                Expr _v_Left2;
                if (!RF_CALL (::refal::Access::Left, (_c_60, _c_102, _ve_ItemBody), _v_Left2))
                {
                  goto _continue1;
                }
                if (_v_Left2.get_len () != 2)
                {
                  goto _continue1;
                }
                if (_v_Left2.symbol_at (0))
                {
                  goto _continue1;
                }
                if (_v_Left2.symbol_at ((0 + 1)))
                {
                  goto _continue1;
                }
                Expr _v_deref__Left2 (Expr (_v_Left2, 0));
                Expr _v_deref__Left22 (Expr (_v_Left2, (0 + 1)));
                int _v_len15 = _v_deref__Left22.get_len ();
                int _v_len16 = 0;
                if (_v_len15 < _v_len16)
                {
                  goto _continue1;
                }
                int _v_len__out2 = (_v_len15 - _v_len16);
                int _v_len17 = _v_deref__Left2.get_len ();
                int _v_len18 = 0;
                if (_v_len17 < _v_len18)
                {
                  goto _continue1;
                }
                int _v_len__in2 = (_v_len17 - _v_len18);
                Expr _ve_in;
                _ve_in = Expr (_v_deref__Left2, 0, _v_len__in2);
                Expr _ve_out;
                _ve_out = Expr (_v_deref__Left22, 0, _v_len__out2);
                Expr _ge_auxcall4;
                RF_CALL (org::refal::plus::compiler::rfp_format::Format_Exp, _ve_in, _ge_auxcall4);
                Expr _ge_auxcall5;
                RF_CALL (org::refal::plus::compiler::rfp_format::Format_Exp, _ve_out, _ge_auxcall5);
                _vs_tab = org::refal::plus::compiler::rfp_helper::Fun;
                _ve_ItemDef = (_ge_auxcall4 () + _ge_auxcall5 ());
                goto _block4;
              }
            _block4__branch2: {}
              {
                if (!_vs_ItemType.term_eq (_c_104, 0))
                {
                  goto _block4__branch3;
                }
                Expr _v_Left3;
                if (!RF_CALL (::refal::Access::Left, (_c_60, _c_102, _ve_ItemBody), _v_Left3))
                {
                  goto _continue1;
                }
                if (_v_Left3.get_len () != 2)
                {
                  goto _continue1;
                }
                if (_v_Left3.symbol_at (0))
                {
                  goto _continue1;
                }
                if (_v_Left3.symbol_at ((0 + 1)))
                {
                  goto _continue1;
                }
                Expr _v_deref__Left3 (Expr (_v_Left3, 0));
                Expr _v_deref__Left32 (Expr (_v_Left3, (0 + 1)));
                int _v_len19 = _v_deref__Left32.get_len ();
                int _v_len20 = 0;
                if (_v_len19 < _v_len20)
                {
                  goto _continue1;
                }
                int _v_len__out3 = (_v_len19 - _v_len20);
                int _v_len21 = _v_deref__Left3.get_len ();
                int _v_len22 = 0;
                if (_v_len21 < _v_len22)
                {
                  goto _continue1;
                }
                int _v_len__in3 = (_v_len21 - _v_len22);
                Expr _ve_in;
                _ve_in = Expr (_v_deref__Left3, 0, _v_len__in3);
                Expr _ve_out;
                _ve_out = Expr (_v_deref__Left32, 0, _v_len__out3);
                Expr _ge_auxcall6;
                RF_CALL (org::refal::plus::compiler::rfp_format::Format_Exp, _ve_in, _ge_auxcall6);
                Expr _ge_auxcall7;
                RF_CALL (org::refal::plus::compiler::rfp_format::Format_Exp, _ve_out, _ge_auxcall7);
                _vs_tab = org::refal::plus::compiler::rfp_helper::IsFun;
                _ve_ItemDef = (_ge_auxcall6 () + _ge_auxcall7 ());
                goto _block4;
              }
            _block4__branch3: {}
              {
                if (!_vs_ItemType.term_eq (_c_105, 0))
                {
                  goto _block4__branch4;
                }
                _vs_tab = org::refal::plus::compiler::rfp_helper::Const;
                _ve_ItemDef = _ve_ItemBody;
                goto _block4;
              }
            _block4__branch4: {}
              if (!_vs_ItemType.symbol_at (0))
              {
                RF_FUNC_ERROR (unexpected_fail);
              }
              Expr _vs__dollar_tmp_m_481_m_12;
              _vs__dollar_tmp_m_481_m_12 = Expr (_vs_ItemType, 0, 1);
              _vs_tab = org::refal::plus::compiler::rfp_helper::Object;
              _ve_ItemDef = _ve_ItemBody;
            }
          _block4: {}
            RF_CALL (::refal::Table::Bind, (_vs_tab, _vt_ItemName, (_vs_Linkage + _vs_ItemType + _ve_ItemDef)), /*void*/);
            goto _block2;
          }
        _block2__branch1: {}
          if (_vt_Item.symbol_at (0))
          {
            goto _continue1;
          }
          Expr _v_deref__Item2 (Expr (_vt_Item, 0));
          int _v_len23 = _v_deref__Item2.get_len ();
          int _v_len24 = 2;
          if (_v_len23 < _v_len24)
          {
            goto _continue1;
          }
          int _v_len__Pragma = (_v_len23 - _v_len24);
          if (!_c_106.term_eq (_v_deref__Item2, 0))
          {
            goto _continue1;
          }
          Expr _ve_Pragma;
          _ve_Pragma = Expr (_v_deref__Item2, (0 + 1), _v_len__Pragma);
          Expr _vt_FName;
          _vt_FName = Expr (_v_deref__Item2, (0 + 1 + _v_len__Pragma), 1);
          RF_CALL (::refal::Table::Bind, (org::refal::plus::compiler::rfp_helper::IsFun, _vt_FName, _c_107), /*void*/);
        }
      _block2: {}
      }
  _continue1: {}
    }
  _exit1: {}
  }
_block1__branch1: {}
  {
    {
      if (!RF_CALL (::refal::Table::IsInTable, (org::refal::plus::compiler::rfp_helper::RFP_Options, _c_108), /*void*/))
      {
        goto _block5__branch1;
      }
      RF_CALL (::refal::Table::Bind, (org::refal::plus::compiler::rfp_helper::IsFun, _c_109, _c_110), /*void*/);
      RF_TAILCALL (::refal::Table::Bind, (org::refal::plus::compiler::rfp_helper::Fun, _c_111, _c_112), /*void*/);
      goto _block5;
    }
  _block5__branch1: {}
  }
_block5: {}
RF_END

RF_FUNC (RFP_Pretty_Print, (RF_ARG _vs_channel, _ve_indent, _ve_expr;;), RF_VOID)
  {
    {
      if (_ve_expr.get_len () < 1)
      {
        goto _block1__branch1;
      }
      RF_lsplit (_ve_expr, 0, _ve_0, _v_lsplit__expr);
      for ( ; ; RF_iter(_ve_expr)++)
      {
        {
          if (!RF_iter(_ve_expr))
          {
            goto _block1__branch1;
          }
          int _v_len1 = _v_lsplit__expr.get_len ();
          int _v_len2 = 1;
          if (_v_len1 < _v_len2)
          {
            goto _block1__branch1;
          }
          int _v_len__2 = (_v_len1 - _v_len2);
          if (_v_lsplit__expr.symbol_at (0))
          {
            goto _continue1;
          }
          Expr _v_deref__lsplit__expr (Expr (_v_lsplit__expr, 0));
          int _v_len3 = _v_deref__lsplit__expr.get_len ();
          int _v_len4 = 0;
          if (_v_len3 < _v_len4)
          {
            goto _continue1;
          }
          int _v_len__1 = (_v_len3 - _v_len4);
          Expr _ve_2;
          _ve_2 = Expr (_v_lsplit__expr, (0 + 1), _v_len__2);
          Expr _ve_1;
          _ve_1 = Expr (_v_deref__lsplit__expr, 0, _v_len__1);
          RF_CALL (::refal::StdIO::WriteCh, (_vs_channel, _ve_0), /*void*/);
          {
            {
              int _v_len5 = _ve_indent.get_len ();
              int _v_len6 = 0;
              if (_v_len5 < (_v_len6 + 1))
              {
                goto _block2__branch1;
              }
              int _v_len___dollar_tmp_m_499_m_21 = (_v_len5 - _v_len6);
              Expr _vv__dollar_tmp_m_499_m_21;
              _vv__dollar_tmp_m_499_m_21 = Expr (_ve_indent, 0, _v_len___dollar_tmp_m_499_m_21);
              RF_CALL (::refal::StdIO::PrintLnCh, (_vs_channel, empty), /*void*/);
              goto _block2;
            }
          _block2__branch1: {}
          }
        _block2: {}
          RF_CALL (::refal::StdIO::PrintCh, (_vs_channel, (_ve_indent + _c_113)), /*void*/);
          RF_CALL (RFP_Pretty_Print, (_vs_channel, (_ve_indent + _c_114), _ve_1), /*void*/);
          {
            {
              if (_v_len__1 < 1)
              {
                goto _block3__branch1;
              }
              RF_lsplit (_ve_1, 0, _ve__dollar_tmp_m_503_m_15, _v_lsplit__1);
              for ( ; ; RF_iter(_ve_1)++)
              {
                {
                  if (!RF_iter(_ve_1))
                  {
                    goto _block3__branch1;
                  }
                  int _v_len7 = _v_lsplit__1.get_len ();
                  int _v_len8 = 1;
                  if (_v_len7 < _v_len8)
                  {
                    goto _block3__branch1;
                  }
                  int _v_len___dollar_tmp_m_503_m_21 = (_v_len7 - _v_len8);
                  if (_v_lsplit__1.symbol_at (0))
                  {
                    goto _continue2;
                  }
                  Expr _v_deref__lsplit__1 (Expr (_v_lsplit__1, 0));
                  int _v_len9 = _v_deref__lsplit__1.get_len ();
                  int _v_len10 = 0;
                  if (_v_len9 < _v_len10)
                  {
                    goto _continue2;
                  }
                  int _v_len___dollar_tmp_m_503_m_18 = (_v_len9 - _v_len10);
                  Expr _ve__dollar_tmp_m_503_m_21;
                  _ve__dollar_tmp_m_503_m_21 = Expr (_v_lsplit__1, (0 + 1), _v_len___dollar_tmp_m_503_m_21);
                  Expr _ve__dollar_tmp_m_503_m_18;
                  _ve__dollar_tmp_m_503_m_18 = Expr (_v_deref__lsplit__1, 0, _v_len___dollar_tmp_m_503_m_18);
                  RF_CALL (::refal::StdIO::PrintLnCh, (_vs_channel, empty), /*void*/);
                  RF_CALL (::refal::StdIO::PrintCh, (_vs_channel, (_ve_indent + _c_115)), /*void*/);
                  goto _exit2;
                }
            _continue2: {}
              }
            _exit2: {}
              goto _block3;
            }
          _block3__branch1: {}
            RF_CALL (::refal::StdIO::PrintCh, (_vs_channel, _c_115), /*void*/);
          }
        _block3: {}
          {
            {
              int _v_len11 = _v_len__2;
              int _v_len12 = 1;
              if (_v_len11 < _v_len12)
              {
                goto _block4__branch1;
              }
              int _v_len___dollar_tmp_m_509_m_19 = (_v_len11 - _v_len12);
              if (_ve_2.symbol_at (0))
              {
                goto _block4__branch1;
              }
              Expr _v_deref__2 (Expr (_ve_2, 0));
              int _v_len13 = _v_deref__2.get_len ();
              int _v_len14 = 0;
              if (_v_len13 < _v_len14)
              {
                goto _block4__branch1;
              }
              int _v_len___dollar_tmp_m_509_m_16 = (_v_len13 - _v_len14);
              Expr _ve__dollar_tmp_m_509_m_19;
              _ve__dollar_tmp_m_509_m_19 = Expr (_ve_2, (0 + 1), _v_len___dollar_tmp_m_509_m_19);
              Expr _ve__dollar_tmp_m_509_m_16;
              _ve__dollar_tmp_m_509_m_16 = Expr (_v_deref__2, 0, _v_len___dollar_tmp_m_509_m_16);
              goto _block4;
            }
          _block4__branch1: {}
            {
              if (_v_len__2 != 0)
              {
                goto _block4__branch2;
              }
              int _v_len15 = _ve_indent.get_len ();
              int _v_len16 = 0;
              if (_v_len15 < (_v_len16 + 1))
              {
                goto _block4__branch2;
              }
              int _v_len___dollar_tmp_m_510_m_28 = (_v_len15 - _v_len16);
              Expr _vv__dollar_tmp_m_510_m_28;
              _vv__dollar_tmp_m_510_m_28 = Expr (_ve_indent, 0, _v_len___dollar_tmp_m_510_m_28);
              goto _block4;
            }
          _block4__branch2: {}
            RF_CALL (::refal::StdIO::PrintLnCh, (_vs_channel, empty), /*void*/);
            RF_CALL (::refal::StdIO::PrintCh, (_vs_channel, _ve_indent), /*void*/);
          }
        _block4: {}
          RF_TAILCALL (RFP_Pretty_Print, (_vs_channel, _ve_indent, _ve_2), /*void*/);
          goto _exit1;
        }
    _continue1: {}
      }
    _exit1: {}
      goto _block1;
    }
  _block1__branch1: {}
    {
      int _v_len17 = _ve_expr.get_len ();
      int _v_len18 = 0;
      if (_v_len17 < (_v_len18 + 1))
      {
        goto _block1__branch2;
      }
      int _v_len__12 = (_v_len17 - _v_len18);
      Expr _vv_1;
      _vv_1 = Expr (_ve_expr, 0, _v_len__12);
      RF_TAILCALL (::refal::StdIO::WriteCh, (_vs_channel, _vv_1), /*void*/);
      goto _block1;
    }
  _block1__branch2: {}
    if (_ve_expr.get_len () != 0)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
  }
_block1: {}
RF_END

RF_FUNC (CPP_Pretty_Print, (RF_ARG _vs_Isinner__call, _vs_channel, _ve_indent, _ve_expr;;), RF_VOID)
  {
    {
      if (_ve_expr.get_len () < 1)
      {
        goto _block1__branch1;
      }
      RF_lsplit (_ve_expr, 0, _ve_0, _v_lsplit__expr);
      for ( ; ; RF_iter(_ve_expr)++)
      {
        {
          if (!RF_iter(_ve_expr))
          {
            goto _block1__branch1;
          }
          int _v_len1 = _v_lsplit__expr.get_len ();
          int _v_len2 = 1;
          if (_v_len1 < _v_len2)
          {
            goto _block1__branch1;
          }
          int _v_len__2 = (_v_len1 - _v_len2);
          if (_v_lsplit__expr.symbol_at (0))
          {
            goto _continue1;
          }
          Expr _v_deref__lsplit__expr (Expr (_v_lsplit__expr, 0));
          int _v_len3 = _v_deref__lsplit__expr.get_len ();
          int _v_len4 = 0;
          if (_v_len3 < _v_len4)
          {
            goto _continue1;
          }
          int _v_len__1 = (_v_len3 - _v_len4);
          Expr _ve_2;
          _ve_2 = Expr (_v_lsplit__expr, (0 + 1), _v_len__2);
          Expr _ve_1;
          _ve_1 = Expr (_v_deref__lsplit__expr, 0, _v_len__1);
          {
            {
              if (!_vs_Isinner__call.term_eq (_c_60, 0))
              {
                goto _block2__branch1;
              }
              RF_CALL (::refal::StdIO::PrintLnCh, (_vs_channel, empty), /*void*/);
              goto _block2;
            }
          _block2__branch1: {}
          }
        _block2: {}
          {
            {
              if (_ve_0.get_len () != 0)
              {
                goto _block3__branch1;
              }
              {
                {
                  int _v_len5 = _v_len__1;
                  int _v_len6 = 1;
                  if (_v_len5 < _v_len6)
                  {
                    goto _block4__branch1;
                  }
                  int _v_len__label = (_v_len5 - _v_len6);
                  if (!_c_116.term_eq (_ve_1, 0))
                  {
                    goto _block4__branch1;
                  }
                  Expr _ve_label;
                  _ve_label = Expr (_ve_1, (0 + 1), _v_len__label);
                  int _v_len7 = _ve_indent.get_len ();
                  int _v_len8 = 2;
                  if (_v_len7 < _v_len8)
                  {
                    RF_FUNC_ERROR (unexpected_fail);
                  }
                  int _v_len__ind = (_v_len7 - _v_len8);
                  if (!Tab.eq (_ve_indent, (0 + _v_len__ind)))
                  {
                    RF_FUNC_ERROR (unexpected_fail);
                  }
                  Expr _ve_ind;
                  _ve_ind = Expr (_ve_indent, 0, _v_len__ind);
                  RF_CALL (::refal::StdIO::PrintLnCh, (_vs_channel, (_ve_ind + _ve_label)), /*void*/);
                  goto _block4;
                }
              _block4__branch1: {}
                {
                  if (_v_len__1 != 0)
                  {
                    goto _block4__branch2;
                  }
                  RF_CALL (::refal::StdIO::PrintLnCh, (_vs_channel, empty), /*void*/);
                  goto _block4;
                }
              _block4__branch2: {}
                RF_CALL (CPP_Pretty_Print, (_c_3, _vs_channel, _ve_indent, _ve_1), /*void*/);
              }
            _block4: {}
              goto _block3;
            }
          _block3__branch1: {}
            RF_CALL (::refal::StdIO::PrintLnCh, (_vs_channel, (_ve_indent + _ve_0)), /*void*/);
            RF_CALL (CPP_Pretty_Print, (_c_3, _vs_channel, (_ve_indent + Tab), _ve_1 ()), /*void*/);
          }
        _block3: {}
          RF_TAILCALL (CPP_Pretty_Print, (_vs_Isinner__call, _vs_channel, _ve_indent, _ve_2), /*void*/);
          goto _exit1;
        }
    _continue1: {}
      }
    _exit1: {}
      goto _block1;
    }
  _block1__branch1: {}
    {
      int _v_len9 = _ve_expr.get_len ();
      int _v_len10 = 0;
      if (_v_len9 < (_v_len10 + 1))
      {
        goto _block1__branch2;
      }
      int _v_len__12 = (_v_len9 - _v_len10);
      Expr _vv_1;
      _vv_1 = Expr (_ve_expr, 0, _v_len__12);
      RF_TAILCALL (::refal::StdIO::PrintLnCh, (_vs_channel, (_ve_indent + _vv_1)), /*void*/);
      goto _block1;
    }
  _block1__branch2: {}
    if (_ve_expr.get_len () != 0)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
  }
_block1: {}
RF_END

RF_FUNC (Verbose, (RF_ARG _ve_string;;), RF_VOID)
  {
    {
      if (!RF_CALL (::refal::Table::IsInTable, (org::refal::plus::compiler::rfp_helper::RFP_Options, _c_117), /*void*/))
      {
        goto _block1__branch1;
      }
      Expr _ge_auxcall1;
      RF_CALL (::refal::Dos::Time, /*void*/, _ge_auxcall1);
      RF_TAILCALL (::refal::StdIO::PrintLn, (_ge_auxcall1 + _c_25 + _ve_string), /*void*/);
      goto _block1;
    }
  _block1__branch1: {}
  }
_block1: {}
RF_END

RF_FUNC (Open_Channel, (RF_ARG _ge_arg1, _ge_arg2;;), (RF_RES _v_res1, _v_res2;;))
  {
    {
      if ((_ge_arg1.get_len () + 1) != 2)
      {
        goto _block1__branch1;
      }
      Expr _v_compose1 ((_ge_arg1 + _ge_arg2 ()));
      if (_v_compose1.symbol_at ((0 + 1)))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__compose1 (Expr (_v_compose1, (0 + 1)));
      int _v_len1 = _v_deref__compose1.get_len ();
      int _v_len2 = 0;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      int _v_len___dollar_tmp_m_547_m_12 = (_v_len1 - _v_len2);
      if (!_v_compose1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _vs_ymbol;
      _vs_ymbol = Expr (_v_compose1, 0, 1);
      Expr _ve__dollar_tmp_m_547_m_12;
      _ve__dollar_tmp_m_547_m_12 = Expr (_v_deref__compose1, 0, _v_len___dollar_tmp_m_547_m_12);
      if (!RF_CALL (::refal::Class::IsChannel, _vs_ymbol, /*void*/))
      {
        goto _block1__branch1;
      }
      _v_res1 = _vs_ymbol;
      _v_res2 = _c_60;
      goto _block1;
    }
  _block1__branch1: {}
    Expr _vs_channel;
    RF_CALL (::refal::StdIO::Channel, /*void*/, _vs_channel);
    {
      {
        if (!RF_CALL (::refal::StdIO::OpenFile, (_vs_channel, (_ge_arg1 + _ge_arg2), _c_118), /*void*/))
        {
          goto _block2__branch1;
        }
        _v_res1 = _vs_channel;
        _v_res2 = _c_3;
        goto _block2;
      }
    _block2__branch1: {}
      RF_CALL (::refal::StdIO::PrintLnCh, (::refal::StdIO::StdErr, (_c_120 + _ge_arg1 + _ge_arg2 + _c_119)), /*void*/);
      RF_CALL (::refal::Dos::Exit, _c_3, /*void*/);
      RF_FUNC_ERROR (unexpected_fail);
    }
  _block2: {}
  }
_block1: {}
RF_END

RF_FUNC (Compilation_Failed, RF_VOID, RF_VOID)
  RF_TAILCALL (::refal::Dos::Exit, _c_3, /*void*/);
RF_END

RF_FUNC (Version, RF_VOID, (RF_RES _v_res1;;))
  {
    {
      if (RevDate.symbol_at (0))
      {
        goto _block1__branch1;
      }
      if (RevDate.symbol_at ((0 + 1)))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__RevDate (Expr (RevDate, 0));
      Expr _v_deref__RevDate2 (Expr (RevDate, (0 + 1)));
      if (_v_deref__RevDate2.get_len () < 3)
      {
        goto _block1__branch1;
      }
      if (_v_deref__RevDate2.get_len () > ((_v_deref__RevDate2.get_len () - 3) + (_v_deref__RevDate2.get_len () - 2) + (_v_deref__RevDate2.get_len () - 3) + 2))
      {
        goto _block1__branch1;
      }
      if (_v_deref__RevDate.get_len () < 3)
      {
        goto _block1__branch1;
      }
      if (_v_deref__RevDate.get_len () > ((_v_deref__RevDate.get_len () - 3) + (_v_deref__RevDate.get_len () - 2) + (_v_deref__RevDate.get_len () - 3) + 2))
      {
        goto _block1__branch1;
      }
      RF_lsplit (_v_deref__RevDate, 0, _ve__dollar_tmp_m_561_m_16, _v_lsplit__deref__RevDate);
      for ( ; ; RF_iter(_v_deref__RevDate)++)
      {
        {
          if (!RF_iter(_v_deref__RevDate))
          {
            goto _block1__branch1;
          }
          if (_v_lsplit__deref__RevDate.get_len () < 3)
          {
            goto _block1__branch1;
          }
          if (!_c_13.term_eq (_v_lsplit__deref__RevDate, 0))
          {
            goto _continue1;
          }
          Expr _v_subexpr__lsplit__deref__RevDate (Expr (_v_lsplit__deref__RevDate, (0 + 1), (_v_lsplit__deref__RevDate.get_len () - (0 + 1 + 0))));
          RF_lsplit (_v_subexpr__lsplit__deref__RevDate, 1, _vv_rev, _v_lsplit__lsplit__deref__RevDate);
          for ( ; ; RF_iter(_v_subexpr__lsplit__deref__RevDate)++)
          {
            {
              if (!RF_iter(_v_subexpr__lsplit__deref__RevDate))
              {
                goto _continue1;
              }
              int _v_len1 = _v_lsplit__lsplit__deref__RevDate.get_len ();
              int _v_len2 = 1;
              if (_v_len1 < _v_len2)
              {
                goto _continue1;
              }
              int _v_len___dollar_tmp_m_561_m_32 = (_v_len1 - _v_len2);
              if (!_c_13.term_eq (_v_lsplit__lsplit__deref__RevDate, 0))
              {
                goto _continue2;
              }
              Expr _ve__dollar_tmp_m_561_m_32;
              _ve__dollar_tmp_m_561_m_32 = Expr (_v_lsplit__lsplit__deref__RevDate, (0 + 1), _v_len___dollar_tmp_m_561_m_32);
              RF_lsplit (_v_deref__RevDate2, 0, _ve__dollar_tmp_m_561_m_36, _v_lsplit__deref__RevDate2);
              for ( ; ; RF_iter(_v_deref__RevDate2)++)
              {
                {
                  if (!RF_iter(_v_deref__RevDate2))
                  {
                    goto _continue2;
                  }
                  if (_v_lsplit__deref__RevDate2.get_len () < 3)
                  {
                    goto _continue2;
                  }
                  if (!_c_13.term_eq (_v_lsplit__deref__RevDate2, 0))
                  {
                    goto _continue3;
                  }
                  Expr _v_subexpr__lsplit__deref__RevDate2 (Expr (_v_lsplit__deref__RevDate2, (0 + 1), (_v_lsplit__deref__RevDate2.get_len () - (0 + 1 + 0))));
                  RF_lsplit (_v_subexpr__lsplit__deref__RevDate2, 1, _vv_date, _v_lsplit__lsplit__deref__RevDate2);
                  for ( ; ; RF_iter(_v_subexpr__lsplit__deref__RevDate2)++)
                  {
                    {
                      if (!RF_iter(_v_subexpr__lsplit__deref__RevDate2))
                      {
                        goto _continue3;
                      }
                      int _v_len3 = _v_lsplit__lsplit__deref__RevDate2.get_len ();
                      int _v_len4 = 1;
                      if (_v_len3 < _v_len4)
                      {
                        goto _continue3;
                      }
                      int _v_len___dollar_tmp_m_561_m_53 = (_v_len3 - _v_len4);
                      if (!_c_13.term_eq (_v_lsplit__lsplit__deref__RevDate2, 0))
                      {
                        goto _continue4;
                      }
                      Expr _ve__dollar_tmp_m_561_m_53;
                      _ve__dollar_tmp_m_561_m_53 = Expr (_v_lsplit__lsplit__deref__RevDate2, (0 + 1), _v_len___dollar_tmp_m_561_m_53);
                      _v_res1 = (_c_122 + _vv_rev + _c_121 + _vv_date);
                      goto _exit4;
                    }
                _continue4: {}
                  }
                _exit4: {}
                  goto _exit3;
                }
            _continue3: {}
              }
            _exit3: {}
              goto _exit2;
            }
        _continue2: {}
          }
        _exit2: {}
          goto _exit1;
        }
    _continue1: {}
      }
    _exit1: {}
      goto _block1;
    }
  _block1__branch1: {}
    _v_res1 = _c_123;
  }
_block1: {}
RF_END

RF_FUNC (Append_0, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  int _v_len1 = _ge_arg1.get_len ();
  int _v_len2 = 1;
  if (_v_len1 < _v_len2)
  {
    RF_ERROR (_c_124);
  }
  int _v_len__stub1 = (_v_len1 - _v_len2);
  if (_ge_arg1.symbol_at (0))
  {
    RF_ERROR (_c_124);
  }
  Expr _v_deref__arg1 (Expr (_ge_arg1, 0));
  int _v_len3 = _v_deref__arg1.get_len ();
  int _v_len4 = 0;
  if (_v_len3 < _v_len4)
  {
    RF_ERROR (_c_124);
  }
  int _v_len__stub2 = (_v_len3 - _v_len4);
  Expr _v_stub1;
  _v_stub1 = Expr (_ge_arg1, (0 + 1), _v_len__stub1);
  Expr _v_stub2;
  _v_stub2 = Expr (_v_deref__arg1, 0, _v_len__stub2);
  RF_TAILCALL (::refal::List::Append, (_v_stub2, _v_stub1), _v_res1);
RF_END

RF_FUNC (IsInTable_0, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  int _v_len1 = _ge_arg1.get_len ();
  int _v_len2 = 1;
  if (_v_len1 < _v_len2)
  {
    RF_ERROR (_c_124);
  }
  int _v_len__stub1 = (_v_len1 - _v_len2);
  if (!_ge_arg1.symbol_at (0))
  {
    RF_ERROR (_c_124);
  }
  Expr _v_stub2;
  _v_stub2 = Expr (_ge_arg1, 0, 1);
  Expr _v_stub1;
  _v_stub1 = Expr (_ge_arg1, (0 + 1), _v_len__stub1);
  if (!RF_CALL (::refal::Table::IsInTable, (_v_stub2, _v_stub1), /*void*/))
  {
    RF_RETFAIL;
  }
  _v_res1 = empty;
RF_END

}

}

}

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfpc {

static void init_ () {
  RFP_Root = rftype::Char::create_expr (L"/usr");
  RFP_Default_Boot_Path = (Char::create_expr ("/usr//lib/refal-plus")) ();
  RFP_Boot_Path = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"RFP_Boot_Path");
  RFP_Include_Path = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"RFP_Include_Path");
  RFP_Trace = new rftype::StaticObject<rftype::Table>(L"RFP_Trace");
  RFP_Includes = new rftype::StaticObject<rftype::Table>(L"RFP_Includes");
  RevDate = (rftype::Char::create_expr (L"$Revision: 3864 $")) () + (rftype::Char::create_expr ("$Date: 2008-07-23 15:34:11 +0400 (Срд, 23 Июл 2008) $")) ();
  Options = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Options");
  Tab = rftype::Char::create_expr (L"  ");
  _c_125 = Expr::create<rftype::Word>("BIND") + Expr::create<rftype::Word>("NO-OPTIM");
  _c_0 = Expr (_c_125, 1, 1);
  _c_14 = rftype::Char::create_expr (L" file ...");
  _c_1 = Expr (_c_14, 6, 1);
  _c_2 = Expr::create<rftype::Word>("True");
  _c_3 = Expr::create<rftype::Integer>("1");
  _c_126 = rftype::Char::create_expr (L"no-check");
  _c_127 = Expr (_c_126, 3, 5);
  _c_128 = rftype::Char::create_expr (L"help");
  _c_129 = ((Expr (_c_127, 1, 1)) () + (_c_128) ()) () + Expr::create<rftype::Word>("HELP");
  _c_4 = Expr (_c_129, 1, 1);
  _c_5 = rftype::Char::create_expr (L"Refal+ compiler ");
  _c_6 = rftype::Char::create_expr (L"Usage: rfpc");
  _c_7 = Expr::create<rftype::Integer>("3");
  _c_8 = rftype::Char::create_expr (L">]");
  _c_9 = rftype::Char::create_expr (L" <");
  _c_10 = rftype::Char::create_expr (L" [-");
  _c_11 = Expr (_c_8, 1, 1);
  _c_12 = Expr::create<rftype::Integer>("64");
  _c_13 = Expr (_c_10, 0, 1);
  _c_15 = rftype::Char::create_expr (L"No input files specified");
  _c_16 = Expr (_c_14, 5, 2);
  _c_130 = rftype::Char::create_expr (L"comp-item");
  _c_131 = Expr (_c_130, 0, 2);
  _c_132 = ((Expr (_c_131, 1, 1)) ()) () + Expr::create<rftype::Word>("NAME") + (Expr::create<rftype::Word>("name| - ")) () + Expr::create<rftype::Word>("place outputs for file1 into files <name>.* or send") + Expr::create<rftype::Word>("them to stdout");
  _c_17 = Expr (_c_132, 1, 1);
  _c_19 = rftype::Char::create_expr (L" .rfi");
  _c_18 = Expr (_c_19, 0, 4);
  _c_20 = Expr::create<rftype::Word>(": parsing started");
  _c_21 = Expr::create<rftype::Word>("Compilation-Failed!");
  _c_22 = Expr::create<rftype::Word>("ERROR");
  _c_23 = Expr::create<rftype::Word>(" --- Error: ");
  _c_24 = Expr::create<rftype::Word>(", ");
  _c_25 = Expr::create<rftype::Word>(": ");
  _c_26 = Expr::create<rftype::Word>(" ");
  _c_27 = Expr::create<rftype::Word>("WARNING");
  _c_28 = Expr::create<rftype::Word>(" --- Warning: ");
  _c_29 = Expr::create<rftype::Word>(": parsing finished");
  _c_133 = Expr::create<rftype::Word>("BIND") + Expr::create<rftype::Word>("AS-REFAL");
  _c_30 = Expr (_c_133, 1, 1);
  _c_31 = rftype::Char::create_expr (L" .asr");
  _c_32 = Expr::create<rftype::Word>("R");
  _c_33 = rftype::Char::create_expr (L" .ast");
  _c_45 = Expr::create<rftype::Word>("CC") + Expr::create<rftype::Word>("HH") + Expr::create<rftype::Word>("TPP") + Expr::create<rftype::Word>("JAVA") + Expr::create<rftype::Word>("JBC") + Expr::create<rftype::Word>("AS-AIL") + Expr::create<rftype::Word>("AS-TRANSFORMED");
  _c_34 = Expr (_c_45, 6, 1);
  _c_35 = rftype::Char::create_expr (L" .asi");
  _c_36 = Expr::create<rftype::Word>("AS-AIL") + Expr::create<rftype::Word>("AS-AIL");
  _c_37 = Expr (_c_36, 0, 1);
  _c_38 = Expr::create<rftype::Word>(" in ");
  _c_39 = Expr::create<rftype::Word>("Error: unknown extension");
  _c_40 = Expr (_c_31, 1, 4);
  _c_134 = Expr::create<rftype::Word>("BIND") + Expr::create<rftype::Word>("NO-CHECK");
  _c_41 = Expr (_c_134, 1, 1);
  _c_42 = Expr::create<rftype::Word>("syntax check started");
  _c_43 = Expr::create<rftype::Word>("syntax check finished");
  _c_44 = Expr::create_sym<rftype::Func> (IsInTable_0);
  _c_135 = Expr::create<rftype::Word>("BIND") + Expr::create<rftype::Word>("NO-TRANSFORM");
  _c_46 = Expr (_c_135, 1, 1);
  _c_47 = Expr::create<rftype::Word>("as-to-as transformation started");
  _c_48 = Expr::create<rftype::Word>("as-to-as transformation finished");
  _c_49 = Expr (_c_33, 1, 4);
  _c_50 = Expr (_c_45, 0, 6);
  _c_51 = Expr::create<rftype::Word>("compilation to abstract imperative language started");
  _c_52 = Expr::create<rftype::Word>("compilation to abstract imperative language finished");
  _c_53 = Expr::create<rftype::Word>("as-ail optimization started");
  _c_54 = Expr::create<rftype::Word>("as-ail optimization finished");
  _c_55 = Expr (_c_35, 1, 4);
  _c_56 = Expr (_c_50, 0, 1);
  _c_57 = Expr::create<rftype::Word>("compilation from as-ail to c++ started");
  _c_58 = Expr::create<rftype::Word>("compilation from as-ail to c++ finished");
  _c_59 = rftype::Char::create_expr (L".cc");
  _c_60 = Expr::create<rftype::Integer>("0");
  _c_61 = Expr (_c_50, 2, 1);
  _c_62 = Expr::create<rftype::Word>("compilation from as-ail to T++ started");
  _c_63 = Expr::create<rftype::Word>("compilation from as-ail to T++ finished");
  _c_64 = rftype::Char::create_expr (L".tpp");
  _c_65 = Expr (_c_50, 3, 1);
  _c_66 = Expr::create<rftype::Word>("compilation from as-ail to java started");
  _c_67 = rftype::Char::create_expr (L".java");
  _c_68 = Expr::create<rftype::Word>("compilation from as-ail to java finished");
  _c_69 = Expr (_c_50, 4, 1);
  _c_70 = Expr::create<rftype::Word>("compilation from as-ail to java-bytecode started");
  _c_71 = Expr::create<rftype::Word>(".class");
  _c_72 = Expr::create<rftype::Word>("compilation from as-ail to java-bytecode finished");
  _c_136 = Expr::create<rftype::Word>("dir");
  _c_137 = ((rftype::Char::create_expr (L"I")) () + (rftype::Char::create_expr (L"ipath")) ()) () + Expr::create<rftype::Word>("IPATH") + (_c_136) () + Expr::create<rftype::Word>("add <dir> to the list of directories to be searched") + Expr::create<rftype::Word>("for .rfi files");
  _c_138 = ((rftype::Char::create_expr (L"B")) () + (rftype::Char::create_expr (L"bootpath")) ()) () + Expr::create<rftype::Word>("BPATH") + (_c_136) () + Expr::create<rftype::Word>("add <dir> to the list of directories to be searched") + Expr::create<rftype::Word>("for standard library .rfi files");
  _c_139 = rftype::Char::create_expr (L"ne");
  _c_140 = rftype::Char::create_expr (L"nc");
  _c_141 = rftype::Char::create_expr (L"entry");
  _c_142 = Expr (_c_141, 1, 2);
  _c_143 = ((Expr (_c_15, 18, 2)) () + (_c_130) ()) () + Expr::create<rftype::Word>("COMP-ITEM") + (Expr::create<rftype::Word>("item")) () + Expr::create<rftype::Word>("compile <item> only, not the whole source") + Expr::create<rftype::Word>("(may be used several times)");
  _c_144 = ((Expr (_c_139, 1, 1)) () + (_c_141) ()) () + Expr::create<rftype::Word>("ENTRY") + (Expr::create<rftype::Word>("func")) () + Expr::create<rftype::Word>("use function <func> as an entry to the program");
  _c_145 = Expr::create<rftype::Word>("BIND") + Expr::create<rftype::Word>("VERBOSE");
  _c_146 = ((Expr (_c_128, 3, 1)) () + (rftype::Char::create_expr (L"package")) ()) () + Expr::create<rftype::Word>("PACKAGE") + (Expr::create<rftype::Word>("pack")) () + Expr::create<rftype::Word>("place output in package <pack>");
  _c_147 = Expr::create<rftype::Word>("BIND") + Expr::create<rftype::Word>("HH");
  _c_148 = Expr::create<rftype::Word>("BIND") + Expr::create<rftype::Word>("AS-AIL");
  _c_149 = ((rftype::Char::create_expr (L"int")) ()) () + Expr::create<rftype::Word>("INT") + (Expr::create<rftype::Word>("class_name")) () + Expr::create<rftype::Word>("class to use for literal integers");
  _c_150 = rftype::Char::create_expr (L"replace-module");
  _c_151 = ((_c_150) ()) () + Expr::create<rftype::Word>("REPLACE-MODULE") + (Expr::create<rftype::Word>("m1") + Expr::create<rftype::Word>("m2")) () + Expr::create<rftype::Word>("use module <m2> instead of <m1>");
  _c_152 = Expr::create<rftype::Word>("BIND") + Expr::create<rftype::Word>("DBG");
  _c_153 = rftype::Char::create_expr (L"traceall");
  _c_154 = ((Expr (_c_153, 0, 5)) ()) () + Expr::create<rftype::Word>("TRACE") + (Expr::create<rftype::Word>("fname")) () + Expr::create<rftype::Word>("trace function <fname> (may be used several times)");
  _c_73 = (_c_137) () + (_c_138) () + (((_c_139) () + (rftype::Char::create_expr (L"no-elaborate")) ()) () + (Expr::create<rftype::Word>("BIND") + Expr::create<rftype::Word>("NO-ELABORATE")) ()) () + (((_c_140) () + (_c_126) ()) () + (_c_134) () + Expr::create<rftype::Word>("don't perform syntax check")) () + (((_c_142) () + (rftype::Char::create_expr (L"no-transform")) ()) () + (_c_135) () + Expr::create<rftype::Word>("don't perform AS-to-AS transformations")) () + (((Expr (_c_140, 1, 1)) () + (_c_127) ()) () + (Expr::create<rftype::Word>("BIND") + Expr::create<rftype::Word>("CHECK")) () + Expr::create<rftype::Word>("check only, causes no file creation in the absence") + Expr::create<rftype::Word>("of other output control options")) () + (((Expr (_c_126, 0, 2)) () + (rftype::Char::create_expr (L"no-optim")) ()) () + (_c_125) () + Expr::create<rftype::Word>("don't perform ASAIL-optimization")) () + (_c_143) () + (_c_144) () + (_c_129) () + (((Expr (_c_67, 3, 1)) () + (rftype::Char::create_expr (L"verbose")) ()) () + (_c_145) () + Expr::create<rftype::Word>("display information about the stages of compilation")) () + (((Expr (_c_15, 6, 1)) ()) () + (Expr::create<rftype::Word>("BIND") + Expr::create<rftype::Word>("CASE-INSENSITIVE")) () + Expr::create<rftype::Word>("convert all symbol-words without surrounding quotes") + Expr::create<rftype::Word>("to upper case")) () + (((_c_131) ()) () + (Expr::create<rftype::Word>("BIND") + Expr::create<rftype::Word>("IDENT-COMPATIBILITY")) () + Expr::create<rftype::Word>("compatibility mode: assume old-style identificator names")) () + (_c_132) () + (_c_146) () + (((Expr (_c_59, 1, 2)) ()) () + (Expr::create<rftype::Word>("BIND") + Expr::create<rftype::Word>("CC")) () + Expr::create<rftype::Word>("output C++ code")) () + (((rftype::Char::create_expr (L"hh")) ()) () + (_c_147) () + Expr::create<rftype::Word>("generate header files")) () + (((Expr (_c_67, 1, 1)) () + (Expr (_c_67, 1, 4)) ()) () + (Expr::create<rftype::Word>("BIND") + Expr::create<rftype::Word>("JAVA")) () + Expr::create<rftype::Word>("output Java code")) () + (((rftype::Char::create_expr (L"jbc")) ()) () + (Expr::create<rftype::Word>("BIND") + Expr::create<rftype::Word>("JBC")) () + Expr::create<rftype::Word>("output Java byte-code")) () + (((Expr (_c_142, 1, 1)) () + (rftype::Char::create_expr (L"t++")) ()) () + (Expr::create<rftype::Word>("BIND") + Expr::create<rftype::Word>("TPP")) () + Expr::create<rftype::Word>("output T++ code")) () + (((Expr (_c_31, 2, 3)) () + (rftype::Char::create_expr (L"as-refal")) ()) () + (_c_133) () + Expr::create<rftype::Word>("output Refal Abstract Syntax")) () + (((Expr (_c_49, 1, 3)) () + (rftype::Char::create_expr (L"as-transformed")) ()) () + (Expr::create<rftype::Word>("BIND") + Expr::create<rftype::Word>("AS-TRANSFORMED")) () + Expr::create<rftype::Word>("output Refal Abstract Syntax after AS-to-AS") + Expr::create<rftype::Word>("transformations")) () + (((Expr (_c_55, 1, 3)) () + (rftype::Char::create_expr (L"as-ail")) ()) () + (_c_148) () + Expr::create<rftype::Word>("output Abstract Syntax of Abstract Imperative") + Expr::create<rftype::Word>("Language")) () + (_c_149) () + (_c_151) () + (((Expr (_c_150, 10, 1)) () + (rftype::Char::create_expr (L"debug")) ()) () + (Expr::create<rftype::Word>("BIND") + Expr::create<rftype::Word>("DEBUG")) ()) () + (((rftype::Char::create_expr (L"dbg")) ()) () + (_c_152) () + Expr::create<rftype::Word>("generate text for debugger")) () + (_c_154) () + (((_c_153) ()) () + (Expr::create<rftype::Word>("BIND") + Expr::create<rftype::Word>("TRACEALL")) () + Expr::create<rftype::Word>("trace all functions")) ();
  _c_74 = Expr::create<rftype::Integer>("29");
  _c_75 = Expr::create<rftype::Word>("Refal+ compiler ");
  _c_76 = Expr::create<rftype::Word>("Copyright blah-blah-blah");
  _c_77 = Expr::create<rftype::Word>("Usage: rfpc [options] file1 [file2 ...]");
  _c_78 = Expr::create<rftype::Word>("Options:");
  _c_79 = Expr (_c_10, 2, 1);
  _c_80 = rftype::Char::create_expr (L", -");
  _c_81 = Expr (_c_8, 0, 1);
  _c_82 = Expr (_c_137, 1, 1);
  _c_83 = Expr (_c_138, 1, 1);
  _c_84 = Expr (_c_143, 1, 1);
  _c_85 = Expr::create<rftype::Word>("ITEMS");
  _c_86 = Expr (_c_144, 1, 1);
  _c_87 = Expr::create<rftype::Word>("ENTRIES");
  _c_88 = Expr (_c_154, 1, 1);
  _c_89 = Expr (_c_146, 1, 1);
  _c_90 = Expr (_c_149, 1, 1);
  _c_91 = Expr (_c_151, 1, 1);
  _c_92 = Expr::create<rftype::Word>("REPLACE-MODULE-2");
  _c_93 = Expr (_c_148, 0, 1);
  _c_94 = Expr::create<rftype::Word>("\"");
  _c_95 = Expr::create<rftype::Word>("Unknown option \"-");
  _c_96 = Expr::create<rftype::Word>("Last option requires parameter");
  _c_97 = Expr::create<rftype::Word>("CC") + Expr::create<rftype::Word>("HH") + Expr::create<rftype::Word>("TPP") + Expr::create<rftype::Word>("JAVA") + Expr::create<rftype::Word>("JBC") + Expr::create<rftype::Word>("AS-REFAL") + Expr::create<rftype::Word>("AS-TRANSFORMED") + Expr::create<rftype::Word>("AS-AIL") + Expr::create<rftype::Word>("CHECK");
  _c_98 = Expr (_c_147, 1, 1);
  _c_99 = Expr::create_sym<rftype::Func> (Append_0);
  _c_100 = Expr::create<rftype::Word>("PRAGMA");
  _c_155 = (Expr::create<rftype::Word>("EVAR")) ();
  _c_112 = Expr::create<rftype::Word>("IMPORT") + Expr::create<rftype::Word>("FUNC") + (_c_155) () + (empty) ();
  _c_101 = Expr (_c_112, 1, 1);
  _c_102 = Expr::create<rftype::Integer>("2");
  _c_103 = Expr::create<rftype::Word>("TFUNC");
  _c_107 = Expr::create<rftype::Word>("IMPORT") + Expr::create<rftype::Word>("FUNC?") + (_c_155) () + (_c_155) ();
  _c_104 = Expr (_c_107, 1, 1);
  _c_105 = Expr::create<rftype::Word>("CONST");
  _c_106 = Expr::create<rftype::Word>("EXTERN");
  _c_108 = Expr (_c_152, 1, 1);
  _c_109 = (Expr::create<rftype::Word>("refal") + Expr::create<rftype::Word>("Debug") + Expr::create<rftype::Word>("ShouldStop")) ();
  _c_110 = Expr::create<rftype::Word>("IMPORT") + Expr::create<rftype::Word>("FUNC?") + (_c_155) () + (empty) ();
  _c_111 = (Expr::create<rftype::Word>("refal") + Expr::create<rftype::Word>("Debug") + Expr::create<rftype::Word>("Debug")) ();
  _c_113 = rftype::Char::create_expr (L"(");
  _c_114 = rftype::Char::create_expr (L"  ");
  _c_115 = rftype::Char::create_expr (L")");
  _c_116 = Expr::create<rftype::Word>("LABEL");
  _c_117 = Expr (_c_145, 1, 1);
  _c_118 = Expr::create<rftype::Word>("W");
  _c_119 = Expr::create<rftype::Word>(" for writing");
  _c_120 = Expr::create<rftype::Word>("Error: cannot open file ");
  _c_121 = Expr (_c_80, 0, 2);
  _c_122 = rftype::Char::create_expr (L"2.0-beta-");
  _c_123 = rftype::Char::create_expr (L"2.0-unknown-beta");
  _c_124 = Expr::create<rftype::Word>("Apply") + Expr::create<rftype::Word>("Apply") + Expr::create<rftype::Word>("Unexpected fail");
}

static AtStart init_registrator_ (&init_);

}

}

}

}

}

rfrt::Entry rf_entry (org::refal::plus::compiler::rfpc::Main);
