// $Source$
// $Revision: 2187 $
// $Date: 2006-12-15 03:17:56 +0300 (Пт, 15 дек 2006) $
// $Author: orlov $

#include <rf_core.hh>
namespace refal
{

using namespace rfrt;
using namespace rftype;

namespace Access 
{

RF_FUNC (R, (RF_ARG s_Right, e_Exp;;), (RF_RES t_SubExp;;))

  Term* p_Right = s_Right.get_first();
  size_t right = 0; 
  if (p_Right->get_type() == type_int32)
  {
    intptr_t r = static_cast<Int32*>(p_Right)->to_int();
    if (r < 0 || uintptr_t(r) > SIZE_MAX)
      RF_LIB_ERROR("Invalid argument");
    right = r;
  }
  else
  if (p_Right->get_type() == type_int)
  {
    Integer* Right = static_cast<Integer*>(p_Right);
    if (Right->cmp(0) < 0 || Right->cmp(SIZE_MAX) > 0) 
      RF_LIB_ERROR("Invalid argument");
    else {
      intptr_t r = Right->to_int();
      right = r;
    }
  }
  else 
    RF_LIB_ERROR("Invalid argument");

  if (e_Exp.get_len() == 0 || right > e_Exp.get_len() - 1)
    RF_RETFAIL;

  t_SubExp = Expr(e_Exp,  e_Exp.get_len() - right - 1, 1);


RF_END
}
}

