#include <rf_core.hh>

using namespace rfrt;

namespace refal
{

namespace Apply
{

RF_DECL(Apply);

RF_FUNC (Apply, (RF_ARG _func, _arg;;), (RF_RES _res;;))
  assert (_func.get_len() == 1);
  Term* t = _func.get_first();
  if (t->is_instance_of<Func>())
  {
    RF_TAILCALL(t->get_obj_ptr<Func>(), _arg, _res)
  }
  if (t->is_instance_of<Closure>())
  {
    RF_TAILAPPLY(t->get_obj_ptr<Closure>(), _arg, _res)
  }
  RF_LIB_ERROR("Invalid argument");
RF_END

}
}
