#include <rf_core.hh>

namespace refal
{

using namespace rfrt;

namespace Box
{

RF_FUNC (Get, (RF_ARG _box;;), (RF_RES _expr;;))
  assert(_box.get_len() == 1);
  Term* t = _box.get_first();
  if (t->is_instance_of<BoxContents>()) {
    _expr = *(t->get_obj_ptr<BoxContents>());
  } else {
    RF_LIB_ERROR(L"Invalid argument");
  }
RF_END

}

}
