#include <rf_core.hh>

namespace refal
{

using namespace rfrt;

namespace Box
{

RF_DECL(Store);

RF_FUNC (Store, (RF_ARG _box, _expr;;), RF_VOID)
  if (_box.get_len() == 1) {
    Term* t = _box.get_first();
    if (t->is_instance_of<BoxContents>()) {
      *(t->get_obj_ptr<BoxContents>()) = _expr;
    } else {
      RF_LIB_ERROR(L"Invalid argument");
    }
  } else {
    FATAL("Box::Store(): Symbol expected");
  }
RF_END

}
}
