
#include <rf_core.hh>

using namespace rfrt;

namespace refal {

namespace Compare {

RF_DECL (Lt);

}

}

namespace refal {

namespace Class {

RF_DECL (IsLetter);

}

}

namespace refal {

namespace Convert {

RF_DECL (ToWord);

}

}

namespace refal {

namespace cpp_specific {

RF_DECL (IsReserved_Word);

}

}

namespace refal {

namespace Convert {

RF_DECL (ToChars);

}

}

namespace refal {

namespace cpp_specific {

Expr Namespace_Delimeter;

static Expr Reserved_Words;

static Expr _c_0;

static Expr _c_1;

static Expr _c_2;

RF_FUNC (IsReserved_Word, (RF_ARG _ve_word;;), RF_VOID)
  {
    {
      Expr _v_ToChars1;
      RF_CALL (refal::Convert::ToChars, _ve_word, _v_ToChars1);
      int _v_len1;
      _v_len1 = _v_ToChars1.get_len ();
      int _v_len2;
      _v_len2 = 2;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      int _v_len___dollar_tmp_m_33_m_34;
      _v_len___dollar_tmp_m_33_m_34 = (_v_len1 - _v_len2);
      if (!_c_0.term_eq (_v_ToChars1, 0))
      {
        goto _block1__branch1;
      }
      if (!_v_ToChars1.symbol_at ((0 + 1)))
      {
        goto _block1__branch1;
      }
      Expr _vs_char;
      _vs_char = Expr (_v_ToChars1, (0 + 1), 1);
      Expr _ve__dollar_tmp_m_33_m_34;
      _ve__dollar_tmp_m_33_m_34 = Expr (_v_ToChars1, (0 + 1 + 1), _v_len___dollar_tmp_m_33_m_34);
      {
        {
          if (!_vs_char.term_eq (_c_0, 0))
          {
            goto _block2__branch1;
          }
          goto _block2;
        }
      _block2__branch1: {}
        if (!RF_CALL (refal::Class::IsLetter, _vs_char, /*void*/))
        {
          goto _block1__branch1;
        }
        {
          RF_lsplit (_c_1, 0, _ve__dollar_tmp_m_35_m_37, _v_lsplit__1);
          for ( ; ; RF_iter(_c_1)++)
          {
            {
              if (!RF_iter(_c_1))
              {
                goto _negation1;
              }
              int _v_len3;
              _v_len3 = _v_lsplit__1.get_len ();
              int _v_len4;
              _v_len4 = 1;
              if (_v_len3 < _v_len4)
              {
                goto _negation1;
              }
              int _v_len___dollar_tmp_m_35_m_46;
              _v_len___dollar_tmp_m_35_m_46 = (_v_len3 - _v_len4);
              if (!_vs_char.term_eq (_v_lsplit__1, 0))
              {
                goto _continue1;
              }
              Expr _ve__dollar_tmp_m_35_m_46;
              _ve__dollar_tmp_m_35_m_46 = Expr (_v_lsplit__1, (0 + 1), _v_len___dollar_tmp_m_35_m_46);
              goto _exit1;
            }
        _continue1: {}
          }
        _exit1: {}
          goto _block1__branch1;
        }
      _negation1: {}
        if (!RF_CALL (refal::Compare::Lt, (_vs_char, _c_2), /*void*/))
        {
          goto _block1__branch1;
        }
      }
    _block2: {}
      goto _block1;
    }
  _block1__branch1: {}
    Expr _gs_word__2;
    RF_CALL (refal::Convert::ToWord, _ve_word, _gs_word__2);
    RF_lsplit (Reserved_Words, 0, _ve__dollar_tmp_m_37_m_49, _v_lsplit__Reserved__Words);
    for ( ; ; RF_iter(Reserved_Words)++)
    {
      {
        if (!RF_iter(Reserved_Words))
        {
          RF_RETFAIL;
        }
        int _v_len5;
        _v_len5 = _v_lsplit__Reserved__Words.get_len ();
        int _v_len6;
        _v_len6 = 1;
        if (_v_len5 < _v_len6)
        {
          RF_RETFAIL;
        }
        int _v_len___dollar_tmp_m_37_m_58;
        _v_len___dollar_tmp_m_37_m_58 = (_v_len5 - _v_len6);
        if (!_gs_word__2.term_eq (_v_lsplit__Reserved__Words, 0))
        {
          goto _continue2;
        }
        Expr _ve__dollar_tmp_m_37_m_58;
        _ve__dollar_tmp_m_37_m_58 = Expr (_v_lsplit__Reserved__Words, (0 + 1), _v_len___dollar_tmp_m_37_m_58);
        goto _exit2;
      }
  _continue2: {}
    }
  _exit2: {}
  }
_block1: {}
RF_END

}

}

namespace refal {

namespace cpp_specific {

static void init_ () {
  Namespace_Delimeter = rftype::Char::create_expr (L"::");
  Reserved_Words = Expr::create<rftype::Word>("asm") + Expr::create<rftype::Word>("do") + Expr::create<rftype::Word>("inline") + Expr::create<rftype::Word>("short") + Expr::create<rftype::Word>("typeid") + Expr::create<rftype::Word>("auto") + Expr::create<rftype::Word>("double") + Expr::create<rftype::Word>("int") + Expr::create<rftype::Word>("signed") + Expr::create<rftype::Word>("typename") + Expr::create<rftype::Word>("bool") + Expr::create<rftype::Word>("dynamic_cast") + Expr::create<rftype::Word>("long") + Expr::create<rftype::Word>("sizeof") + Expr::create<rftype::Word>("union") + Expr::create<rftype::Word>("break") + Expr::create<rftype::Word>("else") + Expr::create<rftype::Word>("mutable") + Expr::create<rftype::Word>("static") + Expr::create<rftype::Word>("unsigned") + Expr::create<rftype::Word>("case") + Expr::create<rftype::Word>("enum") + Expr::create<rftype::Word>("namespace") + Expr::create<rftype::Word>("static_cast") + Expr::create<rftype::Word>("using") + Expr::create<rftype::Word>("catch") + Expr::create<rftype::Word>("explicit") + Expr::create<rftype::Word>("new") + Expr::create<rftype::Word>("struct") + Expr::create<rftype::Word>("virtual") + Expr::create<rftype::Word>("char") + Expr::create<rftype::Word>("extern") + Expr::create<rftype::Word>("operator") + Expr::create<rftype::Word>("switch") + Expr::create<rftype::Word>("void") + Expr::create<rftype::Word>("class") + Expr::create<rftype::Word>("false") + Expr::create<rftype::Word>("private") + Expr::create<rftype::Word>("template") + Expr::create<rftype::Word>("volatile") + Expr::create<rftype::Word>("const") + Expr::create<rftype::Word>("float") + Expr::create<rftype::Word>("protected") + Expr::create<rftype::Word>("this") + Expr::create<rftype::Word>("wchar_t") + Expr::create<rftype::Word>("const_cast") + Expr::create<rftype::Word>("for") + Expr::create<rftype::Word>("public") + Expr::create<rftype::Word>("throw") + Expr::create<rftype::Word>("while") + Expr::create<rftype::Word>("continue") + Expr::create<rftype::Word>("friend") + Expr::create<rftype::Word>("register") + Expr::create<rftype::Word>("true") + Expr::create<rftype::Word>("default") + Expr::create<rftype::Word>("goto") + Expr::create<rftype::Word>("reinterpret_cast") + Expr::create<rftype::Word>("try") + Expr::create<rftype::Word>("delete") + Expr::create<rftype::Word>("if") + Expr::create<rftype::Word>("return") + Expr::create<rftype::Word>("typedef") + Expr::create<rftype::Word>("and") + Expr::create<rftype::Word>("and_eq") + Expr::create<rftype::Word>("bitand") + Expr::create<rftype::Word>("bitor") + Expr::create<rftype::Word>("compl") + Expr::create<rftype::Word>("not") + Expr::create<rftype::Word>("not_eq") + Expr::create<rftype::Word>("or") + Expr::create<rftype::Word>("or_eq") + Expr::create<rftype::Word>("xor") + Expr::create<rftype::Word>("xor_eq");
  _c_0 = rftype::Char::create_expr (L"_");
  _c_1 = rftype::Char::create_expr (L"?!");
  _c_2 = rftype::Char::create_expr (L"a");
}

static AtStart init_registrator_ (&init_);

}

}
