// $Source$
// $Revision: 2187 $
// $Date: 2006-12-15 03:17:56 +0300 (Пт, 15 дек 2006) $
// $Author: orlov $

#ifndef __dir_hh__
#define __dir_hh__

#ifndef WINDOWS
# include <dirent.h>
#else
# include <windows.h>
#endif

namespace rftype
{

class Dir
{

#ifndef WINDOWS
  DIR* dir_ptr;
#else
  HANDLE hDir;
  WIN32_FIND_DATA fd;
  bool is_first;
#endif

  // Copying may mean to open the directory another time...
  NO_COPY_CTOR(Dir)
  NO_ASSIGN(Dir)

public:

  inline Dir (const char* _name) ;
  inline ~Dir () ;
  inline char* read () ;
  inline void close () ;

};

}

#endif // __dir_hh__
