// $Source$
// $Revision: 2187 $
// $Date: 2006-12-15 03:17:56 +0300 (Пт, 15 дек 2006) $
// $Author: orlov $

#include <rf_core.hh>
#include <stdlib.h>

namespace refal
{
using namespace rfrt;
using namespace rftype;

namespace Dos
{

RF_FUNC (Exit, (RF_ARG s_ReturnCode;;), RF_VOID)
  if (s_ReturnCode.get_len() == 1 ) {
    Term* p = s_ReturnCode.get_first();
    intptr_t n;
    if (p->get_type() == type_int32) {
      intptr_t t = static_cast<Int32*>(p)->to_int();
        if (t < 0 || (uintptr_t)t > SIZE_MAX) {
          RF_LIB_ERROR ("Invalid Argument");
        }
        else
          exit(t);
      }
    else
    if (p->get_type() == type_int) {
      Integer* num = static_cast<Integer*>(p);
      if (num->cmp(0) < 0 || num->cmp(SIZE_MAX) > 0)
        RF_LIB_ERROR ("Invalid Argument");
      else {
        n = num->to_int();
        exit(n);
      }
    }
    else
      RF_LIB_ERROR ("Invalid Argument");
  }
  else
    RF_LIB_ERROR ("Invalid Argument");

RF_END

}
  
}


