// $Source$
// $Revision: 2270 $
// $Date: 2007-01-22 17:20:03 +0300 (Пн, 22 янв 2007) $
// $Author: orlov $

#include <rf_core.hh>
#include <stdlib.h>
#include <time.h>
#include <locale.h>

#ifdef _MSC_VER
#include <sys/timeb.h>
#else
#include <sys/time.h>
#endif


namespace refal
{
using namespace rfrt;
using namespace rftype;

namespace Dos
{

RF_FUNC (Time, RF_VOID, (RF_RES e_String;;))

 unsigned uu;

#ifdef _MSC_VER

 struct __timeb64 timebuffer;
 struct tm* lt;
 
 _ftime64(&timebuffer);

 lt = _localtime64(&(timebuffer.time));
 uu = timebuffer.millitm;

 wchar_t s[256]; 
 wcsftime(s, sizeof(s), L"%b" , lt);

#else

 struct timeval ttt;
 struct tm* lt; 
  
 gettimeofday(&ttt, NULL); 
 time_t sec = (time_t)ttt.tv_sec;
 lt = localtime(&sec); 
 uu = ttt.tv_usec/10000; 

 char s[256]; 
 strftime(s, sizeof(s), "%b", lt);

#endif

  Expr space = Char::create_expr(" ");

  Expr e = Integer::create_expr((*lt).tm_mday) + space +
           Word::create_expr(s) + space +
           Integer::create_expr((*lt).tm_year + 1900) + space +
           Integer::create_expr((*lt).tm_hour) +
           Char::create_expr(":") +
           Integer::create_expr((*lt).tm_min) +
           Char::create_expr(":") +
           Integer::create_expr((*lt).tm_sec) +
           Char::create_expr(".") +
           Integer::create_expr(uu);
  
  e_String = e;

RF_END

}
}


