
#include <rf_core.hh>

using namespace rfrt;

namespace refal {

namespace Convert {

RF_DECL (ToWord);

}

}

namespace refal {

namespace Error {

RF_DECL (Lib_Error);

}

}

namespace refal {

namespace List {

RF_DECL (Intersperse);

}

}

namespace refal {

namespace Error {

RF_DECL (Not_Available);

}

}

namespace refal {

namespace Error {

static Expr _c_0;

static Expr _c_1;

RF_FUNC (Lib_Error, (RF_ARG _ve_fname, _ve_rror;;), RF_VOID)
  RF_ERROR ((_ve_fname + _ve_rror));
RF_END

RF_FUNC (Not_Available, (RF_ARG _ve_name;;), RF_VOID)
  Expr _ge_auxcall1;
  RF_CALL (refal::List::Intersperse, (_c_0, _ve_name), _ge_auxcall1);
  Expr _gs_auxcall2;
  RF_CALL (refal::Convert::ToWord, _ge_auxcall1, _gs_auxcall2);
  RF_ERROR ((_gs_auxcall2 + _c_1));
RF_END

}

}

namespace refal {

namespace Error {

static void init_ () {
  _c_0 = rftype::Char::create_expr (L".");
  _c_1 = Expr::create<rftype::Word>("Not available");
}

static AtStart init_registrator_ (&init_);

}

}
