// $Id: sep.cc 2630 2007-04-05 15:10:59Z yura $

#include <rf_core.hh>

namespace refal {

namespace File {

using namespace rftype;

Expr PathSeparator;
Expr DirSeparator;

static void init_ ()
{
  #ifdef WINDOWS
    PathSeparator = Expr::create_sym<BoxContents>(Expr::create<Char>(L';'));
    DirSeparator  = Expr::create_sym<BoxContents>(Expr::create<Char>(L'\\'));
  #else
    PathSeparator = Expr::create_sym<BoxContents>(Expr::create<Char>(L':'));
    DirSeparator  = Expr::create_sym<BoxContents>(Expr::create<Char>(L'/'));
  #endif
}

static AtStart init_registrator_ (&init_);

}
}
