
#include <rf_core.hh>

using namespace rfrt;

namespace refal {

namespace Arithm {

RF_DECL (Sub);

RF_DECL (Add);

}

}

namespace refal {

namespace Class {

RF_DECL (IsDigit);

}

}

namespace refal {

namespace Box {

RF_DECL (Store);

RF_DECL (Get);

}

}

namespace refal {

namespace Compare {

RF_DECL (Eq);

}

}

namespace refal {

namespace Convert {

RF_DECL (ToInt);

RF_DECL (ToLower);

}

}

namespace refal {

namespace Compare {

RF_DECL (Gt);

}

}

namespace refal {

namespace Convert {

RF_DECL (ToWord);

}

}

namespace refal {

namespace Lexer {

namespace Lexer {

RF_DECL (IsBlank);

}

}

}

namespace refal {

namespace Convert {

RF_DECL (ToUpper);

}

}

namespace refal {

namespace Class {

RF_DECL (IsLetter);

}

}

namespace refal {

namespace Lexer {

namespace Lexer {

RF_DECL (IsCollecting_Errors);

RF_DECL (IsFun_Sym);

RF_DECL (IsRead_Term);

RF_DECL (IsScan_Identifier);

RF_DECL (IsScan_Char);

RF_DECL (IsFun_Sym_0);

RF_DECL (IsDigit_0);

RF_DECL (IsScan_Number);

RF_DECL (IsScan_String);

RF_DECL (IsScan_Variable);

RF_DECL (IsScan_Quoted_Word);

RF_DECL (IsSkip_Comment);

RF_DECL (IsVar_Sym);

RF_DECL (IsUppercase_Letter);

RF_DECL (IsSkip_Blank);

RF_DECL (IsScan_Keyword);

RF_DECL (IsBlank_0);

RF_DECL (Read_Term_Aux);

RF_DECL (Start_Collect_Errors);

RF_DECL (Scan_String_Rest);

}

}

}

namespace refal {

namespace Stream {

namespace IndexedStream {

RF_DECL (Current_Pos);

}

}

}

namespace refal {

namespace Stream {

namespace Stream {

RF_DECL (Get_Line);

RF_DECL (Get_Delim);

RF_DECL (Ungets);

RF_DECL (Getc);

RF_DECL (Get_While);

}

}

}

namespace refal {

namespace Lexer {

namespace Lexer {

RF_DECL (Stop_Collect_Errors);

}

}

}

namespace refal {

namespace Stream {

namespace StreamErr {

RF_DECL (Error);

RF_DECL (Error_At);

RF_DECL (Clear_Errors);

}

}

}

namespace refal {

namespace Lexer {

namespace Lexer {

RF_DECL (IsVar_Sym_0);

}

}

}

namespace refal {

namespace Lexer {

namespace Lexer {

Expr Case_Insensitive;

static Expr Collect_Errors_Box;

static Expr Parenth_Level;

static Expr _c_0;

static Expr _c_1;

static Expr _c_2;

static Expr _c_3;

static Expr _c_4;

static Expr _c_5;

static Expr _c_6;

static Expr _c_7;

static Expr _c_8;

static Expr _c_9;

static Expr _c_10;

static Expr _c_11;

static Expr _c_12;

static Expr _c_13;

static Expr _c_14;

static Expr _c_15;

static Expr _c_16;

static Expr _c_17;

static Expr _c_18;

static Expr _c_19;

static Expr _c_20;

static Expr _c_21;

static Expr _c_22;

static Expr _c_23;

static Expr _c_24;

static Expr _c_25;

static Expr _c_26;

static Expr _c_29;

static Expr _c_27;

static Expr _c_28;

static Expr _c_30;

static Expr _c_31;

static Expr _c_32;

static Expr _c_33;

static Expr _c_34;

static Expr _c_35;

static Expr _c_36;

static Expr _c_37;

static Expr _c_38;

static Expr _c_39;

static Expr _c_40;

static Expr _c_43;

static Expr _c_41;

static Expr _c_42;

static Expr _c_44;

static Expr _c_45;

static Expr _c_46;

static Expr _c_47;

static Expr _c_48;

static Expr _c_49;

static Expr _c_50;

static Expr _c_51;

static Expr _c_52;

static Expr _c_53;

static Expr _c_54;

static Expr _c_55;

static Expr _c_56;

static Expr _c_57;

static Expr _c_58;

static Expr _c_59;

static Expr _c_60;

static Expr _c_61;

static Expr _c_62;

static Expr _c_63;

static Expr _c_64;

static Expr _c_69;

static Expr _c_65;

static Expr _c_66;

static Expr _c_67;

static Expr _c_68;

static Expr _c_70;

static Expr _c_71;

static Expr _c_72;

static Expr _c_73;

static Expr _c_74;

static Expr _c_75;

static Expr _c_76;

static Expr _c_77;

static Expr _c_78;

static Expr _c_79;

static Expr _c_80;

static Expr _c_81;

static Expr _c_82;

static Expr _c_83;

static Expr _c_84;

static Expr _c_85;

static Expr _c_86;

static Expr _c_87;

RF_FUNC (Start_Collect_Errors, RF_VOID, RF_VOID)
  Expr _v_Get1;
  RF_CALL (refal::Box::Get, Collect_Errors_Box, _v_Get1);
  if (_v_Get1.get_len () != 1)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_v_Get1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _vs_num;
  _vs_num = Expr (_v_Get1, 0, 1);
  Expr _gs_auxcall1;
  RF_CALL (refal::Arithm::Add, (_vs_num, _c_0), _gs_auxcall1);
  RF_TAILCALL (refal::Box::Store, (Collect_Errors_Box, _gs_auxcall1), /*void*/);
RF_END

RF_FUNC (Stop_Collect_Errors, RF_VOID, RF_VOID)
  Expr _v_Get1;
  RF_CALL (refal::Box::Get, Collect_Errors_Box, _v_Get1);
  {
    {
      if (_v_Get1.get_len () != 1)
      {
        goto _block1__branch1;
      }
      if (!_c_1.term_eq (_v_Get1, 0))
      {
        goto _block1__branch1;
      }
      goto _block1;
    }
  _block1__branch1: {}
    if (_v_Get1.get_len () != 1)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    if (!_v_Get1.symbol_at (0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _vs_num;
    _vs_num = Expr (_v_Get1, 0, 1);
    Expr _gs_auxcall1;
    RF_CALL (refal::Arithm::Sub, (_vs_num, _c_0), _gs_auxcall1);
    RF_TAILCALL (refal::Box::Store, (Collect_Errors_Box, _gs_auxcall1), /*void*/);
  }
_block1: {}
RF_END

RF_FUNC (IsCollecting_Errors, RF_VOID, RF_VOID)
  {
    Expr _v_Get1;
    RF_CALL (refal::Box::Get, Collect_Errors_Box, _v_Get1);
    if (_v_Get1.get_len () != 1)
    {
      goto _negation1;
    }
    if (!_c_1.term_eq (_v_Get1, 0))
    {
      goto _negation1;
    }
    RF_RETFAIL;
  }
_negation1: {}
RF_END

RF_FUNC (IsBlank, (RF_ARG _gt_arg1;;), RF_VOID)
  {
    {
      if (!_gt_arg1.term_eq (_c_2, 0))
      {
        goto _block1__branch1;
      }
      goto _block1;
    }
  _block1__branch1: {}
    {
      if (!_gt_arg1.term_eq (_c_3, 0))
      {
        goto _block1__branch2;
      }
      goto _block1;
    }
  _block1__branch2: {}
    {
      if (!_gt_arg1.term_eq (_c_4, 0))
      {
        goto _block1__branch3;
      }
      goto _block1;
    }
  _block1__branch3: {}
    if (!_gt_arg1.term_eq (_c_5, 0))
    {
      RF_RETFAIL;
    }
  }
_block1: {}
RF_END

RF_FUNC (IsSkip_Blank, (RF_ARG _vs_tream;;), RF_VOID)
  Expr _v_Get__While1;
  RF_CALL (refal::Stream::Stream::Get_While, (_vs_tream, _c_6), _v_Get__While1);
  int _v_len1;
  _v_len1 = _v_Get__While1.get_len ();
  int _v_len2;
  _v_len2 = 0;
  if (_v_len1 < (_v_len2 + 1))
  {
    RF_RETFAIL;
  }
  int _v_len___dollar_tmp_m_40_m_54;
  _v_len___dollar_tmp_m_40_m_54 = (_v_len1 - _v_len2);
  Expr _vv__dollar_tmp_m_40_m_54;
  _vv__dollar_tmp_m_40_m_54 = Expr (_v_Get__While1, 0, _v_len___dollar_tmp_m_40_m_54);
RF_END

RF_FUNC (IsSkip_Comment, (RF_ARG _vs_tream;;), RF_VOID)
  {
    {
      {
        if (!RF_CALL (IsCollecting_Errors, /*void*/, /*void*/))
        {
          goto _negation1;
        }
        goto _block1__branch1;
      }
    _negation1: {}
      RF_CALL (refal::Stream::StreamErr::Clear_Errors, /*void*/, /*void*/);
      goto _block1;
    }
  _block1__branch1: {}
  }
_block1: {}
  Expr _v_Getc1;
  if (!RF_CALL (refal::Stream::Stream::Getc, _vs_tream, _v_Getc1))
  {
    RF_RETFAIL;
  }
  {
    {
      if (!_v_Getc1.term_eq (_c_7, 0))
      {
        goto _block2__branch1;
      }
      Expr _v_Get__Line1;
      RF_CALL (refal::Stream::Stream::Get_Line, _vs_tream, _v_Get__Line1);
      int _v_len1;
      _v_len1 = _v_Get__Line1.get_len ();
      int _v_len2;
      _v_len2 = 0;
      if (_v_len1 < _v_len2)
      {
        RF_RETFAIL;
      }
      int _v_len___dollar_tmp_m_46_m_32;
      _v_len___dollar_tmp_m_46_m_32 = (_v_len1 - _v_len2);
      Expr _ve__dollar_tmp_m_46_m_32;
      _ve__dollar_tmp_m_46_m_32 = Expr (_v_Get__Line1, 0, _v_len___dollar_tmp_m_46_m_32);
      goto _block2;
    }
  _block2__branch1: {}
    {
      if (!_v_Getc1.term_eq (_c_8, 0))
      {
        goto _block2__branch2;
      }
      Expr _vt_pos;
      RF_CALL (refal::Stream::IndexedStream::Current_Pos, _vs_tream, _vt_pos);
      {
        {
          Expr _v_Getc2;
          if (!RF_CALL (refal::Stream::Stream::Getc, _vs_tream, _v_Getc2))
          {
            goto _block3__branch1;
          }
          {
            {
              if (!_v_Getc2.term_eq (_c_8, 0))
              {
                goto _block4__branch1;
              }
              Expr _v_Get__Line2;
              RF_CALL (refal::Stream::Stream::Get_Line, _vs_tream, _v_Get__Line2);
              int _v_len3;
              _v_len3 = _v_Get__Line2.get_len ();
              int _v_len4;
              _v_len4 = 0;
              if (_v_len3 < _v_len4)
              {
                RF_RETFAIL;
              }
              int _v_len___dollar_tmp_m_51_m_38;
              _v_len___dollar_tmp_m_51_m_38 = (_v_len3 - _v_len4);
              Expr _ve__dollar_tmp_m_51_m_38;
              _ve__dollar_tmp_m_51_m_38 = Expr (_v_Get__Line2, 0, _v_len___dollar_tmp_m_51_m_38);
              goto _block4;
            }
          _block4__branch1: {}
            {
              if (!_v_Getc2.term_eq (_c_7, 0))
              {
                goto _block4__branch2;
              }
              Expr _ve_Isstop;
              _ve_Isstop = empty;
              for ( ; ; )
              {
                {
                  if (_ve_Isstop.get_len () != 1)
                  {
                    goto _iter1;
                  }
                  if (!_c_9.term_eq (_ve_Isstop, 0))
                  {
                    goto _iter1;
                  }
                  goto _exit__iter1;
                }
              _iter1: {}
                {
                  {
                    Expr _v_Get__Delim1;
                    RF_CALL (refal::Stream::Stream::Get_Delim, (_vs_tream, _c_7), _v_Get__Delim1);
                    int _v_len5;
                    _v_len5 = _v_Get__Delim1.get_len ();
                    int _v_len6;
                    _v_len6 = 0;
                    if (_v_len5 < (_v_len6 + 1))
                    {
                      goto _block5__branch1;
                    }
                    int _v_len___dollar_tmp_m_54_m_41;
                    _v_len___dollar_tmp_m_54_m_41 = (_v_len5 - _v_len6);
                    Expr _vv__dollar_tmp_m_54_m_41;
                    _vv__dollar_tmp_m_54_m_41 = Expr (_v_Get__Delim1, 0, _v_len___dollar_tmp_m_54_m_41);
                    {
                      {
                        Expr _v_Getc3;
                        if (!RF_CALL (refal::Stream::Stream::Getc, _vs_tream, _v_Getc3))
                        {
                          goto _block6__branch1;
                        }
                        {
                          {
                            if (!_v_Getc3.term_eq (_c_8, 0))
                            {
                              goto _block7__branch1;
                            }
                            _ve_Isstop = _c_9;
                            goto _block7;
                          }
                        _block7__branch1: {}
                          Expr _vt__dollar_tmp_m_57_m_20;
                          _vt__dollar_tmp_m_57_m_20 = Expr (_v_Getc3, 0, 1);
                          _ve_Isstop = empty;
                        }
                      _block7: {}
                        goto _block6;
                      }
                    _block6__branch1: {}
                      RF_CALL (refal::Stream::StreamErr::Error_At, (_vt_pos, _c_10), /*void*/);
                      _ve_Isstop = _c_9;
                    }
                  _block6: {}
                    goto _block5;
                  }
                _block5__branch1: {}
                  RF_CALL (refal::Stream::StreamErr::Error_At, (_vt_pos, _c_10), /*void*/);
                  _ve_Isstop = _c_9;
                }
              _block5: {}
              }
            _exit__iter1: {}
              goto _block4;
            }
          _block4__branch2: {}
            Expr _vt_1;
            _vt_1 = Expr (_v_Getc2, 0, 1);
            RF_CALL (refal::Stream::StreamErr::Error, (_vs_tream, (_c_12 + _vt_1 + _c_11)), /*void*/);
            RF_RETFAIL;
          }
        _block4: {}
          goto _block3;
        }
      _block3__branch1: {}
        RF_CALL (refal::Stream::StreamErr::Error_At, (_vt_pos, _c_13), /*void*/);
        RF_RETFAIL;
      }
    _block3: {}
      goto _block2;
    }
  _block2__branch2: {}
    Expr _vt_1;
    _vt_1 = Expr (_v_Getc1, 0, 1);
    RF_CALL (refal::Stream::Stream::Ungets, (_vs_tream, _vt_1), /*void*/);
    RF_RETFAIL;
  }
_block2: {}
RF_END

RF_FUNC (IsVar_Sym, (RF_ARG _gt_arg1;;), RF_VOID)
  if (!_gt_arg1.symbol_at (0))
  {
    RF_RETFAIL;
  }
  Expr _vs_ym;
  _vs_ym = Expr (_gt_arg1, 0, 1);
  {
    {
      if (!RF_CALL (refal::Class::IsLetter, _vs_ym, /*void*/))
      {
        goto _block1__branch1;
      }
      goto _block1;
    }
  _block1__branch1: {}
    {
      if (!RF_CALL (refal::Class::IsDigit, _vs_ym, /*void*/))
      {
        goto _block1__branch2;
      }
      goto _block1;
    }
  _block1__branch2: {}
    RF_lsplit (_c_14, 0, _ve__dollar_tmp_m_80_m_14, _v_lsplit__14);
    for ( ; ; RF_iter(_c_14)++)
    {
      {
        if (!RF_iter(_c_14))
        {
          RF_RETFAIL;
        }
        int _v_len1;
        _v_len1 = _v_lsplit__14.get_len ();
        int _v_len2;
        _v_len2 = 1;
        if (_v_len1 < _v_len2)
        {
          RF_RETFAIL;
        }
        int _v_len___dollar_tmp_m_80_m_20;
        _v_len___dollar_tmp_m_80_m_20 = (_v_len1 - _v_len2);
        if (!_vs_ym.term_eq (_v_lsplit__14, 0))
        {
          goto _continue1;
        }
        Expr _ve__dollar_tmp_m_80_m_20;
        _ve__dollar_tmp_m_80_m_20 = Expr (_v_lsplit__14, (0 + 1), _v_len___dollar_tmp_m_80_m_20);
        goto _exit1;
      }
  _continue1: {}
    }
  _exit1: {}
  }
_block1: {}
RF_END

RF_FUNC (IsScan_Keyword, (RF_ARG _vs_tream;;), (RF_RES _v_res1;;))
  Expr _v_Getc1;
  if (!RF_CALL (refal::Stream::Stream::Getc, _vs_tream, _v_Getc1))
  {
    RF_RETFAIL;
  }
  {
    {
      if (!_v_Getc1.term_eq (_c_15, 0))
      {
        goto _block1__branch1;
      }
      goto _block1;
    }
  _block1__branch1: {}
    Expr _vt_1;
    _vt_1 = Expr (_v_Getc1, 0, 1);
    RF_CALL (refal::Stream::Stream::Ungets, (_vs_tream, _vt_1), /*void*/);
    RF_RETFAIL;
  }
_block1: {}
  Expr _ve_ident;
  RF_CALL (refal::Stream::Stream::Get_While, (_vs_tream, _c_16), _ve_ident);
  Expr _ge_auxalt1;
  {
    {
      Expr _v_Get1;
      RF_CALL (refal::Box::Get, Case_Insensitive, _v_Get1);
      if (_v_Get1.get_len () != 1)
      {
        goto _block2__branch1;
      }
      if (!_c_0.term_eq (_v_Get1, 0))
      {
        goto _block2__branch1;
      }
      RF_CALL (refal::Convert::ToLower, _ve_ident, _ge_auxalt1);
      goto _block2;
    }
  _block2__branch1: {}
    _ge_auxalt1 = _ve_ident;
  }
_block2: {}
  {
    {
      if (_ge_auxalt1.get_len () != 3)
      {
        goto _block3__branch1;
      }
      if (!_c_17.eq (_ge_auxalt1, 0))
      {
        goto _block3__branch1;
      }
      _v_res1 = _c_18;
      goto _block3;
    }
  _block3__branch1: {}
    {
      if (_ge_auxalt1.get_len () != 7)
      {
        goto _block3__branch2;
      }
      if (!_c_19.eq (_ge_auxalt1, 0))
      {
        goto _block3__branch2;
      }
      _v_res1 = _c_20;
      goto _block3;
    }
  _block3__branch2: {}
    {
      if (_ge_auxalt1.get_len () != 5)
      {
        goto _block3__branch3;
      }
      if (!_c_21.eq (_ge_auxalt1, 0))
      {
        goto _block3__branch3;
      }
      _v_res1 = _c_22;
      goto _block3;
    }
  _block3__branch3: {}
    {
      if (_ge_auxalt1.get_len () != 5)
      {
        goto _block3__branch4;
      }
      if (!_c_23.eq (_ge_auxalt1, 0))
      {
        goto _block3__branch4;
      }
      _v_res1 = _c_24;
      goto _block3;
    }
  _block3__branch4: {}
    {
      if (_ge_auxalt1.get_len () != 4)
      {
        goto _block3__branch5;
      }
      if (!_c_25.eq (_ge_auxalt1, 0))
      {
        goto _block3__branch5;
      }
      _v_res1 = _c_26;
      goto _block3;
    }
  _block3__branch5: {}
    {
      if (_ge_auxalt1.get_len () != 4)
      {
        goto _block3__branch6;
      }
      if (!_c_27.eq (_ge_auxalt1, 0))
      {
        goto _block3__branch6;
      }
      _v_res1 = _c_28;
      goto _block3;
    }
  _block3__branch6: {}
    {
      if (_ge_auxalt1.get_len () != 5)
      {
        goto _block3__branch7;
      }
      if (!_c_29.eq (_ge_auxalt1, 0))
      {
        goto _block3__branch7;
      }
      _v_res1 = _c_30;
      goto _block3;
    }
  _block3__branch7: {}
    {
      if (_ge_auxalt1.get_len () != 4)
      {
        goto _block3__branch8;
      }
      if (!_c_31.eq (_ge_auxalt1, 0))
      {
        goto _block3__branch8;
      }
      _v_res1 = _c_32;
      goto _block3;
    }
  _block3__branch8: {}
    {
      if (_ge_auxalt1.get_len () != 1)
      {
        goto _block3__branch9;
      }
      if (!_c_33.term_eq (_ge_auxalt1, 0))
      {
        goto _block3__branch9;
      }
      _v_res1 = _c_34;
      goto _block3;
    }
  _block3__branch9: {}
    {
      if (_ge_auxalt1.get_len () != 1)
      {
        goto _block3__branch10;
      }
      if (!_c_35.term_eq (_ge_auxalt1, 0))
      {
        goto _block3__branch10;
      }
      _v_res1 = _c_36;
      goto _block3;
    }
  _block3__branch10: {}
    {
      if (_ge_auxalt1.get_len () != 6)
      {
        goto _block3__branch11;
      }
      if (!_c_37.eq (_ge_auxalt1, 0))
      {
        goto _block3__branch11;
      }
      _v_res1 = _c_38;
      goto _block3;
    }
  _block3__branch11: {}
    {
      if (_ge_auxalt1.get_len () != 5)
      {
        goto _block3__branch12;
      }
      if (!_c_39.eq (_ge_auxalt1, 0))
      {
        goto _block3__branch12;
      }
      _v_res1 = _c_40;
      goto _block3;
    }
  _block3__branch12: {}
    {
      if (_ge_auxalt1.get_len () != 5)
      {
        goto _block3__branch13;
      }
      if (!_c_41.eq (_ge_auxalt1, 0))
      {
        goto _block3__branch13;
      }
      _v_res1 = _c_42;
      goto _block3;
    }
  _block3__branch13: {}
    {
      if (_ge_auxalt1.get_len () != 8)
      {
        goto _block3__branch14;
      }
      if (!_c_43.eq (_ge_auxalt1, 0))
      {
        goto _block3__branch14;
      }
      _v_res1 = _c_44;
      goto _block3;
    }
  _block3__branch14: {}
    {
      if (_ge_auxalt1.get_len () != 4)
      {
        goto _block3__branch15;
      }
      if (!_c_45.eq (_ge_auxalt1, 0))
      {
        goto _block3__branch15;
      }
      _v_res1 = _c_46;
      goto _block3;
    }
  _block3__branch15: {}
    {
      if (_ge_auxalt1.get_len () != 3)
      {
        goto _block3__branch16;
      }
      if (!_c_47.eq (_ge_auxalt1, 0))
      {
        goto _block3__branch16;
      }
      _v_res1 = _c_48;
      goto _block3;
    }
  _block3__branch16: {}
    {
      if (_ge_auxalt1.get_len () != 6)
      {
        goto _block3__branch17;
      }
      if (!_c_49.eq (_ge_auxalt1, 0))
      {
        goto _block3__branch17;
      }
      _v_res1 = _c_50;
      goto _block3;
    }
  _block3__branch17: {}
    {
      if (_ge_auxalt1.get_len () != 4)
      {
        goto _block3__branch18;
      }
      if (!_c_51.eq (_ge_auxalt1, 0))
      {
        goto _block3__branch18;
      }
      _v_res1 = _c_52;
      goto _block3;
    }
  _block3__branch18: {}
    int _v_len1;
    _v_len1 = _ge_auxalt1.get_len ();
    int _v_len2;
    _v_len2 = 0;
    if (_v_len1 < _v_len2)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    int _v_len__1;
    _v_len__1 = (_v_len1 - _v_len2);
    Expr _ve_1;
    _ve_1 = Expr (_ge_auxalt1, 0, _v_len__1);
    RF_CALL (refal::Stream::Stream::Ungets, (_vs_tream, (_c_15 + _ve_1)), /*void*/);
    RF_RETFAIL;
  }
_block3: {}
RF_END

RF_FUNC (IsScan_Number, (RF_ARG _vs_tream;;), (RF_RES _v_res1;;))
  Expr _v_Getc1;
  if (!RF_CALL (refal::Stream::Stream::Getc, _vs_tream, _v_Getc1))
  {
    RF_RETFAIL;
  }
  if (!_v_Getc1.symbol_at (0))
  {
    RF_RETFAIL;
  }
  Expr _vs_first;
  _vs_first = Expr (_v_Getc1, 0, 1);
  {
    {
      if (!RF_CALL (refal::Class::IsDigit, _vs_first, /*void*/))
      {
        goto _block1__branch1;
      }
      goto _block1;
    }
  _block1__branch1: {}
    {
      {
        {
          if (!_vs_first.term_eq (_c_53, 0))
          {
            goto _block2__branch1;
          }
          goto _block2;
        }
      _block2__branch1: {}
        if (!_vs_first.term_eq (_c_54, 0))
        {
          goto _block1__branch2;
        }
      }
    _block2: {}
      goto _block1;
    }
  _block1__branch2: {}
    RF_CALL (refal::Stream::Stream::Ungets, (_vs_tream, _vs_first), /*void*/);
    RF_RETFAIL;
  }
_block1: {}
  Expr _v_Get__While1;
  RF_CALL (refal::Stream::Stream::Get_While, (_vs_tream, _c_55), _v_Get__While1);
  _v_res1 = (_c_56 + _vs_first + _v_Get__While1);
RF_END

RF_FUNC (IsScan_Variable, (RF_ARG _vs_tream;;), (RF_RES _v_res1;;))
  Expr _v_Getc1;
  if (!RF_CALL (refal::Stream::Stream::Getc, _vs_tream, _v_Getc1))
  {
    RF_RETFAIL;
  }
  Expr _vs_type;
  {
    {
      if (!_v_Getc1.term_eq (_c_57, 0))
      {
        goto _block1__branch1;
      }
      _vs_type = _c_58;
      goto _block1;
    }
  _block1__branch1: {}
    {
      if (!_v_Getc1.term_eq (_c_59, 0))
      {
        goto _block1__branch2;
      }
      _vs_type = _c_60;
      goto _block1;
    }
  _block1__branch2: {}
    {
      if (!_v_Getc1.term_eq (_c_61, 0))
      {
        goto _block1__branch3;
      }
      _vs_type = _c_62;
      goto _block1;
    }
  _block1__branch3: {}
    {
      if (!_v_Getc1.term_eq (_c_63, 0))
      {
        goto _block1__branch4;
      }
      _vs_type = _c_64;
      goto _block1;
    }
  _block1__branch4: {}
    Expr _vt_1;
    _vt_1 = Expr (_v_Getc1, 0, 1);
    RF_CALL (refal::Stream::Stream::Ungets, (_vs_tream, _vt_1), /*void*/);
    RF_RETFAIL;
  }
_block1: {}
  Expr _v_Getc2;
  if (!RF_CALL (refal::Stream::Stream::Getc, _vs_tream, _v_Getc2))
  {
    RF_RETFAIL;
  }
  Expr _ve_name;
  {
    {
      if (!_v_Getc2.term_eq (_c_65, 0))
      {
        goto _block2__branch1;
      }
      RF_CALL (refal::Stream::Stream::Get_While, (_vs_tream, _c_16), _ve_name);
      goto _block2;
    }
  _block2__branch1: {}
    {
      if (!_v_Getc2.symbol_at (0))
      {
        goto _block2__branch2;
      }
      Expr _vs_1;
      _vs_1 = Expr (_v_Getc2, 0, 1);
      if (!RF_CALL (IsVar_Sym, _vs_1, /*void*/))
      {
        goto _block2__branch2;
      }
      Expr _v_Get__While1;
      RF_CALL (refal::Stream::Stream::Get_While, (_vs_tream, _c_16), _v_Get__While1);
      _ve_name = (_vs_1 + _v_Get__While1);
      goto _block2;
    }
  _block2__branch2: {}
    Expr _vt_1;
    _vt_1 = Expr (_v_Getc2, 0, 1);
    RF_CALL (refal::Stream::Stream::Ungets, (_vs_tream, _vt_1), /*void*/);
    _ve_name = empty;
  }
_block2: {}
  _v_res1 = (_vs_type + _ve_name);
RF_END

RF_FUNC (IsScan_Identifier, (RF_ARG _vs_tream;;), (RF_RES _v_res1;;))
  Expr _v_Getc1;
  if (!RF_CALL (refal::Stream::Stream::Getc, _vs_tream, _v_Getc1))
  {
    RF_RETFAIL;
  }
  if (!_v_Getc1.symbol_at (0))
  {
    RF_RETFAIL;
  }
  Expr _vs_first;
  _vs_first = Expr (_v_Getc1, 0, 1);
  {
    {
      {
        {
          if (!RF_CALL (IsUppercase_Letter, _vs_first, /*void*/))
          {
            goto _block2__branch1;
          }
          goto _block2;
        }
      _block2__branch1: {}
        if (!_vs_first.term_eq (_c_66, 0))
        {
          goto _block1__branch1;
        }
      }
    _block2: {}
      Expr _v_Get__While1;
      RF_CALL (refal::Stream::Stream::Get_While, (_vs_tream, _c_67), _v_Get__While1);
      _v_res1 = (_c_68 + _vs_first + _v_Get__While1);
      goto _block1;
    }
  _block1__branch1: {}
    RF_CALL (refal::Stream::Stream::Ungets, (_vs_tream, _vs_first), /*void*/);
    RF_RETFAIL;
  }
_block1: {}
RF_END

RF_FUNC (IsUppercase_Letter, (RF_ARG _vs_letter;;), RF_VOID)
  if (!RF_CALL (refal::Class::IsLetter, _vs_letter, /*void*/))
  {
    RF_RETFAIL;
  }
  Expr _ge_auxcall1;
  RF_CALL (refal::Convert::ToUpper, _vs_letter, _ge_auxcall1);
  RF_TAILCALL (refal::Compare::Eq, (_ge_auxcall1, _vs_letter), /*void*/);
RF_END

RF_FUNC (IsFun_Sym, (RF_ARG _gt_arg1;;), RF_VOID)
  if (!_gt_arg1.symbol_at (0))
  {
    RF_RETFAIL;
  }
  Expr _vs_ym;
  _vs_ym = Expr (_gt_arg1, 0, 1);
  {
    {
      if (!RF_CALL (refal::Class::IsLetter, _vs_ym, /*void*/))
      {
        goto _block1__branch1;
      }
      goto _block1;
    }
  _block1__branch1: {}
    {
      if (!RF_CALL (refal::Class::IsDigit, _vs_ym, /*void*/))
      {
        goto _block1__branch2;
      }
      goto _block1;
    }
  _block1__branch2: {}
    RF_lsplit (_c_69, 0, _ve__dollar_tmp_m_168_m_13, _v_lsplit__69);
    for ( ; ; RF_iter(_c_69)++)
    {
      {
        if (!RF_iter(_c_69))
        {
          RF_RETFAIL;
        }
        int _v_len1;
        _v_len1 = _v_lsplit__69.get_len ();
        int _v_len2;
        _v_len2 = 1;
        if (_v_len1 < _v_len2)
        {
          RF_RETFAIL;
        }
        int _v_len___dollar_tmp_m_168_m_19;
        _v_len___dollar_tmp_m_168_m_19 = (_v_len1 - _v_len2);
        if (!_vs_ym.term_eq (_v_lsplit__69, 0))
        {
          goto _continue1;
        }
        Expr _ve__dollar_tmp_m_168_m_19;
        _ve__dollar_tmp_m_168_m_19 = Expr (_v_lsplit__69, (0 + 1), _v_len___dollar_tmp_m_168_m_19);
        goto _exit1;
      }
  _continue1: {}
    }
  _exit1: {}
  }
_block1: {}
RF_END

RF_FUNC (IsScan_Quoted_Word, (RF_ARG _vs_tream;;), (RF_RES _v_res1;;))
  {
    {
      {
        if (!RF_CALL (IsCollecting_Errors, /*void*/, /*void*/))
        {
          goto _negation1;
        }
        goto _block1__branch1;
      }
    _negation1: {}
      RF_CALL (refal::Stream::StreamErr::Clear_Errors, /*void*/, /*void*/);
      goto _block1;
    }
  _block1__branch1: {}
  }
_block1: {}
  Expr _vt_pos;
  RF_CALL (refal::Stream::IndexedStream::Current_Pos, _vs_tream, _vt_pos);
  Expr _v_Getc1;
  if (!RF_CALL (refal::Stream::Stream::Getc, _vs_tream, _v_Getc1))
  {
    RF_RETFAIL;
  }
  {
    {
      if (!_v_Getc1.term_eq (_c_70, 0))
      {
        goto _block2__branch1;
      }
      Expr _v_Scan__String__Rest1;
      RF_CALL (Scan_String_Rest, (_vt_pos, _c_71, _c_70, _vs_tream), _v_Scan__String__Rest1);
      _v_res1 = (_c_72 + _v_Scan__String__Rest1);
      goto _block2;
    }
  _block2__branch1: {}
    Expr _vt_1;
    _vt_1 = Expr (_v_Getc1, 0, 1);
    RF_CALL (refal::Stream::Stream::Ungets, (_vs_tream, _vt_1), /*void*/);
    RF_RETFAIL;
  }
_block2: {}
RF_END

RF_FUNC (IsScan_String, (RF_ARG _vs_tream;;), (RF_RES _v_res1;;))
  {
    {
      {
        if (!RF_CALL (IsCollecting_Errors, /*void*/, /*void*/))
        {
          goto _negation1;
        }
        goto _block1__branch1;
      }
    _negation1: {}
      RF_CALL (refal::Stream::StreamErr::Clear_Errors, /*void*/, /*void*/);
      goto _block1;
    }
  _block1__branch1: {}
  }
_block1: {}
  Expr _vt_pos;
  RF_CALL (refal::Stream::IndexedStream::Current_Pos, _vs_tream, _vt_pos);
  Expr _v_Getc1;
  if (!RF_CALL (refal::Stream::Stream::Getc, _vs_tream, _v_Getc1))
  {
    RF_RETFAIL;
  }
  {
    {
      if (!_v_Getc1.term_eq (_c_73, 0))
      {
        goto _block2__branch1;
      }
      Expr _v_Scan__String__Rest1;
      RF_CALL (Scan_String_Rest, (_vt_pos, _c_71, _c_73, _vs_tream), _v_Scan__String__Rest1);
      _v_res1 = (_c_74 + _v_Scan__String__Rest1);
      goto _block2;
    }
  _block2__branch1: {}
    Expr _vt_1;
    _vt_1 = Expr (_v_Getc1, 0, 1);
    RF_CALL (refal::Stream::Stream::Ungets, (_vs_tream, _vt_1), /*void*/);
    RF_RETFAIL;
  }
_block2: {}
RF_END

RF_FUNC (IsScan_Char, (RF_ARG _vs_tream;;), (RF_RES _v_res1;;))
  {
    {
      {
        if (!RF_CALL (IsCollecting_Errors, /*void*/, /*void*/))
        {
          goto _negation1;
        }
        goto _block1__branch1;
      }
    _negation1: {}
      RF_CALL (refal::Stream::StreamErr::Clear_Errors, /*void*/, /*void*/);
      goto _block1;
    }
  _block1__branch1: {}
  }
_block1: {}
  Expr _vt_pos;
  RF_CALL (refal::Stream::IndexedStream::Current_Pos, _vs_tream, _vt_pos);
  Expr _v_Getc1;
  if (!RF_CALL (refal::Stream::Stream::Getc, _vs_tream, _v_Getc1))
  {
    RF_RETFAIL;
  }
  {
    {
      if (!_v_Getc1.term_eq (_c_73, 0))
      {
        goto _block2__branch1;
      }
      Expr _v_Scan__String__Rest1;
      RF_CALL (Scan_String_Rest, (_vt_pos, _c_0, _c_73, _vs_tream), _v_Scan__String__Rest1);
      {
        {
          int _v_len1;
          _v_len1 = _v_Scan__String__Rest1.get_len ();
          int _v_len2;
          _v_len2 = 0;
          if (_v_len1 < (_v_len2 + 1))
          {
            goto _block3__branch1;
          }
          int _v_len__str;
          _v_len__str = (_v_len1 - _v_len2);
          Expr _vv_str;
          _vv_str = Expr (_v_Scan__String__Rest1, 0, _v_len__str);
          RF_CALL (refal::Stream::Stream::Ungets, (_vs_tream, _c_73), /*void*/);
          _v_res1 = (_c_74 + _vv_str);
          goto _block3;
        }
      _block3__branch1: {}
        int _v_len3;
        _v_len3 = _v_Scan__String__Rest1.get_len ();
        int _v_len4;
        _v_len4 = 0;
        if (_v_len3 < _v_len4)
        {
          RF_FUNC_ERROR (unexpected_fail);
        }
        int _v_len__mpty;
        _v_len__mpty = (_v_len3 - _v_len4);
        Expr _ve_mpty;
        _ve_mpty = Expr (_v_Scan__String__Rest1, 0, _v_len__mpty);
        _v_res1 = _c_74;
      }
    _block3: {}
      goto _block2;
    }
  _block2__branch1: {}
    Expr _vt_1;
    _vt_1 = Expr (_v_Getc1, 0, 1);
    RF_CALL (refal::Stream::Stream::Ungets, (_vs_tream, _vt_1), /*void*/);
    RF_RETFAIL;
  }
_block2: {}
RF_END

RF_FUNC (Scan_String_Rest, (RF_ARG _vt_pos, _vs_max, _vs_term, _vs_tream;;), (RF_RES _v_res1;;))
  Expr _ve_s;
  _ve_s = empty;
  Expr _gs_max__0;
  _gs_max__0 = _vs_max;
  for ( ; ; )
  {
    {
      if (!_gs_max__0.term_eq (_c_1, 0))
      {
        goto _iter1;
      }
      _v_res1 = _ve_s;
      goto _exit__iter1;
    }
  _iter1: {}
    {
      {
        Expr _v_Getc1;
        if (!RF_CALL (refal::Stream::Stream::Getc, _vs_tream, _v_Getc1))
        {
          goto _block1__branch1;
        }
        {
          {
            if (!_vs_term.term_eq (_v_Getc1, 0))
            {
              goto _block2__branch1;
            }
            _gs_max__0 = _c_1;
            goto _block2;
          }
        _block2__branch1: {}
          {
            if (!_v_Getc1.term_eq (_c_75, 0))
            {
              goto _block2__branch2;
            }
            {
              {
                Expr _v_Getc2;
                if (!RF_CALL (refal::Stream::Stream::Getc, _vs_tream, _v_Getc2))
                {
                  goto _block3__branch1;
                }
                {
                  {
                    if (!_v_Getc2.term_eq (_c_76, 0))
                    {
                      goto _block4__branch1;
                    }
                    RF_CALL (refal::Arithm::Sub, (_gs_max__0, _c_0), _gs_max__0);
                    _ve_s = (_ve_s + _c_4);
                    goto _block4;
                  }
                _block4__branch1: {}
                  {
                    if (!_v_Getc2.term_eq (_c_63, 0))
                    {
                      goto _block4__branch2;
                    }
                    RF_CALL (refal::Arithm::Sub, (_gs_max__0, _c_0), _gs_max__0);
                    _ve_s = (_ve_s + _c_3);
                    goto _block4;
                  }
                _block4__branch2: {}
                  {
                    if (!_v_Getc2.term_eq (_c_61, 0))
                    {
                      goto _block4__branch3;
                    }
                    RF_CALL (refal::Arithm::Sub, (_gs_max__0, _c_0), _gs_max__0);
                    _ve_s = (_ve_s + _c_61);
                    goto _block4;
                  }
                _block4__branch3: {}
                  {
                    if (!_v_Getc2.term_eq (_c_77, 0))
                    {
                      goto _block4__branch4;
                    }
                    RF_CALL (refal::Arithm::Sub, (_gs_max__0, _c_0), _gs_max__0);
                    _ve_s = (_ve_s + _c_77);
                    goto _block4;
                  }
                _block4__branch4: {}
                  {
                    if (!_v_Getc2.term_eq (_c_35, 0))
                    {
                      goto _block4__branch5;
                    }
                    RF_CALL (refal::Arithm::Sub, (_gs_max__0, _c_0), _gs_max__0);
                    _ve_s = (_ve_s + _c_5);
                    goto _block4;
                  }
                _block4__branch5: {}
                  {
                    if (!_v_Getc2.term_eq (_c_78, 0))
                    {
                      goto _block4__branch6;
                    }
                    RF_CALL (refal::Arithm::Sub, (_gs_max__0, _c_0), _gs_max__0);
                    _ve_s = (_ve_s + _c_78);
                    goto _block4;
                  }
                _block4__branch6: {}
                  {
                    if (!_v_Getc2.term_eq (_c_75, 0))
                    {
                      goto _block4__branch7;
                    }
                    RF_CALL (refal::Arithm::Sub, (_gs_max__0, _c_0), _gs_max__0);
                    _ve_s = (_ve_s + _c_75);
                    goto _block4;
                  }
                _block4__branch7: {}
                  {
                    if (!_v_Getc2.term_eq (_c_73, 0))
                    {
                      goto _block4__branch8;
                    }
                    RF_CALL (refal::Arithm::Sub, (_gs_max__0, _c_0), _gs_max__0);
                    _ve_s = (_ve_s + _c_73);
                    goto _block4;
                  }
                _block4__branch8: {}
                  {
                    if (!_v_Getc2.term_eq (_c_70, 0))
                    {
                      goto _block4__branch9;
                    }
                    RF_CALL (refal::Arithm::Sub, (_gs_max__0, _c_0), _gs_max__0);
                    _ve_s = (_ve_s + _c_70);
                    goto _block4;
                  }
                _block4__branch9: {}
                  {
                    if (!_v_Getc2.term_eq (_c_4, 0))
                    {
                      goto _block4__branch10;
                    }
                    goto _block4;
                  }
                _block4__branch10: {}
                  {
                    if (!_v_Getc2.symbol_at (0))
                    {
                      goto _block4__branch11;
                    }
                    Expr _vs_1;
                    _vs_1 = Expr (_v_Getc2, 0, 1);
                    RF_CALL (refal::Stream::StreamErr::Error, (_vs_tream, (_c_79 + _vs_1 + _c_11)), /*void*/);
                    RF_CALL (refal::Arithm::Sub, (_gs_max__0, _c_0), _gs_max__0);
                    _ve_s = (_ve_s + _vs_1);
                    goto _block4;
                  }
                _block4__branch11: {}
                  Expr _vt_1;
                  _vt_1 = Expr (_v_Getc2, 0, 1);
                  RF_CALL (refal::Stream::StreamErr::Error, (_vs_tream, (_c_80 + _vt_1 + _c_11)), /*void*/);
                }
              _block4: {}
                goto _block3;
              }
            _block3__branch1: {}
              RF_CALL (refal::Stream::StreamErr::Error_At, (_vt_pos, _c_81), /*void*/);
              _gs_max__0 = _c_1;
            }
          _block3: {}
            goto _block2;
          }
        _block2__branch2: {}
          {
            if (!_v_Getc1.term_eq (_c_4, 0))
            {
              goto _block2__branch3;
            }
            RF_CALL (refal::Arithm::Sub, (_gs_max__0, _c_0), _gs_max__0);
            _ve_s = (_ve_s + _c_4);
            goto _block2;
          }
        _block2__branch3: {}
          {
            if (!_v_Getc1.symbol_at (0))
            {
              goto _block2__branch4;
            }
            Expr _vs_1;
            _vs_1 = Expr (_v_Getc1, 0, 1);
            RF_CALL (refal::Arithm::Sub, (_gs_max__0, _c_0), _gs_max__0);
            _ve_s = (_ve_s + _vs_1);
            goto _block2;
          }
        _block2__branch4: {}
          Expr _vt_1;
          _vt_1 = Expr (_v_Getc1, 0, 1);
          RF_CALL (refal::Stream::StreamErr::Error, (_vs_tream, (_c_12 + _vt_1 + _c_11)), /*void*/);
        }
      _block2: {}
        goto _block1;
      }
    _block1__branch1: {}
      RF_CALL (refal::Stream::StreamErr::Error_At, (_vt_pos, _c_81), /*void*/);
      _gs_max__0 = _c_1;
    }
  _block1: {}
  }
_exit__iter1: {}
RF_END

RF_FUNC (IsRead_Term, (RF_ARG _vs_tream;;), (RF_RES _v_res1;;))
  RF_CALL (Start_Collect_Errors, /*void*/, /*void*/);
  RF_CALL (refal::Box::Store, (Parenth_Level, _c_1), /*void*/);
  {
    {
      Expr _vt_erm;
      if (!RF_CALL (Read_Term_Aux, _vs_tream, _vt_erm))
      {
        goto _block1__branch1;
      }
      RF_CALL (Stop_Collect_Errors, /*void*/, /*void*/);
      _v_res1 = _vt_erm;
      goto _block1;
    }
  _block1__branch1: {}
    RF_CALL (Stop_Collect_Errors, /*void*/, /*void*/);
    RF_RETFAIL;
  }
_block1: {}
RF_END

RF_FUNC (Read_Term_Aux, (RF_ARG _vs_tream;;), (RF_RES _v_res1;;))
  Expr _ve_Isstop;
  _ve_Isstop = empty;
  for ( ; ; )
  {
    {
      if (_ve_Isstop.get_len () != 1)
      {
        goto _iter1;
      }
      if (!_c_9.term_eq (_ve_Isstop, 0))
      {
        goto _iter1;
      }
      {
        {
          Expr _vt_pos;
          RF_CALL (refal::Stream::IndexedStream::Current_Pos, _vs_tream, _vt_pos);
          Expr _v_Getc1;
          if (!RF_CALL (refal::Stream::Stream::Getc, _vs_tream, _v_Getc1))
          {
            goto _block1__branch1;
          }
          {
            {
              if (!_v_Getc1.term_eq (_c_82, 0))
              {
                goto _block2__branch1;
              }
              Expr _v_Get1;
              RF_CALL (refal::Box::Get, Parenth_Level, _v_Get1);
              if (_v_Get1.get_len () != 1)
              {
                RF_RETFAIL;
              }
              if (!_v_Get1.symbol_at (0))
              {
                RF_RETFAIL;
              }
              Expr _vs_level;
              _vs_level = Expr (_v_Get1, 0, 1);
              Expr _gs_auxcall1;
              RF_CALL (refal::Arithm::Add, (_vs_level, _c_0), _gs_auxcall1);
              RF_CALL (refal::Box::Store, (Parenth_Level, _gs_auxcall1), /*void*/);
              Expr _ve_terms;
              _ve_terms = empty;
              Expr _ve_last;
              _ve_last = empty;
              for ( ; ; )
              {
                {
                  Expr _v_Get2;
                  RF_CALL (refal::Box::Get, Parenth_Level, _v_Get2);
                  if (_v_Get2.get_len () != 1)
                  {
                    goto _iter2;
                  }
                  if (!_vs_level.term_eq (_v_Get2, 0))
                  {
                    goto _iter2;
                  }
                  _v_res1 = _ve_terms ();
                  goto _exit__iter2;
                }
              _iter2: {}
                {
                  {
                    Expr _gt_auxcall2;
                    if (!RF_CALL (Read_Term_Aux, _vs_tream, _gt_auxcall2))
                    {
                      goto _block3__branch1;
                    }
                    _ve_terms = (_ve_terms + _ve_last);
                    _ve_last = _gt_auxcall2;
                    goto _block3;
                  }
                _block3__branch1: {}
                  RF_CALL (refal::Stream::StreamErr::Error_At, (_vt_pos, _c_83), /*void*/);
                  RF_RETFAIL;
                }
              _block3: {}
              }
            _exit__iter2: {}
              goto _block2;
            }
          _block2__branch1: {}
            {
              if (!_v_Getc1.term_eq (_c_84, 0))
              {
                goto _block2__branch2;
              }
              Expr _v_Get3;
              RF_CALL (refal::Box::Get, Parenth_Level, _v_Get3);
              if (_v_Get3.get_len () != 1)
              {
                RF_RETFAIL;
              }
              if (!_v_Get3.symbol_at (0))
              {
                RF_RETFAIL;
              }
              Expr _vs_level;
              _vs_level = Expr (_v_Get3, 0, 1);
              {
                {
                  if (!RF_CALL (refal::Compare::Gt, (_vs_level, _c_1), /*void*/))
                  {
                    goto _block4__branch1;
                  }
                  Expr _gs_auxcall3;
                  RF_CALL (refal::Arithm::Sub, (_vs_level, _c_0), _gs_auxcall3);
                  RF_CALL (refal::Box::Store, (Parenth_Level, _gs_auxcall3), /*void*/);
                  _v_res1 = _c_85;
                  goto _block4;
                }
              _block4__branch1: {}
                RF_CALL (refal::Stream::StreamErr::Error, (_vs_tream, _c_86), /*void*/);
                RF_RETFAIL;
              }
            _block4: {}
              goto _block2;
            }
          _block2__branch2: {}
            Expr _vt_1;
            _vt_1 = Expr (_v_Getc1, 0, 1);
            RF_CALL (refal::Stream::Stream::Ungets, (_vs_tream, _vt_1), /*void*/);
            goto _block1__branch1;
          }
        _block2: {}
          goto _block1;
        }
      _block1__branch1: {}
        {
          Expr _ge_auxalt4;
          {
            {
              if (!RF_CALL (IsScan_Identifier, _vs_tream, _ge_auxalt4))
              {
                goto _block5__branch1;
              }
              goto _block5;
            }
          _block5__branch1: {}
            {
              if (!RF_CALL (IsScan_Quoted_Word, _vs_tream, _ge_auxalt4))
              {
                goto _block5__branch2;
              }
              goto _block5;
            }
          _block5__branch2: {}
            {
              if (!RF_CALL (IsScan_Char, _vs_tream, _ge_auxalt4))
              {
                goto _block5__branch3;
              }
              goto _block5;
            }
          _block5__branch3: {}
            if (!RF_CALL (IsScan_Number, _vs_tream, _ge_auxalt4))
            {
              goto _block1__branch2;
            }
          }
        _block5: {}
          int _v_len1;
          _v_len1 = _ge_auxalt4.get_len ();
          int _v_len2;
          _v_len2 = 1;
          if (_v_len1 < _v_len2)
          {
            goto _block1__branch2;
          }
          int _v_len__value;
          _v_len__value = (_v_len1 - _v_len2);
          if (!_ge_auxalt4.symbol_at (0))
          {
            goto _block1__branch2;
          }
          Expr _vs_type;
          _vs_type = Expr (_ge_auxalt4, 0, 1);
          Expr _ve_value;
          _ve_value = Expr (_ge_auxalt4, (0 + 1), _v_len__value);
          {
            {
              if (!_vs_type.term_eq (_c_68, 0))
              {
                goto _block6__branch1;
              }
              {
                {
                  Expr _v_Get4;
                  RF_CALL (refal::Box::Get, Case_Insensitive, _v_Get4);
                  if (_v_Get4.get_len () != 1)
                  {
                    goto _block7__branch1;
                  }
                  if (!_c_0.term_eq (_v_Get4, 0))
                  {
                    goto _block7__branch1;
                  }
                  Expr _ge_auxcall5;
                  RF_CALL (refal::Convert::ToUpper, _ve_value, _ge_auxcall5);
                  RF_CALL (refal::Convert::ToWord, _ge_auxcall5, _v_res1);
                  goto _block7;
                }
              _block7__branch1: {}
                RF_CALL (refal::Convert::ToWord, _ve_value, _v_res1);
              }
            _block7: {}
              goto _block6;
            }
          _block6__branch1: {}
            {
              if (!_vs_type.term_eq (_c_72, 0))
              {
                goto _block6__branch2;
              }
              RF_CALL (refal::Convert::ToWord, _ve_value, _v_res1);
              goto _block6;
            }
          _block6__branch2: {}
            {
              if (!_vs_type.term_eq (_c_74, 0))
              {
                goto _block6__branch3;
              }
              {
                {
                  if (_v_len__value != 1)
                  {
                    goto _block8__branch1;
                  }
                  if (!_ve_value.symbol_at (0))
                  {
                    goto _block8__branch1;
                  }
                  Expr _vs_ymbol;
                  _vs_ymbol = Expr (_ve_value, 0, 1);
                  _v_res1 = _vs_ymbol;
                  goto _block8;
                }
              _block8__branch1: {}
                RF_TAILCALL (Read_Term_Aux, _vs_tream, _v_res1);
              }
            _block8: {}
              goto _block6;
            }
          _block6__branch3: {}
            if (!_vs_type.term_eq (_c_56, 0))
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            if (!RF_CALL (refal::Convert::ToInt, _ve_value, _v_res1))
            {
              RF_RETFAIL;
            }
          }
        _block6: {}
          goto _block1;
        }
      _block1__branch2: {}
        Expr _v_Getc2;
        if (!RF_CALL (refal::Stream::Stream::Getc, _vs_tream, _v_Getc2))
        {
          RF_RETFAIL;
        }
        Expr _vt_1;
        _vt_1 = Expr (_v_Getc2, 0, 1);
        RF_CALL (refal::Stream::StreamErr::Error, (_vs_tream, (_c_12 + _vt_1 + _c_11)), /*void*/);
        RF_TAILCALL (Read_Term_Aux, _vs_tream, _v_res1);
      }
    _block1: {}
      goto _exit__iter1;
    }
  _iter1: {}
    {
      {
        if (!RF_CALL (IsSkip_Blank, _vs_tream, /*void*/))
        {
          goto _block9__branch1;
        }
        _ve_Isstop = empty;
        goto _block9;
      }
    _block9__branch1: {}
      {
        if (!RF_CALL (IsSkip_Comment, _vs_tream, /*void*/))
        {
          goto _block9__branch2;
        }
        _ve_Isstop = empty;
        goto _block9;
      }
    _block9__branch2: {}
      _ve_Isstop = _c_9;
    }
  _block9: {}
  }
_exit__iter1: {}
RF_END

RF_FUNC (IsFun_Sym_0, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  if (_ge_arg1.get_len () != 1)
  {
    RF_ERROR (_c_87);
  }
  Expr _v_stub1;
  _v_stub1 = Expr (_ge_arg1, 0, 1);
  if (!RF_CALL (IsFun_Sym, _v_stub1, /*void*/))
  {
    RF_RETFAIL;
  }
  _v_res1 = empty;
RF_END

RF_FUNC (IsBlank_0, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  if (_ge_arg1.get_len () != 1)
  {
    RF_ERROR (_c_87);
  }
  Expr _v_stub1;
  _v_stub1 = Expr (_ge_arg1, 0, 1);
  if (!RF_CALL (IsBlank, _v_stub1, /*void*/))
  {
    RF_RETFAIL;
  }
  _v_res1 = empty;
RF_END

RF_FUNC (IsDigit_0, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  int _v_len1;
  _v_len1 = _ge_arg1.get_len ();
  int _v_len2;
  _v_len2 = 0;
  if (_v_len1 < _v_len2)
  {
    RF_ERROR (_c_87);
  }
  int _v_len__stub1;
  _v_len__stub1 = (_v_len1 - _v_len2);
  Expr _v_stub1;
  _v_stub1 = Expr (_ge_arg1, 0, _v_len__stub1);
  if (!RF_CALL (refal::Class::IsDigit, _v_stub1, /*void*/))
  {
    RF_RETFAIL;
  }
  _v_res1 = empty;
RF_END

RF_FUNC (IsVar_Sym_0, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  if (_ge_arg1.get_len () != 1)
  {
    RF_ERROR (_c_87);
  }
  Expr _v_stub1;
  _v_stub1 = Expr (_ge_arg1, 0, 1);
  if (!RF_CALL (IsVar_Sym, _v_stub1, /*void*/))
  {
    RF_RETFAIL;
  }
  _v_res1 = empty;
RF_END

}

}

}

namespace refal {

namespace Lexer {

namespace Lexer {

static void init_ () {
  Case_Insensitive = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Case_Insensitive");
  Parenth_Level = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Parenth_Level");
  _c_0 = Expr::create<rftype::Integer>("1");
  _c_1 = Expr::create<rftype::Integer>("0");
  Collect_Errors_Box = Expr::create_sym<BoxContents>(_c_1);
  _c_2 = rftype::Char::create_expr (L" ");
  _c_3 = rftype::Char::create_expr (L"\t");
  _c_4 = rftype::Char::create_expr (L"\n");
  _c_5 = rftype::Char::create_expr (L"\r");
  _c_6 = Expr::create_sym<rftype::Func> (IsBlank_0);
  _c_7 = rftype::Char::create_expr (L"*");
  _c_8 = rftype::Char::create_expr (L"/");
  _c_9 = Expr::create<rftype::Word>("Stop");
  _c_10 = Expr::create<rftype::Word>("Unclosed comment");
  _c_11 = Expr::create<rftype::Word>("'");
  _c_12 = Expr::create<rftype::Word>("Invalid character '");
  _c_13 = Expr::create<rftype::Word>("Unexpected end of file");
  _c_14 = rftype::Char::create_expr (L"-?!");
  _c_15 = rftype::Char::create_expr (L"$");
  _c_16 = Expr::create_sym<rftype::Func> (IsVar_Sym_0);
  _c_17 = rftype::Char::create_expr (L"box");
  _c_18 = Expr::create<rftype::Word>("BOX");
  _c_19 = rftype::Char::create_expr (L"channel");
  _c_20 = Expr::create<rftype::Word>("CHANNEL");
  _c_21 = rftype::Char::create_expr (L"const");
  _c_22 = Expr::create<rftype::Word>("CONST");
  _c_23 = rftype::Char::create_expr (L"error");
  _c_24 = Expr::create<rftype::Word>("ERROR");
  _c_25 = rftype::Char::create_expr (L"fail");
  _c_26 = Expr::create<rftype::Word>("FAIL");
  _c_29 = rftype::Char::create_expr (L"func?");
  _c_27 = Expr (_c_29, 0, 4);
  _c_28 = Expr::create<rftype::Word>("FUNC");
  _c_30 = Expr::create<rftype::Word>("FUNC?");
  _c_31 = rftype::Char::create_expr (L"iter");
  _c_32 = Expr::create<rftype::Word>("ITER");
  _c_33 = Expr (_c_19, 6, 1);
  _c_34 = Expr::create<rftype::Word>("L");
  _c_35 = Expr (_c_31, 3, 1);
  _c_36 = Expr::create<rftype::Word>("R");
  _c_37 = rftype::Char::create_expr (L"string");
  _c_38 = Expr::create<rftype::Word>("STRING");
  _c_39 = rftype::Char::create_expr (L"table");
  _c_40 = Expr::create<rftype::Word>("TABLE");
  _c_43 = rftype::Char::create_expr (L"traceall");
  _c_41 = Expr (_c_43, 0, 5);
  _c_42 = Expr::create<rftype::Word>("TRACE");
  _c_44 = Expr::create<rftype::Word>("TRACEALL");
  _c_45 = rftype::Char::create_expr (L"trap");
  _c_46 = Expr::create<rftype::Word>("TRAP");
  _c_47 = rftype::Char::create_expr (L"use");
  _c_48 = Expr::create<rftype::Word>("USE");
  _c_49 = rftype::Char::create_expr (L"vector");
  _c_50 = Expr::create<rftype::Word>("VECTOR");
  _c_51 = rftype::Char::create_expr (L"with");
  _c_52 = Expr::create<rftype::Word>("WITH");
  _c_53 = rftype::Char::create_expr (L"+");
  _c_54 = Expr (_c_14, 0, 1);
  _c_55 = Expr::create_sym<rftype::Func> (IsDigit_0);
  _c_56 = Expr::create<rftype::Word>("NUMBER");
  _c_57 = Expr (_c_47, 1, 1);
  _c_58 = Expr::create<rftype::Word>("SVAR");
  _c_59 = Expr (_c_47, 2, 1);
  _c_60 = Expr::create<rftype::Word>("EVAR");
  _c_61 = Expr (_c_49, 0, 1);
  _c_62 = Expr::create<rftype::Word>("VVAR");
  _c_63 = Expr (_c_51, 2, 1);
  _c_64 = Expr::create<rftype::Word>("TVAR");
  _c_69 = rftype::Char::create_expr (L"_.");
  _c_65 = Expr (_c_69, 1, 1);
  _c_66 = Expr (_c_69, 0, 1);
  _c_67 = Expr::create_sym<rftype::Func> (IsFun_Sym_0);
  _c_68 = Expr::create<rftype::Word>("WORD");
  _c_70 = rftype::Char::create_expr (L"\"");
  _c_71 = Expr::create<rftype::Integer>("-1");
  _c_72 = Expr::create<rftype::Word>("QWORD");
  _c_73 = rftype::Char::create_expr (L"'");
  _c_74 = Expr::create<rftype::Word>("SYMBOLS");
  _c_75 = rftype::Char::create_expr (L"\\");
  _c_76 = Expr (_c_27, 2, 1);
  _c_77 = Expr (_c_17, 0, 1);
  _c_78 = Expr (_c_27, 0, 1);
  _c_79 = Expr::create<rftype::Word>("Unknown control sequence '\\");
  _c_80 = Expr::create<rftype::Word>("Bad symbol '");
  _c_81 = Expr::create<rftype::Word>("Unclosed quotes");
  _c_82 = rftype::Char::create_expr (L"(");
  _c_83 = Expr::create<rftype::Word>("Unclosed parentheses");
  _c_84 = rftype::Char::create_expr (L")");
  _c_85 = (Expr::create<rftype::Word>("Time-To-Close-Parentheses")) ();
  _c_86 = Expr::create<rftype::Word>("Unexpected right parenthesis");
  _c_87 = Expr::create<rftype::Word>("Apply") + Expr::create<rftype::Word>("Apply") + Expr::create<rftype::Word>("Unexpected fail");
}

static AtStart init_registrator_ (&init_);

}

}

}
