#include <rf_core.hh>

using namespace rfrt;

namespace refal
{

namespace StdIO
{

RF_DECL(Write);
RF_DECL(WriteLn);

RF_FUNC (Write, (RF_ARG _expr;;), RF_VOID)
  if (!_expr.write(stdout)) {
    throw Word::create_expr(L"Write") +
      Word::create_expr(L"Expr::write() failed");
  }
RF_END

RF_FUNC (WriteLn, (RF_ARG _expr;;), RF_VOID)
  if (!_expr.writeln(stdout)) {
    throw Word::create_expr(L"WriteLn") +
      Word::create_expr(L"Expr::writeln() failed");
  }
RF_END

}
}
