#include <rf_core.hh>
#include <rf_types.hh>

using namespace rfrt;

namespace refal
{

namespace Table
{

RF_DECL(Bind);

RF_FUNC (Bind, (RF_ARG _table, _key, _val;;), RF_VOID)
   
  if (_table.get_len() == 1) {
    Term* p = _table.get_first();
    rftype::Table* _t = p->cast_to<rftype::Table>(type_table);
    if (!_t)
      RF_LIB_ERROR("Invalid argument");
    _t -> bind(_key,_val);   
  } else
   RF_LIB_ERROR("Invalid argument");

RF_END

}
}
