#include <rf_core.hh>

namespace refal
{

namespace Table
{

using namespace rfrt;

RF_FUNC (ClearTable, (RF_ARG _table;;), RF_VOID)
  assert(_table.get_len()==1);
  Term* p = _table.get_first();      
  rftype::Table* tab = p->cast_to<rftype::Table>(type_table);
  if (!tab)
    RF_LIB_ERROR("Invalid argument");
  tab->clear();        
RF_END

}
}
