#include <rf_core.hh>
#include <rf_types.hh>

#include <typeinfo>

using namespace rfrt;

namespace refal
{

namespace Table
{

RF_DECL(TableCopy);

RF_FUNC (TableCopy, (RF_ARG _table;;), (RF_RES _tabcopy;;))
   
  if (_table.get_len() == 1) {
    Term* p = _table.get_first();
    rftype::Table* t = p->cast_to<rftype::Table>(type_table);
    if (!t)
      RF_LIB_ERROR("Invalid argument");              
    _tabcopy = Expr(new rftype::Table(*t));   
  } else
    RF_LIB_ERROR("Invalid argument");

RF_END

}
}
