#include <rf_core.hh>
#include <rf_types.hh>

using namespace rfrt;

namespace refal
{

namespace Table
{

RF_DECL(Unbind);

RF_FUNC (Unbind, (RF_ARG _table, _key;;), RF_VOID)
   
  if (_table.get_len() == 1) {
    Term* p = _table.get_first();
    rftype::Table* t = p->cast_to<rftype::Table>(type_table);
    if (!t)
      RF_LIB_ERROR("Invalid argument");
    t -> unbind(_key);                                                    
  } else
    RF_LIB_ERROR("Invalid argument");

RF_END

}
}
