
#include <rf_core.hh>

using namespace rfrt;

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_asail {

RF_DECL (ASAIL_ADD);

RF_DECL (ASAIL_MAX);

RF_DECL (ASAIL_MUL);

RF_DECL (ASAIL_MIN);

RF_DECL (ASAIL_DIV);

RF_DECL (Op);

RF_DECL (ASAIL_SUB);

}

}

}

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_asail {

static Expr _c_0;

static Expr _c_1;

static Expr _c_2;

static Expr _c_3;

static Expr _c_4;

static Expr _c_5;

RF_FUNC (ASAIL_ADD, (RF_ARG _ve_args;;), (RF_RES _v_res1;;))
  RF_TAILCALL (Op, (_c_0, _ve_args), _v_res1);
RF_END

RF_FUNC (ASAIL_SUB, (RF_ARG _ve_args;;), (RF_RES _v_res1;;))
  RF_TAILCALL (Op, (_c_1, _ve_args), _v_res1);
RF_END

RF_FUNC (ASAIL_MUL, (RF_ARG _ve_args;;), (RF_RES _v_res1;;))
  RF_TAILCALL (Op, (_c_2, _ve_args), _v_res1);
RF_END

RF_FUNC (ASAIL_DIV, (RF_ARG _ve_args;;), (RF_RES _v_res1;;))
  RF_TAILCALL (Op, (_c_3, _ve_args), _v_res1);
RF_END

RF_FUNC (ASAIL_MAX, (RF_ARG _ve_args;;), (RF_RES _v_res1;;))
  RF_TAILCALL (Op, (_c_4, _ve_args), _v_res1);
RF_END

RF_FUNC (ASAIL_MIN, (RF_ARG _ve_args;;), (RF_RES _v_res1;;))
  RF_TAILCALL (Op, (_c_5, _ve_args), _v_res1);
RF_END

RF_FUNC (Op, (RF_ARG _ve_op, _ve_args;;), (RF_RES _v_res1;;))
  {
    {
      if (_ve_args.get_len () != 0)
      {
        goto _block1__branch1;
      }
      _v_res1 = empty;
      goto _block1;
    }
  _block1__branch1: {}
    {
      if (_ve_args.get_len () != 1)
      {
        goto _block1__branch2;
      }
      Expr _vt_1;
      _vt_1 = Expr (_ve_args, 0, 1);
      _v_res1 = _vt_1;
      goto _block1;
    }
  _block1__branch2: {}
    int _v_len1 = _ve_args.get_len ();
    int _v_len2 = 2;
    if (_v_len1 < _v_len2)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    int _v_len__1 = (_v_len1 - _v_len2);
    Expr _ve_1;
    _ve_1 = Expr (_ve_args, 0, _v_len__1);
    Expr _vt_2;
    _vt_2 = Expr (_ve_args, (0 + _v_len__1), 1);
    Expr _vt_3;
    _vt_3 = Expr (_ve_args, (0 + _v_len__1 + 1), 1);
    RF_TAILCALL (Op, (_ve_op, (_ve_1 + (_ve_op + _vt_2 () + _vt_3 ()) ())), _v_res1);
  }
_block1: {}
RF_END

}

}

}

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_asail {

static void init_ () {
  _c_0 = Expr::create<rftype::Word>("INFIX") + Expr::create<rftype::Word>("+");
  _c_1 = Expr::create<rftype::Word>("INFIX") + Expr::create<rftype::Word>("-");
  _c_2 = Expr::create<rftype::Word>("INFIX") + Expr::create<rftype::Word>("*");
  _c_3 = Expr::create<rftype::Word>("INFIX") + Expr::create<rftype::Word>("/");
  _c_4 = Expr::create<rftype::Word>("MAX");
  _c_5 = Expr::create<rftype::Word>("MIN");
}

static AtStart init_registrator_ (&init_);

}

}

}

}

}
