
#include <rf_core.hh>

using namespace rfrt;

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_err {

RF_DECL (RFP_Warning);

RF_DECL (RFP_Error);

}

}

}

}

}

namespace refal {

namespace Box {

RF_DECL (Get);

}

}

namespace refal {

namespace StdIO {

RF_DECL (PrintLn);

}

}

namespace refal {

namespace Box {

RF_DECL (Store);

}

}

namespace refal {

namespace Arithm {

RF_DECL (Add);

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_err {

Expr Error_Counter;

Expr Warning_Counter;

static Expr _c_0;

static Expr _c_1;

static Expr _c_2;

static Expr _c_3;

static Expr _c_4;

RF_FUNC (RFP_Error, (RF_ARG _ge_arg1, _ge_arg2;;), RF_VOID)
  Expr _v_compose1 ((_ge_arg1 () + _ge_arg2 ()));
  if (_v_compose1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (_v_compose1.symbol_at ((0 + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _v_deref__compose1 (Expr (_v_compose1, 0));
  Expr _v_deref__compose12 (Expr (_v_compose1, (0 + 1)));
  if (_v_deref__compose1.get_len () != 2)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  int _v_len1 = _v_deref__compose12.get_len ();
  int _v_len2 = 0;
  if (_v_len1 < _v_len2)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  int _v_len__message = (_v_len1 - _v_len2);
  if (!_v_deref__compose1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_v_deref__compose1.symbol_at ((0 + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _vs_row;
  _vs_row = Expr (_v_deref__compose1, 0, 1);
  Expr _vs_column;
  _vs_column = Expr (_v_deref__compose1, (0 + 1), 1);
  Expr _ve_message;
  _ve_message = Expr (_v_deref__compose12, 0, _v_len__message);
  Expr _vs_n;
  {
    {
      Expr _v_Get1;
      RF_CALL (::refal::Box::Get, Error_Counter, _v_Get1);
      if (_v_Get1.get_len () != 1)
      {
        goto _block1__branch1;
      }
      if (!_v_Get1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _gs_n__2;
      _gs_n__2 = Expr (_v_Get1, 0, 1);
      _vs_n = _gs_n__2;
      goto _block1;
    }
  _block1__branch1: {}
    _vs_n = _c_0;
  }
_block1: {}
  Expr _gs_auxcall1;
  RF_CALL (::refal::Arithm::Add, (_vs_n, _c_1), _gs_auxcall1);
  RF_CALL (::refal::Box::Store, (Error_Counter, _gs_auxcall1), /*void*/);
  RF_TAILCALL (::refal::StdIO::PrintLn, (_vs_row + _c_3 + _vs_column + _c_2 + _ve_message), /*void*/);
RF_END

RF_FUNC (RFP_Warning, (RF_ARG _ge_arg1, _ge_arg2;;), RF_VOID)
  Expr _v_compose1 ((_ge_arg1 () + _ge_arg2 ()));
  if (_v_compose1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (_v_compose1.symbol_at ((0 + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _v_deref__compose1 (Expr (_v_compose1, 0));
  Expr _v_deref__compose12 (Expr (_v_compose1, (0 + 1)));
  if (_v_deref__compose1.get_len () != 4)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  int _v_len1 = _v_deref__compose12.get_len ();
  int _v_len2 = 0;
  if (_v_len1 < _v_len2)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  int _v_len__message = (_v_len1 - _v_len2);
  if (!_v_deref__compose1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_v_deref__compose1.symbol_at ((0 + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_v_deref__compose1.symbol_at ((0 + 1 + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_v_deref__compose1.symbol_at ((0 + 1 + 1 + 1)))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _vs_idx;
  _vs_idx = Expr (_v_deref__compose1, 0, 1);
  Expr _vs_type;
  _vs_type = Expr (_v_deref__compose1, (0 + 1), 1);
  Expr _vs_row;
  _vs_row = Expr (_v_deref__compose1, (0 + 1 + 1), 1);
  Expr _vs_column;
  _vs_column = Expr (_v_deref__compose1, (0 + 1 + 1 + 1), 1);
  Expr _ve_message;
  _ve_message = Expr (_v_deref__compose12, 0, _v_len__message);
  Expr _vs_n;
  {
    {
      Expr _v_Get1;
      RF_CALL (::refal::Box::Get, Warning_Counter, _v_Get1);
      if (_v_Get1.get_len () != 1)
      {
        goto _block1__branch1;
      }
      if (!_v_Get1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _gs_n__2;
      _gs_n__2 = Expr (_v_Get1, 0, 1);
      _vs_n = _gs_n__2;
      goto _block1;
    }
  _block1__branch1: {}
    _vs_n = _c_0;
  }
_block1: {}
  Expr _gs_auxcall1;
  RF_CALL (::refal::Arithm::Add, (_vs_n, _c_1), _gs_auxcall1);
  RF_CALL (::refal::Box::Store, (Warning_Counter, _gs_auxcall1), /*void*/);
  RF_TAILCALL (::refal::StdIO::PrintLn, (_vs_row + _c_3 + _vs_column + _c_4 + _ve_message), /*void*/);
RF_END

}

}

}

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_err {

static void init_ () {
  Error_Counter = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Error_Counter");
  Warning_Counter = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Warning_Counter");
  _c_0 = Expr::create<rftype::Integer>("0");
  _c_1 = Expr::create<rftype::Integer>("1");
  _c_2 = Expr::create<rftype::Word>(" --- Error: ");
  _c_3 = Expr::create<rftype::Word>(", ");
  _c_4 = Expr::create<rftype::Word>(" --- Warning: ");
}

static AtStart init_registrator_ (&init_);

}

}

}

}

}
