
#include <rf_core.hh>

using namespace rfrt;

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_lex {

RF_DECL (AddError);

RF_DECL (AddWarning);

RF_DECL (GetSourceLine);

RF_DECL (Next_Column);

RF_DECL (IsNoDelimiter);

RF_DECL (Apply_0);

RF_DECL (AddErrorWPos);

RF_DECL (Next_Row);

RF_DECL (ScanCharsRest);

RF_DECL (ScanChars);

RF_DECL (RFP_Lexer);

RF_DECL (ScanNumber);

RF_DECL (ScanSymbols);

RF_DECL (ScanQWord);

RF_DECL (ScanVariable);

RF_DECL (SkipComment);

RF_DECL (ScanWord);

RF_DECL (ScanToken);

RF_DECL (ScanKeyword);

RF_DECL (Next_Column_0);

RF_DECL (TokenPosition);

}

}

}

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_src {

RF_DECL (IsCaseInsensitive);

RF_DECL (NextRow);

RF_DECL (PositionToChars);

RF_DECL (NextColumn);

RF_DECL (InitPosition);

RF_DECL (VarSymbol);

RF_DECL (WordSymbol);

}

}

}

}

}

namespace refal {

namespace Apply {

RF_DECL (Apply);

}

}

namespace refal {

namespace Access {

RF_DECL (Length);

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_src {

RF_DECL (WordFirstSymbol);

}

}

}

}

}

namespace refal {

namespace Box {

RF_DECL (Put);

RF_DECL (Get);

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_src {

RF_DECL (Reader_GetLine);

}

}

}

}

}

namespace refal {

namespace Class {

RF_DECL (IsDigit);

}

}

namespace refal {

namespace Compare {

RF_DECL (Eq);

}

}

namespace refal {

namespace Convert {

RF_DECL (ToInt);

}

}

namespace refal {

namespace Class {

RF_DECL (IsLetter);

}

}

namespace refal {

namespace List {

RF_DECL (Map);

}

}

namespace refal {

namespace Convert {

RF_DECL (ToUpper);

}

}

namespace refal {

namespace List {

RF_DECL (Replicate);

}

}

namespace refal {

namespace Convert {

RF_DECL (ToLower);

}

}

namespace refal {

namespace Box {

RF_DECL (Store);

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_lex {

RF_DECL (SkipLineComment);

}

}

}

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_lex {

static Expr Errors;

static Expr Position;

static Expr Source;

static Expr _c_4;

static Expr _c_0;

static Expr _c_136;

static Expr _c_1;

static Expr _c_2;

static Expr _c_3;

static Expr _c_5;

static Expr _c_6;

static Expr _c_7;

static Expr _c_8;

static Expr _c_9;

static Expr _c_10;

static Expr _c_11;

static Expr _c_12;

static Expr _c_13;

static Expr _c_14;

static Expr _c_15;

static Expr _c_16;

static Expr _c_17;

static Expr _c_18;

static Expr _c_19;

static Expr _c_20;

static Expr _c_21;

static Expr _c_22;

static Expr _c_23;

static Expr _c_24;

static Expr _c_25;

static Expr _c_26;

static Expr _c_27;

static Expr _c_28;

static Expr _c_29;

static Expr _c_30;

static Expr _c_31;

static Expr _c_32;

static Expr _c_33;

static Expr _c_34;

static Expr _c_35;

static Expr _c_36;

static Expr _c_37;

static Expr _c_38;

static Expr _c_39;

static Expr _c_40;

static Expr _c_41;

static Expr _c_42;

static Expr _c_43;

static Expr _c_44;

static Expr _c_45;

static Expr _c_46;

static Expr _c_47;

static Expr _c_113;

static Expr _c_48;

static Expr _c_49;

static Expr _c_50;

static Expr _c_51;

static Expr _c_52;

static Expr _c_53;

static Expr _c_54;

static Expr _c_55;

static Expr _c_56;

static Expr _c_57;

static Expr _c_58;

static Expr _c_61;

static Expr _c_59;

static Expr _c_60;

static Expr _c_62;

static Expr _c_63;

static Expr _c_64;

static Expr _c_65;

static Expr _c_66;

static Expr _c_67;

static Expr _c_68;

static Expr _c_69;

static Expr _c_70;

static Expr _c_71;

static Expr _c_72;

static Expr _c_73;

static Expr _c_74;

static Expr _c_75;

static Expr _c_76;

static Expr _c_77;

static Expr _c_78;

static Expr _c_79;

static Expr _c_80;

static Expr _c_81;

static Expr _c_82;

static Expr _c_85;

static Expr _c_83;

static Expr _c_84;

static Expr _c_86;

static Expr _c_87;

static Expr _c_88;

static Expr _c_89;

static Expr _c_90;

static Expr _c_91;

static Expr _c_92;

static Expr _c_93;

static Expr _c_94;

static Expr _c_95;

static Expr _c_96;

static Expr _c_134;

static Expr _c_97;

static Expr _c_112;

static Expr _c_98;

static Expr _c_99;

static Expr _c_100;

static Expr _c_101;

static Expr _c_102;

static Expr _c_103;

static Expr _c_104;

static Expr _c_105;

static Expr _c_106;

static Expr _c_107;

static Expr _c_108;

static Expr _c_109;

static Expr _c_110;

static Expr _c_111;

static Expr _c_114;

static Expr _c_115;

static Expr _c_116;

static Expr _c_117;

static Expr _c_118;

static Expr _c_119;

static Expr _c_120;

static Expr _c_121;

static Expr _c_122;

static Expr _c_123;

static Expr _c_124;

static Expr _c_125;

static Expr _c_126;

static Expr _c_127;

static Expr _c_128;

static Expr _c_129;

static Expr _c_130;

static Expr _c_131;

static Expr _c_132;

static Expr _c_133;

static Expr _c_135;

RF_FUNC (RFP_Lexer, (RF_ARG _ve_source;;), (RF_RES _v_res1, _v_res2;;))
  RF_CALL (::refal::Box::Store, (Source, _ve_source), /*void*/);
  Expr _ge_auxcall1;
  RF_CALL (org::refal::plus::compiler::rfp_src::InitPosition, /*void*/, _ge_auxcall1);
  RF_CALL (::refal::Box::Store, (Position, _ge_auxcall1), /*void*/);
  RF_CALL (::refal::Box::Store, (Errors, empty), /*void*/);
  Expr _ve_tokens;
  Expr _ve_line;
  for ( ; ; )
  {
    {
      int _v_len1 = _ve_tokens.get_len ();
      int _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _iter1;
      }
      int _v_len___dollar_tmp_m_32_m_15 = (_v_len1 - _v_len2);
      if (_ve_tokens.symbol_at ((0 + _v_len___dollar_tmp_m_32_m_15)))
      {
        goto _iter1;
      }
      Expr _v_deref__tokens (Expr (_ve_tokens, (0 + _v_len___dollar_tmp_m_32_m_15)));
      if (_v_deref__tokens.get_len () != 2)
      {
        goto _iter1;
      }
      if (_v_deref__tokens.symbol_at (0))
      {
        goto _iter1;
      }
      Expr _v_deref__deref__tokens (Expr (_v_deref__tokens, 0));
      int _v_len3 = _v_deref__deref__tokens.get_len ();
      int _v_len4 = 0;
      if (_v_len3 < _v_len4)
      {
        goto _iter1;
      }
      int _v_len___dollar_tmp_m_32_m_19 = (_v_len3 - _v_len4);
      if (!_c_0.term_eq (_v_deref__tokens, (0 + 1)))
      {
        goto _iter1;
      }
      Expr _ve__dollar_tmp_m_32_m_15;
      _ve__dollar_tmp_m_32_m_15 = Expr (_ve_tokens, 0, _v_len___dollar_tmp_m_32_m_15);
      Expr _ve__dollar_tmp_m_32_m_19;
      _ve__dollar_tmp_m_32_m_19 = Expr (_v_deref__deref__tokens, 0, _v_len___dollar_tmp_m_32_m_19);
      Expr _ge_auxcall2;
      RF_CALL (::refal::Box::Get, Errors, _ge_auxcall2);
      _v_res1 = _ve_tokens;
      _v_res2 = _ge_auxcall2;
      goto _exit__iter1;
    }
  _iter1: {}
    Expr _v_ScanToken1;
    RF_CALL (ScanToken, _ve_line, (_v_ScanToken1, _ve_line));
    _ve_tokens = (_ve_tokens + _v_ScanToken1);
  }
_exit__iter1: {}
RF_END

RF_FUNC (AddErrorWPos, (RF_ARG _ve_pos, _ve_msg;;), RF_VOID)
  RF_TAILCALL (::refal::Box::Put, (Errors, (_c_2 + (_ve_pos () + _c_1) () + _ve_msg ()) ()), /*void*/);
RF_END

RF_FUNC (AddError, (RF_ARG _ve_msg;;), RF_VOID)
  Expr _ge_auxcall1;
  RF_CALL (TokenPosition, /*void*/, _ge_auxcall1);
  RF_TAILCALL (::refal::Box::Put, (Errors, (_c_2 + (_ge_auxcall1 () + _c_1) () + _ve_msg ()) ()), /*void*/);
RF_END

RF_FUNC (AddWarning, (RF_ARG _ve_msg;;), RF_VOID)
  Expr _ge_auxcall1;
  RF_CALL (TokenPosition, /*void*/, _ge_auxcall1);
  RF_TAILCALL (::refal::Box::Put, (Errors, (_c_3 + (_ge_auxcall1 () + _c_1) () + _ve_msg ()) ()), /*void*/);
RF_END

RF_FUNC (GetSourceLine, RF_VOID, (RF_RES _v_res1;;))
  Expr _ge_auxcall1;
  RF_CALL (::refal::Box::Get, Source, _ge_auxcall1);
  Expr _ve_line;
  if (!RF_CALL (org::refal::plus::compiler::rfp_src::Reader_GetLine, _ge_auxcall1, _ve_line))
  {
    RF_RETFAIL;
  }
  RF_CALL (Next_Row, /*void*/, /*void*/);
  _v_res1 = _ve_line;
RF_END

RF_FUNC (ScanToken, (RF_ARG _ve_line;;), (RF_RES _v_res1, _v_res2;;))
  Expr _ve_saved__position;
  RF_CALL (TokenPosition, /*void*/, _ve_saved__position);
  Expr _ge_auxalt2;
  Expr _ge_auxalt3;
  {
    {
      if (_ve_line.get_len () != 0)
      {
        goto _block1__branch1;
      }
      {
        {
          Expr _ge_auxcall1;
          if (!RF_CALL (GetSourceLine, /*void*/, _ge_auxcall1))
          {
            goto _block2__branch1;
          }
          _ge_auxalt2 = _ge_auxcall1;
          _ge_auxalt3 = empty;
          goto _block2;
        }
      _block2__branch1: {}
        _ge_auxalt2 = _c_4;
        _ge_auxalt3 = _c_5;
      }
    _block2: {}
      goto _block1;
    }
  _block1__branch1: {}
    {
      int _v_len1 = _ve_line.get_len ();
      int _v_len2 = 2;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch2;
      }
      int _v_len__rest = (_v_len1 - _v_len2);
      if (!_ve_line.symbol_at (0))
      {
        goto _block1__branch2;
      }
      if (!_ve_line.symbol_at ((0 + 1)))
      {
        goto _block1__branch2;
      }
      Expr _vs_char1;
      _vs_char1 = Expr (_ve_line, 0, 1);
      Expr _vs_char2;
      _vs_char2 = Expr (_ve_line, (0 + 1), 1);
      Expr _ve_rest;
      _ve_rest = Expr (_ve_line, (0 + 1 + 1), _v_len__rest);
      {
        {
          {
            {
              Expr _vs_tk;
              {
                {
                  Expr _v_compose1 ((_vs_char1 + _vs_char2));
                  if (!_c_6.eq (_v_compose1, 0))
                  {
                    goto _block5__branch1;
                  }
                  _vs_tk = _c_7;
                  goto _block5;
                }
              _block5__branch1: {}
                {
                  Expr _v_compose2 ((_vs_char1 + _vs_char2));
                  if (!_c_8.eq (_v_compose2, 0))
                  {
                    goto _block5__branch2;
                  }
                  _vs_tk = _c_9;
                  goto _block5;
                }
              _block5__branch2: {}
                {
                  Expr _v_compose3 ((_vs_char1 + _vs_char2));
                  if (!_c_10.eq (_v_compose3, 0))
                  {
                    goto _block5__branch3;
                  }
                  _vs_tk = _c_11;
                  goto _block5;
                }
              _block5__branch3: {}
                Expr _v_compose4 ((_vs_char1 + _vs_char2));
                if (!_c_12.eq (_v_compose4, 0))
                {
                  goto _block4__branch1;
                }
                int _v_len3 = 1;
                int _v_len4 = 0;
                if (_v_len3 < _v_len4)
                {
                  goto _block4__branch1;
                }
                int _v_len___dollar_tmp_m_59_m_24 = (_v_len3 - _v_len4);
                Expr _ve__dollar_tmp_m_59_m_24;
                _ve__dollar_tmp_m_59_m_24 = Expr (_c_13, 0, _v_len___dollar_tmp_m_59_m_24);
                _vs_tk = _c_14;
              }
            _block5: {}
              RF_CALL (Next_Column, /*void*/, /*void*/);
              RF_CALL (Next_Column, /*void*/, /*void*/);
              _ge_auxalt2 = _vs_tk;
              _ge_auxalt3 = _ve_rest ();
              goto _block4;
            }
          _block4__branch1: {}
            {
              Expr _v_compose5 ((_vs_char1 + _vs_char2));
              if (!_c_15.eq (_v_compose5, 0))
              {
                goto _block4__branch2;
              }
              RF_CALL (Next_Column, /*void*/, /*void*/);
              RF_CALL (Next_Column, /*void*/, /*void*/);
              Expr _v_SkipComment1;
              RF_CALL (SkipComment, _ve_rest, (_ge_auxalt2, _v_SkipComment1));
              _ge_auxalt3 = _v_SkipComment1 ();
              goto _block4;
            }
          _block4__branch2: {}
            Expr _v_compose6 ((_vs_char1 + _vs_char2));
            if (!_c_16.eq (_v_compose6, 0))
            {
              goto _block3__branch1;
            }
            RF_CALL (Next_Column, /*void*/, /*void*/);
            RF_CALL (Next_Column, /*void*/, /*void*/);
            Expr _v_SkipLineComment1;
            RF_CALL (SkipLineComment, _ve_rest, (_ge_auxalt2, _v_SkipLineComment1));
            _ge_auxalt3 = _v_SkipLineComment1 ();
          }
        _block4: {}
          goto _block3;
        }
      _block3__branch1: {}
        {
          {
            if (!_vs_char1.term_eq (_c_17, 0))
            {
              goto _block6__branch1;
            }
            goto _block6;
          }
        _block6__branch1: {}
          if (!_vs_char1.term_eq (_c_18, 0))
          {
            goto _block1__branch2;
          }
        }
      _block6: {}
        RF_CALL (Next_Column, /*void*/, /*void*/);
        RF_CALL (AddError, (_c_21 + _vs_char2 + _c_20 + _vs_char1 + _c_19), /*void*/);
        RF_CALL (Next_Column, /*void*/, /*void*/);
        _ge_auxalt2 = _ve_rest;
        _ge_auxalt3 = empty;
      }
    _block3: {}
      goto _block1;
    }
  _block1__branch2: {}
    int _v_len5 = _ve_line.get_len ();
    int _v_len6 = 1;
    if (_v_len5 < _v_len6)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    int _v_len__rest2 = (_v_len5 - _v_len6);
    if (!_ve_line.symbol_at (0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _vs_char;
    _vs_char = Expr (_ve_line, 0, 1);
    Expr _ve_rest;
    _ve_rest = Expr (_ve_line, (0 + 1), _v_len__rest2);
    {
      {
        {
          {
            Expr _vs_tk;
            {
              {
                if (!_vs_char.term_eq (_c_22, 0))
                {
                  goto _block9__branch1;
                }
                _vs_tk = _c_23;
                goto _block9;
              }
            _block9__branch1: {}
              {
                if (!_vs_char.term_eq (_c_24, 0))
                {
                  goto _block9__branch2;
                }
                _vs_tk = _c_25;
                goto _block9;
              }
            _block9__branch2: {}
              {
                if (!_vs_char.term_eq (_c_26, 0))
                {
                  goto _block9__branch3;
                }
                _vs_tk = _c_27;
                goto _block9;
              }
            _block9__branch3: {}
              {
                if (!_vs_char.term_eq (_c_28, 0))
                {
                  goto _block9__branch4;
                }
                _vs_tk = _c_29;
                goto _block9;
              }
            _block9__branch4: {}
              {
                if (!_vs_char.term_eq (_c_30, 0))
                {
                  goto _block9__branch5;
                }
                _vs_tk = _c_31;
                goto _block9;
              }
            _block9__branch5: {}
              {
                if (!_vs_char.term_eq (_c_13, 0))
                {
                  goto _block9__branch6;
                }
                _vs_tk = _c_32;
                goto _block9;
              }
            _block9__branch6: {}
              {
                if (!_vs_char.term_eq (_c_33, 0))
                {
                  goto _block9__branch7;
                }
                _vs_tk = _c_34;
                goto _block9;
              }
            _block9__branch7: {}
              {
                if (!_vs_char.term_eq (_c_35, 0))
                {
                  goto _block9__branch8;
                }
                _vs_tk = _c_36;
                goto _block9;
              }
            _block9__branch8: {}
              {
                if (!_vs_char.term_eq (_c_37, 0))
                {
                  goto _block9__branch9;
                }
                _vs_tk = _c_38;
                goto _block9;
              }
            _block9__branch9: {}
              {
                if (!_vs_char.term_eq (_c_39, 0))
                {
                  goto _block9__branch10;
                }
                _vs_tk = _c_40;
                goto _block9;
              }
            _block9__branch10: {}
              {
                if (!_vs_char.term_eq (_c_41, 0))
                {
                  goto _block9__branch11;
                }
                _vs_tk = _c_42;
                goto _block9;
              }
            _block9__branch11: {}
              if (!_vs_char.term_eq (_c_43, 0))
              {
                goto _block8__branch1;
              }
              _vs_tk = _c_44;
            }
          _block9: {}
            RF_CALL (Next_Column, /*void*/, /*void*/);
            _ge_auxalt2 = _vs_tk;
            _ge_auxalt3 = _ve_rest ();
            goto _block8;
          }
        _block8__branch1: {}
          {
            if (!_vs_char.term_eq (_c_45, 0))
            {
              goto _block8__branch2;
            }
            RF_CALL (Next_Column, /*void*/, /*void*/);
            Expr _v_SkipLineComment2;
            RF_CALL (SkipLineComment, _ve_rest, (_ge_auxalt2, _v_SkipLineComment2));
            _ge_auxalt3 = _v_SkipLineComment2 ();
            goto _block8;
          }
        _block8__branch2: {}
          {
            {
              if (!_vs_char.term_eq (_c_17, 0))
              {
                goto _block10__branch1;
              }
              goto _block10;
            }
          _block10__branch1: {}
            if (!_vs_char.term_eq (_c_18, 0))
            {
              goto _block7__branch1;
            }
          }
        _block10: {}
          RF_CALL (Next_Column, /*void*/, /*void*/);
          RF_CALL (AddError, (_c_46 + _vs_char + _c_19), /*void*/);
          _ge_auxalt2 = empty;
          _ge_auxalt3 = empty;
        }
      _block8: {}
        goto _block7;
      }
    _block7__branch1: {}
      {
        RF_lsplit (_c_47, 0, _ve__dollar_tmp_m_94_m_20, _v_lsplit__47);
        for ( ; ; RF_iter(_c_47)++)
        {
          {
            if (!RF_iter(_c_47))
            {
              goto _block7__branch2;
            }
            int _v_len7 = _v_lsplit__47.get_len ();
            int _v_len8 = 1;
            if (_v_len7 < _v_len8)
            {
              goto _block7__branch2;
            }
            int _v_len___dollar_tmp_m_94_m_29 = (_v_len7 - _v_len8);
            if (!_vs_char.term_eq (_v_lsplit__47, 0))
            {
              goto _continue1;
            }
            Expr _ve__dollar_tmp_m_94_m_29;
            _ve__dollar_tmp_m_94_m_29 = Expr (_v_lsplit__47, (0 + 1), _v_len___dollar_tmp_m_94_m_29);
            RF_CALL (Next_Column, /*void*/, /*void*/);
            _ge_auxalt2 = _ve_rest;
            _ge_auxalt3 = empty;
            goto _exit1;
          }
      _continue1: {}
        }
      _exit1: {}
        goto _block7;
      }
    _block7__branch2: {}
      {
        Expr _v_ScanKeyword1;
        if (!RF_CALL (ScanKeyword, (_ve_saved__position, _ve_line), (_ge_auxalt2, _v_ScanKeyword1)))
        {
          goto _block7__branch3;
        }
        _ge_auxalt3 = _v_ScanKeyword1 ();
        goto _block7;
      }
    _block7__branch3: {}
      {
        Expr _v_ScanWord1;
        if (!RF_CALL (ScanWord, _ve_line, (_ge_auxalt2, _v_ScanWord1)))
        {
          goto _block7__branch4;
        }
        _ge_auxalt3 = _v_ScanWord1 ();
        goto _block7;
      }
    _block7__branch4: {}
      {
        Expr _v_ScanVariable1;
        if (!RF_CALL (ScanVariable, _ve_line, (_ge_auxalt2, _v_ScanVariable1)))
        {
          goto _block7__branch5;
        }
        _ge_auxalt3 = _v_ScanVariable1 ();
        goto _block7;
      }
    _block7__branch5: {}
      {
        Expr _v_ScanQWord1;
        if (!RF_CALL (ScanQWord, _ve_line, (_ge_auxalt2, _v_ScanQWord1)))
        {
          goto _block7__branch6;
        }
        _ge_auxalt3 = _v_ScanQWord1 ();
        goto _block7;
      }
    _block7__branch6: {}
      {
        Expr _v_ScanChars1;
        if (!RF_CALL (ScanChars, _ve_line, (_ge_auxalt2, _v_ScanChars1)))
        {
          goto _block7__branch7;
        }
        _ge_auxalt3 = _v_ScanChars1 ();
        goto _block7;
      }
    _block7__branch7: {}
      {
        Expr _v_ScanNumber1;
        if (!RF_CALL (ScanNumber, (_ve_saved__position, _ve_line), (_ge_auxalt2, _v_ScanNumber1)))
        {
          goto _block7__branch8;
        }
        _ge_auxalt3 = _v_ScanNumber1 ();
        goto _block7;
      }
    _block7__branch8: {}
      RF_CALL (AddError, (_c_21 + _vs_char + _c_19), /*void*/);
      RF_CALL (Next_Column, /*void*/, /*void*/);
      _ge_auxalt2 = _ve_rest;
      _ge_auxalt3 = empty;
    }
  _block7: {}
  }
_block1: {}
  {
    {
      if ((_ge_auxalt3.get_len () + 1) != 1)
      {
        goto _block11__branch1;
      }
      Expr _v_compose7 ((_ge_auxalt2 () + _ge_auxalt3));
      if (_v_compose7.symbol_at (0))
      {
        goto _block11__branch1;
      }
      Expr _v_deref__compose7 (Expr (_v_compose7, 0));
      int _v_len9 = _v_deref__compose7.get_len ();
      int _v_len10 = 0;
      if (_v_len9 < _v_len10)
      {
        goto _block11__branch1;
      }
      int _v_len__rest3 = (_v_len9 - _v_len10);
      Expr _ve_rest;
      _ve_rest = Expr (_v_deref__compose7, 0, _v_len__rest3);
      _v_res1 = empty;
      _v_res2 = _ve_rest;
      goto _block11;
    }
  _block11__branch1: {}
    if ((_ge_auxalt3.get_len () + 1) != 2)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _v_compose8 ((_ge_auxalt2 () + _ge_auxalt3));
    if (_v_compose8.symbol_at (0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    if (_v_compose8.symbol_at ((0 + 1)))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _v_deref__compose8 (Expr (_v_compose8, 0));
    Expr _v_deref__compose82 (Expr (_v_compose8, (0 + 1)));
    int _v_len11 = _v_deref__compose82.get_len ();
    int _v_len12 = 0;
    if (_v_len11 < _v_len12)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    int _v_len__rest4 = (_v_len11 - _v_len12);
    int _v_len13 = _v_deref__compose8.get_len ();
    int _v_len14 = 0;
    if (_v_len13 < _v_len14)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    int _v_len__tk = (_v_len13 - _v_len14);
    Expr _ve_tk;
    _ve_tk = Expr (_v_deref__compose8, 0, _v_len__tk);
    Expr _ve_rest;
    _ve_rest = Expr (_v_deref__compose82, 0, _v_len__rest4);
    Expr _ge_auxcall4;
    RF_CALL (TokenPosition, /*void*/, _ge_auxcall4);
    _v_res1 = ((_ve_saved__position () + _ge_auxcall4 ()) () + _ve_tk ()) ();
    _v_res2 = _ve_rest;
  }
_block11: {}
RF_END

RF_FUNC (ScanKeyword, (RF_ARG _ge_arg1, _ge_arg2;;), (RF_RES _v_res1, _v_res2;;))
  int _v_len1 = (_ge_arg2.get_len () + 1);
  int _v_len2 = 2;
  if (_v_len1 < _v_len2)
  {
    RF_RETFAIL;
  }
  int _v_len__rest = (_v_len1 - _v_len2);
  Expr _v_compose1 ((_ge_arg1 () + _ge_arg2));
  if (_v_compose1.symbol_at (0))
  {
    RF_RETFAIL;
  }
  Expr _v_deref__compose1 (Expr (_v_compose1, 0));
  int _v_len3 = _v_deref__compose1.get_len ();
  int _v_len4 = 0;
  if (_v_len3 < _v_len4)
  {
    RF_RETFAIL;
  }
  int _v_len__saved__position = (_v_len3 - _v_len4);
  if (!_c_48.term_eq (_v_compose1, (0 + 1)))
  {
    RF_RETFAIL;
  }
  Expr _ve_rest;
  _ve_rest = Expr (_v_compose1, (0 + 1 + 1), _v_len__rest);
  Expr _ve_saved__position;
  _ve_saved__position = Expr (_v_deref__compose1, 0, _v_len__saved__position);
  RF_CALL (Next_Column, /*void*/, /*void*/);
  Expr _ve_last;
  RF_CALL (ScanSymbols, (_c_49, _ve_rest), (_ve_last, _ve_rest));
  Expr _ge_auxalt1;
  {
    {
      if (!RF_CALL (org::refal::plus::compiler::rfp_src::IsCaseInsensitive, /*void*/, /*void*/))
      {
        goto _block1__branch1;
      }
      RF_CALL (::refal::Convert::ToLower, _ve_last, _ge_auxalt1);
      goto _block1;
    }
  _block1__branch1: {}
    _ge_auxalt1 = _ve_last;
  }
_block1: {}
  Expr _vs_key;
  {
    {
      if (_ge_auxalt1.get_len () != 3)
      {
        goto _block2__branch1;
      }
      if (!_c_50.eq (_ge_auxalt1, 0))
      {
        goto _block2__branch1;
      }
      _vs_key = _c_51;
      goto _block2;
    }
  _block2__branch1: {}
    {
      if (_ge_auxalt1.get_len () != 7)
      {
        goto _block2__branch2;
      }
      if (!_c_52.eq (_ge_auxalt1, 0))
      {
        goto _block2__branch2;
      }
      _vs_key = _c_53;
      goto _block2;
    }
  _block2__branch2: {}
    {
      if (_ge_auxalt1.get_len () != 5)
      {
        goto _block2__branch3;
      }
      if (!_c_54.eq (_ge_auxalt1, 0))
      {
        goto _block2__branch3;
      }
      _vs_key = _c_55;
      goto _block2;
    }
  _block2__branch3: {}
    {
      if (_ge_auxalt1.get_len () != 5)
      {
        goto _block2__branch4;
      }
      if (!_c_56.eq (_ge_auxalt1, 0))
      {
        goto _block2__branch4;
      }
      _vs_key = _c_2;
      goto _block2;
    }
  _block2__branch4: {}
    {
      if (_ge_auxalt1.get_len () != 4)
      {
        goto _block2__branch5;
      }
      if (!_c_57.eq (_ge_auxalt1, 0))
      {
        goto _block2__branch5;
      }
      _vs_key = _c_58;
      goto _block2;
    }
  _block2__branch5: {}
    {
      if (_ge_auxalt1.get_len () != 4)
      {
        goto _block2__branch6;
      }
      if (!_c_59.eq (_ge_auxalt1, 0))
      {
        goto _block2__branch6;
      }
      _vs_key = _c_60;
      goto _block2;
    }
  _block2__branch6: {}
    {
      if (_ge_auxalt1.get_len () != 5)
      {
        goto _block2__branch7;
      }
      if (!_c_61.eq (_ge_auxalt1, 0))
      {
        goto _block2__branch7;
      }
      _vs_key = _c_62;
      goto _block2;
    }
  _block2__branch7: {}
    {
      if (_ge_auxalt1.get_len () != 5)
      {
        goto _block2__branch8;
      }
      if (!_c_63.eq (_ge_auxalt1, 0))
      {
        goto _block2__branch8;
      }
      _vs_key = _c_64;
      goto _block2;
    }
  _block2__branch8: {}
    {
      if (_ge_auxalt1.get_len () != 6)
      {
        goto _block2__branch9;
      }
      if (!_c_65.eq (_ge_auxalt1, 0))
      {
        goto _block2__branch9;
      }
      _vs_key = _c_66;
      goto _block2;
    }
  _block2__branch9: {}
    {
      if (_ge_auxalt1.get_len () != 4)
      {
        goto _block2__branch10;
      }
      if (!_c_67.eq (_ge_auxalt1, 0))
      {
        goto _block2__branch10;
      }
      _vs_key = _c_68;
      goto _block2;
    }
  _block2__branch10: {}
    {
      if (_ge_auxalt1.get_len () != 1)
      {
        goto _block2__branch11;
      }
      if (!_c_69.term_eq (_ge_auxalt1, 0))
      {
        goto _block2__branch11;
      }
      _vs_key = _c_70;
      goto _block2;
    }
  _block2__branch11: {}
    {
      if (_ge_auxalt1.get_len () != 1)
      {
        goto _block2__branch12;
      }
      if (!_c_71.term_eq (_ge_auxalt1, 0))
      {
        goto _block2__branch12;
      }
      _vs_key = _c_72;
      goto _block2;
    }
  _block2__branch12: {}
    {
      if (_ge_auxalt1.get_len () != 6)
      {
        goto _block2__branch13;
      }
      if (!_c_73.eq (_ge_auxalt1, 0))
      {
        goto _block2__branch13;
      }
      _vs_key = _c_74;
      goto _block2;
    }
  _block2__branch13: {}
    {
      if (_ge_auxalt1.get_len () != 6)
      {
        goto _block2__branch14;
      }
      if (!_c_75.eq (_ge_auxalt1, 0))
      {
        goto _block2__branch14;
      }
      _vs_key = _c_76;
      goto _block2;
    }
  _block2__branch14: {}
    {
      if (_ge_auxalt1.get_len () != 6)
      {
        goto _block2__branch15;
      }
      if (!_c_77.eq (_ge_auxalt1, 0))
      {
        goto _block2__branch15;
      }
      _vs_key = _c_78;
      goto _block2;
    }
  _block2__branch15: {}
    {
      if (_ge_auxalt1.get_len () != 6)
      {
        goto _block2__branch16;
      }
      if (!_c_79.eq (_ge_auxalt1, 0))
      {
        goto _block2__branch16;
      }
      _vs_key = _c_80;
      goto _block2;
    }
  _block2__branch16: {}
    {
      if (_ge_auxalt1.get_len () != 5)
      {
        goto _block2__branch17;
      }
      if (!_c_81.eq (_ge_auxalt1, 0))
      {
        goto _block2__branch17;
      }
      _vs_key = _c_82;
      goto _block2;
    }
  _block2__branch17: {}
    {
      if (_ge_auxalt1.get_len () != 5)
      {
        goto _block2__branch18;
      }
      if (!_c_83.eq (_ge_auxalt1, 0))
      {
        goto _block2__branch18;
      }
      _vs_key = _c_84;
      goto _block2;
    }
  _block2__branch18: {}
    {
      if (_ge_auxalt1.get_len () != 8)
      {
        goto _block2__branch19;
      }
      if (!_c_85.eq (_ge_auxalt1, 0))
      {
        goto _block2__branch19;
      }
      _vs_key = _c_86;
      goto _block2;
    }
  _block2__branch19: {}
    {
      if (_ge_auxalt1.get_len () != 4)
      {
        goto _block2__branch20;
      }
      if (!_c_87.eq (_ge_auxalt1, 0))
      {
        goto _block2__branch20;
      }
      _vs_key = _c_88;
      goto _block2;
    }
  _block2__branch20: {}
    {
      if (_ge_auxalt1.get_len () != 3)
      {
        goto _block2__branch21;
      }
      if (!_c_89.eq (_ge_auxalt1, 0))
      {
        goto _block2__branch21;
      }
      _vs_key = _c_90;
      goto _block2;
    }
  _block2__branch21: {}
    {
      if (_ge_auxalt1.get_len () != 6)
      {
        goto _block2__branch22;
      }
      if (!_c_91.eq (_ge_auxalt1, 0))
      {
        goto _block2__branch22;
      }
      _vs_key = _c_92;
      goto _block2;
    }
  _block2__branch22: {}
    {
      if (_ge_auxalt1.get_len () != 4)
      {
        goto _block2__branch23;
      }
      if (!_c_93.eq (_ge_auxalt1, 0))
      {
        goto _block2__branch23;
      }
      _vs_key = _c_94;
      goto _block2;
    }
  _block2__branch23: {}
    int _v_len5 = _ge_auxalt1.get_len ();
    int _v_len6 = 0;
    if (_v_len5 < _v_len6)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    int _v_len___dollar_tmp_m_140_m_6 = (_v_len5 - _v_len6);
    Expr _ve__dollar_tmp_m_140_m_6;
    _ve__dollar_tmp_m_140_m_6 = Expr (_ge_auxalt1, 0, _v_len___dollar_tmp_m_140_m_6);
    RF_CALL (AddErrorWPos, (_ve_saved__position, (_c_95 + _ve_last + _c_19)), /*void*/);
    _vs_key = _c_2;
  }
_block2: {}
  {
    {
      if (!RF_CALL (IsNoDelimiter, _ve_rest, /*void*/))
      {
        goto _block3__branch1;
      }
      RF_CALL (AddError, _c_96, /*void*/);
      goto _block3;
    }
  _block3__branch1: {}
  }
_block3: {}
  _v_res1 = _vs_key;
  _v_res2 = _ve_rest;
RF_END

RF_FUNC (ScanNumber, (RF_ARG _ge_arg1, _ge_arg2;;), (RF_RES _v_res1, _v_res2;;))
  int _v_len1 = (_ge_arg2.get_len () + 1);
  int _v_len2 = 2;
  if (_v_len1 < _v_len2)
  {
    RF_RETFAIL;
  }
  int _v_len__rest = (_v_len1 - _v_len2);
  Expr _v_compose1 ((_ge_arg1 () + _ge_arg2));
  if (_v_compose1.symbol_at (0))
  {
    RF_RETFAIL;
  }
  Expr _v_deref__compose1 (Expr (_v_compose1, 0));
  int _v_len3 = _v_deref__compose1.get_len ();
  int _v_len4 = 0;
  if (_v_len3 < _v_len4)
  {
    RF_RETFAIL;
  }
  int _v_len__saved__position = (_v_len3 - _v_len4);
  if (!_v_compose1.symbol_at ((0 + 1)))
  {
    RF_RETFAIL;
  }
  Expr _vs_first;
  _vs_first = Expr (_v_compose1, (0 + 1), 1);
  Expr _ve_rest;
  _ve_rest = Expr (_v_compose1, (0 + 1 + 1), _v_len__rest);
  Expr _ve_saved__position;
  _ve_saved__position = Expr (_v_deref__compose1, 0, _v_len__saved__position);
  {
    {
      if (!RF_CALL (::refal::Class::IsDigit, _vs_first, /*void*/))
      {
        goto _block1__branch1;
      }
      goto _block1;
    }
  _block1__branch1: {}
    RF_lsplit (_c_97, 0, _ve__dollar_tmp_m_150_m_13, _v_lsplit__97);
    for ( ; ; RF_iter(_c_97)++)
    {
      {
        if (!RF_iter(_c_97))
        {
          RF_RETFAIL;
        }
        int _v_len5 = _v_lsplit__97.get_len ();
        int _v_len6 = 1;
        if (_v_len5 < _v_len6)
        {
          RF_RETFAIL;
        }
        int _v_len___dollar_tmp_m_150_m_23 = (_v_len5 - _v_len6);
        if (!_vs_first.term_eq (_v_lsplit__97, 0))
        {
          goto _continue1;
        }
        Expr _ve__dollar_tmp_m_150_m_23;
        _ve__dollar_tmp_m_150_m_23 = Expr (_v_lsplit__97, (0 + 1), _v_len___dollar_tmp_m_150_m_23);
        goto _exit1;
      }
  _continue1: {}
    }
  _exit1: {}
  }
_block1: {}
  RF_CALL (Next_Column, /*void*/, /*void*/);
  Expr _ve_last;
  RF_CALL (ScanSymbols, (_c_98, _ve_rest), (_ve_last, _ve_rest));
  Expr _vs_num;
  {
    {
      if (!RF_CALL (::refal::Convert::ToInt, (_vs_first + _ve_last), _vs_num))
      {
        goto _block2__branch1;
      }
      goto _block2;
    }
  _block2__branch1: {}
    RF_CALL (AddErrorWPos, (_ve_saved__position, (_c_99 + _vs_first + _ve_last + _c_19)), /*void*/);
    _vs_num = _c_100;
  }
_block2: {}
  {
    {
      if (!RF_CALL (IsNoDelimiter, _ve_rest, /*void*/))
      {
        goto _block3__branch1;
      }
      RF_CALL (AddError, _c_101, /*void*/);
      goto _block3;
    }
  _block3__branch1: {}
  }
_block3: {}
  _v_res1 = (_c_102 + _vs_num);
  _v_res2 = _ve_rest;
RF_END

RF_FUNC (ScanVariable, (RF_ARG _ge_arg1;;), (RF_RES _v_res1, _v_res2;;))
  int _v_len1 = _ge_arg1.get_len ();
  int _v_len2 = 1;
  if (_v_len1 < _v_len2)
  {
    RF_RETFAIL;
  }
  int _v_len__rest = (_v_len1 - _v_len2);
  if (!_ge_arg1.symbol_at (0))
  {
    RF_RETFAIL;
  }
  Expr _vs_first;
  _vs_first = Expr (_ge_arg1, 0, 1);
  Expr _ve_rest;
  _ve_rest = Expr (_ge_arg1, (0 + 1), _v_len__rest);
  Expr _vs_type;
  {
    {
      if (!_vs_first.term_eq (_c_103, 0))
      {
        goto _block1__branch1;
      }
      _vs_type = _c_104;
      goto _block1;
    }
  _block1__branch1: {}
    {
      if (!_vs_first.term_eq (_c_105, 0))
      {
        goto _block1__branch2;
      }
      _vs_type = _c_106;
      goto _block1;
    }
  _block1__branch2: {}
    {
      if (!_vs_first.term_eq (_c_107, 0))
      {
        goto _block1__branch3;
      }
      _vs_type = _c_108;
      goto _block1;
    }
  _block1__branch3: {}
    if (!_vs_first.term_eq (_c_109, 0))
    {
      RF_RETFAIL;
    }
    _vs_type = _c_110;
  }
_block1: {}
  RF_CALL (Next_Column, /*void*/, /*void*/);
  Expr _ge_rest__2;
  {
    {
      int _v_len3 = _v_len__rest;
      int _v_len4 = 1;
      if (_v_len3 < _v_len4)
      {
        goto _block2__branch1;
      }
      int _v_len__new__rest = (_v_len3 - _v_len4);
      if (!_c_111.term_eq (_ve_rest, 0))
      {
        goto _block2__branch1;
      }
      Expr _ve_new__rest;
      _ve_new__rest = Expr (_ve_rest, (0 + 1), _v_len__new__rest);
      RF_CALL (Next_Column, /*void*/, /*void*/);
      _ge_rest__2 = _ve_new__rest;
      goto _block2;
    }
  _block2__branch1: {}
    _ge_rest__2 = _ve_rest;
  }
_block2: {}
  Expr _ge_auxcall1;
  RF_CALL (org::refal::plus::compiler::rfp_src::VarSymbol, /*void*/, _ge_auxcall1);
  Expr _ve_name;
  RF_CALL (ScanSymbols, ((_c_112 + _ge_auxcall1), _ge_rest__2), (_ve_name, _ge_rest__2));
  Expr _ge_name__3;
  {
    {
      if (_ve_name.get_len () != 0)
      {
        goto _block3__branch1;
      }
      Expr _ge_auxcall2;
      RF_CALL (TokenPosition, /*void*/, _ge_auxcall2);
      Expr _v_PositionToChars1;
      RF_CALL (org::refal::plus::compiler::rfp_src::PositionToChars, _ge_auxcall2, _v_PositionToChars1);
      _ge_name__3 = (_c_113 + _v_PositionToChars1);
      goto _block3;
    }
  _block3__branch1: {}
    _ge_name__3 = _ve_name;
  }
_block3: {}
  Expr _ge_name__3__4;
  {
    {
      if (!RF_CALL (org::refal::plus::compiler::rfp_src::IsCaseInsensitive, /*void*/, /*void*/))
      {
        goto _block4__branch1;
      }
      RF_CALL (::refal::Convert::ToLower, _ge_name__3, _ge_name__3__4);
      goto _block4;
    }
  _block4__branch1: {}
    _ge_name__3__4 = _ge_name__3;
  }
_block4: {}
  {
    {
      if (!RF_CALL (IsNoDelimiter, _ge_rest__2, /*void*/))
      {
        goto _block5__branch1;
      }
      RF_CALL (AddError, _c_114, /*void*/);
      goto _block5;
    }
  _block5__branch1: {}
  }
_block5: {}
  _v_res1 = (_vs_type + _ge_name__3__4);
  _v_res2 = _ge_rest__2;
RF_END

RF_FUNC (ScanWord, (RF_ARG _ge_arg1;;), (RF_RES _v_res1, _v_res2;;))
  int _v_len1 = _ge_arg1.get_len ();
  int _v_len2 = 1;
  if (_v_len1 < _v_len2)
  {
    RF_RETFAIL;
  }
  int _v_len__rest = (_v_len1 - _v_len2);
  if (!_ge_arg1.symbol_at (0))
  {
    RF_RETFAIL;
  }
  Expr _vs_first;
  _vs_first = Expr (_ge_arg1, 0, 1);
  Expr _ve_rest;
  _ve_rest = Expr (_ge_arg1, (0 + 1), _v_len__rest);
  {
    {
      if (!RF_CALL (::refal::Class::IsLetter, _vs_first, /*void*/))
      {
        goto _block1__branch1;
      }
      Expr _ge_auxcall1;
      RF_CALL (::refal::Convert::ToUpper, _vs_first, _ge_auxcall1);
      if (!RF_CALL (::refal::Compare::Eq, (_ge_auxcall1, _vs_first), /*void*/))
      {
        goto _block1__branch1;
      }
      goto _block1;
    }
  _block1__branch1: {}
    Expr _v_WordFirstSymbol1;
    RF_CALL (org::refal::plus::compiler::rfp_src::WordFirstSymbol, /*void*/, _v_WordFirstSymbol1);
    if (_v_WordFirstSymbol1.get_len () < 1)
    {
      RF_RETFAIL;
    }
    RF_lsplit (_v_WordFirstSymbol1, 0, _ve__dollar_tmp_m_192_m_36, _v_lsplit__WordFirstSymbol1);
    for ( ; ; RF_iter(_v_WordFirstSymbol1)++)
    {
      {
        if (!RF_iter(_v_WordFirstSymbol1))
        {
          RF_RETFAIL;
        }
        int _v_len3 = _v_lsplit__WordFirstSymbol1.get_len ();
        int _v_len4 = 1;
        if (_v_len3 < _v_len4)
        {
          RF_RETFAIL;
        }
        int _v_len___dollar_tmp_m_192_m_46 = (_v_len3 - _v_len4);
        if (!_vs_first.term_eq (_v_lsplit__WordFirstSymbol1, 0))
        {
          goto _continue1;
        }
        Expr _ve__dollar_tmp_m_192_m_46;
        _ve__dollar_tmp_m_192_m_46 = Expr (_v_lsplit__WordFirstSymbol1, (0 + 1), _v_len___dollar_tmp_m_192_m_46);
        goto _exit1;
      }
  _continue1: {}
    }
  _exit1: {}
  }
_block1: {}
  RF_CALL (Next_Column, /*void*/, /*void*/);
  Expr _ge_auxcall2;
  RF_CALL (org::refal::plus::compiler::rfp_src::WordSymbol, /*void*/, _ge_auxcall2);
  Expr _ve_last;
  RF_CALL (ScanSymbols, ((_c_112 + _ge_auxcall2), _ve_rest), (_ve_last, _ve_rest));
  {
    {
      if (!RF_CALL (IsNoDelimiter, _ve_rest, /*void*/))
      {
        goto _block2__branch1;
      }
      RF_CALL (AddError, _c_115, /*void*/);
      goto _block2;
    }
  _block2__branch1: {}
  }
_block2: {}
  _v_res1 = (_c_116 + _vs_first + _ve_last);
  _v_res2 = _ve_rest;
RF_END

RF_FUNC (ScanQWord, (RF_ARG _ge_arg1;;), (RF_RES _v_res1, _v_res2;;))
  int _v_len1 = _ge_arg1.get_len ();
  int _v_len2 = 1;
  if (_v_len1 < _v_len2)
  {
    RF_RETFAIL;
  }
  int _v_len__rest = (_v_len1 - _v_len2);
  if (!_c_117.term_eq (_ge_arg1, 0))
  {
    RF_RETFAIL;
  }
  Expr _ve_rest;
  _ve_rest = Expr (_ge_arg1, (0 + 1), _v_len__rest);
  RF_CALL (Next_Column, /*void*/, /*void*/);
  Expr _ve_word;
  RF_CALL (ScanCharsRest, (empty, _ve_rest, _c_117), (_ve_word, _ve_rest));
  _v_res1 = (_c_118 + _ve_word);
  _v_res2 = _ve_rest;
RF_END

RF_FUNC (ScanChars, (RF_ARG _ge_arg1;;), (RF_RES _v_res1, _v_res2;;))
  int _v_len1 = _ge_arg1.get_len ();
  int _v_len2 = 1;
  if (_v_len1 < _v_len2)
  {
    RF_RETFAIL;
  }
  int _v_len__rest = (_v_len1 - _v_len2);
  if (!_c_119.term_eq (_ge_arg1, 0))
  {
    RF_RETFAIL;
  }
  Expr _ve_rest;
  _ve_rest = Expr (_ge_arg1, (0 + 1), _v_len__rest);
  RF_CALL (Next_Column, /*void*/, /*void*/);
  Expr _ve_chars;
  RF_CALL (ScanCharsRest, (empty, _ve_rest, _c_119), (_ve_chars, _ve_rest));
  _v_res1 = (_c_120 + _ve_chars);
  _v_res2 = _ve_rest;
RF_END

RF_FUNC (ScanSymbols, (RF_ARG _ve_symbols, _ve_line;;), (RF_RES _v_res1, _v_res2;;))
  Expr _ve_string;
  Expr _ge_line__0 (_ve_line);
  Expr _vs_cond (_c_121);
  for ( ; ; )
  {
    {
      if (!_vs_cond.term_eq (_c_122, 0))
      {
        goto _iter1;
      }
      _v_res1 = _ve_string;
      _v_res2 = _ge_line__0;
      goto _exit__iter1;
    }
  _iter1: {}
    {
      {
        int _v_len1 = _ge_line__0.get_len ();
        int _v_len2 = 1;
        if (_v_len1 < _v_len2)
        {
          goto _block1__branch1;
        }
        int _v_len__rest = (_v_len1 - _v_len2);
        if (!_ge_line__0.symbol_at (0))
        {
          goto _block1__branch1;
        }
        Expr _vs_first;
        _vs_first = Expr (_ge_line__0, 0, 1);
        Expr _ve_rest;
        _ve_rest = Expr (_ge_line__0, (0 + 1), _v_len__rest);
        {
          {
            if (_ve_symbols.get_len () < 1)
            {
              goto _block2__branch1;
            }
            RF_lsplit (_ve_symbols, 0, _ve__dollar_tmp_m_215_m_22, _v_lsplit__symbols);
            for ( ; ; RF_iter(_ve_symbols)++)
            {
              {
                if (!RF_iter(_ve_symbols))
                {
                  goto _block2__branch1;
                }
                int _v_len3 = _v_lsplit__symbols.get_len ();
                int _v_len4 = 1;
                if (_v_len3 < _v_len4)
                {
                  goto _block2__branch1;
                }
                int _v_len___dollar_tmp_m_215_m_28 = (_v_len3 - _v_len4);
                if (!_c_98.term_eq (_v_lsplit__symbols, 0))
                {
                  goto _continue1;
                }
                Expr _ve__dollar_tmp_m_215_m_28;
                _ve__dollar_tmp_m_215_m_28 = Expr (_v_lsplit__symbols, (0 + 1), _v_len___dollar_tmp_m_215_m_28);
                if (!RF_CALL (::refal::Class::IsDigit, _vs_first, /*void*/))
                {
                  goto _continue1;
                }
                goto _exit1;
              }
          _continue1: {}
            }
          _exit1: {}
            goto _block2;
          }
        _block2__branch1: {}
          {
            if (_ve_symbols.get_len () < 1)
            {
              goto _block2__branch2;
            }
            RF_lsplit (_ve_symbols, 0, _ve__dollar_tmp_m_216_m_22, _v_lsplit__symbols2);
            for ( ; ; RF_iter(_ve_symbols)++)
            {
              {
                if (!RF_iter(_ve_symbols))
                {
                  goto _block2__branch2;
                }
                int _v_len5 = _v_lsplit__symbols2.get_len ();
                int _v_len6 = 1;
                if (_v_len5 < _v_len6)
                {
                  goto _block2__branch2;
                }
                int _v_len___dollar_tmp_m_216_m_28 = (_v_len5 - _v_len6);
                if (!_c_123.term_eq (_v_lsplit__symbols2, 0))
                {
                  goto _continue2;
                }
                Expr _ve__dollar_tmp_m_216_m_28;
                _ve__dollar_tmp_m_216_m_28 = Expr (_v_lsplit__symbols2, (0 + 1), _v_len___dollar_tmp_m_216_m_28);
                if (!RF_CALL (::refal::Class::IsLetter, _vs_first, /*void*/))
                {
                  goto _continue2;
                }
                goto _exit2;
              }
          _continue2: {}
            }
          _exit2: {}
            goto _block2;
          }
        _block2__branch2: {}
          if (_ve_symbols.get_len () < 1)
          {
            goto _block1__branch1;
          }
          RF_lsplit (_ve_symbols, 0, _ve__dollar_tmp_m_217_m_22, _v_lsplit__symbols3);
          for ( ; ; RF_iter(_ve_symbols)++)
          {
            {
              if (!RF_iter(_ve_symbols))
              {
                goto _block1__branch1;
              }
              int _v_len7 = _v_lsplit__symbols3.get_len ();
              int _v_len8 = 1;
              if (_v_len7 < _v_len8)
              {
                goto _block1__branch1;
              }
              int _v_len___dollar_tmp_m_217_m_32 = (_v_len7 - _v_len8);
              if (!_vs_first.term_eq (_v_lsplit__symbols3, 0))
              {
                goto _continue3;
              }
              Expr _ve__dollar_tmp_m_217_m_32;
              _ve__dollar_tmp_m_217_m_32 = Expr (_v_lsplit__symbols3, (0 + 1), _v_len___dollar_tmp_m_217_m_32);
              goto _exit3;
            }
        _continue3: {}
          }
        _exit3: {}
        }
      _block2: {}
        RF_CALL (Next_Column, /*void*/, /*void*/);
        _ve_string = (_ve_string + _vs_first);
        _ge_line__0 = _ve_rest;
        _vs_cond = _c_121;
        goto _block1;
      }
    _block1__branch1: {}
      _vs_cond = _c_122;
    }
  _block1: {}
  }
_exit__iter1: {}
RF_END

RF_FUNC (ScanCharsRest, (RF_ARG _ve_start, _ve_line, _vs_term;;), (RF_RES _v_res1, _v_res2;;))
  Expr _ve_s (_ve_start);
  Expr _ve_l (_ve_line);
  Expr _vs_cond (_c_121);
  for ( ; ; )
  {
    {
      if (!_vs_cond.term_eq (_c_122, 0))
      {
        goto _iter1;
      }
      _v_res1 = _ve_s;
      _v_res2 = _ve_l;
      goto _exit__iter1;
    }
  _iter1: {}
    {
      {
        int _v_len1 = _ve_l.get_len ();
        int _v_len2 = 1;
        if (_v_len1 < _v_len2)
        {
          goto _block1__branch1;
        }
        int _v_len__rest = (_v_len1 - _v_len2);
        if (!_ve_l.symbol_at (0))
        {
          goto _block1__branch1;
        }
        Expr _vs_first;
        _vs_first = Expr (_ve_l, 0, 1);
        Expr _ve_rest;
        _ve_rest = Expr (_ve_l, (0 + 1), _v_len__rest);
        RF_CALL (Next_Column, /*void*/, /*void*/);
        {
          {
            if (!_vs_term.term_eq (_vs_first, 0))
            {
              goto _block2__branch1;
            }
            _ve_l = _ve_rest;
            _vs_cond = _c_122;
            goto _block2;
          }
        _block2__branch1: {}
          {
            if (!_vs_first.term_eq (_c_17, 0))
            {
              goto _block2__branch2;
            }
            {
              {
                int _v_len3 = _v_len__rest;
                int _v_len4 = 1;
                if (_v_len3 < _v_len4)
                {
                  goto _block3__branch1;
                }
                int _v_len__rest2 = (_v_len3 - _v_len4);
                if (!_ve_rest.symbol_at (0))
                {
                  goto _block3__branch1;
                }
                Expr _vs_first2;
                _vs_first2 = Expr (_ve_rest, 0, 1);
                Expr _ve_rest2;
                _ve_rest2 = Expr (_ve_rest, (0 + 1), _v_len__rest2);
                RF_CALL (Next_Column, /*void*/, /*void*/);
                {
                  {
                    if (!_vs_first2.term_eq (_c_109, 0))
                    {
                      goto _block4__branch1;
                    }
                    _ve_s = (_ve_s + _c_124);
                    _ve_l = _ve_rest2;
                    _vs_cond = _c_121;
                    goto _block4;
                  }
                _block4__branch1: {}
                  {
                    if (!_vs_first2.term_eq (_c_125, 0))
                    {
                      goto _block4__branch2;
                    }
                    _ve_s = (_ve_s + _c_126);
                    _ve_l = _ve_rest2;
                    _vs_cond = _c_121;
                    goto _block4;
                  }
                _block4__branch2: {}
                  {
                    if (!_vs_first2.term_eq (_c_71, 0))
                    {
                      goto _block4__branch3;
                    }
                    _ve_s = (_ve_s + _c_127);
                    _ve_l = _ve_rest2;
                    _vs_cond = _c_121;
                    goto _block4;
                  }
                _block4__branch3: {}
                  {
                    if (!_vs_first2.term_eq (_c_17, 0))
                    {
                      goto _block4__branch4;
                    }
                    _ve_s = (_ve_s + _c_17);
                    _ve_l = _ve_rest2;
                    _vs_cond = _c_121;
                    goto _block4;
                  }
                _block4__branch4: {}
                  {
                    if (!_vs_first2.term_eq (_c_119, 0))
                    {
                      goto _block4__branch5;
                    }
                    _ve_s = (_ve_s + _c_119);
                    _ve_l = _ve_rest2;
                    _vs_cond = _c_121;
                    goto _block4;
                  }
                _block4__branch5: {}
                  {
                    if (!_vs_first2.term_eq (_c_117, 0))
                    {
                      goto _block4__branch6;
                    }
                    _ve_s = (_ve_s + _c_117);
                    _ve_l = _ve_rest2;
                    _vs_cond = _c_121;
                    goto _block4;
                  }
                _block4__branch6: {}
                  if (!_vs_first2.symbol_at (0))
                  {
                    goto _block3__branch1;
                  }
                  Expr _vs__dollar_tmp_m_242_m_16;
                  _vs__dollar_tmp_m_242_m_16 = Expr (_vs_first2, 0, 1);
                  RF_CALL (AddWarning, (_c_128 + _vs_first2 + _c_19), /*void*/);
                  _ve_s = (_ve_s + _vs_first2);
                  _ve_l = _ve_rest2;
                  _vs_cond = _c_121;
                }
              _block4: {}
                goto _block3;
              }
            _block3__branch1: {}
              {
                Expr _ge_auxcall1;
                if (!RF_CALL (GetSourceLine, /*void*/, _ge_auxcall1))
                {
                  goto _block3__branch2;
                }
                _ve_l = _ge_auxcall1;
                _vs_cond = _c_121;
                goto _block3;
              }
            _block3__branch2: {}
              RF_CALL (AddError, _c_129, /*void*/);
              _ve_l = empty;
              _vs_cond = _c_122;
            }
          _block3: {}
            goto _block2;
          }
        _block2__branch2: {}
          if (!_vs_first.symbol_at (0))
          {
            RF_FUNC_ERROR (unexpected_fail);
          }
          Expr _vs__dollar_tmp_m_249_m_10;
          _vs__dollar_tmp_m_249_m_10 = Expr (_vs_first, 0, 1);
          _ve_s = (_ve_s + _vs_first);
          _ve_l = _ve_rest;
          _vs_cond = _c_121;
        }
      _block2: {}
        goto _block1;
      }
    _block1__branch1: {}
      RF_CALL (AddError, _c_129, /*void*/);
      _ve_l = empty;
      _vs_cond = _c_122;
    }
  _block1: {}
  }
_exit__iter1: {}
RF_END

RF_FUNC (SkipComment, (RF_ARG _ve_line;;), (RF_RES _v_res1, _v_res2;;))
  Expr _ve_comment;
  Expr _ge_line__0 (_ve_line);
  Expr _vs_tag (_c_122);
  for ( ; ; )
  {
    {
      if (!_vs_tag.term_eq (_c_121, 0))
      {
        goto _iter1;
      }
      _v_res1 = (_c_130 + _ve_comment);
      _v_res2 = _ge_line__0;
      goto _exit__iter1;
    }
  _iter1: {}
    {
      {
        if (_ge_line__0.get_len () < 2)
        {
          goto _block1__branch1;
        }
        RF_lsplit (_ge_line__0, 0, _ve_com, _v_lsplit__line__0);
        for ( ; ; RF_iter(_ge_line__0)++)
        {
          {
            if (!RF_iter(_ge_line__0))
            {
              goto _block1__branch1;
            }
            int _v_len1 = _v_lsplit__line__0.get_len ();
            int _v_len2 = 2;
            if (_v_len1 < _v_len2)
            {
              goto _block1__branch1;
            }
            int _v_len__rest = (_v_len1 - _v_len2);
            if (!_c_131.eq (_v_lsplit__line__0, 0))
            {
              goto _continue1;
            }
            Expr _ve_rest;
            _ve_rest = Expr (_v_lsplit__line__0, (0 + 1 + 1), _v_len__rest);
            Expr _gs_auxcall1;
            RF_CALL (::refal::Access::Length, (_ve_com + _c_131), _gs_auxcall1);
            Expr _ge_auxcall2;
            RF_CALL (::refal::List::Replicate, (_gs_auxcall1, _c_132), _ge_auxcall2);
            Expr _v_Map1;
            if (!RF_CALL (::refal::List::Map, (_c_133, empty, _ge_auxcall2), _v_Map1))
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            int _v_len3 = _v_Map1.get_len ();
            int _v_len4 = 0;
            if (_v_len3 < _v_len4)
            {
              RF_FUNC_ERROR (unexpected_fail);
            }
            int _v_len___dollar_tmp_m_260_m_70 = (_v_len3 - _v_len4);
            Expr _ve__dollar_tmp_m_260_m_70;
            _ve__dollar_tmp_m_260_m_70 = Expr (_v_Map1, 0, _v_len___dollar_tmp_m_260_m_70);
            _ve_comment = (_ve_comment + _ve_com ());
            _ge_line__0 = _ve_rest;
            _vs_tag = _c_121;
            goto _exit1;
          }
      _continue1: {}
        }
      _exit1: {}
        goto _block1;
      }
    _block1__branch1: {}
      Expr _ge_auxcall3;
      if (!RF_CALL (GetSourceLine, /*void*/, _ge_auxcall3))
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      _ve_comment = (_ve_comment + _ge_line__0 ());
      _ge_line__0 = _ge_auxcall3;
      _vs_tag = _c_122;
    }
  _block1: {}
  }
_exit__iter1: {}
RF_END

RF_FUNC (SkipLineComment, (RF_ARG _ve_line;;), (RF_RES _v_res1, _v_res2;;))
  Expr _gs_auxcall1;
  RF_CALL (::refal::Access::Length, _ve_line, _gs_auxcall1);
  Expr _ge_auxcall2;
  RF_CALL (::refal::List::Replicate, (_gs_auxcall1, _c_132), _ge_auxcall2);
  Expr _v_Map1;
  if (!RF_CALL (::refal::List::Map, (_c_133, empty, _ge_auxcall2), _v_Map1))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  int _v_len1 = _v_Map1.get_len ();
  int _v_len2 = 0;
  if (_v_len1 < _v_len2)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  int _v_len___dollar_tmp_m_268_m_62 = (_v_len1 - _v_len2);
  Expr _ve__dollar_tmp_m_268_m_62;
  _ve__dollar_tmp_m_268_m_62 = Expr (_v_Map1, 0, _v_len___dollar_tmp_m_268_m_62);
  _v_res1 = (_c_130 + _ve_line);
  _v_res2 = empty;
RF_END

RF_FUNC (IsNoDelimiter, (RF_ARG _ge_arg1;;), RF_VOID)
  int _v_len1 = _ge_arg1.get_len ();
  int _v_len2 = 1;
  if (_v_len1 < _v_len2)
  {
    RF_RETFAIL;
  }
  int _v_len__rest = (_v_len1 - _v_len2);
  if (!_ge_arg1.symbol_at (0))
  {
    RF_RETFAIL;
  }
  Expr _vs_first;
  _vs_first = Expr (_ge_arg1, 0, 1);
  Expr _ve_rest;
  _ve_rest = Expr (_ge_arg1, (0 + 1), _v_len__rest);
  {
    {
      if (!RF_CALL (::refal::Class::IsDigit, _vs_first, /*void*/))
      {
        goto _block1__branch1;
      }
      goto _block1;
    }
  _block1__branch1: {}
    {
      if (!RF_CALL (::refal::Class::IsLetter, _vs_first, /*void*/))
      {
        goto _block1__branch2;
      }
      goto _block1;
    }
  _block1__branch2: {}
    RF_lsplit (_c_134, 0, _ve__dollar_tmp_m_274_m_15, _v_lsplit__134);
    for ( ; ; RF_iter(_c_134)++)
    {
      {
        if (!RF_iter(_c_134))
        {
          RF_RETFAIL;
        }
        int _v_len3 = _v_lsplit__134.get_len ();
        int _v_len4 = 1;
        if (_v_len3 < _v_len4)
        {
          RF_RETFAIL;
        }
        int _v_len___dollar_tmp_m_274_m_25 = (_v_len3 - _v_len4);
        if (!_vs_first.term_eq (_v_lsplit__134, 0))
        {
          goto _continue1;
        }
        Expr _ve__dollar_tmp_m_274_m_25;
        _ve__dollar_tmp_m_274_m_25 = Expr (_v_lsplit__134, (0 + 1), _v_len___dollar_tmp_m_274_m_25);
        goto _exit1;
      }
  _continue1: {}
    }
  _exit1: {}
  }
_block1: {}
RF_END

RF_FUNC (Next_Column, RF_VOID, RF_VOID)
  Expr _ge_auxcall1;
  RF_CALL (::refal::Box::Get, Position, _ge_auxcall1);
  Expr _ge_auxcall2;
  RF_CALL (org::refal::plus::compiler::rfp_src::NextColumn, _ge_auxcall1, _ge_auxcall2);
  RF_TAILCALL (::refal::Box::Store, (Position, _ge_auxcall2), /*void*/);
RF_END

RF_FUNC (Next_Row, RF_VOID, RF_VOID)
  Expr _ge_auxcall1;
  RF_CALL (::refal::Box::Get, Position, _ge_auxcall1);
  Expr _ge_auxcall2;
  RF_CALL (org::refal::plus::compiler::rfp_src::NextRow, _ge_auxcall1, _ge_auxcall2);
  RF_TAILCALL (::refal::Box::Store, (Position, _ge_auxcall2), /*void*/);
RF_END

RF_FUNC (TokenPosition, RF_VOID, (RF_RES _v_res1;;))
  RF_TAILCALL (::refal::Box::Get, Position, _v_res1);
RF_END

RF_FUNC (Apply_0, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  int _v_len1 = _ge_arg1.get_len ();
  int _v_len2 = 1;
  if (_v_len1 < _v_len2)
  {
    RF_ERROR (_c_135);
  }
  int _v_len__stub1 = (_v_len1 - _v_len2);
  if (!_ge_arg1.symbol_at (0))
  {
    RF_ERROR (_c_135);
  }
  Expr _v_stub2;
  _v_stub2 = Expr (_ge_arg1, 0, 1);
  Expr _v_stub1;
  _v_stub1 = Expr (_ge_arg1, (0 + 1), _v_len__stub1);
  RF_TAILCALL (::refal::Apply::Apply, (_v_stub2, _v_stub1), _v_res1);
RF_END

RF_FUNC (Next_Column_0, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  if (_ge_arg1.get_len () != 0)
  {
    RF_ERROR (_c_135);
  }
  RF_CALL (Next_Column, /*void*/, /*void*/);
  _v_res1 = empty;
RF_END

}

}

}

}

}

namespace org {

namespace refal {

namespace plus {

namespace compiler {

namespace rfp_lex {

static void init_ () {
  Errors = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Errors");
  Position = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Position");
  Source = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Source");
  _c_4 = Expr::create<rftype::Word>("EOF");
  _c_0 = (_c_4) ();
  _c_136 = Expr::create<rftype::Integer>("0") + Expr::create<rftype::Integer>("0");
  _c_1 = (_c_136) ();
  _c_2 = Expr::create<rftype::Word>("ERROR");
  _c_3 = Expr::create<rftype::Word>("WARNING");
  _c_5 = (empty) ();
  _c_6 = rftype::Char::create_expr (L"::");
  _c_7 = Expr::create<rftype::Word>("DCOLON");
  _c_8 = rftype::Char::create_expr (L"\\?");
  _c_9 = Expr::create<rftype::Word>("STAKE");
  _c_10 = rftype::Char::create_expr (L"\\!");
  _c_11 = Expr::create<rftype::Word>("CUT");
  _c_12 = rftype::Char::create_expr (L"\\{");
  _c_13 = rftype::Char::create_expr (L"}");
  _c_14 = Expr::create<rftype::Word>("TLBRACE");
  _c_15 = rftype::Char::create_expr (L"/*");
  _c_16 = rftype::Char::create_expr (L"//");
  _c_17 = Expr (_c_10, 0, 1);
  _c_18 = Expr (_c_16, 0, 1);
  _c_19 = Expr::create<rftype::Word>("'");
  _c_20 = Expr::create<rftype::Word>("' after '");
  _c_21 = Expr::create<rftype::Word>("Invalid character '");
  _c_22 = rftype::Char::create_expr (L"(");
  _c_23 = Expr::create<rftype::Word>("LPAREN");
  _c_24 = rftype::Char::create_expr (L")");
  _c_25 = Expr::create<rftype::Word>("RPAREN");
  _c_26 = rftype::Char::create_expr (L"<");
  _c_27 = Expr::create<rftype::Word>("LBRACKET");
  _c_28 = rftype::Char::create_expr (L">");
  _c_29 = Expr::create<rftype::Word>("RBRACKET");
  _c_30 = Expr (_c_12, 1, 1);
  _c_31 = Expr::create<rftype::Word>("LBRACE");
  _c_32 = Expr::create<rftype::Word>("RBRACE");
  _c_33 = rftype::Char::create_expr (L"#");
  _c_34 = Expr::create<rftype::Word>("NOT");
  _c_35 = rftype::Char::create_expr (L"&");
  _c_36 = Expr::create<rftype::Word>("REF");
  _c_37 = rftype::Char::create_expr (L",");
  _c_38 = Expr::create<rftype::Word>("COMMA");
  _c_39 = rftype::Char::create_expr (L";");
  _c_40 = Expr::create<rftype::Word>("SEMICOLON");
  _c_41 = rftype::Char::create_expr (L"=");
  _c_42 = Expr::create<rftype::Word>("EQUAL");
  _c_43 = Expr (_c_6, 0, 1);
  _c_44 = Expr::create<rftype::Word>("COLON");
  _c_45 = Expr (_c_15, 1, 1);
  _c_46 = Expr::create<rftype::Word>("Unexpected end of line after'");
  _c_47 = rftype::Char::create_expr (L" \n\r\t");
  _c_113 = rftype::Char::create_expr (L"$tmp-");
  _c_48 = Expr (_c_113, 0, 1);
  _c_49 = rftype::Char::create_expr (L"A?");
  _c_50 = rftype::Char::create_expr (L"box");
  _c_51 = Expr::create<rftype::Word>("BOX");
  _c_52 = rftype::Char::create_expr (L"channel");
  _c_53 = Expr::create<rftype::Word>("CHANNEL");
  _c_54 = rftype::Char::create_expr (L"const");
  _c_55 = Expr::create<rftype::Word>("CONST");
  _c_56 = rftype::Char::create_expr (L"error");
  _c_57 = rftype::Char::create_expr (L"fail");
  _c_58 = Expr::create<rftype::Word>("FAIL");
  _c_61 = rftype::Char::create_expr (L"func?");
  _c_59 = Expr (_c_61, 0, 4);
  _c_60 = Expr::create<rftype::Word>("FUNC");
  _c_62 = Expr::create<rftype::Word>("FUNC?");
  _c_63 = rftype::Char::create_expr (L"tfunc");
  _c_64 = Expr::create<rftype::Word>("TFUNC");
  _c_65 = rftype::Char::create_expr (L"extern");
  _c_66 = Expr::create<rftype::Word>("EXTERN");
  _c_67 = rftype::Char::create_expr (L"iter");
  _c_68 = Expr::create<rftype::Word>("ITER");
  _c_69 = Expr (_c_57, 3, 1);
  _c_70 = Expr::create<rftype::Word>("L");
  _c_71 = Expr (_c_67, 3, 1);
  _c_72 = Expr::create<rftype::Word>("R");
  _c_73 = rftype::Char::create_expr (L"native");
  _c_74 = Expr::create<rftype::Word>("NATIVE");
  _c_75 = rftype::Char::create_expr (L"module");
  _c_76 = Expr::create<rftype::Word>("MODULE");
  _c_77 = rftype::Char::create_expr (L"public");
  _c_78 = Expr::create<rftype::Word>("PUBLIC");
  _c_79 = rftype::Char::create_expr (L"string");
  _c_80 = Expr::create<rftype::Word>("STRING");
  _c_81 = rftype::Char::create_expr (L"table");
  _c_82 = Expr::create<rftype::Word>("TABLE");
  _c_85 = rftype::Char::create_expr (L"traceall");
  _c_83 = Expr (_c_85, 0, 5);
  _c_84 = Expr::create<rftype::Word>("TRACE");
  _c_86 = Expr::create<rftype::Word>("TRACEALL");
  _c_87 = rftype::Char::create_expr (L"trap");
  _c_88 = Expr::create<rftype::Word>("TRAP");
  _c_89 = rftype::Char::create_expr (L"use");
  _c_90 = Expr::create<rftype::Word>("USE");
  _c_91 = rftype::Char::create_expr (L"vector");
  _c_92 = Expr::create<rftype::Word>("VECTOR");
  _c_93 = rftype::Char::create_expr (L"with");
  _c_94 = Expr::create<rftype::Word>("WITH");
  _c_95 = Expr::create<rftype::Word>("Invalid keyword '$");
  _c_96 = Expr::create<rftype::Word>("Keyword must be followed by a delimiter");
  _c_134 = rftype::Char::create_expr (L"+-?!_.");
  _c_97 = Expr (_c_134, 0, 2);
  _c_112 = rftype::Char::create_expr (L"A0");
  _c_98 = Expr (_c_112, 1, 1);
  _c_99 = Expr::create<rftype::Word>("Invalid number '");
  _c_100 = Expr (_c_136, 0, 1);
  _c_101 = Expr::create<rftype::Word>("Number must be followed by a delimiter");
  _c_102 = Expr::create<rftype::Word>("NUMBER");
  _c_103 = Expr (_c_89, 1, 1);
  _c_104 = Expr::create<rftype::Word>("SVAR");
  _c_105 = Expr (_c_89, 2, 1);
  _c_106 = Expr::create<rftype::Word>("EVAR");
  _c_107 = Expr (_c_91, 0, 1);
  _c_108 = Expr::create<rftype::Word>("VVAR");
  _c_109 = Expr (_c_67, 1, 1);
  _c_110 = Expr::create<rftype::Word>("TVAR");
  _c_111 = Expr (_c_134, 5, 1);
  _c_114 = Expr::create<rftype::Word>("Variable must be followed by a delimiter");
  _c_115 = Expr::create<rftype::Word>("Word must be followed by a delimiter");
  _c_116 = Expr::create<rftype::Word>("WORD");
  _c_117 = rftype::Char::create_expr (L"\"");
  _c_118 = Expr::create<rftype::Word>("QWORD");
  _c_119 = rftype::Char::create_expr (L"'");
  _c_120 = Expr::create<rftype::Word>("SYMBOLS");
  _c_121 = Expr::create<rftype::Word>("T");
  _c_122 = Expr::create<rftype::Word>("F");
  _c_123 = Expr (_c_112, 0, 1);
  _c_124 = Expr (_c_47, 3, 1);
  _c_125 = Expr (_c_54, 2, 1);
  _c_126 = Expr (_c_47, 1, 1);
  _c_127 = Expr (_c_47, 2, 1);
  _c_128 = Expr::create<rftype::Word>("Unknown control sequence '\\");
  _c_129 = Expr::create<rftype::Word>("Unterminated string detected");
  _c_130 = Expr::create<rftype::Word>("COMMENT");
  _c_131 = rftype::Char::create_expr (L"*/");
  _c_132 = Expr::create_sym<rftype::Func> (Next_Column_0);
  _c_133 = Expr::create_sym<rftype::Func> (Apply_0);
  _c_135 = Expr::create<rftype::Word>("Apply") + Expr::create<rftype::Word>("Apply") + Expr::create<rftype::Word>("Unexpected fail");
}

static AtStart init_registrator_ (&init_);

}

}

}

}

}
