// $Source$
// $Revision: 2187 $
// $Date: 2006-12-15 03:17:56 +0300 (Пт, 15 дек 2006) $
// $Author: orlov $

#ifndef __dir_symbol_hh__
#define __dir_symbol_hh__

#include "rf_symbol.ih"
#include "dir.ih"

namespace rftype
{

RF_NEW_SYMBOL(Dir, ObjectTerm);

template <>
inline pxx::WString RF_SYMBOL(Dir)::to_string (RF_SYMBOL(Dir) const* _dir)
{
  const size_t max_len = hex_ptr_len + 10;
  wchar_t* str = static_cast<wchar_t*>(alloca(max_len * sizeof(wchar_t)));
  Dir* ptr = _dir->get_obj_ptr();
  int len = swprintf(str, max_len, L"<Dir|%p>", ptr);
  if (-1 == len) {
    FATAL("<Dir|%p> is more then %u wide characters", ptr, max_len);
  }
  return pxx::WString(str, len);
}


}

#endif // __dir_symbol_hh__
