
#include <rf_core.hh>

using namespace rfrt;

namespace refal {

namespace Class {

RF_DECL (IsDigit);

}

}

namespace refal {

namespace Apply {

RF_DECL (Apply);

}

}

namespace refal {

namespace Class {

RF_DECL (IsLetter);

}

}

namespace refal {

namespace Convert {

RF_DECL (ToWord);

RF_DECL (ToChars);

}

}

namespace refal {

namespace Class {

RF_DECL (IsInt);

}

}

namespace refal {

namespace JavaMangle {

RF_DECL (Char_To_Unicode);

RF_DECL (Chars2Rfp);

RF_DECL (Java2Rfp);

RF_DECL (Codes2Rfp);

RF_DECL (Chars2Java);

RF_DECL (A_Char2Java);

RF_DECL (Qualifiers2Rfp);

RF_DECL (Qualifier2Java);

}

}

namespace refal {

namespace cpp_specific {

RF_DECL (IsReserved_Word);

}

}

namespace refal {

namespace List {

RF_DECL (Map);

}

}

namespace refal {

namespace cpp_specific {

extern Expr Namespace_Delimeter;

}

}

namespace refal {

namespace JavaMangle {

RF_DECL (Rfp2Java);

RF_DECL (IsReserved_Word_0);

}

}

namespace refal {

namespace JavaMangle {

static Expr Conv_Table;

static Expr _c_0;

static Expr _c_36;

static Expr _c_12;

static Expr _c_1;

static Expr _c_2;

static Expr _c_11;

static Expr _c_3;

static Expr _c_4;

static Expr _c_38;

static Expr _c_14;

static Expr _c_5;

static Expr _c_6;

static Expr _c_39;

static Expr _c_15;

static Expr _c_7;

static Expr _c_9;

static Expr _c_8;

static Expr _c_10;

static Expr _c_37;

static Expr _c_13;

static Expr _c_16;

static Expr _c_17;

static Expr _c_18;

static Expr _c_19;

static Expr _c_20;

static Expr _c_21;

static Expr _c_22;

static Expr _c_23;

static Expr _c_24;

static Expr _c_25;

static Expr _c_26;

static Expr _c_27;

static Expr _c_28;

static Expr _c_29;

static Expr _c_30;

static Expr _c_31;

static Expr _c_32;

static Expr _c_33;

static Expr _c_34;

static Expr _c_35;

static Expr _c_40;

static Expr _c_41;

RF_FUNC (Rfp2Java, (RF_ARG _ve_rfp__obj;;), (RF_RES _v_res1;;))
  Expr _ve_ident;
  {
    {
      Expr _ve_prefix;
      Expr _ve_name;
      {
        {
          if (_ve_rfp__obj.get_len () != 1)
          {
            goto _block2__branch1;
          }
          if (_ve_rfp__obj.symbol_at (0))
          {
            goto _block2__branch1;
          }
          Expr _v_deref__rfp__obj;
          _v_deref__rfp__obj = Expr (_ve_rfp__obj, 0);
          int _v_len1;
          _v_len1 = _v_deref__rfp__obj.get_len ();
          int _v_len2;
          _v_len2 = 2;
          if (_v_len1 < _v_len2)
          {
            goto _block2__branch1;
          }
          int _v_len__ns;
          _v_len__ns = (_v_len1 - _v_len2);
          if (_v_deref__rfp__obj.symbol_at ((0 + 1 + _v_len__ns)))
          {
            goto _block2__branch1;
          }
          Expr _v_deref__deref__rfp__obj;
          _v_deref__deref__rfp__obj = Expr (_v_deref__rfp__obj, (0 + 1 + _v_len__ns));
          int _v_len3;
          _v_len3 = _v_deref__deref__rfp__obj.get_len ();
          int _v_len4;
          _v_len4 = 1;
          if (_v_len3 < _v_len4)
          {
            goto _block2__branch1;
          }
          int _v_len__name__4;
          _v_len__name__4 = (_v_len3 - _v_len4);
          if (!_v_deref__rfp__obj.symbol_at (0))
          {
            goto _block2__branch1;
          }
          if (!_v_deref__deref__rfp__obj.symbol_at ((0 + _v_len__name__4)))
          {
            goto _block2__branch1;
          }
          Expr _vs_tag;
          _vs_tag = Expr (_v_deref__rfp__obj, 0, 1);
          Expr _ve_ns;
          _ve_ns = Expr (_v_deref__rfp__obj, (0 + 1), _v_len__ns);
          Expr _ge_name__4;
          _ge_name__4 = Expr (_v_deref__deref__rfp__obj, 0, _v_len__name__4);
          Expr _vs_last;
          _vs_last = Expr (_v_deref__deref__rfp__obj, (0 + _v_len__name__4), 1);
          if (!RF_CALL (refal::Class::IsInt, _vs_last, /*void*/))
          {
            goto _block2__branch1;
          }
          Expr _vs_t;
          {
            {
              if (!_vs_tag.term_eq (_c_0, 0))
              {
                goto _block3__branch1;
              }
              _vs_t = _c_1;
              goto _block3;
            }
          _block3__branch1: {}
            {
              if (!_vs_tag.term_eq (_c_2, 0))
              {
                goto _block3__branch2;
              }
              _vs_t = _c_3;
              goto _block3;
            }
          _block3__branch2: {}
            {
              if (!_vs_tag.term_eq (_c_4, 0))
              {
                goto _block3__branch3;
              }
              _vs_t = _c_5;
              goto _block3;
            }
          _block3__branch3: {}
            if (!_vs_tag.term_eq (_c_6, 0))
            {
              goto _block2__branch1;
            }
            _vs_t = _c_7;
          }
        _block3: {}
          _ve_prefix = (_c_9 + _vs_t + _ve_ns + _c_8);
          _ve_name = (_ge_name__4 + _vs_last);
          goto _block2;
        }
      _block2__branch1: {}
        {
          if (_ve_rfp__obj.get_len () != 1)
          {
            goto _block2__branch2;
          }
          if (_ve_rfp__obj.symbol_at (0))
          {
            goto _block2__branch2;
          }
          Expr _v_deref__rfp__obj2;
          _v_deref__rfp__obj2 = Expr (_ve_rfp__obj, 0);
          int _v_len5;
          _v_len5 = _v_deref__rfp__obj2.get_len ();
          int _v_len6;
          _v_len6 = 2;
          if (_v_len5 < _v_len6)
          {
            goto _block2__branch2;
          }
          int _v_len__ns2;
          _v_len__ns2 = (_v_len5 - _v_len6);
          if (_v_deref__rfp__obj2.symbol_at ((0 + 1 + _v_len__ns2)))
          {
            goto _block2__branch2;
          }
          Expr _v_deref__deref__rfp__obj2;
          _v_deref__deref__rfp__obj2 = Expr (_v_deref__rfp__obj2, (0 + 1 + _v_len__ns2));
          int _v_len7;
          _v_len7 = _v_deref__deref__rfp__obj2.get_len ();
          int _v_len8;
          _v_len8 = 0;
          if (_v_len7 < _v_len8)
          {
            goto _block2__branch2;
          }
          int _v_len__name__42;
          _v_len__name__42 = (_v_len7 - _v_len8);
          if (!_c_10.term_eq (_v_deref__rfp__obj2, 0))
          {
            goto _block2__branch2;
          }
          Expr _ve_ns;
          _ve_ns = Expr (_v_deref__rfp__obj2, (0 + 1), _v_len__ns2);
          Expr _ge_name__4;
          _ge_name__4 = Expr (_v_deref__deref__rfp__obj2, 0, _v_len__name__42);
          _ve_prefix = (_c_11 + _ve_ns + _c_8);
          _ve_name = _ge_name__4;
          goto _block2;
        }
      _block2__branch2: {}
        {
          if (_ve_rfp__obj.get_len () != 1)
          {
            goto _block2__branch3;
          }
          if (_ve_rfp__obj.symbol_at (0))
          {
            goto _block2__branch3;
          }
          Expr _v_deref__rfp__obj3;
          _v_deref__rfp__obj3 = Expr (_ve_rfp__obj, 0);
          int _v_len9;
          _v_len9 = _v_deref__rfp__obj3.get_len ();
          int _v_len10;
          _v_len10 = 2;
          if (_v_len9 < _v_len10)
          {
            goto _block2__branch3;
          }
          int _v_len__ns3;
          _v_len__ns3 = (_v_len9 - _v_len10);
          if (_v_deref__rfp__obj3.symbol_at ((0 + 1 + _v_len__ns3)))
          {
            goto _block2__branch3;
          }
          Expr _v_deref__deref__rfp__obj3;
          _v_deref__deref__rfp__obj3 = Expr (_v_deref__rfp__obj3, (0 + 1 + _v_len__ns3));
          int _v_len11;
          _v_len11 = _v_deref__deref__rfp__obj3.get_len ();
          int _v_len12;
          _v_len12 = 0;
          if (_v_len11 < _v_len12)
          {
            goto _block2__branch3;
          }
          int _v_len__name__43;
          _v_len__name__43 = (_v_len11 - _v_len12);
          if (!_c_0.term_eq (_v_deref__rfp__obj3, 0))
          {
            goto _block2__branch3;
          }
          Expr _ve_ns;
          _ve_ns = Expr (_v_deref__rfp__obj3, (0 + 1), _v_len__ns3);
          Expr _ge_name__4;
          _ge_name__4 = Expr (_v_deref__deref__rfp__obj3, 0, _v_len__name__43);
          _ve_prefix = (_c_12 + _ve_ns + _c_8);
          _ve_name = _ge_name__4;
          goto _block2;
        }
      _block2__branch3: {}
        {
          if (_ve_rfp__obj.get_len () != 1)
          {
            goto _block2__branch4;
          }
          if (_ve_rfp__obj.symbol_at (0))
          {
            goto _block2__branch4;
          }
          Expr _v_deref__rfp__obj4;
          _v_deref__rfp__obj4 = Expr (_ve_rfp__obj, 0);
          int _v_len13;
          _v_len13 = _v_deref__rfp__obj4.get_len ();
          int _v_len14;
          _v_len14 = 2;
          if (_v_len13 < _v_len14)
          {
            goto _block2__branch4;
          }
          int _v_len__ns4;
          _v_len__ns4 = (_v_len13 - _v_len14);
          if (_v_deref__rfp__obj4.symbol_at ((0 + 1 + _v_len__ns4)))
          {
            goto _block2__branch4;
          }
          Expr _v_deref__deref__rfp__obj4;
          _v_deref__deref__rfp__obj4 = Expr (_v_deref__rfp__obj4, (0 + 1 + _v_len__ns4));
          int _v_len15;
          _v_len15 = _v_deref__deref__rfp__obj4.get_len ();
          int _v_len16;
          _v_len16 = 0;
          if (_v_len15 < _v_len16)
          {
            goto _block2__branch4;
          }
          int _v_len__name__44;
          _v_len__name__44 = (_v_len15 - _v_len16);
          if (!_c_2.term_eq (_v_deref__rfp__obj4, 0))
          {
            goto _block2__branch4;
          }
          Expr _ve_ns;
          _ve_ns = Expr (_v_deref__rfp__obj4, (0 + 1), _v_len__ns4);
          Expr _ge_name__4;
          _ge_name__4 = Expr (_v_deref__deref__rfp__obj4, 0, _v_len__name__44);
          _ve_prefix = (_c_13 + _ve_ns + _c_8);
          _ve_name = _ge_name__4;
          goto _block2;
        }
      _block2__branch4: {}
        {
          if (_ve_rfp__obj.get_len () != 1)
          {
            goto _block2__branch5;
          }
          if (_ve_rfp__obj.symbol_at (0))
          {
            goto _block2__branch5;
          }
          Expr _v_deref__rfp__obj5;
          _v_deref__rfp__obj5 = Expr (_ve_rfp__obj, 0);
          int _v_len17;
          _v_len17 = _v_deref__rfp__obj5.get_len ();
          int _v_len18;
          _v_len18 = 2;
          if (_v_len17 < _v_len18)
          {
            goto _block2__branch5;
          }
          int _v_len__ns5;
          _v_len__ns5 = (_v_len17 - _v_len18);
          if (_v_deref__rfp__obj5.symbol_at ((0 + 1 + _v_len__ns5)))
          {
            goto _block2__branch5;
          }
          Expr _v_deref__deref__rfp__obj5;
          _v_deref__deref__rfp__obj5 = Expr (_v_deref__rfp__obj5, (0 + 1 + _v_len__ns5));
          int _v_len19;
          _v_len19 = _v_deref__deref__rfp__obj5.get_len ();
          int _v_len20;
          _v_len20 = 0;
          if (_v_len19 < _v_len20)
          {
            goto _block2__branch5;
          }
          int _v_len__name__45;
          _v_len__name__45 = (_v_len19 - _v_len20);
          if (!_c_4.term_eq (_v_deref__rfp__obj5, 0))
          {
            goto _block2__branch5;
          }
          Expr _ve_ns;
          _ve_ns = Expr (_v_deref__rfp__obj5, (0 + 1), _v_len__ns5);
          Expr _ge_name__4;
          _ge_name__4 = Expr (_v_deref__deref__rfp__obj5, 0, _v_len__name__45);
          _ve_prefix = (_c_14 + _ve_ns + _c_8);
          _ve_name = _ge_name__4;
          goto _block2;
        }
      _block2__branch5: {}
        {
          if (_ve_rfp__obj.get_len () != 1)
          {
            goto _block2__branch6;
          }
          if (_ve_rfp__obj.symbol_at (0))
          {
            goto _block2__branch6;
          }
          Expr _v_deref__rfp__obj6;
          _v_deref__rfp__obj6 = Expr (_ve_rfp__obj, 0);
          int _v_len21;
          _v_len21 = _v_deref__rfp__obj6.get_len ();
          int _v_len22;
          _v_len22 = 2;
          if (_v_len21 < _v_len22)
          {
            goto _block2__branch6;
          }
          int _v_len__ns6;
          _v_len__ns6 = (_v_len21 - _v_len22);
          if (_v_deref__rfp__obj6.symbol_at ((0 + 1 + _v_len__ns6)))
          {
            goto _block2__branch6;
          }
          Expr _v_deref__deref__rfp__obj6;
          _v_deref__deref__rfp__obj6 = Expr (_v_deref__rfp__obj6, (0 + 1 + _v_len__ns6));
          int _v_len23;
          _v_len23 = _v_deref__deref__rfp__obj6.get_len ();
          int _v_len24;
          _v_len24 = 0;
          if (_v_len23 < _v_len24)
          {
            goto _block2__branch6;
          }
          int _v_len__name__46;
          _v_len__name__46 = (_v_len23 - _v_len24);
          if (!_c_6.term_eq (_v_deref__rfp__obj6, 0))
          {
            goto _block2__branch6;
          }
          Expr _ve_ns;
          _ve_ns = Expr (_v_deref__rfp__obj6, (0 + 1), _v_len__ns6);
          Expr _ge_name__4;
          _ge_name__4 = Expr (_v_deref__deref__rfp__obj6, 0, _v_len__name__46);
          _ve_prefix = (_c_15 + _ve_ns + _c_8);
          _ve_name = _ge_name__4;
          goto _block2;
        }
      _block2__branch6: {}
        {
          if (_ve_rfp__obj.get_len () != 1)
          {
            goto _block2__branch7;
          }
          if (_ve_rfp__obj.symbol_at (0))
          {
            goto _block2__branch7;
          }
          Expr _v_deref__rfp__obj7;
          _v_deref__rfp__obj7 = Expr (_ve_rfp__obj, 0);
          if (_v_deref__rfp__obj7.get_len () != 2)
          {
            goto _block2__branch7;
          }
          if (_v_deref__rfp__obj7.symbol_at ((0 + 1)))
          {
            goto _block2__branch7;
          }
          Expr _v_deref__deref__rfp__obj7;
          _v_deref__deref__rfp__obj7 = Expr (_v_deref__rfp__obj7, (0 + 1));
          int _v_len25;
          _v_len25 = _v_deref__deref__rfp__obj7.get_len ();
          int _v_len26;
          _v_len26 = 0;
          if (_v_len25 < _v_len26)
          {
            goto _block2__branch7;
          }
          int _v_len__name__47;
          _v_len__name__47 = (_v_len25 - _v_len26);
          if (!_c_16.term_eq (_v_deref__rfp__obj7, 0))
          {
            goto _block2__branch7;
          }
          Expr _ge_name__4;
          _ge_name__4 = Expr (_v_deref__deref__rfp__obj7, 0, _v_len__name__47);
          _ve_prefix = _c_17;
          _ve_name = _ge_name__4;
          goto _block2;
        }
      _block2__branch7: {}
        if (_ve_rfp__obj.get_len () != 1)
        {
          goto _block1__branch1;
        }
        if (_ve_rfp__obj.symbol_at (0))
        {
          goto _block1__branch1;
        }
        Expr _v_deref__rfp__obj8;
        _v_deref__rfp__obj8 = Expr (_ve_rfp__obj, 0);
        if (_v_deref__rfp__obj8.get_len () != 2)
        {
          goto _block1__branch1;
        }
        if (_v_deref__rfp__obj8.symbol_at ((0 + 1)))
        {
          goto _block1__branch1;
        }
        Expr _v_deref__deref__rfp__obj8;
        _v_deref__deref__rfp__obj8 = Expr (_v_deref__rfp__obj8, (0 + 1));
        int _v_len27;
        _v_len27 = _v_deref__deref__rfp__obj8.get_len ();
        int _v_len28;
        _v_len28 = 0;
        if (_v_len27 < _v_len28)
        {
          goto _block1__branch1;
        }
        int _v_len__name__48;
        _v_len__name__48 = (_v_len27 - _v_len28);
        if (!_c_18.term_eq (_v_deref__rfp__obj8, 0))
        {
          goto _block1__branch1;
        }
        Expr _ge_name__4;
        _ge_name__4 = Expr (_v_deref__deref__rfp__obj8, 0, _v_len__name__48);
        _ve_prefix = _c_8;
        _ve_name = _ge_name__4;
      }
    _block2: {}
      Expr _v_Chars2Java1;
      RF_CALL (Chars2Java, _ve_name, _v_Chars2Java1);
      _ve_ident = (_ve_prefix + _v_Chars2Java1);
      goto _block1;
    }
  _block1__branch1: {}
    {
      if (_ve_rfp__obj.get_len () != 1)
      {
        goto _block1__branch2;
      }
      if (_ve_rfp__obj.symbol_at (0))
      {
        goto _block1__branch2;
      }
      Expr _v_deref__rfp__obj9;
      _v_deref__rfp__obj9 = Expr (_ve_rfp__obj, 0);
      if (_v_deref__rfp__obj9.get_len () != 2)
      {
        goto _block1__branch2;
      }
      if (!_c_19.term_eq (_v_deref__rfp__obj9, 0))
      {
        goto _block1__branch2;
      }
      Expr _vt_var;
      _vt_var = Expr (_v_deref__rfp__obj9, (0 + 1), 1);
      RF_CALL (Rfp2Java, _vt_var, _ve_ident);
      goto _block1;
    }
  _block1__branch2: {}
    Expr _ve_name;
    {
      {
        if (_ve_rfp__obj.get_len () != 1)
        {
          goto _block4__branch1;
        }
        if (_ve_rfp__obj.symbol_at (0))
        {
          goto _block4__branch1;
        }
        Expr _v_deref__rfp__obj10;
        _v_deref__rfp__obj10 = Expr (_ve_rfp__obj, 0);
        int _v_len29;
        _v_len29 = _v_deref__rfp__obj10.get_len ();
        int _v_len30;
        _v_len30 = 1;
        if (_v_len29 < _v_len30)
        {
          goto _block4__branch1;
        }
        int _v_len__names;
        _v_len__names = (_v_len29 - _v_len30);
        if (!_c_20.term_eq (_v_deref__rfp__obj10, 0))
        {
          goto _block4__branch1;
        }
        Expr _ve_names;
        _ve_names = Expr (_v_deref__rfp__obj10, (0 + 1), _v_len__names);
        _ve_name = _ve_names;
        goto _block4;
      }
    _block4__branch1: {}
      {
        if (_ve_rfp__obj.get_len () != 1)
        {
          goto _block4__branch2;
        }
        if (_ve_rfp__obj.symbol_at (0))
        {
          goto _block4__branch2;
        }
        Expr _v_deref__rfp__obj11;
        _v_deref__rfp__obj11 = Expr (_ve_rfp__obj, 0);
        int _v_len31;
        _v_len31 = _v_deref__rfp__obj11.get_len ();
        int _v_len32;
        _v_len32 = 0;
        if (_v_len31 < _v_len32)
        {
          goto _block4__branch2;
        }
        int _v_len__names2;
        _v_len__names2 = (_v_len31 - _v_len32);
        Expr _ve_names;
        _ve_names = Expr (_v_deref__rfp__obj11, 0, _v_len__names2);
        _ve_name = _ve_names;
        goto _block4;
      }
    _block4__branch2: {}
      int _v_len33;
      _v_len33 = _ve_rfp__obj.get_len ();
      int _v_len34;
      _v_len34 = 0;
      if (_v_len33 < _v_len34)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      int _v_len__names3;
      _v_len__names3 = (_v_len33 - _v_len34);
      Expr _ve_names;
      _ve_names = Expr (_ve_rfp__obj, 0, _v_len__names3);
      _ve_name = _ve_names;
    }
  _block4: {}
    RF_CALL (Chars2Java, _ve_name, _ve_ident);
  }
_block1: {}
  {
    {
      Expr _v_Apply1;
      if (!RF_CALL (refal::Apply::Apply, (_c_21, _ve_ident), _v_Apply1))
      {
        goto _block5__branch1;
      }
      int _v_len35;
      _v_len35 = _v_Apply1.get_len ();
      int _v_len36;
      _v_len36 = 0;
      if (_v_len35 < _v_len36)
      {
        goto _block5__branch1;
      }
      int _v_len___dollar_tmp_m_79_m_41;
      _v_len___dollar_tmp_m_79_m_41 = (_v_len35 - _v_len36);
      Expr _ve__dollar_tmp_m_79_m_41;
      _ve__dollar_tmp_m_79_m_41 = Expr (_v_Apply1, 0, _v_len___dollar_tmp_m_79_m_41);
      _v_res1 = (_c_22 + _ve_ident);
      goto _block5;
    }
  _block5__branch1: {}
    _v_res1 = _ve_ident;
  }
_block5: {}
RF_END

RF_FUNC (Qualifier2Java, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  if (_ge_arg1.get_len () != 1)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_ge_arg1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _vs_qualifier;
  _vs_qualifier = Expr (_ge_arg1, 0, 1);
  Expr _ge_auxcall1;
  RF_CALL (Chars2Java, _vs_qualifier, _ge_auxcall1);
  _v_res1 = (_ge_auxcall1 + refal::cpp_specific::Namespace_Delimeter);
RF_END

RF_FUNC (Chars2Java, (RF_ARG _ve_name;;), (RF_RES _v_res1;;))
  Expr _ge_auxcall1;
  RF_CALL (refal::Convert::ToChars, _ve_name, _ge_auxcall1);
  if (!RF_CALL (refal::List::Map, (_c_23, empty, _ge_auxcall1), _v_res1))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
RF_END

RF_FUNC (A_Char2Java, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  if (_ge_arg1.get_len () != 1)
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  if (!_ge_arg1.symbol_at (0))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
  Expr _vs_char;
  _vs_char = Expr (_ge_arg1, 0, 1);
  {
    {
      if (!RF_CALL (refal::Class::IsDigit, _vs_char, /*void*/))
      {
        goto _block1__branch1;
      }
      _v_res1 = _vs_char;
      goto _block1;
    }
  _block1__branch1: {}
    {
      if (!RF_CALL (refal::Class::IsLetter, _vs_char, /*void*/))
      {
        goto _block1__branch2;
      }
      {
        RF_lsplit (_c_24, 0, _ve__dollar_tmp_m_89_m_35, _v_lsplit__24);
        for ( ; ; RF_iter(_c_24)++)
        {
          {
            if (!RF_iter(_c_24))
            {
              goto _negation1;
            }
            int _v_len1;
            _v_len1 = _v_lsplit__24.get_len ();
            int _v_len2;
            _v_len2 = 1;
            if (_v_len1 < _v_len2)
            {
              goto _negation1;
            }
            int _v_len___dollar_tmp_m_89_m_44;
            _v_len___dollar_tmp_m_89_m_44 = (_v_len1 - _v_len2);
            if (!_vs_char.term_eq (_v_lsplit__24, 0))
            {
              goto _continue1;
            }
            Expr _ve__dollar_tmp_m_89_m_44;
            _ve__dollar_tmp_m_89_m_44 = Expr (_v_lsplit__24, (0 + 1), _v_len___dollar_tmp_m_89_m_44);
            goto _exit1;
          }
      _continue1: {}
        }
      _exit1: {}
        goto _block1__branch2;
      }
    _negation1: {}
      _v_res1 = _vs_char;
      goto _block1;
    }
  _block1__branch2: {}
    {
      RF_lsplit (Conv_Table, 0, _ve__dollar_tmp_m_90_m_18, _v_lsplit__Conv__Table);
      for ( ; ; RF_iter(Conv_Table)++)
      {
        {
          if (!RF_iter(Conv_Table))
          {
            goto _block1__branch3;
          }
          int _v_len3;
          _v_len3 = _v_lsplit__Conv__Table.get_len ();
          int _v_len4;
          _v_len4 = 1;
          if (_v_len3 < _v_len4)
          {
            goto _block1__branch3;
          }
          int _v_len___dollar_tmp_m_90_m_36;
          _v_len___dollar_tmp_m_90_m_36 = (_v_len3 - _v_len4);
          if (_v_lsplit__Conv__Table.symbol_at (0))
          {
            goto _continue2;
          }
          Expr _v_deref__lsplit__Conv__Table;
          _v_deref__lsplit__Conv__Table = Expr (_v_lsplit__Conv__Table, 0);
          int _v_len5;
          _v_len5 = _v_deref__lsplit__Conv__Table.get_len ();
          int _v_len6;
          _v_len6 = 1;
          if (_v_len5 < _v_len6)
          {
            goto _continue2;
          }
          int _v_len__code;
          _v_len__code = (_v_len5 - _v_len6);
          if (!_vs_char.term_eq (_v_deref__lsplit__Conv__Table, 0))
          {
            goto _continue2;
          }
          Expr _ve__dollar_tmp_m_90_m_36;
          _ve__dollar_tmp_m_90_m_36 = Expr (_v_lsplit__Conv__Table, (0 + 1), _v_len___dollar_tmp_m_90_m_36);
          Expr _ve_code;
          _ve_code = Expr (_v_deref__lsplit__Conv__Table, (0 + 1), _v_len__code);
          _v_res1 = (_c_8 + _ve_code + _c_8);
          goto _exit2;
        }
    _continue2: {}
      }
    _exit2: {}
      goto _block1;
    }
  _block1__branch3: {}
    Expr _ge_auxcall1;
    RF_CALL (Char_To_Unicode, _vs_char, _ge_auxcall1);
    _v_res1 = (_c_8 + _ge_auxcall1 + _c_8);
  }
_block1: {}
RF_END

RF_FUNC (Char_To_Unicode, (RF_ARG _gs_arg1;;), (RF_RES _v_res1;;))
  {
    {
      if (!_gs_arg1.term_eq (_c_25, 0))
      {
        goto _block1__branch1;
      }
      _v_res1 = _c_26;
      goto _block1;
    }
  _block1__branch1: {}
    {
      if (!_gs_arg1.term_eq (_c_27, 0))
      {
        goto _block1__branch2;
      }
      _v_res1 = _c_28;
      goto _block1;
    }
  _block1__branch2: {}
    {
      if (!_gs_arg1.term_eq (_c_29, 0))
      {
        goto _block1__branch3;
      }
      _v_res1 = _c_30;
      goto _block1;
    }
  _block1__branch3: {}
    {
      if (!_gs_arg1.term_eq (_c_3, 0))
      {
        goto _block1__branch4;
      }
      _v_res1 = _c_31;
      goto _block1;
    }
  _block1__branch4: {}
    {
      if (!_gs_arg1.term_eq (_c_32, 0))
      {
        goto _block1__branch5;
      }
      _v_res1 = _c_33;
      goto _block1;
    }
  _block1__branch5: {}
    if (!_gs_arg1.term_eq (_c_34, 0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    _v_res1 = _c_35;
  }
_block1: {}
RF_END

RF_FUNC (Java2Rfp, (RF_ARG _ve_ident;;), (RF_RES _v_res1;;))
  Expr _v_ToChars1;
  RF_CALL (refal::Convert::ToChars, _ve_ident, _v_ToChars1);
  Expr _ge_auxalt1;
  {
    {
      int _v_len1;
      _v_len1 = _v_ToChars1.get_len ();
      int _v_len2;
      _v_len2 = 3;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      int _v_len__name;
      _v_len__name = (_v_len1 - _v_len2);
      if (!_c_22.eq (_v_ToChars1, 0))
      {
        goto _block1__branch1;
      }
      Expr _ve_name;
      _ve_name = Expr (_v_ToChars1, (0 + 1 + 1 + 1), _v_len__name);
      _ge_auxalt1 = _ve_name;
      goto _block1;
    }
  _block1__branch1: {}
    int _v_len3;
    _v_len3 = _v_ToChars1.get_len ();
    int _v_len4;
    _v_len4 = 0;
    if (_v_len3 < _v_len4)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    int _v_len__name2;
    _v_len__name2 = (_v_len3 - _v_len4);
    Expr _ve_name;
    _ve_name = Expr (_v_ToChars1, 0, _v_len__name2);
    _ge_auxalt1 = _ve_name;
  }
_block1: {}
  {
    {
      int _v_len5;
      _v_len5 = _ge_auxalt1.get_len ();
      int _v_len6;
      _v_len6 = 4;
      if (_v_len5 < _v_len6)
      {
        goto _block2__branch1;
      }
      int _v_len__name3;
      _v_len__name3 = (_v_len5 - _v_len6);
      if (!_c_36.eq (_ge_auxalt1, 0))
      {
        goto _block2__branch1;
      }
      Expr _ve_name;
      _ve_name = Expr (_ge_auxalt1, (0 + 1 + 1 + 1 + 1), _v_len__name3);
      Expr _gs_auxcall2;
      if (!RF_CALL (Chars2Rfp, _ve_name, _gs_auxcall2))
      {
        RF_RETFAIL;
      }
      _v_res1 = (_c_0 + _gs_auxcall2 ()) ();
      goto _block2;
    }
  _block2__branch1: {}
    {
      int _v_len7;
      _v_len7 = _ge_auxalt1.get_len ();
      int _v_len8;
      _v_len8 = 4;
      if (_v_len7 < _v_len8)
      {
        goto _block2__branch2;
      }
      int _v_len__name4;
      _v_len__name4 = (_v_len7 - _v_len8);
      if (!_c_37.eq (_ge_auxalt1, 0))
      {
        goto _block2__branch2;
      }
      Expr _ve_name;
      _ve_name = Expr (_ge_auxalt1, (0 + 1 + 1 + 1 + 1), _v_len__name4);
      Expr _gs_auxcall3;
      if (!RF_CALL (Chars2Rfp, _ve_name, _gs_auxcall3))
      {
        RF_RETFAIL;
      }
      _v_res1 = (_c_2 + _gs_auxcall3 ()) ();
      goto _block2;
    }
  _block2__branch2: {}
    {
      int _v_len9;
      _v_len9 = _ge_auxalt1.get_len ();
      int _v_len10;
      _v_len10 = 4;
      if (_v_len9 < _v_len10)
      {
        goto _block2__branch3;
      }
      int _v_len__name5;
      _v_len__name5 = (_v_len9 - _v_len10);
      if (!_c_38.eq (_ge_auxalt1, 0))
      {
        goto _block2__branch3;
      }
      Expr _ve_name;
      _ve_name = Expr (_ge_auxalt1, (0 + 1 + 1 + 1 + 1), _v_len__name5);
      Expr _gs_auxcall4;
      if (!RF_CALL (Chars2Rfp, _ve_name, _gs_auxcall4))
      {
        RF_RETFAIL;
      }
      _v_res1 = (_c_4 + _gs_auxcall4 ()) ();
      goto _block2;
    }
  _block2__branch3: {}
    {
      int _v_len11;
      _v_len11 = _ge_auxalt1.get_len ();
      int _v_len12;
      _v_len12 = 4;
      if (_v_len11 < _v_len12)
      {
        goto _block2__branch4;
      }
      int _v_len__name6;
      _v_len__name6 = (_v_len11 - _v_len12);
      if (!_c_39.eq (_ge_auxalt1, 0))
      {
        goto _block2__branch4;
      }
      Expr _ve_name;
      _ve_name = Expr (_ge_auxalt1, (0 + 1 + 1 + 1 + 1), _v_len__name6);
      Expr _gs_auxcall5;
      if (!RF_CALL (Chars2Rfp, _ve_name, _gs_auxcall5))
      {
        RF_RETFAIL;
      }
      _v_res1 = (_c_6 + _gs_auxcall5 ()) ();
      goto _block2;
    }
  _block2__branch4: {}
    int _v_len13;
    _v_len13 = _ge_auxalt1.get_len ();
    int _v_len14;
    _v_len14 = 0;
    if (_v_len13 < _v_len14)
    {
      RF_RETFAIL;
    }
    int _v_len__name7;
    _v_len__name7 = (_v_len13 - _v_len14);
    Expr _ve_name;
    _ve_name = Expr (_ge_auxalt1, 0, _v_len__name7);
    RF_TAILCALL (Qualifiers2Rfp, _ve_name, _v_res1);
  }
_block2: {}
RF_END

RF_FUNC (Qualifiers2Rfp, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  {
    {
      if (_ge_arg1.get_len () < 2)
      {
        goto _block1__branch1;
      }
      RF_lsplit (_ge_arg1, 0, _ve_qualifier, _v_lsplit__arg1);
      for ( ; ; RF_iter(_ge_arg1)++)
      {
        {
          if (!RF_iter(_ge_arg1))
          {
            goto _block1__branch1;
          }
          int _v_len1;
          _v_len1 = _v_lsplit__arg1.get_len ();
          int _v_len2;
          _v_len2 = 2;
          if (_v_len1 < _v_len2)
          {
            goto _block1__branch1;
          }
          int _v_len__rest;
          _v_len__rest = (_v_len1 - _v_len2);
          if (!refal::cpp_specific::Namespace_Delimeter.eq (_v_lsplit__arg1, 0))
          {
            goto _continue1;
          }
          Expr _ve_rest;
          _ve_rest = Expr (_v_lsplit__arg1, (0 + 1 + 1), _v_len__rest);
          Expr _gs_auxcall1;
          if (!RF_CALL (Chars2Rfp, _ve_qualifier, _gs_auxcall1))
          {
            RF_RETFAIL;
          }
          Expr _v_Qualifiers2Rfp1;
          if (!RF_CALL (Qualifiers2Rfp, _ve_rest, _v_Qualifiers2Rfp1))
          {
            RF_RETFAIL;
          }
          _v_res1 = (_gs_auxcall1 + _v_Qualifiers2Rfp1);
          goto _exit1;
        }
    _continue1: {}
      }
    _exit1: {}
      goto _block1;
    }
  _block1__branch1: {}
    if (!RF_CALL (Chars2Rfp, _ge_arg1, _v_res1))
    {
      RF_RETFAIL;
    }
  }
_block1: {}
RF_END

RF_FUNC (Chars2Rfp, (RF_ARG _ve_name;;), (RF_RES _v_res1;;))
  Expr _ge_auxcall1;
  if (!RF_CALL (Codes2Rfp, _ve_name, _ge_auxcall1))
  {
    RF_RETFAIL;
  }
  RF_TAILCALL (refal::Convert::ToWord, _ge_auxcall1, _v_res1);
RF_END

RF_FUNC (Codes2Rfp, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  {
    {
      if (_ge_arg1.get_len () < 2)
      {
        goto _block1__branch1;
      }
      if (!_c_8.term_eq (_ge_arg1, 0))
      {
        goto _block1__branch1;
      }
      Expr _v_subexpr__arg1;
      _v_subexpr__arg1 = Expr (_ge_arg1, (0 + 1), (_ge_arg1.get_len () - (0 + 1 + 0)));
      RF_lsplit (_v_subexpr__arg1, 0, _ve_code, _v_lsplit__arg1);
      for ( ; ; RF_iter(_v_subexpr__arg1)++)
      {
        {
          if (!RF_iter(_v_subexpr__arg1))
          {
            goto _block1__branch1;
          }
          int _v_len1;
          _v_len1 = _v_lsplit__arg1.get_len ();
          int _v_len2;
          _v_len2 = 1;
          if (_v_len1 < _v_len2)
          {
            goto _block1__branch1;
          }
          int _v_len__rest;
          _v_len__rest = (_v_len1 - _v_len2);
          if (!_c_8.term_eq (_v_lsplit__arg1, 0))
          {
            goto _continue1;
          }
          Expr _ve_rest;
          _ve_rest = Expr (_v_lsplit__arg1, (0 + 1), _v_len__rest);
          RF_lsplit (Conv_Table, 0, _ve__dollar_tmp_m_133_m_20, _v_lsplit__Conv__Table);
          for ( ; ; RF_iter(Conv_Table)++)
          {
            {
              if (!RF_iter(Conv_Table))
              {
                RF_RETFAIL;
              }
              int _v_len3;
              _v_len3 = _v_lsplit__Conv__Table.get_len ();
              int _v_len4;
              _v_len4 = 1;
              if (_v_len3 < _v_len4)
              {
                RF_RETFAIL;
              }
              int _v_len___dollar_tmp_m_133_m_38;
              _v_len___dollar_tmp_m_133_m_38 = (_v_len3 - _v_len4);
              if (_v_lsplit__Conv__Table.symbol_at (0))
              {
                goto _continue2;
              }
              Expr _v_deref__lsplit__Conv__Table;
              _v_deref__lsplit__Conv__Table = Expr (_v_lsplit__Conv__Table, 0);
              if (_v_deref__lsplit__Conv__Table.get_len () != (_ve_code.get_len () + 1))
              {
                goto _continue2;
              }
              if (!_v_deref__lsplit__Conv__Table.symbol_at (0))
              {
                goto _continue2;
              }
              if (!_ve_code.eq (_v_deref__lsplit__Conv__Table, (0 + 1)))
              {
                goto _continue2;
              }
              Expr _ve__dollar_tmp_m_133_m_38;
              _ve__dollar_tmp_m_133_m_38 = Expr (_v_lsplit__Conv__Table, (0 + 1), _v_len___dollar_tmp_m_133_m_38);
              Expr _vs_char;
              _vs_char = Expr (_v_deref__lsplit__Conv__Table, 0, 1);
              Expr _v_Codes2Rfp1;
              if (!RF_CALL (Codes2Rfp, _ve_rest, _v_Codes2Rfp1))
              {
                RF_RETFAIL;
              }
              _v_res1 = (_vs_char + _v_Codes2Rfp1);
              goto _exit2;
            }
        _continue2: {}
          }
        _exit2: {}
          goto _exit1;
        }
    _continue1: {}
      }
    _exit1: {}
      goto _block1;
    }
  _block1__branch1: {}
    {
      int _v_len5;
      _v_len5 = _ge_arg1.get_len ();
      int _v_len6;
      _v_len6 = 1;
      if (_v_len5 < _v_len6)
      {
        goto _block1__branch2;
      }
      int _v_len__rest2;
      _v_len__rest2 = (_v_len5 - _v_len6);
      if (!_ge_arg1.symbol_at (0))
      {
        goto _block1__branch2;
      }
      Expr _vs_char;
      _vs_char = Expr (_ge_arg1, 0, 1);
      Expr _ve_rest;
      _ve_rest = Expr (_ge_arg1, (0 + 1), _v_len__rest2);
      {
        {
          if (!RF_CALL (refal::Class::IsDigit, _vs_char, /*void*/))
          {
            goto _block2__branch1;
          }
          goto _block2;
        }
      _block2__branch1: {}
        if (!RF_CALL (refal::Class::IsLetter, _vs_char, /*void*/))
        {
          RF_RETFAIL;
        }
        {
          if (!_vs_char.term_eq (_c_40, 0))
          {
            goto _negation1;
          }
          RF_RETFAIL;
        }
      _negation1: {}
      }
    _block2: {}
      Expr _v_Codes2Rfp2;
      if (!RF_CALL (Codes2Rfp, _ve_rest, _v_Codes2Rfp2))
      {
        RF_RETFAIL;
      }
      _v_res1 = (_vs_char + _v_Codes2Rfp2);
      goto _block1;
    }
  _block1__branch2: {}
    if (_ge_arg1.get_len () != 0)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    _v_res1 = empty;
  }
_block1: {}
RF_END

RF_FUNC (IsReserved_Word_0, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  int _v_len1;
  _v_len1 = _ge_arg1.get_len ();
  int _v_len2;
  _v_len2 = 0;
  if (_v_len1 < _v_len2)
  {
    RF_ERROR (_c_41);
  }
  int _v_len__stub1;
  _v_len__stub1 = (_v_len1 - _v_len2);
  Expr _v_stub1;
  _v_stub1 = Expr (_ge_arg1, 0, _v_len__stub1);
  if (!RF_CALL (refal::cpp_specific::IsReserved_Word, _v_stub1, /*void*/))
  {
    RF_RETFAIL;
  }
  _v_res1 = empty;
RF_END

}

}

namespace refal {

namespace JavaMangle {

static void init_ () {
  Conv_Table = (rftype::Char::create_expr (L"!e")) () + (rftype::Char::create_expr (L"?q")) () + (rftype::Char::create_expr (L"_")) () + (rftype::Char::create_expr (L"-m")) () + (rftype::Char::create_expr (L"+p")) () + (rftype::Char::create_expr (L"<lt")) () + (rftype::Char::create_expr (L">gt")) () + (rftype::Char::create_expr (L"=eq")) () + (rftype::Char::create_expr (L"*a")) () + (rftype::Char::create_expr (L"/s")) () + (rftype::Char::create_expr (L" sp")) () + (rftype::Char::create_expr (L"\\bs")) () + (rftype::Char::create_expr (L"|bar")) () + (rftype::Char::create_expr (L"~tilde")) () + (rftype::Char::create_expr (L"@at")) () + (rftype::Char::create_expr (L"#num")) () + (rftype::Char::create_expr (L"$dollar")) () + (rftype::Char::create_expr (L"%percnt")) () + (rftype::Char::create_expr (L"^circ")) () + (rftype::Char::create_expr (L"&amp")) () + (rftype::Char::create_expr (L"(lpar")) () + (rftype::Char::create_expr (L")rpar")) () + (rftype::Char::create_expr (L"[lsqb")) () + (rftype::Char::create_expr (L"]rsqb")) () + (rftype::Char::create_expr (L"{lcub")) () + (rftype::Char::create_expr (L"}rcub")) () + (rftype::Char::create_expr (L"`grave")) () + (rftype::Char::create_expr (L"'apos")) () + (rftype::Char::create_expr (L"\"quot")) () + (rftype::Char::create_expr (L",comma")) () + (rftype::Char::create_expr (L".period")) () + (rftype::Char::create_expr (L":colon")) () + (rftype::Char::create_expr (L";semi")) ();
  _c_0 = Expr::create<rftype::Word>("EVAR");
  _c_36 = rftype::Char::create_expr (L"_ve_");
  _c_12 = Expr (_c_36, 0, 3);
  _c_1 = Expr (_c_12, 2, 1);
  _c_2 = Expr::create<rftype::Word>("VVAR");
  _c_11 = Expr (_c_12, 0, 2);
  _c_3 = Expr (_c_11, 1, 1);
  _c_4 = Expr::create<rftype::Word>("TVAR");
  _c_38 = rftype::Char::create_expr (L"_vt_");
  _c_14 = Expr (_c_38, 0, 3);
  _c_5 = Expr (_c_14, 2, 1);
  _c_6 = Expr::create<rftype::Word>("SVAR");
  _c_39 = rftype::Char::create_expr (L"_vs_");
  _c_15 = Expr (_c_39, 0, 3);
  _c_7 = Expr (_c_15, 2, 1);
  _c_9 = rftype::Char::create_expr (L"_g");
  _c_8 = Expr (_c_9, 0, 1);
  _c_10 = Expr::create<rftype::Word>("VAR");
  _c_37 = rftype::Char::create_expr (L"_vv_");
  _c_13 = Expr (_c_37, 0, 3);
  _c_16 = Expr::create<rftype::Word>("STATIC");
  _c_17 = rftype::Char::create_expr (L"_c_");
  _c_18 = Expr::create<rftype::Word>("LABEL");
  _c_19 = Expr::create<rftype::Word>("INT");
  _c_20 = Expr::create<rftype::Word>("OBJ");
  _c_21 = Expr::create_sym<rftype::Func> (IsReserved_Word_0);
  _c_22 = rftype::Char::create_expr (L"_r_");
  _c_23 = Expr::create_sym<rftype::Func> (A_Char2Java);
  _c_24 = rftype::Char::create_expr (L"?!");
  _c_25 = rftype::Char::create_expr (L"b");
  _c_26 = rftype::Char::create_expr (L"08");
  _c_27 = rftype::Char::create_expr (L"\t");
  _c_28 = rftype::Char::create_expr (L"09");
  _c_29 = rftype::Char::create_expr (L"\n");
  _c_30 = rftype::Char::create_expr (L"0A");
  _c_31 = rftype::Char::create_expr (L"0B");
  _c_32 = rftype::Char::create_expr (L"f");
  _c_33 = rftype::Char::create_expr (L"0C");
  _c_34 = rftype::Char::create_expr (L"\r");
  _c_35 = rftype::Char::create_expr (L"0D");
  _c_40 = Expr (_c_24, 0, 1);
  _c_41 = Expr::create<rftype::Word>("Apply") + Expr::create<rftype::Word>("Apply") + Expr::create<rftype::Word>("Unexpected fail");
}

static AtStart init_registrator_ (&init_);

}

}
