
#include <rf_core.hh>

using namespace rfrt;

namespace refal {

namespace Apply {

RF_DECL (Apply);

}

}

namespace refal {

namespace Compare {

RF_DECL (Le);

}

}

namespace refal {

namespace Arithm {

RF_DECL (Sub);

}

}

namespace refal {

namespace List {

RF_DECL (And);

RF_DECL (Any);

RF_DECL (All);

RF_DECL (Concat);

RF_DECL (Deparen_Term);

RF_DECL (Append);

RF_DECL (Filter);

RF_DECL (Foldr1);

RF_DECL (Foldr);

RF_DECL (Intersperse);

RF_DECL (IsElem);

RF_DECL (Id);

RF_DECL (Deparen_Term_0);

RF_DECL (MapIn);

RF_DECL (Or);

RF_DECL (Paren);

RF_DECL (Nub);

RF_DECL (Replicate);

RF_DECL (Paren_Term_0);

RF_DECL (Paren_Term);

RF_DECL (Separate);

RF_DECL (Sub);

RF_DECL (Zip);

RF_DECL (Split);

RF_DECL (Reverse);

RF_DECL (Map);

}

}

namespace refal {

namespace List {

static Expr _c_0;

static Expr _c_1;

static Expr _c_2;

static Expr _c_3;

static Expr _c_4;

RF_FUNC (Deparen_Term, (RF_ARG _gt_arg1;;), (RF_RES _v_res1;;))
  {
    {
      if (_gt_arg1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__arg1;
      _v_deref__arg1 = Expr (_gt_arg1, 0);
      int _v_len1;
      _v_len1 = _v_deref__arg1.get_len ();
      int _v_len2;
      _v_len2 = 0;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      int _v_len__xpr;
      _v_len__xpr = (_v_len1 - _v_len2);
      Expr _ve_xpr;
      _ve_xpr = Expr (_v_deref__arg1, 0, _v_len__xpr);
      _v_res1 = _ve_xpr;
      goto _block1;
    }
  _block1__branch1: {}
    _v_res1 = _gt_arg1;
  }
_block1: {}
RF_END

RF_FUNC (Paren_Term, (RF_ARG _vt_erm;;), (RF_RES _v_res1;;))
  _v_res1 = _vt_erm;
RF_END

RF_FUNC (Id, (RF_ARG _ve_1;;), (RF_RES _v_res1;;))
  _v_res1 = _ve_1;
RF_END

RF_FUNC (Append, (RF_ARG _ve_1, _ve_2;;), (RF_RES _v_res1;;))
  _v_res1 = (_ve_2 + _ve_1);
RF_END

RF_FUNC (Zip, (RF_ARG _ve_list1, _ve_list2;;), (RF_RES _v_res1;;))
  Expr _ge_list1__0;
  _ge_list1__0 = _ve_list1;
  Expr _ge_list2__0;
  _ge_list2__0 = _ve_list2;
  Expr _ve_new__list;
  _ve_new__list = empty;
  for ( ; ; )
  {
    {
      if (_ge_list1__0.get_len () != 0)
      {
        goto _iter1;
      }
      _v_res1 = _ve_new__list;
      goto _exit__iter1;
    }
  _iter1: {}
    int _v_len1;
    _v_len1 = _ge_list2__0.get_len ();
    int _v_len2;
    _v_len2 = 1;
    if (_v_len1 < _v_len2)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    int _v_len__rest2;
    _v_len__rest2 = (_v_len1 - _v_len2);
    int _v_len3;
    _v_len3 = _ge_list1__0.get_len ();
    int _v_len4;
    _v_len4 = 1;
    if (_v_len3 < _v_len4)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    int _v_len__rest1;
    _v_len__rest1 = (_v_len3 - _v_len4);
    Expr _vt_first1;
    _vt_first1 = Expr (_ge_list1__0, 0, 1);
    Expr _ve_rest1;
    _ve_rest1 = Expr (_ge_list1__0, (0 + 1), _v_len__rest1);
    Expr _vt_first2;
    _vt_first2 = Expr (_ge_list2__0, 0, 1);
    Expr _ve_rest2;
    _ve_rest2 = Expr (_ge_list2__0, (0 + 1), _v_len__rest2);
    _ge_list1__0 = _ve_rest1;
    _ge_list2__0 = _ve_rest2;
    _ve_new__list = (_ve_new__list + (_vt_first1 + _vt_first2) ());
  }
_exit__iter1: {}
RF_END

RF_FUNC (Map, (RF_ARG _vs_Fname, _ve_Fargs, _ve_list;;), (RF_RES _v_res1;;))
  Expr _ve_new__list;
  _ve_new__list = empty;
  Expr _ge_list__0;
  _ge_list__0 = _ve_list;
  for ( ; ; )
  {
    {
      if (_ge_list__0.get_len () != 0)
      {
        goto _iter1;
      }
      _v_res1 = _ve_new__list;
      goto _exit__iter1;
    }
  _iter1: {}
    int _v_len1;
    _v_len1 = _ge_list__0.get_len ();
    int _v_len2;
    _v_len2 = 1;
    if (_v_len1 < _v_len2)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    int _v_len__rest;
    _v_len__rest = (_v_len1 - _v_len2);
    Expr _vt_item;
    _vt_item = Expr (_ge_list__0, 0, 1);
    Expr _ve_rest;
    _ve_rest = Expr (_ge_list__0, (0 + 1), _v_len__rest);
    Expr _ge_auxcall1;
    if (!RF_CALL (refal::Apply::Apply, (_vs_Fname, (_ve_Fargs + _vt_item)), _ge_auxcall1))
    {
      RF_RETFAIL;
    }
    _ve_new__list = (_ve_new__list + _ge_auxcall1);
    _ge_list__0 = _ve_rest;
  }
_exit__iter1: {}
RF_END

RF_FUNC (MapIn, (RF_ARG _vs_Fname, _ve_Fargs, _ve_list;;), (RF_RES _v_res1;;))
  Expr _ve_new__list;
  _ve_new__list = empty;
  Expr _ge_list__0;
  _ge_list__0 = _ve_list;
  for ( ; ; )
  {
    {
      if (_ge_list__0.get_len () != 0)
      {
        goto _iter1;
      }
      _v_res1 = _ve_new__list;
      goto _exit__iter1;
    }
  _iter1: {}
    int _v_len1;
    _v_len1 = _ge_list__0.get_len ();
    int _v_len2;
    _v_len2 = 1;
    if (_v_len1 < _v_len2)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    int _v_len__rest;
    _v_len__rest = (_v_len1 - _v_len2);
    if (_ge_list__0.symbol_at (0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _v_deref__list__0;
    _v_deref__list__0 = Expr (_ge_list__0, 0);
    int _v_len3;
    _v_len3 = _v_deref__list__0.get_len ();
    int _v_len4;
    _v_len4 = 0;
    if (_v_len3 < _v_len4)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    int _v_len__item;
    _v_len__item = (_v_len3 - _v_len4);
    Expr _ve_rest;
    _ve_rest = Expr (_ge_list__0, (0 + 1), _v_len__rest);
    Expr _ve_item;
    _ve_item = Expr (_v_deref__list__0, 0, _v_len__item);
    Expr _ge_auxcall1;
    if (!RF_CALL (refal::Apply::Apply, (_vs_Fname, (_ve_Fargs + _ve_item)), _ge_auxcall1))
    {
      RF_RETFAIL;
    }
    _ve_new__list = (_ve_new__list + _ge_auxcall1 ());
    _ge_list__0 = _ve_rest;
  }
_exit__iter1: {}
RF_END

RF_FUNC (Filter, (RF_ARG _vs_Fname, _ve_Fargs, _ve_list;;), (RF_RES _v_res1;;))
  Expr _ve_new__list;
  _ve_new__list = empty;
  Expr _ge_list__0;
  _ge_list__0 = _ve_list;
  for ( ; ; )
  {
    {
      if (_ge_list__0.get_len () != 0)
      {
        goto _iter1;
      }
      _v_res1 = _ve_new__list;
      goto _exit__iter1;
    }
  _iter1: {}
    int _v_len1;
    _v_len1 = _ge_list__0.get_len ();
    int _v_len2;
    _v_len2 = 1;
    if (_v_len1 < _v_len2)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    int _v_len__rest;
    _v_len__rest = (_v_len1 - _v_len2);
    Expr _vt_item;
    _vt_item = Expr (_ge_list__0, 0, 1);
    Expr _ve_rest;
    _ve_rest = Expr (_ge_list__0, (0 + 1), _v_len__rest);
    {
      {
        Expr _v_Apply1;
        if (!RF_CALL (refal::Apply::Apply, (_vs_Fname, (_ve_Fargs + _vt_item)), _v_Apply1))
        {
          goto _block2__branch1;
        }
        int _v_len3;
        _v_len3 = _v_Apply1.get_len ();
        int _v_len4;
        _v_len4 = 0;
        if (_v_len3 < _v_len4)
        {
          goto _block2__branch1;
        }
        int _v_len___dollar_tmp_m_48_m_41;
        _v_len___dollar_tmp_m_48_m_41 = (_v_len3 - _v_len4);
        Expr _ve__dollar_tmp_m_48_m_41;
        _ve__dollar_tmp_m_48_m_41 = Expr (_v_Apply1, 0, _v_len___dollar_tmp_m_48_m_41);
        _ve_new__list = (_ve_new__list + _vt_item);
        _ge_list__0 = _ve_rest;
        goto _block2;
      }
    _block2__branch1: {}
      _ge_list__0 = _ve_rest;
    }
  _block2: {}
  }
_exit__iter1: {}
RF_END

RF_FUNC (Split, (RF_ARG _vs_Fname, _ve_Fargs, _ve_list;;), (RF_RES _v_res1, _v_res2;;))
  Expr _ve_true__list;
  _ve_true__list = empty;
  Expr _ve_false__list;
  _ve_false__list = empty;
  Expr _ge_list__0;
  _ge_list__0 = _ve_list;
  for ( ; ; )
  {
    {
      if (_ge_list__0.get_len () != 0)
      {
        goto _iter1;
      }
      _v_res1 = _ve_true__list;
      _v_res2 = _ve_false__list;
      goto _exit__iter1;
    }
  _iter1: {}
    int _v_len1;
    _v_len1 = _ge_list__0.get_len ();
    int _v_len2;
    _v_len2 = 1;
    if (_v_len1 < _v_len2)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    int _v_len__rest;
    _v_len__rest = (_v_len1 - _v_len2);
    Expr _vt_item;
    _vt_item = Expr (_ge_list__0, 0, 1);
    Expr _ve_rest;
    _ve_rest = Expr (_ge_list__0, (0 + 1), _v_len__rest);
    {
      {
        Expr _v_Apply1;
        if (!RF_CALL (refal::Apply::Apply, (_vs_Fname, (_ve_Fargs + _vt_item)), _v_Apply1))
        {
          goto _block2__branch1;
        }
        int _v_len3;
        _v_len3 = _v_Apply1.get_len ();
        int _v_len4;
        _v_len4 = 0;
        if (_v_len3 < _v_len4)
        {
          goto _block2__branch1;
        }
        int _v_len___dollar_tmp_m_59_m_41;
        _v_len___dollar_tmp_m_59_m_41 = (_v_len3 - _v_len4);
        Expr _ve__dollar_tmp_m_59_m_41;
        _ve__dollar_tmp_m_59_m_41 = Expr (_v_Apply1, 0, _v_len___dollar_tmp_m_59_m_41);
        _ve_true__list = (_ve_true__list + _vt_item);
        _ge_list__0 = _ve_rest;
        goto _block2;
      }
    _block2__branch1: {}
      _ve_false__list = (_ve_false__list + _vt_item);
      _ge_list__0 = _ve_rest;
    }
  _block2: {}
  }
_exit__iter1: {}
RF_END

RF_FUNC (IsElem, (RF_ARG _ve_list, _vt_item;;), RF_VOID)
  if (_ve_list.get_len () < 1)
  {
    RF_RETFAIL;
  }
  RF_lsplit (_ve_list, 0, _ve__dollar_tmp_m_68_m_13, _v_lsplit__list);
  for ( ; ; RF_iter(_ve_list)++)
  {
    {
      if (!RF_iter(_ve_list))
      {
        RF_RETFAIL;
      }
      int _v_len1;
      _v_len1 = _v_lsplit__list.get_len ();
      int _v_len2;
      _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        RF_RETFAIL;
      }
      int _v_len___dollar_tmp_m_68_m_22;
      _v_len___dollar_tmp_m_68_m_22 = (_v_len1 - _v_len2);
      if (!_vt_item.term_eq (_v_lsplit__list, 0))
      {
        goto _continue1;
      }
      Expr _ve__dollar_tmp_m_68_m_22;
      _ve__dollar_tmp_m_68_m_22 = Expr (_v_lsplit__list, (0 + 1), _v_len___dollar_tmp_m_68_m_22);
      goto _exit1;
    }
_continue1: {}
  }
_exit1: {}
RF_END

RF_FUNC (Foldr, (RF_ARG _vs_Fname, _ve_Fargs, _ve_value, _ve_list;;), (RF_RES _v_res1;;))
  Expr _ge_value__0;
  _ge_value__0 = _ve_value;
  Expr _ge_list__0;
  _ge_list__0 = _ve_list;
  for ( ; ; )
  {
    {
      if (_ge_list__0.get_len () != 0)
      {
        goto _iter1;
      }
      _v_res1 = _ge_value__0;
      goto _exit__iter1;
    }
  _iter1: {}
    int _v_len1;
    _v_len1 = _ge_list__0.get_len ();
    int _v_len2;
    _v_len2 = 1;
    if (_v_len1 < _v_len2)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    int _v_len__something;
    _v_len__something = (_v_len1 - _v_len2);
    Expr _ve_something;
    _ve_something = Expr (_ge_list__0, 0, _v_len__something);
    Expr _vt_last;
    _vt_last = Expr (_ge_list__0, (0 + _v_len__something), 1);
    Expr _ge_auxcall1;
    if (!RF_CALL (refal::Apply::Apply, (_vs_Fname, (_ve_Fargs + _vt_last + _ge_value__0)), _ge_auxcall1))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    _ge_value__0 = _ge_auxcall1;
    _ge_list__0 = _ve_something;
  }
_exit__iter1: {}
RF_END

RF_FUNC (Foldr1, (RF_ARG _vs_Fname, _ve_Fargs, _ve_list;;), (RF_RES _v_res1;;))
  {
    {
      int _v_len1;
      _v_len1 = _ve_list.get_len ();
      int _v_len2;
      _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      int _v_len__something;
      _v_len__something = (_v_len1 - _v_len2);
      Expr _ve_something;
      _ve_something = Expr (_ve_list, 0, _v_len__something);
      Expr _vt_last;
      _vt_last = Expr (_ve_list, (0 + _v_len__something), 1);
      RF_TAILCALL (Foldr, (_vs_Fname, _ve_Fargs, _vt_last, _ve_something), _v_res1);
      goto _block1;
    }
  _block1__branch1: {}
    _v_res1 = empty;
  }
_block1: {}
RF_END

RF_FUNC (All, (RF_ARG _vs_Fname, _ve_Fargs, _ve_list;;), RF_VOID)
  Expr _ge_list__0;
  _ge_list__0 = _ve_list;
  for ( ; ; )
  {
    {
      if (_ge_list__0.get_len () != 0)
      {
        goto _iter1;
      }
      goto _exit__iter1;
    }
  _iter1: {}
    int _v_len1;
    _v_len1 = _ge_list__0.get_len ();
    int _v_len2;
    _v_len2 = 1;
    if (_v_len1 < _v_len2)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    int _v_len__rest;
    _v_len__rest = (_v_len1 - _v_len2);
    Expr _vt_item;
    _vt_item = Expr (_ge_list__0, 0, 1);
    Expr _ve_rest;
    _ve_rest = Expr (_ge_list__0, (0 + 1), _v_len__rest);
    Expr _v_Apply1;
    if (!RF_CALL (refal::Apply::Apply, (_vs_Fname, (_ve_Fargs + _vt_item)), _v_Apply1))
    {
      RF_RETFAIL;
    }
    int _v_len3;
    _v_len3 = _v_Apply1.get_len ();
    int _v_len4;
    _v_len4 = 0;
    if (_v_len3 < _v_len4)
    {
      RF_RETFAIL;
    }
    int _v_len___dollar_tmp_m_87_m_41;
    _v_len___dollar_tmp_m_87_m_41 = (_v_len3 - _v_len4);
    Expr _ve__dollar_tmp_m_87_m_41;
    _ve__dollar_tmp_m_87_m_41 = Expr (_v_Apply1, 0, _v_len___dollar_tmp_m_87_m_41);
    _ge_list__0 = _ve_rest;
  }
_exit__iter1: {}
RF_END

RF_FUNC (Any, (RF_ARG _vs_Fname, _ve_Fargs, _ve_list;;), RF_VOID)
  {
    Expr _ge_list__2;
    _ge_list__2 = _ve_list;
    for ( ; ; )
    {
      {
        if (_ge_list__2.get_len () != 0)
        {
          goto _iter1;
        }
        goto _exit__iter1;
      }
    _iter1: {}
      int _v_len1;
      _v_len1 = _ge_list__2.get_len ();
      int _v_len2;
      _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      int _v_len__rest;
      _v_len__rest = (_v_len1 - _v_len2);
      Expr _vt_item;
      _vt_item = Expr (_ge_list__2, 0, 1);
      Expr _ve_rest;
      _ve_rest = Expr (_ge_list__2, (0 + 1), _v_len__rest);
      {
        Expr _v_Apply1;
        if (!RF_CALL (refal::Apply::Apply, (_vs_Fname, (_ve_Fargs + _vt_item)), _v_Apply1))
        {
          goto _negation2;
        }
        int _v_len3;
        _v_len3 = _v_Apply1.get_len ();
        int _v_len4;
        _v_len4 = 0;
        if (_v_len3 < _v_len4)
        {
          goto _negation2;
        }
        int _v_len___dollar_tmp_m_95_m_46;
        _v_len___dollar_tmp_m_95_m_46 = (_v_len3 - _v_len4);
        Expr _ve__dollar_tmp_m_95_m_46;
        _ve__dollar_tmp_m_95_m_46 = Expr (_v_Apply1, 0, _v_len___dollar_tmp_m_95_m_46);
        goto _negation1;
      }
    _negation2: {}
      _ge_list__2 = _ve_rest;
    }
  _exit__iter1: {}
    RF_RETFAIL;
  }
_negation1: {}
RF_END

RF_FUNC (Concat, (RF_ARG _ve_lists;;), (RF_RES _v_res1;;))
  if (!RF_CALL (Map, (_c_0, empty, _ve_lists), _v_res1))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
RF_END

RF_FUNC (Paren, (RF_ARG _ve_xpr;;), (RF_RES _v_res1;;))
  if (!RF_CALL (Map, (_c_1, empty, _ve_xpr), _v_res1))
  {
    RF_FUNC_ERROR (unexpected_fail);
  }
RF_END

RF_FUNC (Reverse, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  {
    {
      int _v_len1;
      _v_len1 = _ge_arg1.get_len ();
      int _v_len2;
      _v_len2 = 1;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      int _v_len__list;
      _v_len__list = (_v_len1 - _v_len2);
      Expr _vt_erm;
      _vt_erm = Expr (_ge_arg1, 0, 1);
      Expr _ve_list;
      _ve_list = Expr (_ge_arg1, (0 + 1), _v_len__list);
      Expr _ge_auxcall1;
      RF_CALL (Reverse, _ve_list, _ge_auxcall1);
      _v_res1 = (_ge_auxcall1 + _vt_erm);
      goto _block1;
    }
  _block1__branch1: {}
    if (_ge_arg1.get_len () != 0)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    _v_res1 = empty;
  }
_block1: {}
RF_END

RF_FUNC (Intersperse, (RF_ARG _ge_arg1, _ge_arg2;;), (RF_RES _v_res1;;))
  {
    {
      if ((_ge_arg2.get_len () + 1) != 1)
      {
        goto _block1__branch1;
      }
      Expr _v_compose1;
      _v_compose1 = (_ge_arg1 () + _ge_arg2);
      if (_v_compose1.symbol_at (0))
      {
        goto _block1__branch1;
      }
      Expr _v_deref__compose1;
      _v_deref__compose1 = Expr (_v_compose1, 0);
      int _v_len1;
      _v_len1 = _v_deref__compose1.get_len ();
      int _v_len2;
      _v_len2 = 0;
      if (_v_len1 < _v_len2)
      {
        goto _block1__branch1;
      }
      int _v_len__sep;
      _v_len__sep = (_v_len1 - _v_len2);
      Expr _ve_sep;
      _ve_sep = Expr (_v_deref__compose1, 0, _v_len__sep);
      _v_res1 = empty;
      goto _block1;
    }
  _block1__branch1: {}
    {
      if ((_ge_arg2.get_len () + 1) != 2)
      {
        goto _block1__branch2;
      }
      Expr _v_compose2;
      _v_compose2 = (_ge_arg1 () + _ge_arg2);
      if (_v_compose2.symbol_at (0))
      {
        goto _block1__branch2;
      }
      Expr _v_deref__compose2;
      _v_deref__compose2 = Expr (_v_compose2, 0);
      int _v_len3;
      _v_len3 = _v_deref__compose2.get_len ();
      int _v_len4;
      _v_len4 = 0;
      if (_v_len3 < _v_len4)
      {
        goto _block1__branch2;
      }
      int _v_len__sep2;
      _v_len__sep2 = (_v_len3 - _v_len4);
      Expr _vt_1;
      _vt_1 = Expr (_v_compose2, (0 + 1), 1);
      Expr _ve_sep;
      _ve_sep = Expr (_v_deref__compose2, 0, _v_len__sep2);
      _v_res1 = _vt_1;
      goto _block1;
    }
  _block1__branch2: {}
    int _v_len5;
    _v_len5 = (_ge_arg2.get_len () + 1);
    int _v_len6;
    _v_len6 = 2;
    if (_v_len5 < _v_len6)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    int _v_len__list;
    _v_len__list = (_v_len5 - _v_len6);
    Expr _v_compose3;
    _v_compose3 = (_ge_arg1 () + _ge_arg2);
    if (_v_compose3.symbol_at (0))
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    Expr _v_deref__compose3;
    _v_deref__compose3 = Expr (_v_compose3, 0);
    int _v_len7;
    _v_len7 = _v_deref__compose3.get_len ();
    int _v_len8;
    _v_len8 = 0;
    if (_v_len7 < _v_len8)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    int _v_len__sep3;
    _v_len__sep3 = (_v_len7 - _v_len8);
    Expr _vt_1;
    _vt_1 = Expr (_v_compose3, (0 + 1), 1);
    Expr _ve_list;
    _ve_list = Expr (_v_compose3, (0 + 1 + 1), _v_len__list);
    Expr _ve_sep;
    _ve_sep = Expr (_v_deref__compose3, 0, _v_len__sep3);
    Expr _ve_new__list;
    _ve_new__list = (_vt_1 + _ve_sep);
    for ( ; ; )
    {
      {
        if (_ve_list.get_len () != 1)
        {
          goto _iter1;
        }
        Expr _vt_2;
        _vt_2 = Expr (_ve_list, 0, 1);
        _v_res1 = (_ve_new__list + _vt_2);
        goto _exit__iter1;
      }
    _iter1: {}
      int _v_len9;
      _v_len9 = _ve_list.get_len ();
      int _v_len10;
      _v_len10 = 1;
      if (_v_len9 < _v_len10)
      {
        RF_FUNC_ERROR (unexpected_fail);
      }
      int _v_len__rest;
      _v_len__rest = (_v_len9 - _v_len10);
      Expr _vt_2;
      _vt_2 = Expr (_ve_list, 0, 1);
      Expr _ve_rest;
      _ve_rest = Expr (_ve_list, (0 + 1), _v_len__rest);
      _ve_new__list = (_ve_new__list + _vt_2 + _ve_sep);
      _ve_list = _ve_rest;
    }
  _exit__iter1: {}
  }
_block1: {}
RF_END

RF_FUNC (Separate, (RF_ARG _ve_sep, _ve_list;;), (RF_RES _v_res1;;))
  Expr _ge_list__0;
  _ge_list__0 = _ve_list;
  Expr _ve_ll;
  _ve_ll = empty;
  for ( ; ; )
  {
    {
      if (_ge_list__0.get_len () != 0)
      {
        goto _iter1;
      }
      _v_res1 = _ve_ll;
      goto _exit__iter1;
    }
  _iter1: {}
    {
      {
        if (_ge_list__0.get_len () < _ve_sep.get_len ())
        {
          goto _block1__branch1;
        }
        RF_lsplit (_ge_list__0, 0, _ve_1, _v_lsplit__list__0);
        for ( ; ; RF_iter(_ge_list__0)++)
        {
          {
            if (!RF_iter(_ge_list__0))
            {
              goto _block1__branch1;
            }
            int _v_len1;
            _v_len1 = _v_lsplit__list__0.get_len ();
            int _v_len2;
            _v_len2 = _ve_sep.get_len ();
            if (_v_len1 < _v_len2)
            {
              goto _block1__branch1;
            }
            int _v_len__2;
            _v_len__2 = (_v_len1 - _v_len2);
            if (!_ve_sep.eq (_v_lsplit__list__0, 0))
            {
              goto _continue1;
            }
            Expr _ve_2;
            _ve_2 = Expr (_v_lsplit__list__0, (0 + _ve_sep.get_len ()), _v_len__2);
            _ge_list__0 = _ve_2;
            _ve_ll = (_ve_ll + _ve_1 ());
            goto _exit1;
          }
      _continue1: {}
        }
      _exit1: {}
        goto _block1;
      }
    _block1__branch1: {}
      _ve_ll = (_ve_ll + _ge_list__0 ());
      _ge_list__0 = empty;
    }
  _block1: {}
  }
_exit__iter1: {}
RF_END

RF_FUNC (Nub, (RF_ARG _ve_expr;;), (RF_RES _v_res1;;))
  Expr _ge_expr__0;
  _ge_expr__0 = _ve_expr;
  Expr _ve_selected;
  _ve_selected = empty;
  for ( ; ; )
  {
    {
      if (_ge_expr__0.get_len () != 0)
      {
        goto _iter1;
      }
      _v_res1 = _ve_selected;
      goto _exit__iter1;
    }
  _iter1: {}
    int _v_len1;
    _v_len1 = _ge_expr__0.get_len ();
    int _v_len2;
    _v_len2 = 1;
    if (_v_len1 < _v_len2)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    int _v_len__rest;
    _v_len__rest = (_v_len1 - _v_len2);
    Expr _vt_erm;
    _vt_erm = Expr (_ge_expr__0, 0, 1);
    Expr _ve_rest;
    _ve_rest = Expr (_ge_expr__0, (0 + 1), _v_len__rest);
    {
      {
        if (_ve_selected.get_len () < 1)
        {
          goto _block2__branch1;
        }
        RF_lsplit (_ve_selected, 0, _ve__dollar_tmp_m_133_m_21, _v_lsplit__selected);
        for ( ; ; RF_iter(_ve_selected)++)
        {
          {
            if (!RF_iter(_ve_selected))
            {
              goto _block2__branch1;
            }
            int _v_len3;
            _v_len3 = _v_lsplit__selected.get_len ();
            int _v_len4;
            _v_len4 = 1;
            if (_v_len3 < _v_len4)
            {
              goto _block2__branch1;
            }
            int _v_len___dollar_tmp_m_133_m_28;
            _v_len___dollar_tmp_m_133_m_28 = (_v_len3 - _v_len4);
            if (!_vt_erm.term_eq (_v_lsplit__selected, 0))
            {
              goto _continue1;
            }
            Expr _ve__dollar_tmp_m_133_m_28;
            _ve__dollar_tmp_m_133_m_28 = Expr (_v_lsplit__selected, (0 + 1), _v_len___dollar_tmp_m_133_m_28);
            _ge_expr__0 = _ve_rest;
            goto _exit1;
          }
      _continue1: {}
        }
      _exit1: {}
        goto _block2;
      }
    _block2__branch1: {}
      _ge_expr__0 = _ve_rest;
      _ve_selected = (_ve_selected + _vt_erm);
    }
  _block2: {}
  }
_exit__iter1: {}
RF_END

RF_FUNC (Replicate, (RF_ARG _vs_n, _ve_expr;;), (RF_RES _v_res1;;))
  Expr _gs_n__0;
  _gs_n__0 = _vs_n;
  Expr _ve_list;
  _ve_list = empty;
  for ( ; ; )
  {
    {
      if (!RF_CALL (refal::Compare::Le, (_gs_n__0, _c_2), /*void*/))
      {
        goto _iter1;
      }
      _v_res1 = _ve_list;
      goto _exit__iter1;
    }
  _iter1: {}
    Expr _gs_auxcall1;
    RF_CALL (refal::Arithm::Sub, (_gs_n__0, _c_3), _gs_auxcall1);
    _gs_n__0 = _gs_auxcall1;
    _ve_list = (_ve_list + _ve_expr);
  }
_exit__iter1: {}
RF_END

RF_FUNC (Or, (RF_ARG _ve_list1, _ve_list2;;), (RF_RES _v_res1;;))
  Expr _ge_list1__0;
  _ge_list1__0 = _ve_list1;
  Expr _ge_list2__0;
  _ge_list2__0 = _ve_list2;
  for ( ; ; )
  {
    {
      if (_ge_list2__0.get_len () != 0)
      {
        goto _iter1;
      }
      _v_res1 = _ge_list1__0;
      goto _exit__iter1;
    }
  _iter1: {}
    int _v_len1;
    _v_len1 = _ge_list2__0.get_len ();
    int _v_len2;
    _v_len2 = 1;
    if (_v_len1 < _v_len2)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    int _v_len__rest;
    _v_len__rest = (_v_len1 - _v_len2);
    Expr _vt_erm;
    _vt_erm = Expr (_ge_list2__0, 0, 1);
    Expr _ve_rest;
    _ve_rest = Expr (_ge_list2__0, (0 + 1), _v_len__rest);
    {
      {
        if (_ge_list1__0.get_len () < 1)
        {
          goto _block2__branch1;
        }
        RF_lsplit (_ge_list1__0, 0, _ve__dollar_tmp_m_165_m_20, _v_lsplit__list1__0);
        for ( ; ; RF_iter(_ge_list1__0)++)
        {
          {
            if (!RF_iter(_ge_list1__0))
            {
              goto _block2__branch1;
            }
            int _v_len3;
            _v_len3 = _v_lsplit__list1__0.get_len ();
            int _v_len4;
            _v_len4 = 1;
            if (_v_len3 < _v_len4)
            {
              goto _block2__branch1;
            }
            int _v_len___dollar_tmp_m_165_m_27;
            _v_len___dollar_tmp_m_165_m_27 = (_v_len3 - _v_len4);
            if (!_vt_erm.term_eq (_v_lsplit__list1__0, 0))
            {
              goto _continue1;
            }
            Expr _ve__dollar_tmp_m_165_m_27;
            _ve__dollar_tmp_m_165_m_27 = Expr (_v_lsplit__list1__0, (0 + 1), _v_len___dollar_tmp_m_165_m_27);
            _ge_list2__0 = _ve_rest;
            goto _exit1;
          }
      _continue1: {}
        }
      _exit1: {}
        goto _block2;
      }
    _block2__branch1: {}
      _ge_list1__0 = (_ge_list1__0 + _vt_erm);
      _ge_list2__0 = _ve_rest;
    }
  _block2: {}
  }
_exit__iter1: {}
RF_END

RF_FUNC (And, (RF_ARG _ve_list1, _ve_list2;;), (RF_RES _v_res1;;))
  Expr _ge_list1__0;
  _ge_list1__0 = _ve_list1;
  Expr _ve_and;
  _ve_and = empty;
  for ( ; ; )
  {
    {
      if (_ge_list1__0.get_len () != 0)
      {
        goto _iter1;
      }
      _v_res1 = _ve_and;
      goto _exit__iter1;
    }
  _iter1: {}
    int _v_len1;
    _v_len1 = _ge_list1__0.get_len ();
    int _v_len2;
    _v_len2 = 1;
    if (_v_len1 < _v_len2)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    int _v_len__rest;
    _v_len__rest = (_v_len1 - _v_len2);
    Expr _vt_erm;
    _vt_erm = Expr (_ge_list1__0, 0, 1);
    Expr _ve_rest;
    _ve_rest = Expr (_ge_list1__0, (0 + 1), _v_len__rest);
    {
      {
        if (_ve_list2.get_len () < 1)
        {
          goto _block2__branch1;
        }
        RF_lsplit (_ve_list2, 0, _ve__dollar_tmp_m_179_m_20, _v_lsplit__list2);
        for ( ; ; RF_iter(_ve_list2)++)
        {
          {
            if (!RF_iter(_ve_list2))
            {
              goto _block2__branch1;
            }
            int _v_len3;
            _v_len3 = _v_lsplit__list2.get_len ();
            int _v_len4;
            _v_len4 = 1;
            if (_v_len3 < _v_len4)
            {
              goto _block2__branch1;
            }
            int _v_len___dollar_tmp_m_179_m_27;
            _v_len___dollar_tmp_m_179_m_27 = (_v_len3 - _v_len4);
            if (!_vt_erm.term_eq (_v_lsplit__list2, 0))
            {
              goto _continue1;
            }
            Expr _ve__dollar_tmp_m_179_m_27;
            _ve__dollar_tmp_m_179_m_27 = Expr (_v_lsplit__list2, (0 + 1), _v_len___dollar_tmp_m_179_m_27);
            _ge_list1__0 = _ve_rest;
            _ve_and = (_ve_and + _vt_erm);
            goto _exit1;
          }
      _continue1: {}
        }
      _exit1: {}
        goto _block2;
      }
    _block2__branch1: {}
      _ge_list1__0 = _ve_rest;
    }
  _block2: {}
  }
_exit__iter1: {}
RF_END

RF_FUNC (Sub, (RF_ARG _ve_list1, _ve_list2;;), (RF_RES _v_res1;;))
  Expr _ge_list1__0;
  _ge_list1__0 = _ve_list1;
  Expr _ve_not;
  _ve_not = empty;
  for ( ; ; )
  {
    {
      if (_ge_list1__0.get_len () != 0)
      {
        goto _iter1;
      }
      _v_res1 = _ve_not;
      goto _exit__iter1;
    }
  _iter1: {}
    int _v_len1;
    _v_len1 = _ge_list1__0.get_len ();
    int _v_len2;
    _v_len2 = 1;
    if (_v_len1 < _v_len2)
    {
      RF_FUNC_ERROR (unexpected_fail);
    }
    int _v_len__rest;
    _v_len__rest = (_v_len1 - _v_len2);
    Expr _vt_erm;
    _vt_erm = Expr (_ge_list1__0, 0, 1);
    Expr _ve_rest;
    _ve_rest = Expr (_ge_list1__0, (0 + 1), _v_len__rest);
    {
      {
        if (_ve_list2.get_len () < 1)
        {
          goto _block2__branch1;
        }
        RF_lsplit (_ve_list2, 0, _ve__dollar_tmp_m_193_m_20, _v_lsplit__list2);
        for ( ; ; RF_iter(_ve_list2)++)
        {
          {
            if (!RF_iter(_ve_list2))
            {
              goto _block2__branch1;
            }
            int _v_len3;
            _v_len3 = _v_lsplit__list2.get_len ();
            int _v_len4;
            _v_len4 = 1;
            if (_v_len3 < _v_len4)
            {
              goto _block2__branch1;
            }
            int _v_len___dollar_tmp_m_193_m_27;
            _v_len___dollar_tmp_m_193_m_27 = (_v_len3 - _v_len4);
            if (!_vt_erm.term_eq (_v_lsplit__list2, 0))
            {
              goto _continue1;
            }
            Expr _ve__dollar_tmp_m_193_m_27;
            _ve__dollar_tmp_m_193_m_27 = Expr (_v_lsplit__list2, (0 + 1), _v_len___dollar_tmp_m_193_m_27);
            _ge_list1__0 = _ve_rest;
            goto _exit1;
          }
      _continue1: {}
        }
      _exit1: {}
        goto _block2;
      }
    _block2__branch1: {}
      _ge_list1__0 = _ve_rest;
      _ve_not = (_ve_not + _vt_erm);
    }
  _block2: {}
  }
_exit__iter1: {}
RF_END

RF_FUNC (Paren_Term_0, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  if (_ge_arg1.get_len () != 1)
  {
    RF_ERROR (_c_4);
  }
  Expr _v_stub1;
  _v_stub1 = Expr (_ge_arg1, 0, 1);
  Expr _v_Paren__Term1;
  RF_CALL (Paren_Term, _v_stub1, _v_Paren__Term1);
  _v_res1 = _v_Paren__Term1 ();
RF_END

RF_FUNC (Deparen_Term_0, (RF_ARG _ge_arg1;;), (RF_RES _v_res1;;))
  if (_ge_arg1.get_len () != 1)
  {
    RF_ERROR (_c_4);
  }
  Expr _v_stub1;
  _v_stub1 = Expr (_ge_arg1, 0, 1);
  RF_TAILCALL (Deparen_Term, _v_stub1, _v_res1);
RF_END

}

}

namespace refal {

namespace List {

static void init_ () {
  _c_0 = Expr::create_sym<rftype::Func> (refal::List::Deparen_Term_0);
  _c_1 = Expr::create_sym<rftype::Func> (Paren_Term_0);
  _c_2 = Expr::create<rftype::Integer>("0");
  _c_3 = Expr::create<rftype::Integer>("1");
  _c_4 = Expr::create<rftype::Word>("Apply") + Expr::create<rftype::Word>("Apply") + Expr::create<rftype::Word>("Unexpected fail");
}

static AtStart init_registrator_ (&init_);

}

}
