
#include <rf_core.hh>

using namespace rfrt;

namespace refal {

namespace Box {

RF_DECL (Put);

RF_DECL (Get);

}

}

namespace refal {

namespace StdIO {

RF_DECL (PrintLn);

}

}

namespace refal {

namespace Stream {

namespace StreamErr {

RF_DECL (Clear_Errors);

}

}

}

namespace refal {

namespace Box {

RF_DECL (Store);

}

}

namespace refal {

namespace Stream {

namespace StreamErr {

RF_DECL (Error_At);

RF_DECL (Print_Errors);

RF_DECL (Errors);

RF_DECL (Error);

}

}

}

namespace refal {

namespace Stream {

namespace StreamErr {

static Expr Error_Box;

static Expr _c_4;

static Expr _c_0;

static Expr _c_1;

static Expr _c_2;

static Expr _c_3;

RF_FUNC (Errors, RF_VOID, (RF_RES _v_res1;;))
  RF_TAILCALL (refal::Box::Get, Error_Box, _v_res1);
RF_END

RF_FUNC (Clear_Errors, RF_VOID, RF_VOID)
  RF_TAILCALL (refal::Box::Store, (Error_Box, empty), /*void*/);
RF_END

RF_FUNC (Error, (RF_ARG _vs_tream, _ve_message;;), RF_VOID)
  RF_TAILCALL (refal::Box::Put, (Error_Box, (_c_0 + _ve_message ()) ()), /*void*/);
RF_END

RF_FUNC (Error_At, (RF_ARG _vt_pos, _ve_message;;), RF_VOID)
  RF_TAILCALL (refal::Box::Put, (Error_Box, (_c_0 + _ve_message ()) ()), /*void*/);
RF_END

RF_FUNC (Print_Errors, RF_VOID, RF_VOID)
  {
    Expr _v_Errors1;
    RF_CALL (Errors, /*void*/, _v_Errors1);
    if (_v_Errors1.get_len () < 1)
    {
      goto _block1__branch1;
    }
    RF_lsplit (_v_Errors1, 0, _ve__dollar_tmp_m_38_m_15, _v_lsplit__Errors1);
    for ( ; ; RF_iter(_v_Errors1)++)
    {
      {
        if (!RF_iter(_v_Errors1))
        {
          goto _block1__branch1;
        }
        int _v_len1;
        _v_len1 = _v_lsplit__Errors1.get_len ();
        int _v_len2;
        _v_len2 = 1;
        if (_v_len1 < _v_len2)
        {
          goto _block1__branch1;
        }
        int _v_len___dollar_tmp_m_38_m_54;
        _v_len___dollar_tmp_m_38_m_54 = (_v_len1 - _v_len2);
        if (_v_lsplit__Errors1.symbol_at (0))
        {
          goto _continue1;
        }
        Expr _v_deref__lsplit__Errors1;
        _v_deref__lsplit__Errors1 = Expr (_v_lsplit__Errors1, 0);
        if (_v_deref__lsplit__Errors1.get_len () != 3)
        {
          goto _continue1;
        }
        if (_v_deref__lsplit__Errors1.symbol_at (0))
        {
          goto _continue1;
        }
        if (_v_deref__lsplit__Errors1.symbol_at ((0 + 1)))
        {
          goto _continue1;
        }
        if (_v_deref__lsplit__Errors1.symbol_at ((0 + 1 + 1)))
        {
          goto _continue1;
        }
        Expr _v_deref__deref__lsplit__Errors1;
        _v_deref__deref__lsplit__Errors1 = Expr (_v_deref__lsplit__Errors1, 0);
        Expr _v_deref__deref__lsplit__Errors12;
        _v_deref__deref__lsplit__Errors12 = Expr (_v_deref__lsplit__Errors1, (0 + 1));
        Expr _v_deref__deref__lsplit__Errors13;
        _v_deref__deref__lsplit__Errors13 = Expr (_v_deref__lsplit__Errors1, (0 + 1 + 1));
        if (_v_deref__deref__lsplit__Errors12.get_len () != 2)
        {
          goto _continue1;
        }
        int _v_len3;
        _v_len3 = _v_deref__deref__lsplit__Errors13.get_len ();
        int _v_len4;
        _v_len4 = 0;
        if (_v_len3 < _v_len4)
        {
          goto _continue1;
        }
        int _v_len__message;
        _v_len__message = (_v_len3 - _v_len4);
        int _v_len5;
        _v_len5 = _v_deref__deref__lsplit__Errors1.get_len ();
        int _v_len6;
        _v_len6 = 0;
        if (_v_len5 < _v_len6)
        {
          goto _continue1;
        }
        int _v_len__name;
        _v_len__name = (_v_len5 - _v_len6);
        if (!_v_deref__deref__lsplit__Errors12.symbol_at (0))
        {
          goto _continue1;
        }
        if (!_v_deref__deref__lsplit__Errors12.symbol_at ((0 + 1)))
        {
          goto _continue1;
        }
        Expr _ve__dollar_tmp_m_38_m_54;
        _ve__dollar_tmp_m_38_m_54 = Expr (_v_lsplit__Errors1, (0 + 1), _v_len___dollar_tmp_m_38_m_54);
        Expr _ve_name;
        _ve_name = Expr (_v_deref__deref__lsplit__Errors1, 0, _v_len__name);
        Expr _vs_row;
        _vs_row = Expr (_v_deref__deref__lsplit__Errors12, 0, 1);
        Expr _vs_col;
        _vs_col = Expr (_v_deref__deref__lsplit__Errors12, (0 + 1), 1);
        Expr _ve_message;
        _ve_message = Expr (_v_deref__deref__lsplit__Errors13, 0, _v_len__message);
        RF_CALL (refal::StdIO::PrintLn, (_ve_name + _c_3 + _vs_row + _c_2 + _vs_col + _c_1 + _ve_message), /*void*/);
      }
  _continue1: {}
    }
  _exit1: {}
  }
_block1__branch1: {}
RF_END

}

}

}

namespace refal {

namespace Stream {

namespace StreamErr {

static void init_ () {
  Error_Box = Expr::create_sym< rftype::NamedObject<rftype::BoxContents> >(L"Error_Box");
  _c_4 = Expr::create<rftype::Integer>("0") + Expr::create<rftype::Integer>("0");
  _c_0 = (empty) () + (_c_4) ();
  _c_1 = Expr::create<rftype::Word>(" --- Error: ");
  _c_2 = Expr::create<rftype::Word>(", ");
  _c_3 = Expr::create<rftype::Word>(": ");
}

static AtStart init_registrator_ (&init_);

}

}

}
