// $Id: entries.cc 2187 2006-12-15 00:17:56Z orlov $

#include <rf_core.hh>

namespace refal
{

namespace Table
{

using namespace rfrt;

RF_FUNC (Entries, (RF_ARG _table;;), (RF_RES _res;;))
   assert(_table.get_len() == 1);
   Term* p = _table.get_first();
   rftype::Table* t = p->cast_to<rftype::Table>(type_table);
   if (!t)
     RF_LIB_ERROR("Invalid argument");
   _res=t->entries();    
RF_END

}
}
