#include <rf_core.hh>
#include <rf_types.hh>

using namespace rfrt;

namespace refal
{

namespace Table
{

RF_DECL(Lookup);

RF_FUNC (Lookup, (RF_ARG _table, _key;;), (RF_RES _val;;))
   
  Expr result;
  if (_table.get_len()==1) {
    Term* p = _table.get_first(); 
    rftype::Table*  _t = p->cast_to<rftype::Table>(type_table);         
    if (!_t)
      RF_LIB_ERROR("Invalid argument");  
    if (!(_t->lookup(_key, result))) 
      RF_RETFAIL;
    _val=result;   
  } else
    RF_LIB_ERROR("Invalid argument");

RF_END

}
}
