#include <rf_core.hh>
#include <rf_types.hh>

using namespace rfrt;

namespace refal
{

namespace Table
{

RF_DECL(ReplaceTable);

RF_FUNC (ReplaceTable, (RF_ARG _target, _source;;), RF_VOID)
   
  if (_target.get_len()==1) {
    Term* p = _target.get_first();      
    rftype::Table* target = p->cast_to<rftype::Table>(type_table);
    if (!target)
      RF_LIB_ERROR("Invalid argument");
    if (_source.get_len() == 1) {
      Term* t = _source.get_first();
      rftype::Table* source = t->cast_to<rftype::Table>(type_table);
      if (!source)
        RF_LIB_ERROR("Invalid argument");
      target->replace_table(*source);        
    } else
      RF_LIB_ERROR("Invalid argument");   
  } else
    RF_LIB_ERROR("Invalid argument");

RF_END

}
}
