// $Source$
// $Revision: 2187 $
// $Date: 2006-12-15 03:17:56 +0300 (Пт, 15 дек 2006) $
// $Author: orlov $

#include "rf_object_ref.ih"

namespace rftype
{

using namespace rfrt ;

void ObjectRef::ctor (ObjectRef* _to, ObjectRef const* _from)
{
  _to->data1 = _from->data1;
  _to->ptr_data2 = _from->ptr_data2;
  _to->get_obj_ptr()->ref_count++;
}

void ObjectRef::dtor (ObjectRef* _ref)
{
  Object* obj = _ref->get_obj_ptr();
  if (--(obj->ref_count) == 0) delete obj;
}

pxx::WString ObjectRef::to_string (ObjectRef const* _ref)
{
  return _ref->get_obj_ptr()->to_string();
}

short_type_funcs_t ObjectRef::funcs = {
  0,
  (void (*)(Term*, Term const*))(ObjectRef::ctor),
  (void (*)(Term*))(ObjectRef::dtor),
  null, // eq
  null, // (int (*)(Term const*, Term const*))(ObjectRef::compare), FIXME:
  null, // (uint32_t (*)(Term const*))(ObjectRef::hash), FIXME:
  (pxx::WString (*)(Term const*))(ObjectRef::to_string),
  null
};

}
