#ifndef __rf_parenth_hh__
#define __rf_parenth_hh__

#include "rf_symbol.ih"
#include "rf_expr.hh"

namespace rftype
{

using namespace rfrt ;

RF_NEW_SYMBOL(Expr, ObjectTerm);

template <>
inline bool RF_SYMBOL(Expr)::eq (
    RF_SYMBOL(Expr) const* _s1, RF_SYMBOL(Expr) const* _s2
)
{
  return (*_s1->get_obj_ptr()) == (*_s2->get_obj_ptr());
}

template <>
inline int RF_SYMBOL(Expr)::compare (
    RF_SYMBOL(Expr) const* _s1, RF_SYMBOL(Expr) const* _s2
)
{
  return Expr::compare(*_s1->get_obj_ptr(), *_s2->get_obj_ptr());
}

template <>
inline pxx::WString RF_SYMBOL(Expr)::to_string (RF_SYMBOL(Expr) const* _s)
{
  return pxx::WString(L"(")
       + pxx::WString(*_s->get_obj_ptr())
       + pxx::WString(L")");
}

}

#endif // __rf_parenth_hh__

